// DO NOT EDIT!  Generated automatically by mkbuiltins.

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "defun.h"
#include "help.h"
#include "oct-obj.h"
#include "variables.h"
#include "builtins.h"

#if defined (quad)
#undef quad
#endif

#if defined (ENABLE_DYNAMIC_LINKING)

#define XDEFUN_DLD_INTERNAL(name, args_name, nargout_name, doc)

#define XDEFUNX_DLD_INTERNAL(name, fname, args_name, nargout_name, doc)

#else

#define XDEFUN_DLD_INTERNAL(name, args_name, nargout_name, doc) \
  XDEFUN_INTERNAL(name, args_name, nargout_name, doc)

#define XDEFUNX_DLD_INTERNAL(name, fname, args_name, nargout_name, doc) \
  XDEFUNX_INTERNAL(name, fname, args_name, nargout_name, doc)

#endif

#define XDEFUN_FILE_NAME(name) \
  std::string file = name;

#define XDEFUN_INTERNAL(name, args_name, nargout_name, doc) \
  extern DECLARE_FUN (name, args_name, nargout_name); \
  install_builtin_function (F ## name, #name, file, doc); \

#define XDEFCONSTFUN_INTERNAL(name, args_name, nargout_name, doc) \
  extern DECLARE_FUN (name, args_name, nargout_name); \
  install_builtin_function (F ## name, #name, file, doc, false); \

#define XDEFUNX_INTERNAL(name, fname, args_name, nargout_name, doc) \
  extern DECLARE_FUNX (fname, args_name, nargout_name); \
  install_builtin_function (fname, name, file, doc); \

#define XDEFALIAS_INTERNAL(alias, name) \
  alias_builtin (#alias, #name);

#define XDEFCONST_INTERNAL(name, defn, doc)

static void
install_octave_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave.cc")
 XDEFUN_INTERNAL (__version_info__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {retval =} __version_info__ (@var{name}, @var{version}, @var{release}, @var{date})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (isguirunning, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isguirunning ()\nReturn true if Octave is running in GUI mode and false otherwise.\n@seealso{have_window_system}\n@end deftypefn") 
 XDEFUN_INTERNAL (argv, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} argv ()\nReturn the command line arguments passed to Octave.\n\nFor example, if you invoked Octave using the command\n\n@example\noctave --no-line-editing --silent\n@end example\n\n@noindent\n@code{argv} would return a cell array of strings with the elements\n@option{--no-line-editing} and @option{--silent}.\n\nIf you write an executable Octave script, @code{argv} will return the list\nof arguments passed to the script.  @xref{Executable Octave Programs}, for\nan example of how to create an executable Octave script.\n@end deftypefn") 
 XDEFUN_INTERNAL (program_invocation_name, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} program_invocation_name ()\nReturn the name that was typed at the shell prompt to run Octave.\n\nIf executing a script from the command line (e.g., @code{octave foo.m})\nor using an executable Octave script, the program name is set to the\nname of the script.  @xref{Executable Octave Programs}, for an example of\nhow to create an executable Octave script.\n@seealso{program_name}\n@end deftypefn") 
 XDEFUN_INTERNAL (program_name, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} program_name ()\nReturn the last component of the value returned by\n@code{program_invocation_name}.\n@seealso{program_invocation_name}\n@end deftypefn") 
}

static void
install_ov_base_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-base.cc")
 XDEFUN_INTERNAL (sparse_auto_mutate, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} sparse_auto_mutate ()\n@deftypefnx {Built-in Function} {@var{old_val} =} sparse_auto_mutate (@var{new_val})\n@deftypefnx {Built-in Function} {} sparse_auto_mutate (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will\nautomatically mutate sparse matrices to full matrices to save memory.\n\nFor example:\n\n@example\n@group\ns = speye (3);\nsparse_auto_mutate (false);\ns(:, 1) = 1;\ntypeinfo (s)\n@result{} sparse matrix\nsparse_auto_mutate (true);\ns(1, :) = 1;\ntypeinfo (s)\n@result{} matrix\n@end group\n@end example\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_ov_bool_mat_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-bool-mat.cc")
 XDEFUN_INTERNAL (logical, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} logical (@var{x})\nConvert the numeric object @var{x} to logical type.\n\nAny nonzero values will be converted to true (1) while zero values will be\nconverted to false (0).  The non-numeric value NaN cannot be converted and\nwill produce an error.\n\nCompatibility Note: Octave accepts complex values as input, whereas\n@sc{matlab} issues an error.\n@seealso{double, single, char}\n@end deftypefn") 
}

static void
install_ov_cell_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-cell.cc")
 XDEFUN_INTERNAL (iscell, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} iscell (@var{x})\nReturn true if @var{x} is a cell array object.\n@seealso{ismatrix, isstruct, iscellstr, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (cell, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cell (@var{n})\n@deftypefnx {Built-in Function} {} cell (@var{m}, @var{n})\n@deftypefnx {Built-in Function} {} cell (@var{m}, @var{n}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} cell ([@var{m} @var{n} @dots{}])\nCreate a new cell array object.\n\nIf invoked with a single scalar integer argument, return a square\n@nospell{NxN} cell array.  If invoked with two or more scalar integer\narguments, or a vector of integer values, return an array with the given\ndimensions.\n@seealso{cellstr, mat2cell, num2cell, struct2cell}\n@end deftypefn") 
 XDEFUN_INTERNAL (iscellstr, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} iscellstr (@var{cell})\nReturn true if every element of the cell array @var{cell} is a character\nstring.\n@seealso{ischar}\n@end deftypefn") 
 XDEFUN_INTERNAL (cellstr, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{cstr} =} cellstr (@var{strmat})\nCreate a new cell array object from the elements of the string array\n@var{strmat}.\n\nEach row of @var{strmat} becomes an element of @var{cstr}.  Any trailing\nspaces in a row are deleted before conversion.\n\nTo convert back from a cellstr to a character array use @code{char}.\n@seealso{cell, char}\n@end deftypefn") 
 XDEFUN_INTERNAL (struct2cell, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{c} =} struct2cell (@var{s})\nCreate a new cell array from the objects stored in the struct object.\n\nIf @var{f} is the number of fields in the structure, the resulting cell\narray will have a dimension vector corresponding to\n@code{[@var{f} size(@var{s})]}.  For example:\n\n@example\n@group\ns = struct (\"name\", @{\"Peter\", \"Hannah\", \"Robert\"@},\n           \"age\", @{23, 16, 3@});\nc = struct2cell (s)\n   @result{} c = @{2x1x3 Cell Array@}\nc(1,1,:)(:)\n   @result{}\n      @{\n        [1,1] = Peter\n        [2,1] = Hannah\n        [3,1] = Robert\n      @}\nc(2,1,:)(:)\n   @result{}\n      @{\n        [1,1] = 23\n        [2,1] = 16\n        [3,1] = 3\n      @}\n@end group\n@end example\n\n@seealso{cell2struct, fieldnames}\n@end deftypefn") 
}

static void
install_ov_class_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-class.cc")
 XDEFUN_INTERNAL (class, args, , "-*- texinfo -*-\n@deftypefn  {Function File} {@var{classname} =} class (@var{obj})\n@deftypefnx {Function File} {} class (@var{s}, @var{id})\n@deftypefnx {Function File} {} class (@var{s}, @var{id}, @var{p}, @dots{})\nReturn the class of the object @var{obj}, or create a class with\nfields from structure @var{s} and name (string) @var{id}.\n\nAdditional arguments name a list of parent classes from which the new class\nis derived.\n@seealso{typeinfo, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (isa, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} isa (@var{obj}, @var{classname})\nReturn true if @var{obj} is an object from the class @var{classname}.\n\n@var{classname} may also be one of the following class categories:\n\n@table @asis\n@item @qcode{\"float\"}\nFloating point value comprising classes @qcode{\"double\"} and\n@qcode{\"single\"}.\n\n@item @qcode{\"integer\"}\nInteger value comprising classes (u)int8, (u)int16, (u)int32, (u)int64.\n\n@item @qcode{\"numeric\"}\nNumeric value comprising either a floating point or integer value.\n@end table\n\nIf @var{classname} is a cell array of string, a logical array of the same\nsize is returned, containing true for each class to which @var{obj}\nbelongs to.\n\n@seealso{class, typeinfo}\n@end deftypefn") 
 XDEFUN_INTERNAL (__parent_classes__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __parent_classes__ (@var{x})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (isobject, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isobject (@var{x})\nReturn true if @var{x} is a class object.\n@seealso{class, typeinfo, isa, ismethod, isprop}\n@end deftypefn") 
 XDEFUN_INTERNAL (ismethod, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ismethod (@var{obj}, @var{method})\nReturn true if @var{obj} is a class object and the string @var{method}\nis a method of this class.\n@seealso{isprop, isobject}\n@end deftypefn") 
 XDEFUN_INTERNAL (__methods__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __methods__ (@var{x})\n@deftypefnx {Built-in Function} {} __methods__ (\"classname\")\nInternal function.\n\nImplements @code{methods} for Octave class objects and classnames.\n@seealso{methods}\n@end deftypefn") 
 XDEFUN_INTERNAL (superiorto, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} superiorto (@var{class_name}, @dots{})\nWhen called from a class constructor, mark the object currently\nconstructed as having a higher precedence than @var{class_name}.\n\nMore that one such class can be specified in a single call.\nThis function may only be called from a class constructor.\n@seealso{inferiorto}\n@end deftypefn") 
 XDEFUN_INTERNAL (inferiorto, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} inferiorto (@var{class_name}, @dots{})\nWhen called from a class constructor, mark the object currently\nconstructed as having a lower precedence than @var{class_name}.\n\nMore that one such class can be specified in a single call.\nThis function may only be called from a class constructor.\n@seealso{superiorto}\n@end deftypefn") 
}

static void
install_ov_classdef_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-classdef.cc")
 XDEFUN_INTERNAL (__meta_get_package__, args, , "") 
 XDEFUN_INTERNAL (__superclass_reference__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __superclass_reference__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__meta_class_query__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __meta_class_query__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (metaclass, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} metaclass (obj)\nReturns the meta.class object corresponding to the class of @var{obj}.\n@end deftypefn") 
}

static void
install_ov_fcn_handle_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-fcn-handle.cc")
 XDEFUN_INTERNAL (functions, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{s} =} functions (@var{fcn_handle})\nReturn a structure containing information about the function handle\n@var{fcn_handle}.\n\nThe structure @var{s} always contains these three fields:\n\n@table @asis\n@item function\nThe function name.  For an anonymous function (no name) this will be the\nactual function definition.\n\n@item type\nType of the function.\n\n@table @asis\n@item anonymous\nThe function is anonymous.\n\n@item private\nThe function is private.\n\n@item overloaded\nThe function overloads an existing function.\n\n@item simple\nThe function is a built-in or m-file function.\n\n@item subfunction\nThe function is a subfunction within an m-file.\n@end table\n\n@item file\nThe m-file that will be called to perform the function.  This field is empty\nfor anonymous and built-in functions.\n@end table\n\nIn addition, some function types may return more information in additional\nfields.\n\n@strong{Warning:} @code{functions} is provided for debugging purposes only.\nIt's behavior may change in the future and programs should not depend on a\nparticular output.\n\n@end deftypefn") 
 XDEFUN_INTERNAL (func2str, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} func2str (@var{fcn_handle})\nReturn a string containing the name of the function referenced by the\nfunction handle @var{fcn_handle}.\n@seealso{str2func, functions}\n@end deftypefn") 
 XDEFUN_INTERNAL (str2func, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} str2func (@var{fcn_name})\n@deftypefnx {Built-in Function} {} str2func (@var{fcn_name}, \"global\")\nReturn a function handle constructed from the string @var{fcn_name}.\n\nIf the optional @qcode{\"global\"} argument is passed, locally visible\nfunctions are ignored in the lookup.\n@seealso{func2str, inline}\n@end deftypefn") 
 XDEFUN_INTERNAL (is_function_handle, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} is_function_handle (@var{x})\nReturn true if @var{x} is a function handle.\n@seealso{isa, typeinfo, class, functions}\n@end deftypefn") 
}

static void
install_ov_fcn_inline_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-fcn-inline.cc")
 XDEFUNX_INTERNAL ("inline", Finline, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} inline (@var{str})\n@deftypefnx {Built-in Function} {} inline (@var{str}, @var{arg1}, @dots{})\n@deftypefnx {Built-in Function} {} inline (@var{str}, @var{n})\nCreate an inline function from the character string @var{str}.\n\nIf called with a single argument, the arguments of the generated function\nare extracted from the function itself.  The generated function arguments\nwill then be in alphabetical order.  It should be noted that i and j are\nignored as arguments due to the ambiguity between their use as a variable or\ntheir use as an built-in constant.  All arguments followed by a parenthesis\nare considered to be functions.  If no arguments are found, a function\ntaking a single argument named @code{x} will be created.\n\nIf the second and subsequent arguments are character strings, they are the\nnames of the arguments of the function.\n\nIf the second argument is an integer @var{n}, the arguments are\n@qcode{\"x\"}, @qcode{\"P1\"}, @dots{}, @qcode{\"P@var{N}\"}.\n\nProgramming Note: The use of @code{inline} is discouraged and it may be\nremoved from a future version of Octave.  The preferred way to create\nfunctions from strings is through the use of anonymous functions\n(@pxref{Anonymous Functions}) or @code{str2func}.\n@seealso{argnames, formula, vectorize, str2func}\n@end deftypefn") 
 XDEFUN_INTERNAL (formula, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} formula (@var{fun})\nReturn a character string representing the inline function @var{fun}.\n\nNote that @code{char (@var{fun})} is equivalent to\n@code{formula (@var{fun})}.\n@seealso{char, argnames, inline, vectorize}\n@end deftypefn") 
 XDEFUN_INTERNAL (argnames, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} argnames (@var{fun})\nReturn a cell array of character strings containing the names of the\narguments of the inline function @var{fun}.\n@seealso{inline, formula, vectorize}\n@end deftypefn") 
 XDEFUN_INTERNAL (vectorize, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} vectorize (@var{fun})\nCreate a vectorized version of the inline function @var{fun} by replacing\nall occurrences of @code{*}, @code{/}, etc., with @code{.*}, @code{./}, etc.\n\nThis may be useful, for example, when using inline functions with numerical\nintegration or optimization where a vector-valued function is expected.\n\n@example\n@group\nfcn = vectorize (inline (\"x^2 - 1\"))\n   @result{} fcn = f(x) = x.^2 - 1\nquadv (fcn, 0, 3)\n   @result{} 6\n@end group\n@end example\n@seealso{inline, formula, argnames}\n@end deftypefn") 
}

static void
install_ov_flt_re_mat_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-flt-re-mat.cc")
 XDEFUN_INTERNAL (single, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} single (@var{x})\nConvert @var{x} to single precision type.\n@seealso{double}\n@end deftypefn") 
}

static void
install_ov_java_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-java.cc")
 XDEFUN_INTERNAL (__java_init__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __java_init__ ()\nInternal function used @strong{only} when debugging Java interface.\n\nFunction will directly call initialize_java() to create an instance of a JVM.\n@end deftypefn") 
 XDEFUN_INTERNAL (__java_exit__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __java_exit__ ()\nInternal function used @strong{only} when debugging Java interface.\n\nFunction will directly call terminate_jvm() to destroy the current JVM\ninstance.\n@end deftypefn") 
 XDEFUN_INTERNAL (javaObject, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{jobj} =} javaObject (@var{classname})\n@deftypefnx {Built-in Function} {@var{jobj} =} javaObject (@var{classname}, @var{arg1}, @dots{})\nCreate a Java object of class @var{classsname}, by calling the class\nconstructor with the arguments @var{arg1}, @dots{}\n\nThe first example below creates an uninitialized object, while the second\nexample supplies an initial argument to the constructor.\n\n@example\n@group\nx = javaObject (\"java.lang.StringBuffer\")\nx = javaObject (\"java.lang.StringBuffer\", \"Initial string\")\n@end group\n@end example\n\n@seealso{javaMethod, javaArray}\n@end deftypefn") 
 XDEFUN_INTERNAL (javaMethod, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{ret} =} javaMethod (@var{methodname}, @var{obj})\n@deftypefnx {Built-in Function} {@var{ret} =} javaMethod (@var{methodname}, @var{obj}, @var{arg1}, @dots{})\nInvoke the method @var{methodname} on the Java object @var{obj} with the\narguments @var{arg1}, @dots{}.\n\nFor static methods, @var{obj} can be a string representing the fully\nqualified name of the corresponding class.\n\nWhen @var{obj} is a regular Java object, structure-like indexing can be\nused as a shortcut syntax.  For instance, the two following statements are\nequivalent\n\n@example\n@group\n  ret = javaMethod (\"method1\", x, 1.0, \"a string\")\n  ret = x.method1 (1.0, \"a string\")\n@end group\n@end example\n\n@code{javaMethod} returns the result of the method invocation.\n\n@seealso{methods, javaObject}\n@end deftypefn") 
 XDEFUN_INTERNAL (__java_get__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{val} =} __java_get__ (@var{obj}, @var{name})\nGet the value of the field @var{name} of the Java object @var{obj}.\n\nFor static fields, @var{obj} can be a string representing the fully qualified\nname of the corresponding class.\n\nWhen @var{obj} is a regular Java object, structure-like indexing can be used\nas a shortcut syntax.  For instance, the two following statements are\nequivalent\n\n@example\n@group\n  __java_get__ (x, \"field1\")\n  x.field1\n@end group\n@end example\n\n@seealso{__java_set__, javaMethod, javaObject}\n@end deftypefn") 
 XDEFUN_INTERNAL (__java_set__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{obj} =} __java_set__ (@var{obj}, @var{name}, @var{val})\nSet the value of the field @var{name} of the Java object @var{obj} to\n@var{val}.\n\nFor static fields, @var{obj} can be a string representing the fully\nqualified named of the corresponding Java class.\n\nWhen @var{obj} is a regular Java object, structure-like indexing can be\nused as a shortcut syntax.  For instance, the two following statements are\nequivalent\n\n@example\n@group\n  __java_set__ (x, \"field1\", val)\n  x.field1 = val\n@end group\n@end example\n\n@seealso{__java_get__, javaMethod, javaObject}\n@end deftypefn") 
 XDEFUN_INTERNAL (java2mat, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} java2mat (@var{javaobj})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (java_matrix_autoconversion, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} java_matrix_autoconversion ()\n@deftypefnx {Built-in Function} {@var{old_val} =} java_matrix_autoconversion (@var{new_val})\n@deftypefnx {Built-in Function} {} java_matrix_autoconversion (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Java arrays are\nautomatically converted to Octave matrices.\n\nThe default value is false.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{java_unsigned_autoconversion, debug_java}\n@end deftypefn") 
 XDEFUN_INTERNAL (java_unsigned_autoconversion, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} java_unsigned_autoconversion ()\n@deftypefnx {Built-in Function} {@var{old_val} =} java_unsigned_autoconversion (@var{new_val})\n@deftypefnx {Built-in Function} {} java_unsigned_autoconversion (@var{new_val}, \"local\")\nQuery or set the internal variable that controls how integer classes are\nconverted when @code{java_matrix_autoconversion} is enabled.\n\nWhen enabled, Java arrays of class Byte or Integer are converted to matrices\nof class uint8 or uint32 respectively.  The default value is true.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{java_matrix_autoconversion, debug_java}\n@end deftypefn") 
 XDEFUN_INTERNAL (debug_java, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} debug_java ()\n@deftypefnx {Built-in Function} {@var{old_val} =} debug_java (@var{new_val})\n@deftypefnx {Built-in Function} {} debug_java (@var{new_val}, \"local\")\nQuery or set the internal variable that determines whether extra debugging\ninformation regarding the initialization of the JVM and any Java exceptions\nis printed.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{java_matrix_autoconversion, java_unsigned_autoconversion}\n@end deftypefn") 
 XDEFUN_INTERNAL (isjava, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isjava (@var{x})\nReturn true if @var{x} is a Java object.\n@seealso{class, typeinfo, isa, javaObject}\n@end deftypefn") 
}

static void
install_ov_null_mat_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-null-mat.cc")
 XDEFUN_INTERNAL (isnull, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isnull (@var{x})\nReturn true if @var{x} is a special null matrix, string, or single quoted\nstring.\n\nIndexed assignment with such a value on the right-hand side should delete\narray elements.  This function should be used when overloading indexed\nassignment for user-defined classes instead of @code{isempty}, to\ndistinguish the cases:\n\n@table @asis\n@item @code{A(I) = []}\nThis should delete elements if @code{I} is nonempty.\n\n@item @code{X = []; A(I) = X}\nThis should give an error if @code{I} is nonempty.\n@end table\n@seealso{isempty, isindex}\n@end deftypefn") 
}

static void
install_ov_oncleanup_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-oncleanup.cc")
 XDEFUN_INTERNAL (onCleanup, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{obj} =} onCleanup (@var{function})\nCreate a special object that executes a given function upon destruction.\n\nIf the object is copied to multiple variables (or cell or struct array\nelements) or returned from a function, @var{function} will be executed after\nclearing the last copy of the object.  Note that if multiple local onCleanup\nvariables are created, the order in which they are called is unspecified.\nFor similar functionality @xref{The unwind_protect Statement}.\n@end deftypefn") 
}

static void
install_ov_range_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-range.cc")
 XDEFUN_INTERNAL (allow_noninteger_range_as_index, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} allow_noninteger_range_as_index ()\n@deftypefnx {Built-in Function} {@var{old_val} =} allow_noninteger_range_as_index (@var{new_val})\n@deftypefnx {Built-in Function} {} allow_noninteger_range_as_index (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether non-integer\nranges are allowed as indices.\n\nThis might be useful for @sc{matlab} compatibility; however, it is still not\nentirely compatible because @sc{matlab} treats the range expression\ndifferently in different contexts.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_ov_re_mat_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-re-mat.cc")
 XDEFUN_INTERNAL (double, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} double (@var{x})\nConvert @var{x} to double precision type.\n@seealso{single}\n@end deftypefn") 
}

static void
install_ov_struct_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-struct.cc")
 XDEFUN_INTERNAL (struct, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{s} =} struct ()\n@deftypefnx {Built-in Function} {@var{s} =} struct (@var{field1}, @var{value1}, @var{field2}, @var{value2}, @dots{})\n@deftypefnx {Built-in Function} {@var{s} =} struct (@var{obj})\n\nCreate a scalar or array structure and initialize its values.\n\nThe @var{field1}, @var{field2}, @dots{} variables are strings specifying the\nnames of the fields and the @var{value1}, @var{value2}, @dots{} variables\ncan be of any type.\n\nIf the values are cell arrays, create a structure array and initialize its\nvalues.  The dimensions of each cell array of values must match.  Singleton\ncells and non-cell values are repeated so that they fill the entire array. \nIf the cells are empty, create an empty structure array with the specified\nfield names.\n\nIf the argument is an object, return the underlying struct.\n\nObserve that the syntax is optimized for struct @strong{arrays}.  Consider\nthe following examples:\n\n@example\n@group\nstruct (\"foo\", 1)\n  @result{} scalar structure containing the fields:\n    foo =  1\n\nstruct (\"foo\", @{@})\n  @result{} 0x0 struct array containing the fields:\n    foo\n\nstruct (\"foo\", @{ @{@} @})\n  @result{} scalar structure containing the fields:\n    foo = @{@}(0x0)\n\nstruct (\"foo\", @{1, 2, 3@})\n  @result{} 1x3 struct array containing the fields:\n    foo\n\n@end group\n@end example\n\n@noindent\nThe first case is an ordinary scalar struct---one field, one value.  The\nsecond produces an empty struct array with one field and no values, since\nbeing passed an empty cell array of struct array values.  When the value is\na cell array containing a single entry, this becomes a scalar struct with\nthat single entry as the value of the field.  That single entry happens\nto be an empty cell array.\n\nFinally, if the value is a non-scalar cell array, then @code{struct}\nproduces a struct @strong{array}.\n@seealso{cell2struct, fieldnames, getfield, setfield, rmfield, isfield, orderfields, isstruct, structfun}\n@end deftypefn") 
 XDEFUN_INTERNAL (isstruct, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isstruct (@var{x})\nReturn true if @var{x} is a structure or a structure array.\n@seealso{ismatrix, iscell, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (__fieldnames__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __fieldnames__ (@var{struct})\n@deftypefnx {Built-in Function} {} __fieldnames__ (@var{obj})\nInternal function.\n\nImplements @code{fieldnames()} for structures and Octave objects.\n@seealso{fieldnames}\n@end deftypefn") 
 XDEFUN_INTERNAL (isfield, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} isfield (@var{x}, \"@var{name}\")\n@deftypefnx {Built-in Function} {} isfield (@var{x}, @var{name})\nReturn true if the @var{x} is a structure and it includes an element named\n@var{name}.\n\nIf @var{name} is a cell array of strings then a logical array of equal\ndimension is returned.\n@seealso{fieldnames}\n@end deftypefn") 
 XDEFUN_INTERNAL (numfields, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} numfields (@var{s})\nReturn the number of fields of the structure @var{s}.\n@seealso{fieldnames}\n@end deftypefn") 
 XDEFUN_INTERNAL (cell2struct, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cell2struct (@var{cell}, @var{fields})\n@deftypefnx {Built-in Function} {} cell2struct (@var{cell}, @var{fields}, @var{dim})\nConvert @var{cell} to a structure.\n\nThe number of fields in @var{fields} must match the number of elements in\n@var{cell} along dimension @var{dim}, that is\n@code{numel (@var{fields}) == size (@var{cell}, @var{dim})}.  If @var{dim}\nis omitted, a value of 1 is assumed.\n\n@example\n@group\nA = cell2struct (@{\"Peter\", \"Hannah\", \"Robert\";\n                   185, 170, 168@},\n                 @{\"Name\",\"Height\"@}, 1);\nA(1)\n   @result{}\n      @{\n        Name   = Peter\n        Height = 185\n      @}\n\n@end group\n@end example\n@seealso{struct2cell, cell2mat, struct}\n@end deftypefn") 
 XDEFUN_INTERNAL (rmfield, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{sout} =} rmfield (@var{s}, \"@var{f}\")\n@deftypefnx {Built-in Function} {@var{sout} =} rmfield (@var{s}, @var{f})\nReturn a @emph{copy} of the structure (array) @var{s} with the field @var{f}\nremoved.\n\nIf @var{f} is a cell array of strings or a character array, remove each of\nthe named fields.\n@seealso{orderfields, fieldnames, isfield}\n@end deftypefn") 
 XDEFUN_INTERNAL (struct_levels_to_print, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} struct_levels_to_print ()\n@deftypefnx {Built-in Function} {@var{old_val} =} struct_levels_to_print (@var{new_val})\n@deftypefnx {Built-in Function} {} struct_levels_to_print (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the number of\nstructure levels to display.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{print_struct_array_contents}\n@end deftypefn") 
 XDEFUN_INTERNAL (print_struct_array_contents, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} print_struct_array_contents ()\n@deftypefnx {Built-in Function} {@var{old_val} =} print_struct_array_contents (@var{new_val})\n@deftypefnx {Built-in Function} {} print_struct_array_contents (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies whether to print struct\narray contents.\n\nIf true, values of struct array elements are printed.  This variable does\nnot affect scalar structures whose elements are always printed.  In both\ncases, however, printing will be limited to the number of levels specified\nby @var{struct_levels_to_print}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{struct_levels_to_print}\n@end deftypefn") 
}

static void
install_ov_typeinfo_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-typeinfo.cc")
 XDEFUN_INTERNAL (typeinfo, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} typeinfo ()\n@deftypefnx {Built-in Function} {} typeinfo (@var{expr})\n\nReturn the type of the expression @var{expr}, as a string.\n\nIf @var{expr} is omitted, return a cell array of strings containing all the\ncurrently installed data types.\n@seealso{class, isa}\n@end deftypefn") 
}

static void
install_ov_usr_fcn_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-usr-fcn.cc")
 XDEFUN_INTERNAL (nargin, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} nargin ()\n@deftypefnx {Built-in Function} {} nargin (@var{fcn})\nReport the number of input arguments to a function.\n\nCalled from within a function, return the number of arguments passed to the\nfunction.  At the top level, return the number of command line arguments\npassed to Octave.\n\nIf called with the optional argument @var{fcn}---a function name or handle---\nreturn the declared number of arguments that the function can accept.\n\nIf the last argument to @var{fcn} is @var{varargin} the returned value is\nnegative.  For example, the function @code{union} for sets is declared as\n\n@example\n@group\nfunction [y, ia, ib] = union (a, b, varargin)\n\nand\n\nnargin (\"union\")\n@result{} -3\n@end group\n@end example\n\nProgramming Note: @code{nargin} does not work on built-in functions.\n@seealso{nargout, narginchk, varargin, inputname}\n@end deftypefn") 
 XDEFUN_INTERNAL (nargout, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} nargout ()\n@deftypefnx {Built-in Function} {} nargout (@var{fcn})\nReport the number of output arguments from a function.\n\nCalled from within a function, return the number of values the caller expects\nto receive.  At the top level, @code{nargout} with no argument is undefined\nand will produce an error.\n\nIf called with the optional argument @var{fcn}---a function name or\nhandle---return the number of declared output values that the function can\nproduce.\n\nIf the final output argument is @var{varargout} the returned value is\nnegative.\n\nFor example,\n\n@example\nf ()\n@end example\n\n@noindent\nwill cause @code{nargout} to return 0 inside the function @code{f} and\n\n@example\n[s, t] = f ()\n@end example\n\n@noindent\nwill cause @code{nargout} to return 2 inside the function @code{f}.\n\nIn the second usage,\n\n@example\nnargout (@@histc) \% or nargout (\"histc\")\n@end example\n\n@noindent\nwill return 2, because @code{histc} has two outputs, whereas\n\n@example\nnargout (@@imread)\n@end example\n\n@noindent\nwill return -2, because @code{imread} has two outputs and the second is\n@var{varargout}.\n\nProgramming Note.  @code{nargout} does not work for built-in functions and\nreturns -1 for all anonymous functions.\n@seealso{nargin, varargout, isargout, nthargout}\n@end deftypefn") 
 XDEFUN_INTERNAL (optimize_subsasgn_calls, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} optimize_subsasgn_calls ()\n@deftypefnx {Built-in Function} {@var{old_val} =} optimize_subsasgn_calls (@var{new_val})\n@deftypefnx {Built-in Function} {} optimize_subsasgn_calls (@var{new_val}, \"local\")\nQuery or set the internal flag for subsasgn method call optimizations.\n\nIf true, Octave will attempt to eliminate the redundant copying when calling\nthe subsasgn method of a user-defined class.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
 XDEFUN_INTERNAL (isargout, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isargout (@var{k})\nWithin a function, return a logical value indicating whether the argument\n@var{k} will be assigned to a variable on output.\n\nIf the result is false, the argument has been ignored during the function\ncall through the use of the tilde (~) special output argument.  Functions\ncan use @code{isargout} to avoid performing unnecessary calculations for\noutputs which are unwanted.\n\nIf @var{k} is outside the range @code{1:max (nargout)}, the function returns\nfalse.  @var{k} can also be an array, in which case the function works\nelement-by-element and a logical array is returned.  At the top level,\n@code{isargout} returns an error.\n@seealso{nargout, varargout, nthargout}\n@end deftypefn") 
}

static void
install_ov_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov.cc")
 XDEFUN_INTERNAL (sizeof, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} sizeof (@var{val})\nReturn the size of @var{val} in bytes.\n@seealso{whos}\n@end deftypefn") 
 XDEFUN_INTERNAL (subsref, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} subsref (@var{val}, @var{idx})\nPerform the subscripted element selection operation according to the\nsubscript specified by @var{idx}.\n\nThe subscript @var{idx} is expected to be a structure array with fields\n@samp{type} and @samp{subs}.  Valid values for @samp{type} are\n@samp{\"()\"}, @samp{\"@{@}\"}, and @samp{\".\"}.  The @samp{subs} field may\nbe either @samp{\":\"} or a cell array of index values.\n\nThe following example shows how to extract the first two columns of a matrix\n\n@example\n@group\nval = magic (3)\n    @result{} val = [ 8   1   6\n               3   5   7\n               4   9   2 ]\nidx.type = \"()\";\nidx.subs = @{\":\", 1:2@};\nsubsref (val, idx)\n     @result{} [ 8   1\n          3   5\n          4   9 ]\n@end group\n@end example\n\n@noindent\nNote that this is the same as writing @code{val(:,1:2)}.\n\nIf @var{idx} is an empty structure array with fields @samp{type} and\n@samp{subs}, return @var{val}.\n@seealso{subsasgn, substruct}\n@end deftypefn") 
 XDEFUN_INTERNAL (subsasgn, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} subsasgn (@var{val}, @var{idx}, @var{rhs})\nPerform the subscripted assignment operation according to the subscript\nspecified by @var{idx}.\n\nThe subscript @var{idx} is expected to be a structure array with fields\n@samp{type} and @samp{subs}.  Valid values for @samp{type} are\n@samp{\"()\"}, @samp{\"@{@}\"}, and @samp{\".\"}.  The @samp{subs} field may\nbe either @samp{\":\"} or a cell array of index values.\n\nThe following example shows how to set the two first columns of a 3-by-3\nmatrix to zero.\n\n@example\n@group\nval = magic (3);\nidx.type = \"()\";\nidx.subs = @{\":\", 1:2@};\nsubsasgn (val, idx, 0)\n     @result{}  [ 0   0   6\n           0   0   7\n           0   0   2 ]\n@end group\n@end example\n\nNote that this is the same as writing @code{val(:,1:2) = 0}.\n\nIf @var{idx} is an empty structure array with fields @samp{type} and\n@samp{subs}, return @var{rhs}.\n@seealso{subsref, substruct}\n@end deftypefn") 
 XDEFUN_INTERNAL (is_sq_string, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} is_sq_string (@var{x})\nReturn true if @var{x} is a single-quoted character string.\n@seealso{is_dq_string, ischar}\n@end deftypefn") 
 XDEFUN_INTERNAL (is_dq_string, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} is_dq_string (@var{x})\nReturn true if @var{x} is a double-quoted character string.\n@seealso{is_sq_string, ischar}\n@end deftypefn") 
 XDEFUN_INTERNAL (disable_permutation_matrix, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} disable_permutation_matrix ()\n@deftypefnx {Built-in Function} {@var{old_val} =} disable_permutation_matrix (@var{new_val})\n@deftypefnx {Built-in Function} {} disable_permutation_matrix (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether permutation\nmatrices are stored in a special space-efficient format.\n\nThe default value is true.  If this option is disabled Octave will store\npermutation matrices as full matrices.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{disable_range, disable_diagonal_matrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (disable_diagonal_matrix, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} disable_diagonal_matrix ()\n@deftypefnx {Built-in Function} {@var{old_val} =} disable_diagonal_matrix (@var{new_val})\n@deftypefnx {Built-in Function} {} disable_diagonal_matrix (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether diagonal\nmatrices are stored in a special space-efficient format.\n\nThe default value is true.  If this option is disabled Octave will store\ndiagonal matrices as full matrices.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{disable_range, disable_permutation_matrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (disable_range, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} disable_range ()\n@deftypefnx {Built-in Function} {@var{old_val} =} disable_range (@var{new_val})\n@deftypefnx {Built-in Function} {} disable_range (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether ranges are stored\nin a special space-efficient format.\n\nThe default value is true.  If this option is disabled Octave will store\nranges as full matrices.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{disable_diagonal_matrix, disable_permutation_matrix}\n@end deftypefn") 
}

static void
install_ov_int16_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-int16.cc")
 XDEFUN_INTERNAL (int16, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} int16 (@var{x})\nConvert @var{x} to 16-bit integer type.\n@seealso{int8, uint8, uint16, int32, uint32, int64, uint64}\n@end deftypefn") 
}

static void
install_ov_int32_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-int32.cc")
 XDEFUN_INTERNAL (int32, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} int32 (@var{x})\nConvert @var{x} to 32-bit integer type.\n@seealso{int8, uint8, int16, uint16, uint32, int64, uint64}\n@end deftypefn") 
}

static void
install_ov_int64_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-int64.cc")
 XDEFUN_INTERNAL (int64, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} int64 (@var{x})\nConvert @var{x} to 64-bit integer type.\n@seealso{int8, uint8, int16, uint16, int32, uint32, uint64}\n@end deftypefn") 
}

static void
install_ov_int8_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-int8.cc")
 XDEFUN_INTERNAL (int8, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} int8 (@var{x})\nConvert @var{x} to 8-bit integer type.\n@seealso{uint8, int16, uint16, int32, uint32, int64, uint64}\n@end deftypefn") 
}

static void
install_ov_uint16_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-uint16.cc")
 XDEFUN_INTERNAL (uint16, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} uint16 (@var{x})\nConvert @var{x} to unsigned 16-bit integer type.\n@seealso{int8, uint8, int16, int32, uint32, int64, uint64}\n@end deftypefn") 
}

static void
install_ov_uint32_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-uint32.cc")
 XDEFUN_INTERNAL (uint32, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} uint32 (@var{x})\nConvert @var{x} to unsigned 32-bit integer type.\n@seealso{int8, uint8, int16, uint16, int32, int64, uint64}\n@end deftypefn") 
}

static void
install_ov_uint64_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-uint64.cc")
 XDEFUN_INTERNAL (uint64, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} uint64 (@var{x})\nConvert @var{x} to unsigned 64-bit integer type.\n@seealso{int8, uint8, int16, uint16, int32, uint32, int64}\n@end deftypefn") 
}

static void
install_ov_uint8_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/octave-value/ov-uint8.cc")
 XDEFUN_INTERNAL (uint8, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} uint8 (@var{x})\nConvert @var{x} to unsigned 8-bit integer type.\n@seealso{int8, int16, uint16, int32, uint32, int64, uint64}\n@end deftypefn") 
}

static void
install_pt_arg_list_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/parse-tree/pt-arg-list.cc")
 XDEFCONSTFUN_INTERNAL (end, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} end\nThe magic index @qcode{\"end\"} refers to the last valid entry in an indexing\noperation.\n\nExample:\n\n@example\n@group\n@var{x} = [ 1 2 3\n      4 5 6 ];\n@var{x}(1,end)\n    @result{} 3\n@var{x}(end,1)\n    @result{} 4\n@var{x}(end,end)\n    @result{} 6\n@end group\n@end example\n@end deftypefn") 
}

static void
install_pt_binop_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/parse-tree/pt-binop.cc")
 XDEFUN_INTERNAL (do_braindead_shortcircuit_evaluation, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} do_braindead_shortcircuit_evaluation ()\n@deftypefnx {Built-in Function} {@var{old_val} =} do_braindead_shortcircuit_evaluation (@var{new_val})\n@deftypefnx {Built-in Function} {} do_braindead_shortcircuit_evaluation (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will\ndo short-circuit evaluation of @samp{|} and @samp{&} operators inside the\nconditions of if or while statements.\n\nThis feature is only provided for compatibility with @sc{matlab} and should\nnot be used unless you are porting old code that relies on this feature.\n\nTo obtain short-circuit behavior for logical expressions in new programs,\nyou should always use the @samp{&&} and @samp{||} operators.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_pt_eval_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/parse-tree/pt-eval.cc")
 XDEFUN_INTERNAL (max_recursion_depth, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} max_recursion_depth ()\n@deftypefnx {Built-in Function} {@var{old_val} =} max_recursion_depth (@var{new_val})\n@deftypefnx {Built-in Function} {} max_recursion_depth (@var{new_val}, \"local\")\nQuery or set the internal limit on the number of times a function may\nbe called recursively.\n\nIf the limit is exceeded, an error message is printed and control returns to\nthe top level.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
 XDEFUN_INTERNAL (silent_functions, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} silent_functions ()\n@deftypefnx {Built-in Function} {@var{old_val} =} silent_functions (@var{new_val})\n@deftypefnx {Built-in Function} {} silent_functions (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether internal\noutput from a function is suppressed.\n\nIf this option is disabled, Octave will display the results produced by\nevaluating expressions within a function body that are not terminated with\na semicolon.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_pt_mat_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/parse-tree/pt-mat.cc")
 XDEFUN_INTERNAL (string_fill_char, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} string_fill_char ()\n@deftypefnx {Built-in Function} {@var{old_val} =} string_fill_char (@var{new_val})\n@deftypefnx {Built-in Function} {} string_fill_char (@var{new_val}, \"local\")\nQuery or set the internal variable used to pad all rows of a character\nmatrix to the same length.\n\nThe value must be a single character and the default is @qcode{\" \"} (a\nsingle space).  For example:\n\n@example\n@group\nstring_fill_char (\"X\");\n[ \"these\"; \"are\"; \"strings\" ]\n      @result{}  \"theseXX\"\n          \"areXXXX\"\n          \"strings\"\n@end group\n@end example\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_lex_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/parse-tree/lex.cc")
 XDEFUN_INTERNAL (iskeyword, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} iskeyword ()\n@deftypefnx {Built-in Function} {} iskeyword (@var{name})\nReturn true if @var{name} is an Octave keyword.\n\nIf @var{name} is omitted, return a list of keywords.\n@seealso{isvarname, exist}\n@end deftypefn") 
 XDEFUN_INTERNAL (__display_tokens__, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __display_tokens__ ()\nQuery or set the internal variable that determines whether Octave's\nlexer displays tokens as they are read.\n@seealso{__lexer_debug_flag__, __token_count__}\n@end deftypefn") 
 XDEFUN_INTERNAL (__token_count__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __token_count__ ()\nReturn the number of language tokens processed since Octave startup.\n@seealso{__lexer_debug_flag__, __display_tokens__}\n@end deftypefn") 
 XDEFUN_INTERNAL (__lexer_debug_flag__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} __lexer_debug_flag__ ()\n@deftypefnx {Built-in Function} {@var{old_val} =} __lexer_debug_flag__ (@var{new_val})\nQuery or set the internal flag that determines whether Octave's lexer prints\ndebug information as it processes an expression.\n@seealso{__display_tokens__, __token_count__, __parse_debug_flag__}\n@end deftypefn") 
}

static void
install___contourc___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__contourc__.cc")
 XDEFUN_INTERNAL (__contourc__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __contourc__ (@var{x}, @var{y}, @var{z}, @var{levels})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install___dispatch___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__dispatch__.cc")
 XDEFUN_INTERNAL (__dispatch__, args, nargout, "Undocumented internal function") 
}

static void
install___dsearchn___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__dsearchn__.cc")
 XDEFUN_INTERNAL (__dsearchn__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{idx}, @var{d}] =} dsearch (@var{x}, @var{xi})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install___ichol___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__ichol__.cc")
 XDEFUN_INTERNAL (__ichol0__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{L} =} __ichol0__ (@var{A})\n@deftypefnx {Built-in Function} {@var{L} =} __ichol0__ (@var{A}, @var{michol})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__icholt__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{L} =} __icholt__ (@var{A})\n@deftypefnx {Built-in Function} {@var{L} =} __icholt__ (@var{A}, @var{droptol})\n@deftypefnx {Built-in Function} {@var{L} =} __icholt__ (@var{A}, @var{droptol}, @var{michol})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install___ilu___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__ilu__.cc")
 XDEFUN_INTERNAL (__ilu0__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{L}, @var{U}] =} __ilu0__ (@var{A})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __ilu0__ (@var{A}, @var{milu})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}] =} __ilu0__ (@var{A}, @dots{})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__iluc__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{L}, @var{U}] =} __iluc__ (@var{A})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __iluc__ (@var{A}, @var{droptol})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __iluc__ (@var{A}, @var{droptol}, @var{milu})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}] =} __iluc__ (@var{A}, @dots{})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__ilutp__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{L}, @var{U}] =} __ilutp__ (@var{A})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __ilutp__ (@var{A}, @var{droptol})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __ilutp__ (@var{A}, @var{droptol}, @var{thresh})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __ilutp__ (@var{A}, @var{droptol}, @var{thresh}, @var{milu})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}] =} __ilutp__ (@var{A}, @var{droptol}, @var{thresh}, @var{milu}, @var{udiag})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}] =} __ilutp__ (@var{A}, @dots{})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install___lin_interpn___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__lin_interpn__.cc")
 XDEFUN_INTERNAL (__lin_interpn__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{vi} =} __lin_interpn__ (@var{x1}, @var{x2}, @dots{}, @var{xn}, @var{v}, @var{y1}, @var{y2}, @dots{}, @var{yn})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install___pchip_deriv___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__pchip_deriv__.cc")
 XDEFUN_INTERNAL (__pchip_deriv__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __pchip_deriv__ (@var{x}, @var{y}, @var{dim})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install___qp___fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/__qp__.cc")
 XDEFUN_INTERNAL (__qp__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{x}, @var{lambda}, @var{info}, @var{iter}] =} __qp__ (@var{x0}, @var{H}, @var{q}, @var{Aeq}, @var{beq}, @var{Ain}, @var{bin}, @var{maxit})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install_balance_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/balance.cc")
 XDEFUN_INTERNAL (balance, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{AA} =} balance (@var{A})\n@deftypefnx {Built-in Function} {@var{AA} =} balance (@var{A}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{DD}, @var{AA}] =} balance (@var{A}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{D}, @var{P}, @var{AA}] =} balance (@var{A}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{CC}, @var{DD}, @var{AA}, @var{BB}] =} balance (@var{A}, @var{B}, @var{opt})\n\nBalance the matrix @var{A} to reduce numerical errors in future\ncalculations.\n\nCompute @code{@var{AA} = @var{DD} \\ @var{A} * @var{DD}} in which @var{AA}\nis a matrix whose row and column norms are roughly equal in magnitude, and\n@code{@var{DD} = @var{P} * @var{D}}, in which @var{P} is a permutation\nmatrix and @var{D} is a diagonal matrix of powers of two.  This allows the\nequilibration to be computed without round-off.  Results of eigenvalue\ncalculation are typically improved by balancing first.\n\nIf two output values are requested, @code{balance} returns\nthe diagonal @var{D} and the permutation @var{P} separately as vectors.\nIn this case, @code{@var{DD} = eye(n)(:,@var{P}) * diag (@var{D})}, where\n@math{n} is the matrix size.\n\nIf four output values are requested, compute @code{@var{AA} =\n@var{CC}*@var{A}*@var{DD}} and @code{@var{BB} = @var{CC}*@var{B}*@var{DD}},\nin which @var{AA} and @var{BB} have nonzero elements of approximately the\nsame magnitude and @var{CC} and @var{DD} are permuted diagonal matrices as\nin @var{DD} for the algebraic eigenvalue problem.\n\nThe eigenvalue balancing option @var{opt} may be one of:\n\n@table @asis\n@item @qcode{\"noperm\"}, @qcode{\"S\"}\nScale only; do not permute.\n\n@item @qcode{\"noscal\"}, @qcode{\"P\"}\nPermute only; do not scale.\n@end table\n\nAlgebraic eigenvalue balancing uses standard @sc{lapack} routines.\n\nGeneralized eigenvalue problem balancing uses Ward's algorithm\n(SIAM Journal on Scientific and Statistical Computing, 1981).\n@end deftypefn") 
}

static void
install_besselj_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/besselj.cc")
 XDEFUN_INTERNAL (besselj, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{j}, @var{ierr}] =} besselj (@var{alpha}, @var{x}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{y}, @var{ierr}] =} bessely (@var{alpha}, @var{x}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{i}, @var{ierr}] =} besseli (@var{alpha}, @var{x}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{k}, @var{ierr}] =} besselk (@var{alpha}, @var{x}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{h}, @var{ierr}] =} besselh (@var{alpha}, @var{k}, @var{x}, @var{opt})\nCompute Bessel or Hankel functions of various kinds:\n\n@table @code\n@item besselj\nBessel functions of the first kind.  If the argument @var{opt} is 1 or true,\nthe result is multiplied by @w{@code{exp (-abs (imag (@var{x})))}}.\n\n@item bessely\nBessel functions of the second kind.  If the argument @var{opt} is 1 or true,\nthe result is multiplied by @code{exp (-abs (imag (@var{x})))}.\n\n@item besseli\n\nModified Bessel functions of the first kind.  If the argument @var{opt} is 1\nor true, the result is multiplied by @code{exp (-abs (real (@var{x})))}.\n\n@item besselk\n\nModified Bessel functions of the second kind.  If the argument @var{opt} is 1\nor true, the result is multiplied by @code{exp (@var{x})}.\n\n@item besselh\nCompute Hankel functions of the first (@var{k} = 1) or second (@var{k}\n= 2) kind.  If the argument @var{opt} is 1 or true, the result is multiplied\nby @code{exp (-I*@var{x})} for @var{k} = 1 or @code{exp (I*@var{x})} for\n@var{k} = 2.\n@end table\n\nIf @var{alpha} is a scalar, the result is the same size as @var{x}.\nIf @var{x} is a scalar, the result is the same size as @var{alpha}.\nIf @var{alpha} is a row vector and @var{x} is a column vector, the\nresult is a matrix with @code{length (@var{x})} rows and\n@code{length (@var{alpha})} columns.  Otherwise, @var{alpha} and\n@var{x} must conform and the result will be the same size.\n\nThe value of @var{alpha} must be real.  The value of @var{x} may be\ncomplex.\n\nIf requested, @var{ierr} contains the following status information\nand is the same size as the result.\n\n@enumerate 0\n@item\nNormal return.\n\n@item\nInput error, return @code{NaN}.\n\n@item\nOverflow, return @code{Inf}.\n\n@item\nLoss of significance by argument reduction results in less than\nhalf of machine accuracy.\n\n@item\nComplete loss of significance by argument reduction, return @code{NaN}.\n\n@item\nError---no computation, algorithm termination condition not met,\nreturn @code{NaN}.\n@end enumerate\n@end deftypefn") 
 XDEFUN_INTERNAL (bessely, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{y}, @var{ierr}] =} bessely (@var{alpha}, @var{x}, @var{opt})\nSee besselj.\n@end deftypefn") 
 XDEFUN_INTERNAL (besseli, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{i}, @var{ierr}] =} besseli (@var{alpha}, @var{x}, @var{opt})\nSee besselj.\n@end deftypefn") 
 XDEFUN_INTERNAL (besselk, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{k}, @var{ierr}] =} besselk (@var{alpha}, @var{x}, @var{opt})\nSee besselj.\n@end deftypefn") 
 XDEFUN_INTERNAL (besselh, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{h}, @var{ierr}] =} besselh (@var{alpha}, @var{k}, @var{x}, @var{opt})\nSee besselj.\n@end deftypefn") 
 XDEFUN_INTERNAL (airy, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{a}, @var{ierr}] =} airy (@var{k}, @var{z}, @var{opt})\nCompute Airy functions of the first and second kind, and their derivatives.\n\n@example\n@group\n K   Function   Scale factor (if \"opt\" is supplied)\n---  --------   ---------------------------------------\n 0   Ai (Z)     exp ((2/3) * Z * sqrt (Z))\n 1   dAi(Z)/dZ  exp ((2/3) * Z * sqrt (Z))\n 2   Bi (Z)     exp (-abs (real ((2/3) * Z * sqrt (Z))))\n 3   dBi(Z)/dZ  exp (-abs (real ((2/3) * Z * sqrt (Z))))\n@end group\n@end example\n\nThe function call @code{airy (@var{z})} is equivalent to\n@code{airy (0, @var{z})}.\n\nThe result is the same size as @var{z}.\n\nIf requested, @var{ierr} contains the following status information and\nis the same size as the result.\n\n@enumerate 0\n@item\nNormal return.\n\n@item\nInput error, return @code{NaN}.\n\n@item\nOverflow, return @code{Inf}.\n\n@item\nLoss of significance by argument reduction results in less than half\n of machine accuracy.\n\n@item\nComplete loss of significance by argument reduction, return @code{NaN}.\n\n@item\nError---no computation, algorithm termination condition not met,\nreturn @code{NaN}.\n@end enumerate\n@end deftypefn") 
}

static void
install_betainc_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/betainc.cc")
 XDEFUN_INTERNAL (betainc, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} betainc (@var{x}, @var{a}, @var{b})\nCompute the regularized incomplete Beta function.\n\nThe regularized incomplete Beta function is defined by\n@tex\n$$\n I (x, a, b) = {1 \\over {B (a, b)}} \\int_0^x t^{(a-z)} (1-t)^{(b-1)} dt.\n$$\n@end tex\n@ifnottex\n@c Set example in small font to prevent overfull line\n\n@smallexample\n@group\n                                   x\n                          1       /\nbetainc (x, a, b) = -----------   | t^(a-1) (1-t)^(b-1) dt.\n                    beta (a, b)   /\n                               t=0\n@end group\n@end smallexample\n\n@end ifnottex\n\nIf @var{x} has more than one component, both @var{a} and @var{b} must be\nscalars.  If @var{x} is a scalar, @var{a} and @var{b} must be of\ncompatible dimensions.\n@seealso{betaincinv, beta, betaln}\n@end deftypefn") 
 XDEFUN_INTERNAL (betaincinv, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} betaincinv (@var{y}, @var{a}, @var{b})\nCompute the inverse of the incomplete Beta function.\n\nThe inverse is the value @var{x} such that\n\n@example\n@var{y} == betainc (@var{x}, @var{a}, @var{b})\n@end example\n@seealso{betainc, beta, betaln}\n@end deftypefn") 
}

static void
install_bitfcns_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/bitfcns.cc")
 XDEFUN_INTERNAL (bitand, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} bitand (@var{x}, @var{y})\nReturn the bitwise AND of non-negative integers.\n\n@var{x}, @var{y} must be in the range [0,bitmax]\n@seealso{bitor, bitxor, bitset, bitget, bitcmp, bitshift, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (bitor, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} bitor (@var{x}, @var{y})\nReturn the bitwise OR of non-negative integers.\n\n@var{x}, @var{y} must be in the range [0,bitmax]\n@seealso{bitor, bitxor, bitset, bitget, bitcmp, bitshift, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (bitxor, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} bitxor (@var{x}, @var{y})\nReturn the bitwise XOR of non-negative integers.\n\n@var{x}, @var{y} must be in the range [0,bitmax]\n@seealso{bitand, bitor, bitset, bitget, bitcmp, bitshift, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (bitshift, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} bitshift (@var{a}, @var{k})\n@deftypefnx {Built-in Function} {} bitshift (@var{a}, @var{k}, @var{n})\nReturn a @var{k} bit shift of @var{n}-digit unsigned integers in @var{a}.\n\nA positive @var{k} leads to a left shift; A negative value to a right shift.\n\nIf @var{n} is omitted it defaults to log2(bitmax)+1.\n@var{n} must be in the range [1,log2(bitmax)+1] usually [1,33].\n\n@example\n@group\nbitshift (eye (3), 1)\n@result{}\n@group\n2 0 0\n0 2 0\n0 0 2\n@end group\n\nbitshift (10, [-2, -1, 0, 1, 2])\n@result{} 2   5  10  20  40\n@c FIXME: restore this example when third arg is allowed to be an array.\n@c\n@c\n@c bitshift ([1, 10], 2, [3,4])\n@c @result{} 4  8\n@end group\n@end example\n@seealso{bitand, bitor, bitxor, bitset, bitget, bitcmp, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (bitmax, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} bitmax ()\n@deftypefnx {Built-in Function} {} bitmax (\"double\")\n@deftypefnx {Built-in Function} {} bitmax (\"single\")\nReturn the largest integer that can be represented within a floating point\nvalue.\n\nThe default class is @qcode{\"double\"}, but @qcode{\"single\"} is a\nvalid option.  On IEEE-754 compatible systems, @code{bitmax} is\n@w{@math{2^{53} - 1}} for @qcode{\"double\"} and @w{@math{2^{24} -1}} for\n@qcode{\"single\"}.\n@seealso{flintmax, intmax, realmax, realmin}\n@end deftypefn") 
 XDEFUN_INTERNAL (flintmax, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} flintmax ()\n@deftypefnx {Built-in Function} {} flintmax (\"double\")\n@deftypefnx {Built-in Function} {} flintmax (\"single\")\nReturn the largest integer that can be represented consecutively in a\nfloating point value.\n\nThe default class is @qcode{\"double\"}, but @qcode{\"single\"} is a valid\noption.  On IEEE-754 compatible systems, @code{flintmax} is @w{@math{2^53}}\nfor @qcode{\"double\"} and @w{@math{2^24}} for @qcode{\"single\"}.\n@seealso{bitmax, intmax, realmax, realmin}\n@end deftypefn") 
 XDEFUN_INTERNAL (intmax, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} intmax (@var{type})\nReturn the largest integer that can be represented in an integer type.\n\nThe variable @var{type} can be\n\n@table @code\n@item int8\nsigned 8-bit integer.\n\n@item int16\nsigned 16-bit integer.\n\n@item int32\nsigned 32-bit integer.\n\n@item int64\nsigned 64-bit integer.\n\n@item uint8\nunsigned 8-bit integer.\n\n@item uint16\nunsigned 16-bit integer.\n\n@item uint32\nunsigned 32-bit integer.\n\n@item uint64\nunsigned 64-bit integer.\n@end table\n\nThe default for @var{type} is @code{int32}.\n@seealso{intmin, flintmax, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (intmin, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} intmin (@var{type})\nReturn the smallest integer that can be represented in an integer type.\n\nThe variable @var{type} can be\n\n@table @code\n@item int8\nsigned 8-bit integer.\n\n@item int16\nsigned 16-bit integer.\n\n@item int32\nsigned 32-bit integer.\n\n@item int64\nsigned 64-bit integer.\n\n@item uint8\nunsigned 8-bit integer.\n\n@item uint16\nunsigned 16-bit integer.\n\n@item uint32\nunsigned 32-bit integer.\n\n@item uint64\nunsigned 64-bit integer.\n@end table\n\nThe default for @var{type} is @code{int32}.\n@seealso{intmax, flintmax, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (sizemax, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} sizemax ()\nReturn the largest value allowed for the size of an array.\n\nIf Octave is compiled with 64-bit indexing, the result is of class int64,\notherwise it is of class int32.  The maximum array size is slightly\nsmaller than the maximum value allowable for the relevant class as reported\nby @code{intmax}.\n@seealso{intmax}\n@end deftypefn") 
}

static void
install_bsxfun_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/bsxfun.cc")
 XDEFUN_INTERNAL (bsxfun, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} bsxfun (@var{f}, @var{A}, @var{B})\nThe binary singleton expansion function performs broadcasting,\nthat is, it applies a binary function @var{f} element-by-element to two\narray arguments @var{A} and @var{B}, and expands as necessary\nsingleton dimensions in either input argument.\n\n@var{f} is a function handle, inline function, or string containing the name\nof the function to evaluate.  The function @var{f} must be capable of\naccepting two column-vector arguments of equal length, or one column vector\nargument and a scalar.\n\nThe dimensions of @var{A} and @var{B} must be equal or singleton.  The\nsingleton dimensions of the arrays will be expanded to the same\ndimensionality as the other array.\n@seealso{arrayfun, cellfun}\n@end deftypefn") 
}

static void
install_cellfun_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/cellfun.cc")
 XDEFUN_INTERNAL (cellfun, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cellfun (@var{name}, @var{C})\n@deftypefnx {Built-in Function} {} cellfun (\"size\", @var{C}, @var{k})\n@deftypefnx {Built-in Function} {} cellfun (\"isclass\", @var{C}, @var{class})\n@deftypefnx {Built-in Function} {} cellfun (@var{func}, @var{C})\n@deftypefnx {Built-in Function} {} cellfun (@var{func}, @var{C}, @var{D})\n@deftypefnx {Built-in Function} {[@var{a}, @dots{}] =} cellfun (@dots{})\n@deftypefnx {Built-in Function} {} cellfun (@dots{}, \"ErrorHandler\", @var{errfunc})\n@deftypefnx {Built-in Function} {} cellfun (@dots{}, \"UniformOutput\", @var{val})\n\nEvaluate the function named @var{name} on the elements of the cell array\n@var{C}.\n\nElements in @var{C} are passed on to the named function individually.  The\nfunction @var{name} can be one of the functions\n\n@table @code\n@item isempty\nReturn 1 for empty elements.\n\n@item islogical\nReturn 1 for logical elements.\n\n@item isnumeric\nReturn 1 for numeric elements.\n\n@item isreal\nReturn 1 for real elements.\n\n@item length\nReturn a vector of the lengths of cell elements.\n\n@item ndims\nReturn the number of dimensions of each element.\n\n@item  numel\n@itemx prodofsize\nReturn the number of elements contained within each cell element.  The\nnumber is the product of the dimensions of the object at each cell element.\n\n@item size\nReturn the size along the @var{k}-th dimension.\n\n@item isclass\nReturn 1 for elements of @var{class}.\n@end table\n\nAdditionally, @code{cellfun} accepts an arbitrary function @var{func}\nin the form of an inline function, function handle, or the name of a\nfunction (in a character string).  The function can take one or more\narguments, with the inputs arguments given by @var{C}, @var{D}, etc.\nEqually the function can return one or more output arguments.  For example:\n\n@example\n@group\ncellfun (\"atan2\", @{1, 0@}, @{0, 1@})\n     @result{} [ 1.57080   0.00000 ]\n@end group\n@end example\n\nThe number of output arguments of @code{cellfun} matches the number of output\narguments of the function.  The outputs of the function will be collected\ninto the output arguments of @code{cellfun} like this:\n\n@example\n@group\nfunction [a, b] = twoouts (x)\n  a = x;\n  b = x*x;\nendfunction\n[aa, bb] = cellfun (@@twoouts, @{1, 2, 3@})\n     @result{}\n        aa =\n           1 2 3\n        bb =\n           1 4 9\n@end group\n@end example\n\nNote that per default the output argument(s) are arrays of the same size as\nthe input arguments.  Input arguments that are singleton (1x1) cells will be\nautomatically expanded to the size of the other arguments.\n\nIf the parameter @qcode{\"UniformOutput\"} is set to true (the default),\nthen the function must return scalars which will be concatenated into the\nreturn array(s).  If @qcode{\"UniformOutput\"} is false, the outputs are\nconcatenated into a cell array (or cell arrays).  For example:\n\n@example\n@group\ncellfun (\"tolower\", @{\"Foo\", \"Bar\", \"FooBar\"@},\n         \"UniformOutput\", false)\n@result{} @{\"foo\", \"bar\", \"foobar\"@}\n@end group\n@end example\n\nGiven the parameter @qcode{\"ErrorHandler\"}, then @var{errfunc} defines a\nfunction to call in case @var{func} generates an error.  The form of the\nfunction is\n\n@example\nfunction [@dots{}] = errfunc (@var{s}, @dots{})\n@end example\n\n@noindent\nwhere there is an additional input argument to @var{errfunc} relative to\n@var{func}, given by @var{s}.  This is a structure with the elements\n@qcode{\"identifier\"}, @qcode{\"message\"} and @qcode{\"index\"}, giving\nrespectively the error identifier, the error message, and the index into the\ninput arguments of the element that caused the error.  For example:\n\n@example\n@group\nfunction y = foo (s, x), y = NaN; endfunction\ncellfun (\"factorial\", @{-1,2@}, \"ErrorHandler\", @@foo)\n@result{} [NaN 2]\n@end group\n@end example\n\nUse @code{cellfun} intelligently.  The @code{cellfun} function is a\nuseful tool for avoiding loops.  It is often used with anonymous\nfunction handles; however, calling an anonymous function involves an\noverhead quite comparable to the overhead of an m-file function.\nPassing a handle to a built-in function is faster, because the\ninterpreter is not involved in the internal loop.  For example:\n\n@example\n@group\na = @{@dots{}@}\nv = cellfun (@@(x) det (x), a); # compute determinants\nv = cellfun (@@det, a); # faster\n@end group\n@end example\n\n@seealso{arrayfun, structfun, spfun}\n@end deftypefn") 
 XDEFUN_INTERNAL (arrayfun, args, nargout, "-*- texinfo -*-\n@deftypefn  {Function File} {} arrayfun (@var{func}, @var{A})\n@deftypefnx {Function File} {@var{x} =} arrayfun (@var{func}, @var{A})\n@deftypefnx {Function File} {@var{x} =} arrayfun (@var{func}, @var{A}, @var{b}, @dots{})\n@deftypefnx {Function File} {[@var{x}, @var{y}, @dots{}] =} arrayfun (@var{func}, @var{A}, @dots{})\n@deftypefnx {Function File} {} arrayfun (@dots{}, \"UniformOutput\", @var{val})\n@deftypefnx {Function File} {} arrayfun (@dots{}, \"ErrorHandler\", @var{errfunc})\n\nExecute a function on each element of an array.\n\nThis is useful for functions that do not accept array arguments.  If the\nfunction does accept array arguments it is better to call the function\ndirectly.\n\nThe first input argument @var{func} can be a string, a function\nhandle, an inline function, or an anonymous function.  The input\nargument @var{A} can be a logic array, a numeric array, a string\narray, a structure array, or a cell array.  By a call of the function\n@command{arrayfun} all elements of @var{A} are passed on to the named\nfunction @var{func} individually.\n\nThe named function can also take more than two input arguments, with\nthe input arguments given as third input argument @var{b}, fourth\ninput argument @var{c}, @dots{}  If given more than one array input\nargument then all input arguments must have the same sizes, for\nexample:\n\n@example\n@group\narrayfun (@@atan2, [1, 0], [0, 1])\n     @result{} [ 1.5708   0.0000 ]\n@end group\n@end example\n\nIf the parameter @var{val} after a further string input argument\n@qcode{\"UniformOutput\"} is set @code{true} (the default), then the named\nfunction @var{func} must return a single element which then will be\nconcatenated into the return value and is of type matrix.  Otherwise,\nif that parameter is set to @code{false}, then the outputs are\nconcatenated in a cell array.  For example:\n\n@example\n@group\narrayfun (@@(x,y) x:y, \"abc\", \"def\", \"UniformOutput\", false)\n@result{}\n   @{\n     [1,1] = abcd\n     [1,2] = bcde\n     [1,3] = cdef\n   @}\n@end group\n@end example\n\nIf more than one output arguments are given then the named function\nmust return the number of return values that also are expected, for\nexample:\n\n@example\n@group\n[A, B, C] = arrayfun (@@find, [10; 0], \"UniformOutput\", false)\n@result{}\nA =\n@{\n   [1,1] =  1\n   [2,1] = [](0x0)\n@}\nB =\n@{\n   [1,1] =  1\n   [2,1] = [](0x0)\n@}\nC =\n@{\n   [1,1] =  10\n   [2,1] = [](0x0)\n@}\n@end group\n@end example\n\nIf the parameter @var{errfunc} after a further string input argument\n@qcode{\"ErrorHandler\"} is another string, a function handle, an inline\nfunction, or an anonymous function, then @var{errfunc} defines a\nfunction to call in the case that @var{func} generates an error.\nThe definition of the function must be of the form\n\n@example\nfunction [@dots{}] = errfunc (@var{s}, @dots{})\n@end example\n\n@noindent\nwhere there is an additional input argument to @var{errfunc}\nrelative to @var{func}, given by @var{s}.  This is a structure with\nthe elements @qcode{\"identifier\"}, @qcode{\"message\"}, and\n@qcode{\"index\"} giving, respectively, the error identifier, the error\nmessage, and the index of the array elements that caused the error.  The\nsize of the output argument of @var{errfunc} must have the same size as the\noutput argument of @var{func}, otherwise a real error is thrown.  For\nexample:\n\n@example\n@group\nfunction y = ferr (s, x), y = \"MyString\"; endfunction\narrayfun (@@str2num, [1234],\n          \"UniformOutput\", false, \"ErrorHandler\", @@ferr)\n@result{}\n   @{\n     [1,1] = MyString\n   @}\n@end group\n@end example\n\n@seealso{spfun, cellfun, structfun}\n@end deftypefn") 
 XDEFUN_INTERNAL (num2cell, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{C} =} num2cell (@var{A})\n@deftypefnx {Built-in Function} {@var{C} =} num2cell (@var{A}, @var{dim})\nConvert the numeric matrix @var{A} to a cell array.\n\nIf @var{dim} is defined, the value @var{C} is of dimension 1 in this\ndimension and the elements of @var{A} are placed into @var{C} in slices.\nFor example:\n\n@example\n@group\nnum2cell ([1,2;3,4])\n   @result{}\n      @{\n        [1,1] =  1\n        [2,1] =  3\n        [1,2] =  2\n        [2,2] =  4\n      @}\nnum2cell ([1,2;3,4],1)\n   @result{}\n      @{\n        [1,1] =\n           1\n           3\n        [1,2] =\n           2\n           4\n      @}\n@end group\n@end example\n\n@seealso{mat2cell}\n@end deftypefn") 
 XDEFUN_INTERNAL (mat2cell, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{C} =} mat2cell (@var{A}, @var{m}, @var{n})\n@deftypefnx {Built-in Function} {@var{C} =} mat2cell (@var{A}, @var{d1}, @var{d2}, @dots{})\n@deftypefnx {Built-in Function} {@var{C} =} mat2cell (@var{A}, @var{r})\nConvert the matrix @var{A} to a cell array.\n\nIf @var{A} is 2-D, then it is required that\n@code{sum (@var{m}) == size (@var{A}, 1)} and\n@code{sum (@var{n}) == size (@var{A}, 2)}.  Similarly, if @var{A} is\nmulti-dimensional and the number of dimensional arguments is equal to the\ndimensions of @var{A}, then it is required that\n@code{sum (@var{di}) == size (@var{A}, i)}.\n\nGiven a single dimensional argument @var{r}, the other dimensional\narguments are assumed to equal @code{size (@var{A},@var{i})}.\n\nAn example of the use of mat2cell is\n\n@example\nmat2cell (reshape (1:16,4,4), [3,1], [3,1])\n@result{}\n@{\n   [1,1] =\n\n      1   5   9\n      2   6  10\n      3   7  11\n\n   [2,1] =\n\n      4   8  12\n\n   [1,2] =\n\n     13\n     14\n     15\n\n   [2,2] = 16\n@}\n@end example\n@seealso{num2cell, cell2mat}\n@end deftypefn") 
 XDEFUN_INTERNAL (cellslices, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{sl} =} cellslices (@var{x}, @var{lb}, @var{ub}, @var{dim})\nGiven an array @var{x}, this function produces a cell array of slices from\nthe array determined by the index vectors @var{lb}, @var{ub}, for lower and\nupper bounds, respectively.\n\nIn other words, it is equivalent to the following code:\n\n@example\n@group\nn = length (lb);\nsl = cell (1, n);\nfor i = 1:length (lb)\n  sl@{i@} = x(:,@dots{},lb(i):ub(i),@dots{},:);\nendfor\n@end group\n@end example\n\nThe position of the index is determined by @var{dim}.  If not specified,\nslicing is done along the first non-singleton dimension.\n@seealso{cell2mat, cellindexmat, cellfun}\n@end deftypefn") 
 XDEFUN_INTERNAL (cellindexmat, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{y} =} cellindexmat (@var{x}, @var{varargin})\nPerform indexing of matrices in a cell array.\n\nGiven a cell array of matrices @var{x}, this function computes\n\n@example\n@group\nY = cell (size (X));\nfor i = 1:numel (X)\n  Y@{i@} = X@{i@}(varargin@{:@});\nendfor\n@end group\n@end example\n@seealso{cellslices, cellfun}\n@end deftypefn") 
}

static void
install_colloc_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/colloc.cc")
 XDEFUN_INTERNAL (colloc, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{r}, @var{amat}, @var{bmat}, @var{q}] =} colloc (@var{n}, \"left\", \"right\")\nCompute derivative and integral weight matrices for orthogonal collocation.\n\nReference: @nospell{J. Villadsen}, @nospell{M. L. Michelsen},\n@cite{Solution of Differential Equation Models by Polynomial Approximation}.\n@end deftypefn") 
}

static void
install_conv2_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/conv2.cc")
 XDEFUN_INTERNAL (conv2, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} conv2 (@var{A}, @var{B})\n@deftypefnx {Built-in Function} {} conv2 (@var{v1}, @var{v2}, @var{m})\n@deftypefnx {Built-in Function} {} conv2 (@dots{}, @var{shape})\nReturn the 2-D convolution of @var{A} and @var{B}.\n\nThe size of the result is determined by the optional @var{shape} argument\nwhich takes the following values\n\n@table @asis\n@item @var{shape} = @qcode{\"full\"}\nReturn the full convolution.  (default)\n\n@item @var{shape} = @qcode{\"same\"}\nReturn the central part of the convolution with the same size as @var{A}.\nThe central part of the convolution begins at the indices\n@code{floor ([size(@var{B})/2] + 1)}.\n\n@item @var{shape} = @qcode{\"valid\"}\nReturn only the parts which do not include zero-padded edges.\nThe size of the result is @code{max (size (A) - size (B) + 1, 0)}.\n@end table\n\nWhen the third argument is a matrix, return the convolution of the matrix\n@var{m} by the vector @var{v1} in the column direction and by the vector\n@var{v2} in the row direction.\n@seealso{conv, convn}\n@end deftypefn") 
 XDEFUN_INTERNAL (convn, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{C} =} convn (@var{A}, @var{B})\n@deftypefnx {Built-in Function} {@var{C} =} convn (@var{A}, @var{B}, @var{shape})\nReturn the n-D convolution of @var{A} and @var{B}.\n\nThe size of the result is determined by the optional @var{shape} argument\nwhich takes the following values\n\n@table @asis\n@item @var{shape} = @qcode{\"full\"}\nReturn the full convolution.  (default)\n\n@item @var{shape} = @qcode{\"same\"}\nReturn central part of the convolution with the same size as @var{A}.\nThe central part of the convolution begins at the indices\n@code{floor ([size(@var{B})/2] + 1)}.\n\n@item @var{shape} = @qcode{\"valid\"}\nReturn only the parts which do not include zero-padded edges.\nThe size of the result is @code{max (size (A) - size (B) + 1, 0)}.\n@end table\n\n@seealso{conv2, conv}\n@end deftypefn") 
}

static void
install_daspk_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/daspk.cc")
 XDEFUN_INTERNAL (daspk_options, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} daspk_options ()\n@deftypefnx {Built-in Function} {val =} daspk_options (@var{opt})\n@deftypefnx {Built-in Function} {} daspk_options (@var{opt}, @var{val})\nQuery or set options for the function @code{daspk}.\n\nWhen called with no arguments, the names of all available options and\ntheir current values are displayed.\n\nGiven one argument, return the value of the option @var{opt}.\n\nWhen called with two arguments, @code{daspk_options} sets the option\n@var{opt} to value @var{val}.\n\nOptions include\n\n@table @code\n@item @qcode{\"absolute tolerance\"}\nAbsolute tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector, and the relative\ntolerance must also be a vector of the same length.\n\n@item @qcode{\"relative tolerance\"}\nRelative tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector, and the absolute\ntolerance must also be a vector of the same length.\n\nThe local error test applied at each integration step is\n\n@example\n@group\n  abs (local error in x(i))\n       <= rtol(i) * abs (Y(i)) + atol(i)\n@end group\n@end example\n\n@item @qcode{\"compute consistent initial condition\"}\nDenoting the differential variables in the state vector by @samp{Y_d}\nand the algebraic variables by @samp{Y_a}, @code{ddaspk} can solve\none of two initialization problems:\n\n@enumerate\n@item Given Y_d, calculate Y_a and Y'_d\n\n@item Given Y', calculate Y.\n@end enumerate\n\nIn either case, initial values for the given components are input, and\ninitial guesses for the unknown components must also be provided as\ninput.  Set this option to 1 to solve the first problem, or 2 to solve\nthe second (the default is 0, so you must provide a set of\ninitial conditions that are consistent).\n\nIf this option is set to a nonzero value, you must also set the\n@qcode{\"algebraic variables\"} option to declare which variables in the\nproblem are algebraic.\n\n@item @qcode{\"use initial condition heuristics\"}\nSet to a nonzero value to use the initial condition heuristics options\ndescribed below.\n\n@item @qcode{\"initial condition heuristics\"}\nA vector of the following parameters that can be used to control the\ninitial condition calculation.\n\n@table @code\n@item MXNIT\nMaximum number of Newton iterations (default is 5).\n\n@item MXNJ\nMaximum number of Jacobian evaluations (default is 6).\n\n@item MXNH\nMaximum number of values of the artificial stepsize parameter to be\ntried if the @qcode{\"compute consistent initial condition\"} option has\nbeen set to 1 (default is 5).\n\nNote that the maximum total number of Newton iterations allowed is\n@code{MXNIT*MXNJ*MXNH} if the @qcode{\"compute consistent initial\ncondition\"} option has been set to 1 and @code{MXNIT*MXNJ} if it is\nset to 2.\n\n@item LSOFF\nSet to a nonzero value to disable the linesearch algorithm (default is\n0).\n\n@item STPTOL\nMinimum scaled step in linesearch algorithm (default is eps^(2/3)).\n\n@item EPINIT\nSwing factor in the Newton iteration convergence test.  The test is\napplied to the residual vector, premultiplied by the approximate\nJacobian.  For convergence, the weighted RMS norm of this vector\n(scaled by the error weights) must be less than @code{EPINIT*EPCON},\nwhere @code{EPCON} = 0.33 is the analogous test constant used in the\ntime steps.  The default is @code{EPINIT} = 0.01.\n@end table\n\n@item @qcode{\"print initial condition info\"}\nSet this option to a nonzero value to display detailed information\nabout the initial condition calculation (default is 0).\n\n@item @qcode{\"exclude algebraic variables from error test\"}\nSet to a nonzero value to exclude algebraic variables from the error\ntest.  You must also set the @qcode{\"algebraic variables\"} option to\ndeclare which variables in the problem are algebraic (default is 0).\n\n@item @qcode{\"algebraic variables\"}\nA vector of the same length as the state vector.  A nonzero element\nindicates that the corresponding element of the state vector is an\nalgebraic variable (i.e., its derivative does not appear explicitly\nin the equation set).\n\nThis option is required by the\n@qcode{\"compute consistent initial condition\"} and\n@qcode{\"exclude algebraic variables from error test\"} options.\n\n@item @qcode{\"enforce inequality constraints\"}\nSet to one of the following values to enforce the inequality\nconstraints specified by the @qcode{\"inequality constraint types\"}\noption (default is 0).\n\n@enumerate\n@item To have constraint checking only in the initial condition calculation.\n\n@item To enforce constraint checking during the integration.\n\n@item To enforce both options 1 and 2.\n@end enumerate\n\n@item @qcode{\"inequality constraint types\"}\nA vector of the same length as the state specifying the type of\ninequality constraint.  Each element of the vector corresponds to an\nelement of the state and should be assigned one of the following\ncodes\n\n@table @asis\n@item -2\nLess than zero.\n\n@item -1\nLess than or equal to zero.\n\n@item 0\nNot constrained.\n\n@item 1\nGreater than or equal to zero.\n\n@item 2\nGreater than zero.\n@end table\n\nThis option only has an effect if the\n@qcode{\"enforce inequality constraints\"} option is nonzero.\n\n@item @qcode{\"initial step size\"}\nDifferential-algebraic problems may occasionally suffer from severe\nscaling difficulties on the first step.  If you know a great deal\nabout the scaling of your problem, you can help to alleviate this\nproblem by specifying an initial stepsize (default is computed\nautomatically).\n\n@item @qcode{\"maximum order\"}\nRestrict the maximum order of the solution method.  This option must\nbe between 1 and 5, inclusive (default is 5).\n\n@item @qcode{\"maximum step size\"}\nSetting the maximum stepsize will avoid passing over very large\nregions (default is not specified).\n@end table\n@end deftypefn") 
 XDEFUN_INTERNAL (daspk, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{x}, @var{xdot}, @var{istate}, @var{msg}] =} daspk (@var{fcn}, @var{x_0}, @var{xdot_0}, @var{t}, @var{t_crit})\nSolve the set of differential-algebraic equations\n@tex\n$$ 0 = f (x, \\dot{x}, t) $$\nwith\n$$ x(t_0) = x_0, \\dot{x}(t_0) = \\dot{x}_0 $$\n@end tex\n@ifnottex\n\n@example\n0 = f (x, xdot, t)\n@end example\n\n@noindent\nwith\n\n@example\nx(t_0) = x_0, xdot(t_0) = xdot_0\n@end example\n\n@end ifnottex\nThe solution is returned in the matrices @var{x} and @var{xdot},\nwith each row in the result matrices corresponding to one of the\nelements in the vector @var{t}.  The first element of @var{t}\nshould be @math{t_0} and correspond to the initial state of the\nsystem @var{x_0} and its derivative @var{xdot_0}, so that the first\nrow of the output @var{x} is @var{x_0} and the first row\nof the output @var{xdot} is @var{xdot_0}.\n\nThe first argument, @var{fcn}, is a string, inline, or function handle\nthat names the function @math{f} to call to compute the vector of\nresiduals for the set of equations.  It must have the form\n\n@example\n@var{res} = f (@var{x}, @var{xdot}, @var{t})\n@end example\n\n@noindent\nin which @var{x}, @var{xdot}, and @var{res} are vectors, and @var{t} is a\nscalar.\n\nIf @var{fcn} is a two-element string array or a two-element cell array\nof strings, inline functions, or function handles, the first element names\nthe function @math{f} described above, and the second element names a\nfunction to compute the modified Jacobian\n@tex\n$$\nJ = {\\partial f \\over \\partial x}\n  + c {\\partial f \\over \\partial \\dot{x}}\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n      df       df\njac = -- + c ------\n      dx     d xdot\n@end group\n@end example\n\n@end ifnottex\n\nThe modified Jacobian function must have the form\n\n@example\n@group\n\n@var{jac} = j (@var{x}, @var{xdot}, @var{t}, @var{c})\n\n@end group\n@end example\n\nThe second and third arguments to @code{daspk} specify the initial\ncondition of the states and their derivatives, and the fourth argument\nspecifies a vector of output times at which the solution is desired,\nincluding the time corresponding to the initial condition.\n\nThe set of initial states and derivatives are not strictly required to\nbe consistent.  If they are not consistent, you must use the\n@code{daspk_options} function to provide additional information so\nthat @code{daspk} can compute a consistent starting point.\n\nThe fifth argument is optional, and may be used to specify a set of\ntimes that the DAE solver should not integrate past.  It is useful for\navoiding difficulties with singularities and points where there is a\ndiscontinuity in the derivative.\n\nAfter a successful computation, the value of @var{istate} will be\ngreater than zero (consistent with the Fortran version of @sc{daspk}).\n\nIf the computation is not successful, the value of @var{istate} will be\nless than zero and @var{msg} will contain additional information.\n\nYou can use the function @code{daspk_options} to set optional\nparameters for @code{daspk}.\n@seealso{dassl}\n@end deftypefn") 
}

static void
install_dasrt_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/dasrt.cc")
 XDEFUN_INTERNAL (dasrt_options, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} dasrt_options ()\n@deftypefnx {Built-in Function} {val =} dasrt_options (@var{opt})\n@deftypefnx {Built-in Function} {} dasrt_options (@var{opt}, @var{val})\nQuery or set options for the function @code{dasrt}.\n\nWhen called with no arguments, the names of all available options and\ntheir current values are displayed.\n\nGiven one argument, return the value of the option @var{opt}.\n\nWhen called with two arguments, @code{dasrt_options} sets the option\n@var{opt} to value @var{val}.\n\nOptions include\n\n@table @code\n@item @qcode{\"absolute tolerance\"}\nAbsolute tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector, and the relative\ntolerance must also be a vector of the same length.\n\n@item @qcode{\"relative tolerance\"}\nRelative tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector, and the absolute\ntolerance must also be a vector of the same length.\n\nThe local error test applied at each integration step is\n\n@example\n@group\n  abs (local error in x(i)) <= ...\n      rtol(i) * abs (Y(i)) + atol(i)\n@end group\n@end example\n\n@item @qcode{\"initial step size\"}\nDifferential-algebraic problems may occasionally suffer from severe\nscaling difficulties on the first step.  If you know a great deal\nabout the scaling of your problem, you can help to alleviate this\nproblem by specifying an initial stepsize.\n\n@item @qcode{\"maximum order\"}\nRestrict the maximum order of the solution method.  This option must\nbe between 1 and 5, inclusive.\n\n@item @qcode{\"maximum step size\"}\nSetting the maximum stepsize will avoid passing over very large\nregions.\n\n@item @qcode{\"step limit\"}\nMaximum number of integration steps to attempt on a single call to the\nunderlying Fortran code.\n@end table\n@end deftypefn") 
 XDEFUN_INTERNAL (dasrt, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{x}, @var{xdot}, @var{t_out}, @var{istat}, @var{msg}] =} dasrt (@var{fcn}, [], @var{x_0}, @var{xdot_0}, @var{t})\n@deftypefnx {Built-in Function} {@dots{} =} dasrt (@var{fcn}, @var{g}, @var{x_0}, @var{xdot_0}, @var{t})\n@deftypefnx {Built-in Function} {@dots{} =} dasrt (@var{fcn}, [], @var{x_0}, @var{xdot_0}, @var{t}, @var{t_crit})\n@deftypefnx {Built-in Function} {@dots{} =} dasrt (@var{fcn}, @var{g}, @var{x_0}, @var{xdot_0}, @var{t}, @var{t_crit})\nSolve the set of differential-algebraic equations\n@tex\n$$ 0 = f (x, \\dot{x}, t) $$\nwith\n$$ x(t_0) = x_0, \\dot{x}(t_0) = \\dot{x}_0 $$\n@end tex\n@ifnottex\n\n@example\n0 = f (x, xdot, t)\n@end example\n\n@noindent\nwith\n\n@example\nx(t_0) = x_0, xdot(t_0) = xdot_0\n@end example\n\n@end ifnottex\nwith functional stopping criteria (root solving).\n\nThe solution is returned in the matrices @var{x} and @var{xdot},\nwith each row in the result matrices corresponding to one of the\nelements in the vector @var{t_out}.  The first element of @var{t}\nshould be @math{t_0} and correspond to the initial state of the\nsystem @var{x_0} and its derivative @var{xdot_0}, so that the first\nrow of the output @var{x} is @var{x_0} and the first row\nof the output @var{xdot} is @var{xdot_0}.\n\nThe vector @var{t} provides an upper limit on the length of the\nintegration.  If the stopping condition is met, the vector\n@var{t_out} will be shorter than @var{t}, and the final element of\n@var{t_out} will be the point at which the stopping condition was met,\nand may not correspond to any element of the vector @var{t}.\n\nThe first argument, @var{fcn}, is a string, inline, or function handle\nthat names the function @math{f} to call to compute the vector of\nresiduals for the set of equations.  It must have the form\n\n@example\n@var{res} = f (@var{x}, @var{xdot}, @var{t})\n@end example\n\n@noindent\nin which @var{x}, @var{xdot}, and @var{res} are vectors, and @var{t} is a\nscalar.\n\nIf @var{fcn} is a two-element string array or a two-element cell array\nof strings, inline functions, or function handles, the first element names\nthe function @math{f} described above, and the second element names a\nfunction to compute the modified Jacobian\n\n@tex\n$$\nJ = {\\partial f \\over \\partial x}\n  + c {\\partial f \\over \\partial \\dot{x}}\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n      df       df\njac = -- + c ------\n      dx     d xdot\n@end group\n@end example\n\n@end ifnottex\n\nThe modified Jacobian function must have the form\n\n@example\n@group\n\n@var{jac} = j (@var{x}, @var{xdot}, @var{t}, @var{c})\n\n@end group\n@end example\n\nThe optional second argument names a function that defines the\nconstraint functions whose roots are desired during the integration.\nThis function must have the form\n\n@example\n@var{g_out} = g (@var{x}, @var{t})\n@end example\n\n@noindent\nand return a vector of the constraint function values.\nIf the value of any of the constraint functions changes sign, @sc{dasrt}\nwill attempt to stop the integration at the point of the sign change.\n\nIf the name of the constraint function is omitted, @code{dasrt} solves\nthe same problem as @code{daspk} or @code{dassl}.\n\nNote that because of numerical errors in the constraint functions\ndue to round-off and integration error, @sc{dasrt} may return false\nroots, or return the same root at two or more nearly equal values of\n@var{T}.  If such false roots are suspected, the user should consider\nsmaller error tolerances or higher precision in the evaluation of the\nconstraint functions.\n\nIf a root of some constraint function defines the end of the problem,\nthe input to @sc{dasrt} should nevertheless allow integration to a\npoint slightly past that root, so that @sc{dasrt} can locate the root\nby interpolation.\n\nThe third and fourth arguments to @code{dasrt} specify the initial\ncondition of the states and their derivatives, and the fourth argument\nspecifies a vector of output times at which the solution is desired,\nincluding the time corresponding to the initial condition.\n\nThe set of initial states and derivatives are not strictly required to\nbe consistent.  In practice, however, @sc{dassl} is not very good at\ndetermining a consistent set for you, so it is best if you ensure that\nthe initial values result in the function evaluating to zero.\n\nThe sixth argument is optional, and may be used to specify a set of\ntimes that the DAE solver should not integrate past.  It is useful for\navoiding difficulties with singularities and points where there is a\ndiscontinuity in the derivative.\n\nAfter a successful computation, the value of @var{istate} will be\ngreater than zero (consistent with the Fortran version of @sc{dassl}).\n\nIf the computation is not successful, the value of @var{istate} will be\nless than zero and @var{msg} will contain additional information.\n\nYou can use the function @code{dasrt_options} to set optional\nparameters for @code{dasrt}.\n@seealso{dasrt_options, daspk, dasrt, lsode}\n@end deftypefn") 
}

static void
install_dassl_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/dassl.cc")
 XDEFUN_INTERNAL (dassl_options, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} dassl_options ()\n@deftypefnx {Built-in Function} {val =} dassl_options (@var{opt})\n@deftypefnx {Built-in Function} {} dassl_options (@var{opt}, @var{val})\nQuery or set options for the function @code{dassl}.\n\nWhen called with no arguments, the names of all available options and\ntheir current values are displayed.\n\nGiven one argument, return the value of the option @var{opt}.\n\nWhen called with two arguments, @code{dassl_options} sets the option\n@var{opt} to value @var{val}.\n\nOptions include\n\n@table @code\n@item @qcode{\"absolute tolerance\"}\nAbsolute tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector, and the relative\ntolerance must also be a vector of the same length.\n\n@item @qcode{\"relative tolerance\"}\nRelative tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector, and the absolute\ntolerance must also be a vector of the same length.\n\nThe local error test applied at each integration step is\n\n@example\n@group\n  abs (local error in x(i))\n       <= rtol(i) * abs (Y(i)) + atol(i)\n@end group\n@end example\n\n@item @qcode{\"compute consistent initial condition\"}\nIf nonzero, @code{dassl} will attempt to compute a consistent set of initial\nconditions.  This is generally not reliable, so it is best to provide\na consistent set and leave this option set to zero.\n\n@item @qcode{\"enforce nonnegativity constraints\"}\nIf you know that the solutions to your equations will always be\nnon-negative, it may help to set this parameter to a nonzero\nvalue.  However, it is probably best to try leaving this option set to\nzero first, and only setting it to a nonzero value if that doesn't\nwork very well.\n\n@item @qcode{\"initial step size\"}\nDifferential-algebraic problems may occasionally suffer from severe\nscaling difficulties on the first step.  If you know a great deal\nabout the scaling of your problem, you can help to alleviate this\nproblem by specifying an initial stepsize.\n\n@item @qcode{\"maximum order\"}\nRestrict the maximum order of the solution method.  This option must\nbe between 1 and 5, inclusive.\n\n@item @qcode{\"maximum step size\"}\nSetting the maximum stepsize will avoid passing over very large\nregions  (default is not specified).\n\n@item @qcode{\"step limit\"}\nMaximum number of integration steps to attempt on a single call to the\nunderlying Fortran code.\n@end table\n@end deftypefn") 
 XDEFUN_INTERNAL (dassl, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{x}, @var{xdot}, @var{istate}, @var{msg}] =} dassl (@var{fcn}, @var{x_0}, @var{xdot_0}, @var{t}, @var{t_crit})\nSolve the set of differential-algebraic equations\n@tex\n$$ 0 = f (x, \\dot{x}, t) $$\nwith\n$$ x(t_0) = x_0, \\dot{x}(t_0) = \\dot{x}_0 $$\n@end tex\n@ifnottex\n\n@example\n0 = f (x, xdot, t)\n@end example\n\n@noindent\nwith\n\n@example\nx(t_0) = x_0, xdot(t_0) = xdot_0\n@end example\n\n@end ifnottex\nThe solution is returned in the matrices @var{x} and @var{xdot},\nwith each row in the result matrices corresponding to one of the\nelements in the vector @var{t}.  The first element of @var{t}\nshould be @math{t_0} and correspond to the initial state of the\nsystem @var{x_0} and its derivative @var{xdot_0}, so that the first\nrow of the output @var{x} is @var{x_0} and the first row\nof the output @var{xdot} is @var{xdot_0}.\n\nThe first argument, @var{fcn}, is a string, inline, or function handle\nthat names the function @math{f} to call to compute the vector of\nresiduals for the set of equations.  It must have the form\n\n@example\n@var{res} = f (@var{x}, @var{xdot}, @var{t})\n@end example\n\n@noindent\nin which @var{x}, @var{xdot}, and @var{res} are vectors, and @var{t} is a\nscalar.\n\nIf @var{fcn} is a two-element string array or a two-element cell array\nof strings, inline functions, or function handles, the first element names\nthe function @math{f} described above, and the second element names a\nfunction to compute the modified Jacobian\n\n@tex\n$$\nJ = {\\partial f \\over \\partial x}\n  + c {\\partial f \\over \\partial \\dot{x}}\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n      df       df\njac = -- + c ------\n      dx     d xdot\n@end group\n@end example\n\n@end ifnottex\n\nThe modified Jacobian function must have the form\n\n@example\n@group\n\n@var{jac} = j (@var{x}, @var{xdot}, @var{t}, @var{c})\n\n@end group\n@end example\n\nThe second and third arguments to @code{dassl} specify the initial\ncondition of the states and their derivatives, and the fourth argument\nspecifies a vector of output times at which the solution is desired,\nincluding the time corresponding to the initial condition.\n\nThe set of initial states and derivatives are not strictly required to\nbe consistent.  In practice, however, @sc{dassl} is not very good at\ndetermining a consistent set for you, so it is best if you ensure that\nthe initial values result in the function evaluating to zero.\n\nThe fifth argument is optional, and may be used to specify a set of\ntimes that the DAE solver should not integrate past.  It is useful for\navoiding difficulties with singularities and points where there is a\ndiscontinuity in the derivative.\n\nAfter a successful computation, the value of @var{istate} will be\ngreater than zero (consistent with the Fortran version of @sc{dassl}).\n\nIf the computation is not successful, the value of @var{istate} will be\nless than zero and @var{msg} will contain additional information.\n\nYou can use the function @code{dassl_options} to set optional\nparameters for @code{dassl}.\n@seealso{daspk, dasrt, lsode}\n@end deftypefn") 
}

static void
install_data_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/data.cc")
 XDEFUN_INTERNAL (all, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} all (@var{x})\n@deftypefnx {Built-in Function} {} all (@var{x}, @var{dim})\nFor a vector argument, return true (logical 1) if all elements of the vector\nare nonzero.\n\nFor a matrix argument, return a row vector of logical ones and\nzeros with each element indicating whether all of the elements of the\ncorresponding column of the matrix are nonzero.  For example:\n\n@example\n@group\nall ([2, 3; 1, 0])\n    @result{} [ 1, 0 ]\n@end group\n@end example\n\nIf the optional argument @var{dim} is supplied, work along dimension\n@var{dim}.\n@seealso{any}\n@end deftypefn") 
 XDEFUN_INTERNAL (any, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} any (@var{x})\n@deftypefnx {Built-in Function} {} any (@var{x}, @var{dim})\nFor a vector argument, return true (logical 1) if any element of the vector\nis nonzero.\n\nFor a matrix argument, return a row vector of logical ones and\nzeros with each element indicating whether any of the elements of the\ncorresponding column of the matrix are nonzero.  For example:\n\n@example\n@group\nany (eye (2, 4))\n @result{} [ 1, 1, 0, 0 ]\n@end group\n@end example\n\nIf the optional argument @var{dim} is supplied, work along dimension\n@var{dim}.  For example:\n\n@example\n@group\nany (eye (2, 4), 2)\n @result{} [ 1; 1 ]\n@end group\n@end example\n@seealso{all}\n@end deftypefn") 
 XDEFUN_INTERNAL (atan2, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} atan2 (@var{y}, @var{x})\nCompute atan (@var{y} / @var{x}) for corresponding elements of @var{y}\nand @var{x}.\n\n@var{y} and @var{x} must match in size and orientation.\n@seealso{tan, tand, tanh, atanh}\n@end deftypefn") 
 XDEFUN_INTERNAL (hypot, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} hypot (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {} hypot (@var{x}, @var{y}, @var{z}, @dots{})\nCompute the element-by-element square root of the sum of the squares of\n@var{x} and @var{y}.\n\nThis is equivalent to\n@code{sqrt (@var{x}.^2 + @var{y}.^2)}, but is calculated in a manner that\navoids overflows for large values of @var{x} or @var{y}.\n\n@code{hypot} can also be called with more than 2 arguments; in this case,\nthe arguments are accumulated from left to right:\n\n@example\n@group\nhypot (hypot (@var{x}, @var{y}), @var{z})\nhypot (hypot (hypot (@var{x}, @var{y}), @var{z}), @var{w}), etc.\n@end group\n@end example\n@end deftypefn") 
 XDEFUN_INTERNAL (log2, args, nargout, "-*- texinfo -*-\n@deftypefn  {Mapping Function} {} log2 (@var{x})\n@deftypefnx {Mapping Function} {[@var{f}, @var{e}] =} log2 (@var{x})\nCompute the base-2 logarithm of each element of @var{x}.\n\nIf called with two output arguments, split @var{x} into\nbinary mantissa and exponent so that\n@tex\n${1 \\over 2} \\le \\left| f \\right| < 1$\n@end tex\n@ifnottex\n@code{1/2 <= abs(f) < 1}\n@end ifnottex\nand @var{e} is an integer.  If\n@tex\n$x = 0$, $f = e = 0$.\n@end tex\n@ifnottex\n@code{x = 0}, @code{f = e = 0}.\n@end ifnottex\n@seealso{pow2, log, log10, exp}\n@end deftypefn") 
 XDEFUN_INTERNAL (rem, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} rem (@var{x}, @var{y})\nReturn the remainder of the division @code{@var{x} / @var{y}}.\n\nThe remainder is computed using the expression\n\n@example\nx - y .* fix (x ./ y)\n@end example\n\nAn error message is printed if the dimensions of the arguments do not agree,\nor if either of the arguments is complex.\n@seealso{mod}\n@end deftypefn") 
 XDEFUN_INTERNAL (mod, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} mod (@var{x}, @var{y})\nCompute the modulo of @var{x} and @var{y}.\n\nConceptually this is given by\n\n@example\nx - y .* floor (x ./ y)\n@end example\n\n@noindent\nand is written such that the correct modulus is returned for integer types.\nThis function handles negative values correctly.  That is,\n@code{mod (-1, 3)} is 2, not -1, as @code{rem (-1, 3)} returns.\n@code{mod (@var{x}, 0)} returns @var{x}.\n\nAn error results if the dimensions of the arguments do not agree, or if\neither of the arguments is complex.\n@seealso{rem}\n@end deftypefn") 
 XDEFUN_INTERNAL (cumprod, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cumprod (@var{x})\n@deftypefnx {Built-in Function} {} cumprod (@var{x}, @var{dim})\nCumulative product of elements along dimension @var{dim}.\n\nIf @var{dim} is omitted, it defaults to the first non-singleton dimension.\n@seealso{prod, cumsum}\n@end deftypefn") 
 XDEFUN_INTERNAL (cumsum, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cumsum (@var{x})\n@deftypefnx {Built-in Function} {} cumsum (@var{x}, @var{dim})\n@deftypefnx {Built-in Function} {} cumsum (@dots{}, \"native\")\n@deftypefnx {Built-in Function} {} cumsum (@dots{}, \"double\")\n@deftypefnx {Built-in Function} {} cumsum (@dots{}, \"extra\")\nCumulative sum of elements along dimension @var{dim}.\n\nIf @var{dim} is omitted, it defaults to the first non-singleton dimension.\n\nSee @code{sum} for an explanation of the optional parameters\n@qcode{\"native\"}, @qcode{\"double\"}, and @qcode{\"extra\"}.\n@seealso{sum, cumprod}\n@end deftypefn") 
 XDEFUN_INTERNAL (diag, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{M} =} diag (@var{v})\n@deftypefnx {Built-in Function} {@var{M} =} diag (@var{v}, @var{k})\n@deftypefnx {Built-in Function} {@var{M} =} diag (@var{v}, @var{m}, @var{n})\n@deftypefnx {Built-in Function} {@var{v} =} diag (@var{M})\n@deftypefnx {Built-in Function} {@var{v} =} diag (@var{M}, @var{k})\nReturn a diagonal matrix with vector @var{v} on diagonal @var{k}.\n\nThe second argument is optional.  If it is positive, the vector is placed on\nthe @var{k}-th superdiagonal.  If it is negative, it is placed on the\n@var{-k}-th subdiagonal.  The default value of @var{k} is 0, and the vector\nis placed on the main diagonal.  For example:\n\n@example\n@group\ndiag ([1, 2, 3], 1)\n   @result{}  0  1  0  0\n       0  0  2  0\n       0  0  0  3\n       0  0  0  0\n@end group\n@end example\n\n@noindent\nThe 3-input form returns a diagonal matrix with vector @var{v} on the main\ndiagonal and the resulting matrix being of size @var{m} rows x @var{n}\ncolumns.\n\nGiven a matrix argument, instead of a vector, @code{diag} extracts the\n@var{k}-th diagonal of the matrix.\n@end deftypefn") 
 XDEFUN_INTERNAL (prod, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} prod (@var{x})\n@deftypefnx {Built-in Function} {} prod (@var{x}, @var{dim})\n@deftypefnx {Built-in Function} {} prod (@dots{}, \"native\")\n@deftypefnx {Built-in Function} {} prod (@dots{}, \"double\")\nProduct of elements along dimension @var{dim}.\n\nIf @var{dim} is omitted, it defaults to the first non-singleton dimension.\n\nThe optional @qcode{\"type\"} input determines the class of the variable\nused for calculations.  If the argument @qcode{\"native\"} is given, then\nthe operation is performed in the same type as the original argument, rather\nthan the default double type.\n\nFor example:\n\n@example\n@group\nprod ([true, true])\n   @result{} 1\nprod ([true, true], \"native\")\n   @result{} true\n@end group\n@end example\n\nOn the contrary, if @qcode{\"double\"} is given, the operation is performed\nin double precision even for single precision inputs.\n@seealso{cumprod, sum}\n@end deftypefn") 
 XDEFUN_INTERNAL (horzcat, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} horzcat (@var{array1}, @var{array2}, @dots{}, @var{arrayN})\nReturn the horizontal concatenation of N-D array objects, @var{array1},\n@var{array2}, @dots{}, @var{arrayN} along dimension 2.\n\nArrays may also be concatenated horizontally using the syntax for creating\nnew matrices.  For example:\n\n@example\n@var{hcat} = [ @var{array1}, @var{array2}, @dots{} ]\n@end example\n@seealso{cat, vertcat}\n@end deftypefn") 
 XDEFUN_INTERNAL (vertcat, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} vertcat (@var{array1}, @var{array2}, @dots{}, @var{arrayN})\nReturn the vertical concatenation of N-D array objects, @var{array1},\n@var{array2}, @dots{}, @var{arrayN} along dimension 1.\n\nArrays may also be concatenated vertically using the syntax for creating\nnew matrices.  For example:\n\n@example\n@var{vcat} = [ @var{array1}; @var{array2}; @dots{} ]\n@end example\n@seealso{cat, horzcat}\n@end deftypefn") 
 XDEFUN_INTERNAL (cat, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} cat (@var{dim}, @var{array1}, @var{array2}, @dots{}, @var{arrayN})\nReturn the concatenation of N-D array objects, @var{array1},\n@var{array2}, @dots{}, @var{arrayN} along dimension @var{dim}.\n\n@example\n@group\nA = ones (2, 2);\nB = zeros (2, 2);\ncat (2, A, B)\n  @result{} 1 1 0 0\n     1 1 0 0\n@end group\n@end example\n\nAlternatively, we can concatenate @var{A} and @var{B} along the\nsecond dimension in the following way:\n\n@example\n@group\n[A, B]\n@end group\n@end example\n\n@var{dim} can be larger than the dimensions of the N-D array objects\nand the result will thus have @var{dim} dimensions as the\nfollowing example shows:\n\n@example\n@group\ncat (4, ones (2, 2), zeros (2, 2))\n  @result{} ans(:,:,1,1) =\n\n       1 1\n       1 1\n\n     ans(:,:,1,2) =\n\n       0 0\n       0 0\n@end group\n@end example\n@seealso{horzcat, vertcat}\n@end deftypefn") 
 XDEFUN_INTERNAL (permute, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} permute (@var{A}, @var{perm})\nReturn the generalized transpose for an N-D array object @var{A}.\n\nThe permutation vector @var{perm} must contain the elements\n@code{1:ndims (A)} (in any order, but each element must appear only once).\n\nThe @var{N}th dimension of @var{A} gets remapped to dimension\n@code{@var{PERM}(@var{N})}.  For example:\n\n@example\n@group\n@var{x} = zeros ([2, 3, 5, 7]);\nsize (@var{x})\n   @result{}  2   3   5   7\n\nsize (permute (@var{x}, [2, 1, 3, 4]))\n   @result{}  3   2   5   7\n\nsize (permute (@var{x}, [1, 3, 4, 2]))\n   @result{}  2   5   7   3\n\n## The identity permutation\nsize (permute (@var{x}, [1, 2, 3, 4]))\n   @result{}  2   3   5   7\n@end group\n@end example\n@seealso{ipermute}\n@end deftypefn") 
 XDEFUN_INTERNAL (ipermute, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ipermute (@var{A}, @var{iperm})\nThe inverse of the @code{permute} function.\n\nThe expression\n\n@example\nipermute (permute (A, perm), perm)\n@end example\n\n@noindent\nreturns the original array @var{A}.\n@seealso{permute}\n@end deftypefn") 
 XDEFUN_INTERNAL (length, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} length (@var{a})\nReturn the length of the object @var{a}.\n\nThe length is 0 for empty objects, 1 for scalars, and the number of elements\nfor vectors.  For matrix objects, the length is the number of rows or\ncolumns, whichever is greater (this odd definition is used for compatibility\nwith @sc{matlab}).\n@seealso{numel, size}\n@end deftypefn") 
 XDEFUN_INTERNAL (ndims, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ndims (@var{a})\nReturn the number of dimensions of @var{a}.\n\nFor any array, the result will always be greater than or equal to 2.\nTrailing singleton dimensions are not counted.\n\n@example\n@group\nndims (ones (4, 1, 2, 1))\n    @result{} 3\n@end group\n@end example\n@seealso{size}\n@end deftypefn") 
 XDEFUN_INTERNAL (numel, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} numel (@var{a})\n@deftypefnx {Built-in Function} {} numel (@var{a}, @var{idx1}, @var{idx2}, @dots{})\nReturn the number of elements in the object @var{a}.\n\nOptionally, if indices @var{idx1}, @var{idx2}, @dots{} are supplied,\nreturn the number of elements that would result from the indexing\n\n@example\n@var{a}(@var{idx1}, @var{idx2}, @dots{})\n@end example\n\nNote that the indices do not have to be numerical.  For example,\n\n@example\n@group\n@var{a} = 1;\n@var{b} = ones (2, 3);\nnumel (@var{a}, @var{b})\n@end group\n@end example\n\n@noindent\nwill return 6, as this is the number of ways to index with @var{b}.\n\nThis method is also called when an object appears as lvalue with cs-list\nindexing, i.e., @code{object@{@dots{}@}} or @code{object(@dots{}).field}.\n@seealso{size}\n@end deftypefn") 
 XDEFUN_INTERNAL (size, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} size (@var{a})\n@deftypefnx {Built-in Function} {} size (@var{a}, @var{dim})\nReturn the number of rows and columns of @var{a}.\n\nWith one input argument and one output argument, the result is returned\nin a row vector.  If there are multiple output arguments, the number of\nrows is assigned to the first, and the number of columns to the second,\netc.  For example:\n\n@example\n@group\nsize ([1, 2; 3, 4; 5, 6])\n   @result{} [ 3, 2 ]\n\n[nr, nc] = size ([1, 2; 3, 4; 5, 6])\n    @result{} nr = 3\n    @result{} nc = 2\n@end group\n@end example\n\nIf given a second argument, @code{size} will return the size of the\ncorresponding dimension.  For example,\n\n@example\n@group\nsize ([1, 2; 3, 4; 5, 6], 2)\n    @result{} 2\n@end group\n@end example\n\n@noindent\nreturns the number of columns in the given matrix.\n@seealso{numel, ndims, length, rows, columns}\n@end deftypefn") 
 XDEFUN_INTERNAL (size_equal, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} size_equal (@var{a}, @var{b}, @dots{})\nReturn true if the dimensions of all arguments agree.\n\nTrailing singleton dimensions are ignored.\nWhen called with a single or no argument @code{size_equal} returns true.\n@seealso{size, numel, ndims}\n@end deftypefn") 
 XDEFUN_INTERNAL (nnz, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{n} =} nnz (@var{a})\nReturn the number of nonzero elements in @var{a}.\n@seealso{nzmax, nonzeros, find}\n@end deftypefn") 
 XDEFUN_INTERNAL (nzmax, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{n} =} nzmax (@var{SM})\nReturn the amount of storage allocated to the sparse matrix @var{SM}.\n\nNote that Octave tends to crop unused memory at the first opportunity\nfor sparse objects.  Thus, in general the value of @code{nzmax} will be the\nsame as @code{nnz} except for some cases of user-created sparse objects.\n@seealso{nnz, spalloc, sparse}\n@end deftypefn") 
 XDEFUN_INTERNAL (rows, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} rows (@var{a})\nReturn the number of rows of @var{a}.\n@seealso{columns, size, length, numel, isscalar, isvector, ismatrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (columns, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} columns (@var{a})\nReturn the number of columns of @var{a}.\n@seealso{rows, size, length, numel, isscalar, isvector, ismatrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (sum, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} sum (@var{x})\n@deftypefnx {Built-in Function} {} sum (@var{x}, @var{dim})\n@deftypefnx {Built-in Function} {} sum (@dots{}, \"native\")\n@deftypefnx {Built-in Function} {} sum (@dots{}, \"double\")\n@deftypefnx {Built-in Function} {} sum (@dots{}, \"extra\")\nSum of elements along dimension @var{dim}.\n\nIf @var{dim} is omitted, it defaults to the first non-singleton dimension.\n\nThe optional @qcode{\"type\"} input determines the class of the variable\nused for calculations.  If the argument @qcode{\"native\"} is given, then\nthe operation is performed in the same type as the original argument, rather\nthan the default double type.\n\nFor example:\n\n@example\n@group\nsum ([true, true])\n   @result{} 2\nsum ([true, true], \"native\")\n   @result{} true\n@end group\n@end example\n\nOn the contrary, if @qcode{\"double\"} is given, the sum is performed in\ndouble precision even for single precision inputs.\n\nFor double precision inputs, the @qcode{\"extra\"} option will use a more\naccurate algorithm than straightforward summation.  For single precision\ninputs, @qcode{\"extra\"} is the same as @qcode{\"double\"}.  Otherwise,\n@qcode{\"extra\"} has no effect.\n@seealso{cumsum, sumsq, prod}\n@end deftypefn") 
 XDEFUN_INTERNAL (sumsq, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} sumsq (@var{x})\n@deftypefnx {Built-in Function} {} sumsq (@var{x}, @var{dim})\nSum of squares of elements along dimension @var{dim}.\n\nIf @var{dim} is omitted, it defaults to the first non-singleton dimension.\n\nThis function is conceptually equivalent to computing\n\n@example\nsum (x .* conj (x), dim)\n@end example\n\n@noindent\nbut it uses less memory and avoids calling @code{conj} if @var{x} is real.\n@seealso{sum, prod}\n@end deftypefn") 
 XDEFUN_INTERNAL (islogical, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} islogical (@var{x})\n@deftypefnx {Built-in Function} {} isbool (@var{x})\nReturn true if @var{x} is a logical object.\n@seealso{isfloat, isinteger, ischar, isnumeric, isa}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(isbool, islogical) ;
 XDEFUN_INTERNAL (isinteger, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isinteger (@var{x})\nReturn true if @var{x} is an integer object (int8, uint8, int16, etc.).\n\nNote that @w{@code{isinteger (14)}} is false because numeric constants in\nOctave are double precision floating point values.\n@seealso{isfloat, ischar, islogical, isnumeric, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (iscomplex, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} iscomplex (@var{x})\nReturn true if @var{x} is a complex-valued numeric object.\n@seealso{isreal, isnumeric, islogical, ischar, isfloat, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (isfloat, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isfloat (@var{x})\nReturn true if @var{x} is a floating-point numeric object.\n\nObjects of class double or single are floating-point objects.\n@seealso{isinteger, ischar, islogical, isnumeric, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (complex, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} complex (@var{x})\n@deftypefnx {Built-in Function} {} complex (@var{re}, @var{im})\nReturn a complex value from real arguments.\n\nWith 1 real argument @var{x}, return the complex result @code{@var{x} + 0i}.\n\nWith 2 real arguments, return the complex result @code{@var{re} + @var{im}}.\n@code{complex} can often be more convenient than expressions such as\n@code{a + i*b}.\nFor example:\n\n@example\n@group\ncomplex ([1, 2], [3, 4])\n  @result{} [ 1 + 3i   2 + 4i ]\n@end group\n@end example\n@seealso{real, imag, iscomplex, abs, arg}\n@end deftypefn") 
 XDEFUN_INTERNAL (isreal, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isreal (@var{x})\nReturn true if @var{x} is a non-complex matrix or scalar.\n\nFor compatibility with @sc{matlab}, this includes logical and character\nmatrices.\n@seealso{iscomplex, isnumeric, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (isempty, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isempty (@var{a})\nReturn true if @var{a} is an empty matrix (any one of its dimensions is\nzero).\n@seealso{isnull, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (isnumeric, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isnumeric (@var{x})\nReturn true if @var{x} is a numeric object, i.e., an integer, real, or\ncomplex array.\n\nLogical and character arrays are not considered to be numeric.\n@seealso{isinteger, isfloat, isreal, iscomplex, islogical, ischar, iscell, isstruct, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (isscalar, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isscalar (@var{x})\nReturn true if @var{x} is a scalar.\n@seealso{isvector, ismatrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (isvector, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} isvector (@var{x})\nReturn true if @var{x} is a vector.\n\nA vector is a 2-D array where one of the dimensions is equal to 1.  As a\nconsequence a 1x1 array, or scalar, is also a vector.\n@seealso{isscalar, ismatrix, size, rows, columns, length}\n@end deftypefn") 
 XDEFUN_INTERNAL (isrow, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} isrow (@var{x})\nReturn true if @var{x} is a row vector 1xN with non-negative N.\n@seealso{iscolumn, isscalar, isvector, ismatrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (iscolumn, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} iscolumn (@var{x})\nReturn true if @var{x} is a column vector Nx1 with non-negative N.\n@seealso{isrow, isscalar, isvector, ismatrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (ismatrix, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ismatrix (@var{a})\nReturn true if @var{a} is a 2-D array.\n@seealso{isscalar, isvector, iscell, isstruct, issparse, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (issquare, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} issquare (@var{x})\nReturn true if @var{x} is a square matrix.\n@seealso{isscalar, isvector, ismatrix, size}\n@end deftypefn") 
 XDEFUN_INTERNAL (ones, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} ones (@var{n})\n@deftypefnx {Built-in Function} {} ones (@var{m}, @var{n})\n@deftypefnx {Built-in Function} {} ones (@var{m}, @var{n}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} ones ([@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {} ones (@dots{}, @var{class})\nReturn a matrix or N-dimensional array whose elements are all 1.\n\nIf invoked with a single scalar integer argument @var{n}, return a square\n@nospell{NxN} matrix.\n\nIf invoked with two or more scalar integer arguments, or a vector of integer\nvalues, return an array with the given dimensions.\n\nTo create a constant matrix whose values are all the same use an expression\nsuch as\n\n@example\nval_matrix = val * ones (m, n)\n@end example\n\nThe optional argument @var{class} specifies the class of the return array\nand defaults to double.  For example:\n\n@example\nval = ones (m,n, \"uint8\")\n@end example\n@seealso{zeros}\n@end deftypefn") 
 XDEFUN_INTERNAL (zeros, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} zeros (@var{n})\n@deftypefnx {Built-in Function} {} zeros (@var{m}, @var{n})\n@deftypefnx {Built-in Function} {} zeros (@var{m}, @var{n}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} zeros ([@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {} zeros (@dots{}, @var{class})\nReturn a matrix or N-dimensional array whose elements are all 0.\n\nIf invoked with a single scalar integer argument, return a square\n@nospell{NxN} matrix.\n\nIf invoked with two or more scalar integer arguments, or a vector of integer\nvalues, return an array with the given dimensions.\n\nThe optional argument @var{class} specifies the class of the return array\nand defaults to double.  For example:\n\n@example\nval = zeros (m,n, \"uint8\")\n@end example\n@seealso{ones}\n@end deftypefn") 
 XDEFUN_INTERNAL (Inf, args, , "-*- texinfo -*-\n@c List other form of function in documentation index\n@findex inf\n\n@deftypefn  {Built-in Function} {} Inf\n@deftypefnx {Built-in Function} {} Inf (@var{n})\n@deftypefnx {Built-in Function} {} Inf (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} Inf (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} Inf (@dots{}, @var{class})\nReturn a scalar, matrix or N-dimensional array whose elements are all equal\nto the IEEE representation for positive infinity.\n\nInfinity is produced when results are too large to be represented using the\nIEEE floating point format for numbers.  Two common examples which produce\ninfinity are division by zero and overflow.\n\n@example\n@group\n[ 1/0 e^800 ]\n@result{} Inf   Inf\n@end group\n@end example\n\nWhen called with no arguments, return a scalar with the value @samp{Inf}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{isinf, NaN}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(inf, Inf) ;
 XDEFUN_INTERNAL (NaN, args, , "-*- texinfo -*-\n@c List other form of function in documentation index\n@findex nan\n\n@deftypefn  {Built-in Function} {} NaN\n@deftypefnx {Built-in Function} {} NaN (@var{n})\n@deftypefnx {Built-in Function} {} NaN (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} NaN (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} NaN (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the IEEE symbol NaN (Not a Number).\n\nNaN is the result of operations which do not produce a well defined numerical\nresult.  Common operations which produce a NaN are arithmetic with infinity\n@tex\n($\\infty - \\infty$), zero divided by zero ($0/0$),\n@end tex\n@ifnottex\n(Inf - Inf), zero divided by zero (0/0),\n@end ifnottex\nand any operation involving another NaN value (5 + NaN).\n\nNote that NaN always compares not equal to NaN (NaN != NaN).  This behavior\nis specified by the IEEE standard for floating point arithmetic.  To find\nNaN values, use the @code{isnan} function.\n\nWhen called with no arguments, return a scalar with the value @samp{NaN}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{isnan, Inf}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(nan, NaN) ;
 XDEFUN_INTERNAL (e, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} e\n@deftypefnx {Built-in Function} {} e (@var{n})\n@deftypefnx {Built-in Function} {} e (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} e (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} e (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the base of natural logarithms.\n\nThe constant\n@tex\n$e$ satisfies the equation $\\log (e) = 1$.\n@end tex\n@ifnottex\n@samp{e} satisfies the equation @code{log} (e) = 1.\n@end ifnottex\n\nWhen called with no arguments, return a scalar with the value @math{e}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{log, exp, pi, I}\n@end deftypefn") 
 XDEFUN_INTERNAL (eps, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} eps\n@deftypefnx {Built-in Function} {} eps (@var{x})\n@deftypefnx {Built-in Function} {} eps (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} eps (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} eps (@dots{}, @var{class})\nReturn a scalar, matrix or N-dimensional array whose elements are all eps,\nthe machine precision.\n\nMore precisely, @code{eps} is the relative spacing between any two adjacent\nnumbers in the machine's floating point system.  This number is obviously\nsystem dependent.  On machines that support IEEE floating point arithmetic,\n@code{eps} is approximately\n@tex\n$2.2204\\times10^{-16}$ for double precision and $1.1921\\times10^{-7}$\n@end tex\n@ifnottex\n2.2204e-16 for double precision and 1.1921e-07\n@end ifnottex\nfor single precision.\n\nWhen called with no arguments, return a scalar with the value\n@code{eps (1.0)}.\n\nGiven a single argument @var{x}, return the distance between @var{x} and the\nnext largest value.\n\nWhen called with more than one argument the first two arguments are taken as\nthe number of rows and columns and any further arguments specify additional\nmatrix dimensions.  The optional argument @var{class} specifies the return\ntype and may be either @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{realmax, realmin, intmax, bitmax}\n@end deftypefn") 
 XDEFUN_INTERNAL (pi, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} pi\n@deftypefnx {Built-in Function} {} pi (@var{n})\n@deftypefnx {Built-in Function} {} pi (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} pi (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} pi (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the ratio of the circumference of a circle to its\n@tex\ndiameter($\\pi$).\n@end tex\n@ifnottex\ndiameter.\n@end ifnottex\n\nInternally, @code{pi} is computed as @samp{4.0 * atan (1.0)}.\n\nWhen called with no arguments, return a scalar with the value of\n@tex\n$\\pi$.\n@end tex\n@ifnottex\npi.\n@end ifnottex\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{e, I}\n@end deftypefn") 
 XDEFUN_INTERNAL (realmax, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} realmax\n@deftypefnx {Built-in Function} {} realmax (@var{n})\n@deftypefnx {Built-in Function} {} realmax (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} realmax (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} realmax (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the largest floating point number that is representable.\n\nThe actual value is system dependent.  On machines that support IEEE\nfloating point arithmetic, @code{realmax} is approximately\n@tex\n$1.7977\\times10^{308}$ for double precision and $3.4028\\times10^{38}$\n@end tex\n@ifnottex\n1.7977e+308 for double precision and 3.4028e+38\n@end ifnottex\nfor single precision.\n\nWhen called with no arguments, return a scalar with the value\n@code{realmax (@qcode{\"double\"})}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{realmin, intmax, bitmax, eps}\n@end deftypefn") 
 XDEFUN_INTERNAL (realmin, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} realmin\n@deftypefnx {Built-in Function} {} realmin (@var{n})\n@deftypefnx {Built-in Function} {} realmin (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} realmin (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} realmin (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the smallest normalized floating point number that is representable.\n\nThe actual value is system dependent.  On machines that support\nIEEE floating point arithmetic, @code{realmin} is approximately\n@tex\n$2.2251\\times10^{-308}$ for double precision and $1.1755\\times10^{-38}$\n@end tex\n@ifnottex\n2.2251e-308 for double precision and 1.1755e-38\n@end ifnottex\nfor single precision.\n\nWhen called with no arguments, return a scalar with the value\n@code{realmin (@qcode{\"double\"})}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{realmax, intmin, eps}\n@end deftypefn") 
 XDEFUN_INTERNAL (I, args, , "-*- texinfo -*-\n@c List other forms of function in documentation index\n@findex i\n@findex j\n@findex J\n\n@deftypefn  {Built-in Function} {} I\n@deftypefnx {Built-in Function} {} I (@var{n})\n@deftypefnx {Built-in Function} {} I (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} I (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} I (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the pure imaginary unit, defined as\n@tex\n$\\sqrt{-1}$.\n@end tex\n@ifnottex\n@code{sqrt (-1)}.\n@end ifnottex\n\nI, and its equivalents i, j, and J, are functions so any of the names may\nbe reused for other purposes (such as i for a counter variable).\n\nWhen called with no arguments, return a scalar with the value @math{i}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{e, pi, log, exp}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(i, I) ;
 XDEFALIAS_INTERNAL(J, I) ;
 XDEFALIAS_INTERNAL(j, I) ;
 XDEFUN_INTERNAL (NA, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} NA\n@deftypefnx {Built-in Function} {} NA (@var{n})\n@deftypefnx {Built-in Function} {} NA (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} NA (@var{n}, @var{m}, @var{k}, @dots{})\n@deftypefnx {Built-in Function} {} NA (@dots{}, @var{class})\nReturn a scalar, matrix, or N-dimensional array whose elements are all equal\nto the special constant used to designate missing values.\n\nNote that NA always compares not equal to NA (NA != NA).\nTo find NA values, use the @code{isna} function.\n\nWhen called with no arguments, return a scalar with the value @samp{NA}.\n\nWhen called with a single argument, return a square matrix with the dimension\nspecified.\n\nWhen called with more than one scalar argument the first two arguments are\ntaken as the number of rows and columns and any further arguments specify\nadditional matrix dimensions.\n\nThe optional argument @var{class} specifies the return type and may be\neither @qcode{\"double\"} or @qcode{\"single\"}.\n@seealso{isna}\n@end deftypefn") 
 XDEFUN_INTERNAL (false, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} false (@var{x})\n@deftypefnx {Built-in Function} {} false (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} false (@var{n}, @var{m}, @var{k}, @dots{})\nReturn a matrix or N-dimensional array whose elements are all logical 0.\n\nIf invoked with a single scalar integer argument, return a square\nmatrix of the specified size.\n\nIf invoked with two or more scalar integer arguments, or a vector of integer\nvalues, return an array with given dimensions.\n@seealso{true}\n@end deftypefn") 
 XDEFUN_INTERNAL (true, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} true (@var{x})\n@deftypefnx {Built-in Function} {} true (@var{n}, @var{m})\n@deftypefnx {Built-in Function} {} true (@var{n}, @var{m}, @var{k}, @dots{})\nReturn a matrix or N-dimensional array whose elements are all logical 1.\n\nIf invoked with a single scalar integer argument, return a square\nmatrix of the specified size.\n\nIf invoked with two or more scalar integer arguments, or a vector of integer\nvalues, return an array with given dimensions.\n@seealso{false}\n@end deftypefn") 
 XDEFUN_INTERNAL (eye, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} eye (@var{n})\n@deftypefnx {Built-in Function} {} eye (@var{m}, @var{n})\n@deftypefnx {Built-in Function} {} eye ([@var{m} @var{n}])\n@deftypefnx {Built-in Function} {} eye (@dots{}, @var{class})\nReturn an identity matrix.\n\nIf invoked with a single scalar argument @var{n}, return a square\n@nospell{NxN} identity matrix.\n\nIf supplied two scalar arguments (@var{m}, @var{n}), @code{eye} takes them\nto be the number of rows and columns.  If given a vector with two elements,\n@code{eye} uses the values of the elements as the number of rows and\ncolumns, respectively.  For example:\n\n@example\n@group\neye (3)\n @result{}  1  0  0\n     0  1  0\n     0  0  1\n@end group\n@end example\n\nThe following expressions all produce the same result:\n\n@example\n@group\neye (2)\n@equiv{}\neye (2, 2)\n@equiv{}\neye (size ([1, 2; 3, 4]))\n@end group\n@end example\n\nThe optional argument @var{class}, allows @code{eye} to return an array of\nthe specified type, like\n\n@example\nval = zeros (n,m, \"uint8\")\n@end example\n\nCalling @code{eye} with no arguments is equivalent to calling it with an\nargument of 1.  Any negative dimensions are treated as zero.  These odd\ndefinitions are for compatibility with @sc{matlab}.\n@seealso{speye, ones, zeros}\n@end deftypefn") 
 XDEFUN_INTERNAL (linspace, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} linspace (@var{base}, @var{limit})\n@deftypefnx {Built-in Function} {} linspace (@var{base}, @var{limit}, @var{n})\nReturn a row vector with @var{n} linearly spaced elements between\n@var{base} and @var{limit}.\n\nIf the number of elements is greater than one, then the endpoints @var{base}\nand @var{limit} are always included in the range.  If @var{base} is greater\nthan @var{limit}, the elements are stored in decreasing order.  If the\nnumber of points is not specified, a value of 100 is used.\n\nThe @code{linspace} function always returns a row vector if both @var{base}\nand @var{limit} are scalars.  If one, or both, of them are column vectors,\n@code{linspace} returns a matrix.\n\nFor compatibility with @sc{matlab}, return the second argument (@var{limit})\nif fewer than two values are requested.\n@seealso{logspace}\n@end deftypefn") 
 XDEFUN_INTERNAL (resize, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} resize (@var{x}, @var{m})\n@deftypefnx {Built-in Function} {} resize (@var{x}, @var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} resize (@var{x}, [@var{m} @var{n} @dots{}])\nResize @var{x} cutting off elements as necessary.\n\nIn the result, element with certain indices is equal to the corresponding\nelement of @var{x} if the indices are within the bounds of @var{x};\notherwise, the element is set to zero.\n\nIn other words, the statement\n\n@example\ny = resize (x, dv)\n@end example\n\n@noindent\nis equivalent to the following code:\n\n@example\n@group\ny = zeros (dv, class (x));\nsz = min (dv, size (x));\nfor i = 1:length (sz)\n  idx@{i@} = 1:sz(i);\nendfor\ny(idx@{:@}) = x(idx@{:@});\n@end group\n@end example\n\n@noindent\nbut is performed more efficiently.\n\nIf only @var{m} is supplied, and it is a scalar, the dimension of the\nresult is @var{m}-by-@var{m}.\nIf @var{m}, @var{n}, @dots{} are all scalars, then the dimensions of\nthe result are @var{m}-by-@var{n}-by-@dots{}.\nIf given a vector as input, then the\ndimensions of the result are given by the elements of that vector.\n\nAn object can be resized to more dimensions than it has;\nin such case the missing dimensions are assumed to be 1.\nResizing an object to fewer dimensions is not possible.\n@seealso{reshape, postpad, prepad, cat}\n@end deftypefn") 
 XDEFUN_INTERNAL (reshape, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} reshape (@var{A}, @var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} reshape (@var{A}, [@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {} reshape (@var{A}, @dots{}, [], @dots{})\n@deftypefnx {Built-in Function} {} reshape (@var{A}, @var{size})\nReturn a matrix with the specified dimensions (@var{m}, @var{n}, @dots{})\nwhose elements are taken from the matrix @var{A}.\n\nThe elements of the matrix are accessed in column-major order (like Fortran\narrays are stored).\n\nThe following code demonstrates reshaping a 1x4 row vector into a 2x2 square\nmatrix.\n\n@example\n@group\nreshape ([1, 2, 3, 4], 2, 2)\n      @result{}  1  3\n          2  4\n@end group\n@end example\n\n@noindent\nNote that the total number of elements in the original matrix\n(@code{prod (size (@var{A}))}) must match the total number of elements\nin the new matrix (@code{prod ([@var{m} @var{n} @dots{}])}).\n\nA single dimension of the return matrix may be left unspecified and Octave\nwill determine its size automatically.  An empty matrix ([]) is used to flag\nthe unspecified dimension.\n@seealso{resize, vec, postpad, cat, squeeze}\n@end deftypefn") 
 XDEFUN_INTERNAL (vec, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{v} =} vec (@var{x})\n@deftypefnx {Built-in Function} {@var{v} =} vec (@var{x}, @var{dim})\nReturn the vector obtained by stacking the columns of the matrix @var{x}\none above the other.\n\nWithout @var{dim} this is equivalent to @code{@var{x}(:)}.\n\nIf @var{dim} is supplied, the dimensions of @var{v} are set to @var{dim}\nwith all elements along the last dimension.  This is equivalent to\n@code{shiftdim (@var{x}(:), 1-@var{dim})}.\n@seealso{vech, resize, cat}\n@end deftypefn") 
 XDEFUN_INTERNAL (squeeze, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} squeeze (@var{x})\nRemove singleton dimensions from @var{x} and return the result.\n\nNote that for compatibility with @sc{matlab}, all objects have\na minimum of two dimensions and row vectors are left unchanged.\n@seealso{reshape}\n@end deftypefn") 
 XDEFUN_INTERNAL (full, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{FM} =} full (@var{SM})\nReturn a full storage matrix from a sparse, diagonal, or permutation matrix,\nor a range.\n@seealso{sparse, issparse}\n@end deftypefn") 
 XDEFUN_INTERNAL (norm, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} norm (@var{A})\n@deftypefnx {Built-in Function} {} norm (@var{A}, @var{p})\n@deftypefnx {Built-in Function} {} norm (@var{A}, @var{p}, @var{opt})\nCompute the p-norm of the matrix @var{A}.\n\nIf the second argument is missing, @code{p = 2} is assumed.\n\nIf @var{A} is a matrix (or sparse matrix):\n\n@table @asis\n@item @var{p} = @code{1}\n1-norm, the largest column sum of the absolute values of @var{A}.\n\n@item @var{p} = @code{2}\nLargest singular value of @var{A}.\n\n@item @var{p} = @code{Inf} or @qcode{\"inf\"}\n@cindex infinity norm\nInfinity norm, the largest row sum of the absolute values of @var{A}.\n\n@item @var{p} = @qcode{\"fro\"}\n@cindex Frobenius norm\nFrobenius norm of @var{A}, @code{sqrt (sum (diag (@var{A}' * @var{A})))}.\n\n@item other @var{p}, @code{@var{p} > 1}\n@cindex general p-norm\nmaximum @code{norm (A*x, p)} such that @code{norm (x, p) == 1}\n@end table\n\nIf @var{A} is a vector or a scalar:\n\n@table @asis\n@item @var{p} = @code{Inf} or @qcode{\"inf\"}\n@code{max (abs (@var{A}))}.\n\n@item @var{p} = @code{-Inf}\n@code{min (abs (@var{A}))}.\n\n@item @var{p} = @qcode{\"fro\"}\nFrobenius norm of @var{A}, @code{sqrt (sumsq (abs (A)))}.\n\n@item @var{p} = 0\nHamming norm - the number of nonzero elements.\n\n@item other @var{p}, @code{@var{p} > 1}\np-norm of @var{A}, @code{(sum (abs (@var{A}) .^ @var{p})) ^ (1/@var{p})}.\n\n@item other @var{p} @code{@var{p} < 1}\nthe p-pseudonorm defined as above.\n@end table\n\nIf @var{opt} is the value @qcode{\"rows\"}, treat each row as a vector and\ncompute its norm.  The result is returned as a column vector.\nSimilarly, if @var{opt} is @qcode{\"columns\"} or @qcode{\"cols\"} then\ncompute the norms of each column and return a row vector.\n@seealso{cond, svd}\n@end deftypefn") 
 XDEFUN_INTERNAL (not, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{z} =} not (@var{x})\nReturn the logical NOT of @var{x}.\n\nThis function is equivalent to the operator syntax @w{@code{! x}}.\n@seealso{and, or, xor}\n@end deftypefn") 
 XDEFUN_INTERNAL (uplus, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} uplus (@var{x})\nThis function and @w{@tcode{+ x}} are equivalent.\n@seealso{uminus, plus, minus}\n@end deftypefn") 
 XDEFUN_INTERNAL (uminus, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} uminus (@var{x})\nThis function and @w{@tcode{- x}} are equivalent.\n@seealso{uplus, minus}\n@end deftypefn") 
 XDEFUN_INTERNAL (transpose, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} transpose (@var{x})\nReturn the transpose of @var{x}.\n\nThis function and @tcode{x.'} are equivalent.\n@seealso{ctranspose}\n@end deftypefn") 
 XDEFUN_INTERNAL (ctranspose, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ctranspose (@var{x})\nReturn the complex conjugate transpose of @var{x}.\n\nThis function and @tcode{x'} are equivalent.\n@seealso{transpose}\n@end deftypefn") 
 XDEFUN_INTERNAL (plus, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} plus (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {} plus (@var{x1}, @var{x2}, @dots{})\nThis function and @w{@tcode{x + y}} are equivalent.\n\nIf more arguments are given, the summation is applied\ncumulatively from left to right:\n\n@example\n(@dots{}((x1 + x2) + x3) + @dots{})\n@end example\n\nAt least one argument is required.\n@seealso{minus, uplus}\n@end deftypefn") 
 XDEFUN_INTERNAL (minus, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} minus (@var{x}, @var{y})\nThis function and @w{@tcode{x - y}} are equivalent.\n@seealso{plus, uminus}\n@end deftypefn") 
 XDEFUN_INTERNAL (mtimes, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} mtimes (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {} mtimes (@var{x1}, @var{x2}, @dots{})\nReturn the matrix multiplication product of inputs.\n\nThis function and @w{@tcode{x * y}} are equivalent.\nIf more arguments are given, the multiplication is applied\ncumulatively from left to right:\n\n@example\n(@dots{}((x1 * x2) * x3) * @dots{})\n@end example\n\nAt least one argument is required.\n@seealso{times, plus, minus, rdivide, mrdivide, mldivide, mpower}\n@end deftypefn") 
 XDEFUN_INTERNAL (mrdivide, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} mrdivide (@var{x}, @var{y})\nReturn the matrix right division of @var{x} and @var{y}.\n\nThis function and @w{@tcode{x / y}} are equivalent.\n@seealso{mldivide, rdivide, plus, minus}\n@end deftypefn") 
 XDEFUN_INTERNAL (mpower, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} mpower (@var{x}, @var{y})\nReturn the matrix power operation of @var{x} raised to the @var{y} power.\n\nThis function and @w{@tcode{x ^ y}} are equivalent.\n@seealso{power, mtimes, plus, minus}\n@end deftypefn") 
 XDEFUN_INTERNAL (mldivide, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} mldivide (@var{x}, @var{y})\nReturn the matrix left division of @var{x} and @var{y}.\n\nThis function and @w{@tcode{x @xbackslashchar{} y}} are equivalent.\n@seealso{mrdivide, ldivide, rdivide}\n@end deftypefn") 
 XDEFUN_INTERNAL (lt, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} lt (@var{x}, @var{y})\nThis function is equivalent to @w{@code{x < y}}.\n@seealso{le, eq, ge, gt, ne}\n@end deftypefn") 
 XDEFUN_INTERNAL (le, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} le (@var{x}, @var{y})\nThis function is equivalent to @w{@code{x <= y}}.\n@seealso{eq, ge, gt, ne, lt}\n@end deftypefn") 
 XDEFUN_INTERNAL (eq, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} eq (@var{x}, @var{y})\nReturn true if the two inputs are equal.\n\nThis function is equivalent to @w{@code{x == y}}.\n@seealso{ne, isequal, le, ge, gt, ne, lt}\n@end deftypefn") 
 XDEFUN_INTERNAL (ge, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ge (@var{x}, @var{y})\nThis function is equivalent to @w{@code{x >= y}}.\n@seealso{le, eq, gt, ne, lt}\n@end deftypefn") 
 XDEFUN_INTERNAL (gt, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} gt (@var{x}, @var{y})\nThis function is equivalent to @w{@code{x > y}}.\n@seealso{le, eq, ge, ne, lt}\n@end deftypefn") 
 XDEFUN_INTERNAL (ne, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ne (@var{x}, @var{y})\nReturn true if the two inputs are not equal.\n\nThis function is equivalent to @w{@code{x != y}}.\n@seealso{eq, isequal, le, ge, lt}\n@end deftypefn") 
 XDEFUN_INTERNAL (times, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} times (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {} times (@var{x1}, @var{x2}, @dots{})\nReturn the element-by-element multiplication product of inputs.\n\nThis function and @w{@tcode{x .* y}} are equivalent.\nIf more arguments are given, the multiplication is applied\ncumulatively from left to right:\n\n@example\n(@dots{}((x1 .* x2) .* x3) .* @dots{})\n@end example\n\nAt least one argument is required.\n@seealso{mtimes, rdivide}\n@end deftypefn") 
 XDEFUN_INTERNAL (rdivide, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} rdivide (@var{x}, @var{y})\nReturn the element-by-element right division of @var{x} and @var{y}.\n\nThis function and @w{@tcode{x ./ y}} are equivalent.\n@seealso{ldivide, mrdivide, times, plus}\n@end deftypefn") 
 XDEFUN_INTERNAL (power, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} power (@var{x}, @var{y})\nReturn the element-by-element operation of @var{x} raised to the\n@var{y} power.\n\nThis function and @w{@tcode{x .^ y}} are equivalent.\n\nIf several complex results are possible, returns the one with smallest\nnon-negative argument (angle).  Use @code{realpow}, @code{realsqrt},\n@code{cbrt}, or @code{nthroot} if a real result is preferred.\n\n@seealso{mpower, realpow, realsqrt, cbrt, nthroot}\n@end deftypefn") 
 XDEFUN_INTERNAL (ldivide, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ldivide (@var{x}, @var{y})\nReturn the element-by-element left division of @var{x} and @var{y}.\n\nThis function and @w{@tcode{x .@xbackslashchar{} y}} are equivalent.\n@seealso{rdivide, mldivide, times, plus}\n@end deftypefn") 
 XDEFUN_INTERNAL (and, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{z} =} and (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {@var{z} =} and (@var{x1}, @var{x2}, @dots{})\nReturn the logical AND of @var{x} and @var{y}.\n\nThis function is equivalent to the operator syntax @w{@code{x & y}}.  If\nmore than two arguments are given, the logical AND is applied cumulatively\nfrom left to right:\n\n@example\n(@dots{}((x1 & x2) & x3) & @dots{})\n@end example\n\nAt least one argument is required.\n@seealso{or, not, xor}\n@end deftypefn") 
 XDEFUN_INTERNAL (or, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{z} =} or (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {@var{z} =} or (@var{x1}, @var{x2}, @dots{})\nReturn the logical OR of @var{x} and @var{y}.\n\nThis function is equivalent to the operator syntax @w{@code{x | y}}.  If\nmore than two arguments are given, the logical OR is applied cumulatively\nfrom left to right:\n\n@example\n(@dots{}((x1 | x2) | x3) | @dots{})\n@end example\n\nAt least one argument is required.\n@seealso{and, not, xor}\n@end deftypefn") 
 XDEFUN_INTERNAL (colon, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{r} =} colon (@var{base}, @var{limit})\n@deftypefnx {Built-in Function} {@var{r} =} colon (@var{base}, @var{increment}, @var{limit})\nReturn the result of the colon expression corresponding to @var{base},\n@var{limit}, and optionally, @var{increment}.\n\nThis function is equivalent to the operator syntax @w{@code{base : limit}}\nor @w{@code{base : increment : limit}}.\n@end deftypefn") 
 XDEFUN_INTERNAL (tic, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} tic ()\n@deftypefnx {Built-in Function} {@var{id} =} tic ()\n@deftypefnx {Built-in Function} {} toc ()\n@deftypefnx {Built-in Function} {} toc (@var{id})\n@deftypefnx {Built-in Function} {@var{val} =} toc (@dots{})\nSet or check a wall-clock timer.\n\nCalling @code{tic} without an output argument sets the internal timer state.\nSubsequent calls to @code{toc} return the number of seconds since the timer\nwas set.\nFor example,\n\n@example\n@group\ntic ();\n# many computations later@dots{}\nelapsed_time = toc ();\n@end group\n@end example\n\n@noindent\nwill set the variable @code{elapsed_time} to the number of seconds since\nthe most recent call to the function @code{tic}.\n\nIf called with one output argument, @code{tic} returns a scalar\nof type @code{uint64} that may be later passed to @code{toc}.\n\n@example\n@group\nid = tic; sleep (5); toc (id)\n      @result{} 5.0010\n@end group\n@end example\n\nCalling @code{tic} and @code{toc} this way allows nested timing calls.\n\nIf you are more interested in the CPU time that your process used, you\nshould use the @code{cputime} function instead.  The @code{tic} and\n@code{toc} functions report the actual wall clock time that elapsed\nbetween the calls.  This may include time spent processing other jobs or\ndoing nothing at all.\n@seealso{toc, cputime}\n@end deftypefn") 
 XDEFUN_INTERNAL (toc, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} toc ()\n@deftypefnx {Built-in Function} {} toc (@var{id})\n@deftypefnx {Built-in Function} {@var{val} =} toc (@dots{})\n@seealso{tic, cputime}\n@end deftypefn") 
 XDEFUN_INTERNAL (cputime, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{total}, @var{user}, @var{system}] =} cputime ();\nReturn the CPU time used by your Octave session.\n\nThe first output is the total time spent executing your process and is equal\nto the sum of second and third outputs, which are the number of CPU seconds\nspent executing in user mode and the number of CPU seconds spent executing\nin system mode, respectively.\n\nIf your system does not have a way to report CPU time usage, @code{cputime}\nreturns 0 for each of its output values.\n\nNote that because Octave used some CPU time to start, it is reasonable\nto check to see if @code{cputime} works by checking to see if the total\nCPU time used is nonzero.\n@seealso{tic, toc}\n@end deftypefn") 
 XDEFUN_INTERNAL (sort, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{s}, @var{i}] =} sort (@var{x})\n@deftypefnx {Built-in Function} {[@var{s}, @var{i}] =} sort (@var{x}, @var{dim})\n@deftypefnx {Built-in Function} {[@var{s}, @var{i}] =} sort (@var{x}, @var{mode})\n@deftypefnx {Built-in Function} {[@var{s}, @var{i}] =} sort (@var{x}, @var{dim}, @var{mode})\nReturn a copy of @var{x} with the elements arranged in increasing order.\n\nFor matrices, @code{sort} orders the elements within columns\n\nFor example:\n\n@example\n@group\nsort ([1, 2; 2, 3; 3, 1])\n   @result{}  1  1\n       2  2\n       3  3\n@end group\n@end example\n\nIf the optional argument @var{dim} is given, then the matrix is sorted\nalong the dimension defined by @var{dim}.  The optional argument @code{mode}\ndefines the order in which the values will be sorted.  Valid values of\n@code{mode} are @qcode{\"ascend\"} or @qcode{\"descend\"}.\n\nThe @code{sort} function may also be used to produce a matrix\ncontaining the original row indices of the elements in the sorted\nmatrix.  For example:\n\n@example\n@group\n[s, i] = sort ([1, 2; 2, 3; 3, 1])\n  @result{} s = 1  1\n         2  2\n         3  3\n  @result{} i = 1  3\n         2  1\n         3  2\n@end group\n@end example\n\nFor equal elements, the indices are such that equal elements are listed\nin the order in which they appeared in the original list.\n\nSorting of complex entries is done first by magnitude (@code{abs (@var{z})})\nand for any ties by phase angle (@code{angle (z)}).  For example:\n\n@example\n@group\nsort ([1+i; 1; 1-i])\n    @result{} 1 + 0i\n       1 - 1i\n       1 + 1i\n@end group\n@end example\n\nNaN values are treated as being greater than any other value and are sorted\nto the end of the list.\n\nThe @code{sort} function may also be used to sort strings and cell arrays\nof strings, in which case ASCII dictionary order (uppercase 'A' precedes\nlowercase 'a') of the strings is used.\n\nThe algorithm used in @code{sort} is optimized for the sorting of partially\nordered lists.\n@seealso{sortrows, issorted}\n@end deftypefn") 
 XDEFUN_INTERNAL (__sort_rows_idx__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __sort_rows_idx__ (@var{a}, @var{mode})\nUndocumented internal function.\n@end deftypefn\n") 
 XDEFUN_INTERNAL (issorted, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} issorted (@var{a})\n@deftypefnx {Built-in Function} {} issorted (@var{a}, @var{mode})\n@deftypefnx {Built-in Function} {} issorted (@var{a}, \"rows\", @var{mode})\nReturn true if the array is sorted according to @var{mode}, which\nmay be either @qcode{\"ascending\"}, @qcode{\"descending\"}, or\n@qcode{\"either\"}.\n\nBy default,  @var{mode} is @qcode{\"ascending\"}.  NaNs are treated in the\nsame manner as @code{sort}.\n\nIf the optional argument @qcode{\"rows\"} is supplied, check whether\nthe array is sorted by rows as output by the function @code{sortrows}\n(with no options).\n\nThis function does not support sparse matrices.\n@seealso{sort, sortrows}\n@end deftypefn\n") 
 XDEFUN_INTERNAL (nth_element, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} nth_element (@var{x}, @var{n})\n@deftypefnx {Built-in Function} {} nth_element (@var{x}, @var{n}, @var{dim})\nSelect the n-th smallest element of a vector, using the ordering defined by\n@code{sort}.\n\nThe result is equivalent to @code{sort(@var{x})(@var{n})}.\n\n@var{n} can also be a contiguous range, either ascending @code{l:u}\nor descending @code{u:-1:l}, in which case a range of elements is returned.\n\nIf @var{x} is an array, @code{nth_element} operates along the dimension\ndefined by @var{dim}, or the first non-singleton dimension if @var{dim} is\nnot given.\n\nProgramming Note: nth_element encapsulates the C++ standard library\nalgorithms nth_element and partial_sort.  On average, the complexity of the\noperation is O(M*log(K)), where @w{@code{M = size (@var{x}, @var{dim})}} and\n@w{@code{K = length (@var{n})}}.  This function is intended for cases where\nthe ratio K/M is small; otherwise, it may be better to use @code{sort}.\n@seealso{sort, min, max}\n@end deftypefn") 
 XDEFUN_INTERNAL (__accumarray_sum__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __accumarray_sum__ (@var{idx}, @var{vals}, @var{n})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__accumarray_min__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __accumarray_min__ (@var{idx}, @var{vals}, @var{zero}, @var{n})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__accumarray_max__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __accumarray_max__ (@var{idx}, @var{vals}, @var{zero}, @var{n})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__accumdim_sum__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __accumdim_sum__ (@var{idx}, @var{vals}, @var{dim}, @var{n})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (merge, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} merge (@var{mask}, @var{tval}, @var{fval})\n@deftypefnx {Built-in Function} {} ifelse (@var{mask}, @var{tval}, @var{fval})\nMerge elements of @var{true_val} and @var{false_val}, depending on the\nvalue of @var{mask}.\n\nIf @var{mask} is a logical scalar, the other two arguments can be arbitrary\nvalues.  Otherwise, @var{mask} must be a logical array, and @var{tval},\n@var{fval} should be arrays of matching class, or cell arrays.  In the\nscalar mask case, @var{tval} is returned if @var{mask} is true, otherwise\n@var{fval} is returned.\n\nIn the array mask case, both @var{tval} and @var{fval} must be either\nscalars or arrays with dimensions equal to @var{mask}.  The result is\nconstructed as follows:\n\n@example\n@group\nresult(mask) = tval(mask);\nresult(! mask) = fval(! mask);\n@end group\n@end example\n\n@var{mask} can also be arbitrary numeric type, in which case it is first\nconverted to logical.\n@seealso{logical, diff}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(ifelse, merge) ;
 XDEFUN_INTERNAL (diff, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} diff (@var{x})\n@deftypefnx {Built-in Function} {} diff (@var{x}, @var{k})\n@deftypefnx {Built-in Function} {} diff (@var{x}, @var{k}, @var{dim})\nIf @var{x} is a vector of length @math{n}, @code{diff (@var{x})} is the\nvector of first differences\n@tex\n $x_2 - x_1, \\ldots{}, x_n - x_{n-1}$.\n@end tex\n@ifnottex\n @var{x}(2) - @var{x}(1), @dots{}, @var{x}(n) - @var{x}(n-1).\n@end ifnottex\n\nIf @var{x} is a matrix, @code{diff (@var{x})} is the matrix of column\ndifferences along the first non-singleton dimension.\n\nThe second argument is optional.  If supplied, @code{diff (@var{x},\n@var{k})}, where @var{k} is a non-negative integer, returns the\n@var{k}-th differences.  It is possible that @var{k} is larger than\nthe first non-singleton dimension of the matrix.  In this case,\n@code{diff} continues to take the differences along the next\nnon-singleton dimension.\n\nThe dimension along which to take the difference can be explicitly\nstated with the optional variable @var{dim}.  In this case the\n@var{k}-th order differences are calculated along this dimension.\nIn the case where @var{k} exceeds @code{size (@var{x}, @var{dim})}\nan empty matrix is returned.\n@seealso{sort, merge}\n@end deftypefn") 
 XDEFUN_INTERNAL (repelems, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} repelems (@var{x}, @var{r})\nConstruct a vector of repeated elements from @var{x}.\n\n@var{r} is a 2x@var{N} integer matrix specifying which elements to repeat and\nhow often to repeat each element.  Entries in the first row, @var{r}(1,j),\nselect an element to repeat.  The corresponding entry in the second row,\n@var{r}(2,j), specifies the repeat count.  If @var{x} is a matrix then the\ncolumns of @var{x} are imagined to be stacked on top of each other for\npurposes of the selection index.  A row vector is always returned.\n\nConceptually the result is calculated as follows:\n\n@example\n@group\ny = [];\nfor i = 1:columns (@var{r})\n  y = [y, @var{x}(@var{r}(1,i)*ones(1, @var{r}(2,i)))];\nendfor\n@end group\n@end example\n@seealso{repmat, cat}\n@end deftypefn") 
 XDEFUN_INTERNAL (base64_encode, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{s} =} base64_encode (@var{x})\nEncode a double matrix or array @var{x} into the base64 format string\n@var{s}.\n\n@seealso{base64_decode}\n@end deftypefn") 
 XDEFUN_INTERNAL (base64_decode, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{x} =} base64_decode (@var{s})\n@deftypefnx {Built-in Function} {@var{x} =} base64_decode (@var{s}, @var{dims})\nDecode the double matrix or array @var{x} from the base64 encoded string\n@var{s}.\n\nThe optional input parameter @var{dims} should be a vector containing the\ndimensions of the decoded array.\n@seealso{base64_encode}\n@end deftypefn") 
}

static void
install_debug_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/debug.cc")
 XDEFUN_INTERNAL (dbstop, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dbstop @var{func}\n@deftypefnx {Command} {} dbstop @var{func} @var{line}\n@deftypefnx {Command} {} dbstop @var{func} @var{line1} @var{line2} @dots{}\n@deftypefnx {Command} {} dbstop @var{line} @dots{}\n@deftypefnx {Built-in Function} {@var{rline} =} dbstop (\"@var{func}\")\n@deftypefnx {Built-in Function} {@var{rline} =} dbstop (\"@var{func}\", @var{line})\n@deftypefnx {Built-in Function} {@var{rline} =} dbstop (\"@var{func}\", @var{line1}, @var{line2}, @dots{})\n@deftypefnx {Built-in Function} {} dbstop (\"@var{func}\", [@var{line1}, @dots{}])\n@deftypefnx {Built-in Function} {} dbstop (@var{line}, @dots{})\nSet a breakpoint at line number @var{line} in function @var{func}.\n\nArguments are\n\n@table @var\n@item func\nFunction name as a string variable.  When already in debug mode this argument\ncan be omitted and the current function will be used.\n\n@item line\nLine number where the breakpoint should be set.  Multiple lines may be given\nas separate arguments or as a vector.\n@end table\n\nWhen called with a single argument @var{func}, the breakpoint is set at the\nfirst executable line in the named function.\n\nThe optional output @var{rline} is the real line number where the breakpoint\nwas set.  This can differ from the specified line if the line is not\nexecutable.  For example, if a breakpoint attempted on a blank line then\nOctave will set the real breakpoint at the next executable line.\n@seealso{dbclear, dbstatus, dbstep, debug_on_error, debug_on_warning, debug_on_interrupt}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbclear, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dbclear @var{func}\n@deftypefnx {Command} {} dbclear @var{func} @var{line}\n@deftypefnx {Command} {} dbclear @var{func} @var{line1} @var{line2} @dots{}\n@deftypefnx {Command} {} dbclear @var{line} @dots{}\n@deftypefnx {Command} {} dbclear all\n@deftypefnx {Built-in Function} {} dbclear (\"@var{func}\")\n@deftypefnx {Built-in Function} {} dbclear (\"@var{func}\", @var{line})\n@deftypefnx {Built-in Function} {} dbclear (\"@var{func}\", @var{line1}, @var{line2}, @dots{})\n@deftypefnx {Built-in Function} {} dbclear (\"@var{func}\", [@var{line1}, @dots{}])\n@deftypefnx {Built-in Function} {} dbclear (@var{line}, @dots{})\n@deftypefnx {Built-in Function} {} dbclear (\"all\")\nDelete a breakpoint at line number @var{line} in the function @var{func}.\n\nArguments are\n\n@table @var\n@item func\nFunction name as a string variable.  When already in debug mode this argument\ncan be omitted and the current function will be used.\n\n@item line\nLine number from which to remove a breakpoint.  Multiple lines may be given\nas separate arguments or as a vector.\n@end table\n\nWhen called without a line number specification all breakpoints in the named\nfunction are cleared.\n\nIf the requested line is not a breakpoint no action is performed.\n\nThe special keyword @qcode{\"all\"} will clear all breakpoints from all\nfiles.\n@seealso{dbstop, dbstatus, dbwhere}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbstatus, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} dbstatus ()\n@deftypefnx {Built-in Function} {@var{brk_list} =} dbstatus ()\n@deftypefnx {Built-in Function} {@var{brk_list} =} dbstatus (\"@var{func}\")\nReport the location of active breakpoints.\n\nWhen called with no input or output arguments, print the list of all\nfunctions with breakpoints and the line numbers where those breakpoints are\nset.\n\nIf a function name @var{func} is specified then only report breakpoints\nfor the named function.\n\nThe optional return argument @var{brk_list} is a struct array with the\nfollowing fields.\n\n@table @asis\n@item name\nThe name of the function with a breakpoint.\n\n@item file\nThe name of the m-file where the function code is located.\n\n@item line\nA line number, or vector of line numbers, with a breakpoint.\n@end table\n\nNote: When @code{dbstatus} is called from the debug prompt within a function,\nthe list of breakpoints is automatically trimmed to the breakpoints in the\ncurrent function.\n@seealso{dbclear, dbwhere}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbwhere, , , "-*- texinfo -*-\n@deftypefn {Command} {} dbwhere\nIn debugging mode, report the current file and line number where execution\nis stopped.\n@seealso{dbstatus, dbcont, dbstep, dbup}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbtype, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dbtype\n@deftypefnx {Command} {} dbtype @var{lineno}\n@deftypefnx {Command} {} dbtype @var{startl:endl}\n@deftypefnx {Command} {} dbtype @var{startl:end}\n@deftypefnx {Command} {} dbtype @var{func}\n@deftypefnx {Command} {} dbtype @var{func} @var{lineno}\n@deftypefnx {Command} {} dbtype @var{func} @var{startl:endl}\n@deftypefnx {Command} {} dbtype @var{func} @var{startl:end}\nDisplay a script file with line numbers.\n\nWhen called with no arguments in debugging mode, display the script file\ncurrently being debugged.\n\nAn optional range specification can be used to list only a portion of the\nfile.  The special keyword @qcode{\"end\"} is a valid line number\nspecification for the last line of the file.\n\nWhen called with the name of a function, list that script file with line\nnumbers.\n@seealso{dbwhere, dbstatus, dbstop}\n@end deftypefn") 
 XDEFUN_INTERNAL (dblist, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dblist\n@deftypefnx {Command} {} dblist @var{n}\nIn debugging mode, list @var{n} lines of the function being debugged\ncentered around the current line to be executed.\n\nIf unspecified @var{n} defaults to 10 (+/- 5 lines)\n@seealso{dbwhere, dbtype}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbstack, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} dbstack\n@deftypefnx {Command} {} dbstack @var{n}\n@deftypefnx {Command} {} dbstack @var{-completenames}\n@deftypefnx {Built-in Function} {[@var{stack}, @var{idx}] =} dbstack (@dots{})\nDisplay or return current debugging function stack information.\n\nWith optional argument @var{n}, omit the @var{n} innermost stack frames.\n\nAlthough accepted, the argument @var{-completenames} is silently ignored.\nOctave always returns absolute file names.\n\nThe arguments @var{n} and @var{-completenames} can be both specified in any\norder.\n\nThe optional return argument @var{stack} is a struct array with the\nfollowing fields:\n\n@table @asis\n@item file\nThe name of the m-file where the function code is located.\n\n@item name\nThe name of the function with a breakpoint.\n\n@item line\nThe line number of an active breakpoint.\n\n@item column\nThe column number of the line where the breakpoint begins.\n\n@item scope\nUndocumented.\n\n@item context\nUndocumented.\n@end table\n\nThe return argument @var{idx} specifies which element of the @var{stack}\nstruct array is currently active.\n@seealso{dbup, dbdown, dbwhere, dbstatus}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbup, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dbup\n@deftypefnx {Command} {} dbup @var{n}\nIn debugging mode, move up the execution stack @var{n} frames.\n\nIf @var{n} is omitted, move up one frame.\n@seealso{dbstack, dbdown}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbdown, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dbdown\n@deftypefnx {Command} {} dbdown @var{n}\nIn debugging mode, move down the execution stack @var{n} frames.\n\nIf @var{n} is omitted, move down one frame.\n@seealso{dbstack, dbup}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbstep, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} dbstep\n@deftypefnx {Command} {} dbstep @var{n}\n@deftypefnx {Command} {} dbstep in\n@deftypefnx {Command} {} dbstep out\n@deftypefnx {Command} {} dbnext @dots{}\nIn debugging mode, execute the next @var{n} lines of code.\n\nIf @var{n} is omitted, execute the next single line of code.  If the next\nline of code is itself defined in terms of an m-file remain in the existing\nfunction.\n\nUsing @code{dbstep in} will cause execution of the next line to step into\nany m-files defined on the next line.\n\nUsing @code{dbstep out} will cause execution to continue until the current\nfunction returns.\n\n@code{dbnext} is an alias for @code{dbstep}.\n@seealso{dbcont, dbquit}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(dbnext, dbstep) ;
 XDEFUN_INTERNAL (dbcont, args, , "-*- texinfo -*-\n@deftypefn {Command} {} dbcont\nLeave command-line debugging mode and continue code execution normally.\n@seealso{dbstep, dbquit}\n@end deftypefn") 
 XDEFUN_INTERNAL (dbquit, args, , "-*- texinfo -*-\n@deftypefn {Command} {} dbquit\nQuit debugging mode immediately without further code execution and return to\nthe Octave prompt.\n@seealso{dbcont, dbstep}\n@end deftypefn") 
 XDEFUN_INTERNAL (isdebugmode, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isdebugmode ()\nReturn true if in debugging mode, otherwise false.\n@seealso{dbwhere, dbstack, dbstatus}\n@end deftypefn") 
 XDEFUN_INTERNAL (__db_next_breakpoint_quiet__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __db_next_breakpoint_quiet__ ()\n@deftypefnx {Built-in Function} {} __db_next_breakpoint_quiet__ (@var{flag})\nDisable line info printing at the next breakpoint.\n\nWith a logical argument @var{flag}, set the state on or off.\n@end deftypefn") 
}

static void
install_defaults_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/defaults.cc")
 XDEFUN_INTERNAL (EDITOR, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} EDITOR ()\n@deftypefnx {Built-in Function} {@var{old_val} =} EDITOR (@var{new_val})\n@deftypefnx {Built-in Function} {} EDITOR (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the default text editor.\n\nThe default value is taken from the environment variable @w{@env{EDITOR}}\nwhen Octave starts.  If the environment variable is not initialized,\n@w{@env{EDITOR}} will be set to @qcode{\"emacs\"}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n\n@seealso{edit, edit_history}\n@end deftypefn") 
 XDEFUN_INTERNAL (EXEC_PATH, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} EXEC_PATH ()\n@deftypefnx {Built-in Function} {@var{old_val} =} EXEC_PATH (@var{new_val})\n@deftypefnx {Built-in Function} {} EXEC_PATH (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies a colon separated\nlist of directories to append to the shell PATH when executing external\nprograms.\n\nThe initial value of is taken from the environment variable\n@w{@env{OCTAVE_EXEC_PATH}}, but that value can be overridden by the command\nline argument @option{--exec-path PATH}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n\n@seealso{IMAGE_PATH, OCTAVE_HOME}\n@end deftypefn") 
 XDEFUN_INTERNAL (IMAGE_PATH, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} IMAGE_PATH ()\n@deftypefnx {Built-in Function} {@var{old_val} =} IMAGE_PATH (@var{new_val})\n@deftypefnx {Built-in Function} {} IMAGE_PATH (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies a colon separated\nlist of directories in which to search for image files.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n\n@seealso{EXEC_PATH, OCTAVE_HOME}\n@end deftypefn") 
 XDEFUN_INTERNAL (OCTAVE_HOME, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} OCTAVE_HOME ()\nReturn the name of the top-level Octave installation directory.\n@seealso{EXEC_PATH, IMAGE_PATH}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("OCTAVE_VERSION", FOCTAVE_VERSION, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} OCTAVE_VERSION ()\nReturn the version number of Octave as a string.\n@seealso{ver, version}\n@end deftypefn") 
}

static void
install_det_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/det.cc")
 XDEFUN_INTERNAL (det, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} det (@var{A})\n@deftypefnx {Built-in Function} {[@var{d}, @var{rcond}] =} det (@var{A})\nCompute the determinant of @var{A}.\n\nReturn an estimate of the reciprocal condition number if requested.\n\nProgramming Notes: Routines from @sc{lapack} are used for full matrices and\ncode from @sc{umfpack} is used for sparse matrices.\n\nThe determinant should not be used to check a matrix for singularity.\nFor that, use any of the condition number functions: @code{cond},\n@code{condest}, @code{rcond}.\n@seealso{cond, condest, rcond}\n@end deftypefn") 
}

static void
install_dirfns_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/dirfns.cc")
 XDEFUN_INTERNAL (cd, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} cd @var{dir}\n@deftypefnx {Command} {} cd\n@deftypefnx {Built-in Function} {@var{old_dir} =} cd (@var{dir})\n@deftypefnx {Command} {} chdir @dots{}\nChange the current working directory to @var{dir}.\n\nIf @var{dir} is omitted, the current directory is changed to the user's home\ndirectory (@qcode{\"~\"}).\n\nFor example,\n\n@example\ncd ~/octave\n@end example\n\n@noindent\nchanges the current working directory to @file{~/octave}.  If the\ndirectory does not exist, an error message is printed and the working\ndirectory is not changed.\n\n@code{chdir} is an alias for @code{cd} and can be used in all of the same\ncalling formats.\n\nCompatibility Note: When called with no arguments, @sc{matlab} prints the\npresent working directory rather than changing to the user's home directory.\n@seealso{pwd, mkdir, rmdir, dir, ls}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(chdir, cd) ;
 XDEFUN_INTERNAL (pwd, , , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} pwd ()\n@deftypefnx {Built-in Function} {@var{dir} =} pwd ()\nReturn the current working directory.\n@seealso{cd, dir, ls, mkdir, rmdir}\n@end deftypefn") 
 XDEFUN_INTERNAL (readdir, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{files} =} readdir (@var{dir})\n@deftypefnx {Built-in Function} {[@var{files}, @var{err}, @var{msg}] =} readdir (@var{dir})\nReturn the names of files in the directory @var{dir} as a cell array of\nstrings.\n\nIf an error occurs, return an empty cell array in @var{files}.\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{ls, dir, glob, what}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("mkdir", Fmkdir, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} mkdir @var{dir}\n@deftypefnx {Built-in Function} {} mkdir (@var{parent}, @var{dir})\n@deftypefnx {Built-in Function} {[@var{status}, @var{msg}, @var{msgid}] =} mkdir (@dots{})\nCreate a directory named @var{dir} in the directory @var{parent}.\n\nIf no @var{parent} directory is specified the present working directory is\nused.\n\nIf successful, @var{status} is 1, and @var{msg}, @var{msgid} are empty\ncharacter strings ("").  Otherwise, @var{status} is 0, @var{msg} contains a\nsystem-dependent error message, and @var{msgid} contains a unique message\nidentifier.\n\nWhen creating a directory permissions will be set to\n@code{0777 - @var{umask}}.\n@seealso{rmdir, pwd, cd, umask}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("rmdir", Frmdir, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} rmdir @var{dir}\n@deftypefnx {Built-in Function} {} rmdir (@var{dir}, \"s\")\n@deftypefnx {Built-in Function} {[@var{status}, @var{msg}, @var{msgid}] =} rmdir (@dots{})\nRemove the directory named @var{dir}.\n\nIf the optional second parameter is supplied with value @qcode{\"s\"},\nrecursively remove all subdirectories as well.\n\nIf successful, @var{status} is 1, and @var{msg}, @var{msgid} are empty\ncharacter strings ("").  Otherwise, @var{status} is 0, @var{msg} contains a\nsystem-dependent error message, and @var{msgid} contains a unique message\nidentifier.\n\n@seealso{mkdir, confirm_recursive_rmdir, pwd}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("link", Flink, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} link @var{old} @var{new}\n@deftypefnx {Built-in Function} {[@var{err}, @var{msg}] =} link (@var{old}, @var{new})\nCreate a new link (also known as a hard link) to an existing file.\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{symlink, unlink, readlink, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("symlink", Fsymlink, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} symlink @var{old} @var{new}\n@deftypefnx {Built-in Function} {[@var{err}, @var{msg}] =} symlink (@var{old}, @var{new})\nCreate a symbolic link @var{new} which contains the string @var{old}.\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{link, unlink, readlink, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("readlink", Freadlink, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} readlink @var{symlink}\n@deftypefnx {Built-in Function} {[@var{result}, @var{err}, @var{msg}] =} readlink (@var{symlink})\nRead the value of the symbolic link @var{symlink}.\n\nIf successful, @var{result} contains the contents of the symbolic link\n@var{symlink}, @var{err} is 0, and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{lstat, symlink, link, unlink, delete}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("rename", Frename, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} rename @var{old} @var{new}\n@deftypefnx {Built-in Function} {[@var{err}, @var{msg}] =} rename (@var{old}, @var{new})\nChange the name of file @var{old} to @var{new}.\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{movefile, copyfile, ls, dir}\n@end deftypefn") 
 XDEFUN_INTERNAL (glob, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} glob (@var{pattern})\nGiven an array of pattern strings (as a char array or a cell array) in\n@var{pattern}, return a cell array of file names that match any of\nthem, or an empty cell array if no patterns match.\n\nThe pattern strings are interpreted as filename globbing patterns (as they\nare used by Unix shells).\n\nWithin a pattern\n\n@table @code\n@item *\nmatches any string, including the null string,\n\n@item ?\nmatches any single character, and\n\n@item [@dots{}]\nmatches any of the enclosed characters.\n@end table\n\nTilde expansion is performed on each of the patterns before looking for\nmatching file names.  For example:\n\n@example\nls\n   @result{}\n      file1  file2  file3  myfile1 myfile1b\nglob (\"*file1\")\n   @result{}\n      @{\n        [1,1] = file1\n        [2,1] = myfile1\n      @}\nglob (\"myfile?\")\n   @result{}\n      @{\n        [1,1] = myfile1\n      @}\nglob (\"file[12]\")\n   @result{}\n      @{\n        [1,1] = file1\n        [2,1] = file2\n      @}\n@end example\n@seealso{ls, dir, readdir, what}\n@end deftypefn") 
 XDEFUN_INTERNAL (__fnmatch__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} fnmatch (@var{pattern}, @var{string})\nReturn true or false for each element of @var{string} that matches any of\nthe elements of the string array @var{pattern}, using the rules of\n\nfilename pattern matching.  For example:\n\n@example\n@group\nfnmatch (\"a*b\", @{\"ab\"; \"axyzb\"; \"xyzab\"@})\n     @result{} [ 1; 1; 0 ]\n@end group\n@end example\n@seealso{glob, regexp}\n@end deftypefn") 
 XDEFUN_INTERNAL (filesep, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} filesep ()\n@deftypefnx {Built-in Function} {} filesep (\"all\")\nReturn the system-dependent character used to separate directory names.\n\nIf @qcode{\"all\"} is given, the function returns all valid file separators\nin the form of a string.  The list of file separators is system-dependent.\nIt is @samp{/} (forward slash) under UNIX or @w{Mac OS X}, @samp{/} and\n@samp{\\} (forward and backward slashes) under Windows.\n@seealso{pathsep}\n@end deftypefn") 
 XDEFUN_INTERNAL (pathsep, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} pathsep ()\n@deftypefnx {Built-in Function} {@var{old_val} =} pathsep (@var{new_val})\nQuery or set the character used to separate directories in a path.\n@seealso{filesep}\n@end deftypefn") 
 XDEFUN_INTERNAL (confirm_recursive_rmdir, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} confirm_recursive_rmdir ()\n@deftypefnx {Built-in Function} {@var{old_val} =} confirm_recursive_rmdir (@var{new_val})\n@deftypefnx {Built-in Function} {} confirm_recursive_rmdir (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave\nwill ask for confirmation before recursively removing a directory tree.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{rmdir}\n@end deftypefn") 
}

static void
install_dlmread_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/dlmread.cc")
 XDEFUN_INTERNAL (dlmread, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{data} =} dlmread (@var{file})\n@deftypefnx {Built-in Function} {@var{data} =} dlmread (@var{file}, @var{sep})\n@deftypefnx {Built-in Function} {@var{data} =} dlmread (@var{file}, @var{sep}, @var{r0}, @var{c0})\n@deftypefnx {Built-in Function} {@var{data} =} dlmread (@var{file}, @var{sep}, @var{range})\n@deftypefnx {Built-in Function} {@var{data} =} dlmread (@dots{}, \"emptyvalue\", @var{EMPTYVAL})\nRead the matrix @var{data} from a text file which uses the delimiter\n@var{sep} between data values.\n\nIf @var{sep} is not defined the separator between fields is determined from\nthe file itself.\n\nGiven two scalar arguments @var{r0} and @var{c0}, these define the starting\nrow and column of the data to be read.  These values are indexed from zero,\nsuch that the first row corresponds to an index of zero.\n\nThe @var{range} parameter may be a 4-element vector containing the upper\nleft and lower right corner @code{[@var{R0},@var{C0},@var{R1},@var{C1}]}\nwhere the lowest index value is zero.  Alternatively, a spreadsheet style\nrange such as @qcode{\"A2..Q15\"} or @qcode{\"T1:AA5\"} can be used.  The\nlowest alphabetical index @qcode{'A'} refers to the first column.  The\nlowest row index is 1.\n\n@var{file} should be a file name or file id given by @code{fopen}.  In the\nlatter case, the file is read until end of file is reached.\n\nThe @qcode{\"emptyvalue\"} option may be used to specify the value used to\nfill empty fields.  The default is zero.\n@seealso{csvread, textscan, textread, dlmwrite}\n@end deftypefn") 
}

static void
install_dot_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/dot.cc")
 XDEFUN_INTERNAL (dot, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} dot (@var{x}, @var{y}, @var{dim})\nCompute the dot product of two vectors.\n\nIf @var{x} and @var{y} are matrices, calculate the dot products along the\nfirst non-singleton dimension.\n\nIf the optional argument @var{dim} is given, calculate the dot products\nalong this dimension.\n\nThis is equivalent to\n@code{sum (conj (@var{X}) .* @var{Y}, @var{dim})},\nbut avoids forming a temporary array and is faster.  When @var{X} and\n@var{Y} are column vectors, the result is equivalent to\n@code{@var{X}' * @var{Y}}.\n@seealso{cross, divergence}\n@end deftypefn") 
 XDEFUN_INTERNAL (blkmm, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} blkmm (@var{A}, @var{B})\nCompute products of matrix blocks.\n\nThe blocks are given as 2-dimensional subarrays of the arrays @var{A},\n@var{B}.  The size of @var{A} must have the form @code{[m,k,@dots{}]} and\nsize of @var{B} must be @code{[k,n,@dots{}]}.  The result is then of size\n@code{[m,n,@dots{}]} and is computed as follows:\n\n@example\n@group\nfor i = 1:prod (size (@var{A})(3:end))\n  @var{C}(:,:,i) = @var{A}(:,:,i) * @var{B}(:,:,i)\nendfor\n@end group\n@end example\n@end deftypefn") 
}

static void
install_eig_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/eig.cc")
 XDEFUN_INTERNAL (eig, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{lambda} =} eig (@var{A})\n@deftypefnx {Built-in Function} {@var{lambda} =} eig (@var{A}, @var{B})\n@deftypefnx {Built-in Function} {[@var{V}, @var{lambda}] =} eig (@var{A})\n@deftypefnx {Built-in Function} {[@var{V}, @var{lambda}] =} eig (@var{A}, @var{B})\nCompute the eigenvalues (and optionally the eigenvectors) of a matrix\nor a pair of matrices\n\nThe algorithm used depends on whether there are one or two input\nmatrices, if they are real or complex, and if they are symmetric\n(Hermitian if complex) or non-symmetric.\n\nThe eigenvalues returned by @code{eig} are not ordered.\n@seealso{eigs, svd}\n@end deftypefn") 
}

static void
install_ellipj_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/ellipj.cc")
 XDEFUN_INTERNAL (ellipj, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{sn}, @var{cn}, @var{dn}, @var{err}] =} ellipj (@var{u}, @var{m})\n@deftypefnx {Built-in Function} {[@var{sn}, @var{cn}, @var{dn}, @var{err}] =} ellipj (@var{u}, @var{m}, @var{tol})\nCompute the Jacobi elliptic functions @var{sn}, @var{cn}, and @var{dn}\nof complex argument @var{u} and real parameter @var{m}.\n\nIf @var{m} is a scalar, the results are the same size as @var{u}.\nIf @var{u} is a scalar, the results are the same size as @var{m}.\nIf @var{u} is a column vector and @var{m} is a row vector, the\nresults are matrices with @code{length (@var{u})} rows and\n@code{length (@var{m})} columns.  Otherwise, @var{u} and\n@var{m} must conform in size and the results will be the same size as the\ninputs.\n\nThe value of @var{u} may be complex.\nThe value of @var{m} must be 0 @leq{} @var{m} @leq{} 1.\n\nThe optional input @var{tol} is currently ignored (@sc{matlab} uses this to\nallow faster, less accurate approximation).\n\nIf requested, @var{err} contains the following status information\nand is the same size as the result.\n\n@enumerate 0\n@item\nNormal return.\n\n@item\nError---no computation, algorithm termination condition not met,\nreturn @code{NaN}.\n@end enumerate\n\nReference: Milton @nospell{Abramowitz} and Irene A @nospell{Stegun},\n@cite{Handbook of Mathematical Functions}, Chapter 16 (Sections 16.4, 16.13,\nand 16.15), Dover, 1965.\n\n@seealso{ellipke}\n@end deftypefn") 
}

static void
install_error_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/error.cc")
 XDEFUN_INTERNAL (rethrow, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} rethrow (@var{err})\nReissue a previous error as defined by @var{err}.\n\n@var{err} is a structure that must contain at least the @qcode{\"message\"}\nand @qcode{\"identifier\"} fields.  @var{err} can also contain a field\n@qcode{\"stack\"} that gives information on the assumed location of the\nerror.  Typically @var{err} is returned from @code{lasterror}.\n@seealso{lasterror, lasterr, error}\n@end deftypefn") 
 XDEFUN_INTERNAL (error, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} error (@var{template}, @dots{})\n@deftypefnx {Built-in Function} {} error (@var{id}, @var{template}, @dots{})\nDisplay an error message and stop m-file execution.\n\nFormat the optional arguments under the control of the template string\n@var{template} using the same rules as the @code{printf} family of\nfunctions (@pxref{Formatted Output}) and print the resulting message\non the @code{stderr} stream.  The message is prefixed by the character\nstring @samp{error: }.\n\nCalling @code{error} also sets Octave's internal error state such that\ncontrol will return to the top level without evaluating any further\ncommands.  This is useful for aborting from functions or scripts.\n\nIf the error message does not end with a newline character, Octave will\nprint a traceback of all the function calls leading to the error.  For\nexample, given the following function definitions:\n\n@example\n@group\nfunction f () g (); end\nfunction g () h (); end\nfunction h () nargin == 1 || error (\"nargin != 1\"); end\n@end group\n@end example\n\n@noindent\ncalling the function @code{f} will result in a list of messages that\ncan help you to quickly locate the exact location of the error:\n\n@example\n@group\nf ()\nerror: nargin != 1\nerror: called from:\nerror:   error at line -1, column -1\nerror:   h at line 1, column 27\nerror:   g at line 1, column 15\nerror:   f at line 1, column 15\n@end group\n@end example\n\nIf the error message ends in a newline character, Octave will print the\nmessage but will not display any traceback messages as it returns\ncontrol to the top level.  For example, modifying the error message\nin the previous example to end in a newline causes Octave to only print\na single message:\n\n@example\n@group\nfunction h () nargin == 1 || error (\"nargin != 1\\n\"); end\nf ()\nerror: nargin != 1\n@end group\n@end example\n\nA null string (\"\") input to @code{error} will be ignored and the code\nwill continue running as if the statement were a NOP@.  This is for\ncompatibility with @sc{matlab}.  It also makes it possible to write code such\nas\n\n@example\n@group\nerr_msg = \"\";\nif (CONDITION 1)\n  err_msg = \"CONDITION 1 found\";\nelseif (CONDITION2)\n  err_msg = \"CONDITION 2 found\";\n@dots{}\nendif\nerror (err_msg);\n@end group\n@end example\n\n@noindent\nwhich will only stop execution if an error has been found.\n\nImplementation Note: For compatibility with @sc{matlab}, escape\nsequences in @var{template} (e.g., @qcode{\"@xbackslashchar{}n\"} =>\nnewline) are processed regardless of whether @var{template} has been defined\nwith single quotes, as long as there are two or more input arguments.  To\ndisable escape sequence expansion use a second backslash before the sequence\n(e.g., @qcode{\"@xbackslashchar{}@xbackslashchar{}n\"}) or use the\n@code{regexptranslate} function.\n@seealso{warning, lasterror}\n@end deftypefn") 
 XDEFUN_INTERNAL (warning, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} warning (@var{template}, @dots{})\n@deftypefnx {Built-in Function} {} warning (@var{id}, @var{template}, @dots{})\n@deftypefnx {Built-in Function} {} warning (\"on\", @var{id})\n@deftypefnx {Built-in Function} {} warning (\"off\", @var{id})\n@deftypefnx {Built-in Function} {} warning (\"query\", @var{id})\n@deftypefnx {Built-in Function} {} warning (\"error\", @var{id})\n@deftypefnx {Built-in Function} {} warning (@var{state}, \"backtrace\")\n@deftypefnx {Built-in Function} {} warning (@var{state}, @var{id}, \"local\")\nDisplay a warning message or control the behavior of Octave's warning system.\n\nFormat the optional arguments under the control of the template string\n@var{template} using the same rules as the @code{printf} family of\nfunctions (@pxref{Formatted Output}) and print the resulting message\non the @code{stderr} stream.  The message is prefixed by the character\nstring @samp{warning: }.\nYou should use this function when you want to notify the user\nof an unusual condition, but only when it makes sense for your program\nto go on.\n\nThe optional message identifier allows users to enable or disable\nwarnings tagged by @var{id}.  A message identifier is of the form\n\"NAMESPACE:WARNING-NAME\".  Octave's own warnings use the @qcode{\"Octave\"}\nnamespace (@pxref{XREFwarning_ids}).  The special identifier @qcode{\"all\"}\nmay be used to set the state of all warnings.\n\nIf the first argument is @qcode{\"on\"} or @qcode{\"off\"},\nset the state of a particular warning using the identifier @var{id}.  If the\nfirst argument is @qcode{\"query\"}, query the state of this warning\ninstead.  If the identifier is omitted, a value of @qcode{\"all\"} is\nassumed.  If you set the state of a warning to @qcode{\"error\"}, the\nwarning named by @var{id} is handled as if it were an error instead.  So,\nfor example, the following handles all warnings as errors:\n\n@example\n@group\nwarning (\"error\");\n@end group\n@end example\n\nIf the state is @qcode{\"on\"} or @qcode{\"off\"} and the third argument\nis @qcode{\"backtrace\"}, then a stack trace is printed along with the\nwarning message when warnings occur inside function calls.  This option\nis enabled by default.\n\nIf the state is @qcode{\"on\"}, @qcode{\"off\"}, or @qcode{\"error\"}\nand the third argument is @qcode{\"local\"}, then the warning state\nwill be set temporarily, until the end of the current function.\nChanges to warning states that are set locally affect the current\nfunction and all functions called from the current scope.  The\nprevious warning state is restored on return from the current\nfunction.  The @qcode{\"local\"} option is ignored if used in the top-level\nworkspace.\n\nImplementation Note: For compatibility with @sc{matlab}, escape\nsequences in @var{template} (e.g., @qcode{\"@xbackslashchar{}n\"} =>\nnewline) are processed regardless of whether @var{template} has been defined\nwith single quotes, as long as there are two or more input arguments.  To\ndisable escape sequence expansion use a second backslash before the sequence\n(e.g., @qcode{\"@xbackslashchar{}@xbackslashchar{}n\"}) or use the\n@code{regexptranslate} function.\n@seealso{warning_ids, lastwarn, error}\n@end deftypefn") 
 XDEFUN_INTERNAL (lasterror, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{lasterr} =} lasterror ()\n@deftypefnx {Built-in Function} {} lasterror (@var{err})\n@deftypefnx {Built-in Function} {} lasterror (\"reset\")\nQuery or set the last error message structure.\n\nWhen called without arguments, return a structure containing the last error\nmessage and other information related to this error.  The elements of the\nstructure are:\n\n@table @code\n@item message\nThe text of the last error message\n\n@item identifier\nThe message identifier of this error message\n\n@item stack\nA structure containing information on where the message occurred.  This may\nbe an empty structure if the information cannot be obtained.  The fields of\nthe structure are:\n\n@table @code\n@item file\nThe name of the file where the error occurred\n\n@item name\nThe name of function in which the error occurred\n\n@item line\nThe line number at which the error occurred\n\n@item column\nAn optional field with the column number at which the error occurred\n@end table\n@end table\n\nThe last error structure may be set by passing a scalar structure, @var{err},\nas input.  Any fields of @var{err} that match those above are set while any\nunspecified fields are initialized with default values.\n\nIf @code{lasterror} is called with the argument @qcode{\"reset\"}, all\nfields are set to their default values.\n@seealso{lasterr, error, lastwarn}\n@end deftypefn") 
 XDEFUN_INTERNAL (lasterr, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{msg}, @var{msgid}] =} lasterr ()\n@deftypefnx {Built-in Function} {} lasterr (@var{msg})\n@deftypefnx {Built-in Function} {} lasterr (@var{msg}, @var{msgid})\nQuery or set the last error message.\n\nWhen called without input arguments, return the last error message and\nmessage identifier.\n\nWith one argument, set the last error message to @var{msg}.\n\nWith two arguments, also set the last message identifier.\n@seealso{lasterror, error, lastwarn}\n@end deftypefn") 
 XDEFUN_INTERNAL (lastwarn, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{msg}, @var{msgid}] =} lastwarn ()\n@deftypefnx {Built-in Function} {} lastwarn (@var{msg})\n@deftypefnx {Built-in Function} {} lastwarn (@var{msg}, @var{msgid})\nQuery or set the last warning message.\n\nWhen called without input arguments, return the last warning message and\nmessage identifier.\n\nWith one argument, set the last warning message to @var{msg}.\n\nWith two arguments, also set the last message identifier.\n@seealso{warning, lasterror, lasterr}\n@end deftypefn") 
 XDEFUN_INTERNAL (__usage__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} usage (@var{msg})\nPrint the message @var{msg}, prefixed by the string @samp{usage: }, and\nset Octave's internal error state such that control will return to the\ntop level without evaluating any more commands.  This is useful for\naborting from functions.\n\nAfter @code{usage} is evaluated, Octave will print a traceback of all\nthe function calls leading to the usage message.\n\nYou should use this function for reporting problems errors that result\nfrom an improper call to a function, such as calling a function with an\nincorrect number of arguments, or with arguments of the wrong type.  For\nexample, most functions distributed with Octave begin with code like\nthis\n\n@example\n@group\nif (nargin != 2)\n  usage (\"foo (a, b)\");\nendif\n@end group\n@end example\n\n@noindent\nto check for the proper number of arguments.\n@end deftypefn") 
 XDEFUN_INTERNAL (beep_on_error, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} beep_on_error ()\n@deftypefnx {Built-in Function} {@var{old_val} =} beep_on_error (@var{new_val})\n@deftypefnx {Built-in Function} {} beep_on_error (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will try\nto ring the terminal bell before printing an error message.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
 XDEFUN_INTERNAL (debug_on_error, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} debug_on_error ()\n@deftypefnx {Built-in Function} {@var{old_val} =} debug_on_error (@var{new_val})\n@deftypefnx {Built-in Function} {} debug_on_error (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will try\nto enter the debugger when an error is encountered.\n\nThis will also inhibit printing of the normal traceback message (you will\nonly see the top-level error message).\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{debug_on_warning, debug_on_interrupt}\n@end deftypefn") 
 XDEFUN_INTERNAL (debug_on_warning, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} debug_on_warning ()\n@deftypefnx {Built-in Function} {@var{old_val} =} debug_on_warning (@var{new_val})\n@deftypefnx {Built-in Function} {} debug_on_warning (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will try\nto enter the debugger when a warning is encountered.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{debug_on_error, debug_on_interrupt}\n@end deftypefn") 
}

static void
install_fft_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/fft.cc")
 XDEFUN_INTERNAL (fft, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fft (@var{x})\n@deftypefnx {Built-in Function} {} fft (@var{x}, @var{n})\n@deftypefnx {Built-in Function} {} fft (@var{x}, @var{n}, @var{dim})\nCompute the discrete Fourier transform of @var{A} using\na Fast Fourier Transform (FFT) algorithm.\n\nThe FFT is calculated along the first non-singleton dimension of the\narray.  Thus if @var{x} is a matrix, @code{fft (@var{x})} computes the\nFFT for each column of @var{x}.\n\nIf called with two arguments, @var{n} is expected to be an integer\nspecifying the number of elements of @var{x} to use, or an empty\nmatrix to specify that its value should be ignored.  If @var{n} is\nlarger than the dimension along which the FFT is calculated, then\n@var{x} is resized and padded with zeros.  Otherwise, if @var{n} is\nsmaller than the dimension along which the FFT is calculated, then\n@var{x} is truncated.\n\nIf called with three arguments, @var{dim} is an integer specifying the\ndimension of the matrix along which the FFT is performed\n@seealso{ifft, fft2, fftn, fftw}\n@end deftypefn") 
 XDEFUN_INTERNAL (ifft, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} ifft (@var{x})\n@deftypefnx {Built-in Function} {} ifft (@var{x}, @var{n})\n@deftypefnx {Built-in Function} {} ifft (@var{x}, @var{n}, @var{dim})\nCompute the inverse discrete Fourier transform of @var{A}\nusing a Fast Fourier Transform (FFT) algorithm.\n\nThe inverse FFT is calculated along the first non-singleton dimension\nof the array.  Thus if @var{x} is a matrix, @code{fft (@var{x})} computes\nthe inverse FFT for each column of @var{x}.\n\nIf called with two arguments, @var{n} is expected to be an integer\nspecifying the number of elements of @var{x} to use, or an empty\nmatrix to specify that its value should be ignored.  If @var{n} is\nlarger than the dimension along which the inverse FFT is calculated, then\n@var{x} is resized and padded with zeros.  Otherwise, if @var{n} is\nsmaller than the dimension along which the inverse FFT is calculated,\nthen @var{x} is truncated.\n\nIf called with three arguments, @var{dim} is an integer specifying the\ndimension of the matrix along which the inverse FFT is performed\n@seealso{fft, ifft2, ifftn, fftw}\n@end deftypefn") 
}

static void
install_fft2_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/fft2.cc")
 XDEFUN_INTERNAL (fft2, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fft2 (@var{A})\n@deftypefnx {Built-in Function} {} fft2 (@var{A}, @var{m}, @var{n})\nCompute the two-dimensional discrete Fourier transform of @var{A} using\na Fast Fourier Transform (FFT) algorithm.\n\nThe optional arguments @var{m} and @var{n} may be used specify the number of\nrows and columns of @var{A} to use.  If either of these is larger than the\nsize of @var{A}, @var{A} is resized and padded with zeros.\n\nIf @var{A} is a multi-dimensional matrix, each two-dimensional sub-matrix\nof @var{A} is treated separately.\n@seealso{ifft2, fft, fftn, fftw}\n@end deftypefn") 
 XDEFUN_INTERNAL (ifft2, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} ifft2 (@var{A})\n@deftypefnx {Built-in Function} {} ifft2 (@var{A}, @var{m}, @var{n})\nCompute the inverse two-dimensional discrete Fourier transform of @var{A}\nusing a Fast Fourier Transform (FFT) algorithm.\n\nThe optional arguments @var{m} and @var{n} may be used specify the number of\nrows and columns of @var{A} to use.  If either of these is larger than the\nsize of @var{A}, @var{A} is resized and padded with zeros.\n\nIf @var{A} is a multi-dimensional matrix, each two-dimensional sub-matrix\nof @var{A} is treated separately\n@seealso{fft2, ifft, ifftn, fftw}\n@end deftypefn") 
}

static void
install_fftn_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/fftn.cc")
 XDEFUN_INTERNAL (fftn, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fftn (@var{A})\n@deftypefnx {Built-in Function} {} fftn (@var{A}, @var{size})\nCompute the N-dimensional discrete Fourier transform of @var{A} using\na Fast Fourier Transform (FFT) algorithm.\n\nThe optional vector argument @var{size} may be used specify the dimensions\nof the array to be used.  If an element of @var{size} is smaller than the\ncorresponding dimension of @var{A}, then the dimension of @var{A} is\ntruncated prior to performing the FFT@.  Otherwise, if an element of\n@var{size} is larger than the corresponding dimension then @var{A} is\nresized and padded with zeros.\n@seealso{ifftn, fft, fft2, fftw}\n@end deftypefn") 
 XDEFUN_INTERNAL (ifftn, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} ifftn (@var{A})\n@deftypefnx {Built-in Function} {} ifftn (@var{A}, @var{size})\nCompute the inverse N-dimensional discrete Fourier transform of @var{A}\nusing a Fast Fourier Transform (FFT) algorithm.\n\nThe optional vector argument @var{size} may be used specify the dimensions\nof the array to be used.  If an element of @var{size} is smaller than the\ncorresponding dimension of @var{A}, then the dimension of @var{A} is\ntruncated prior to performing the inverse FFT@.  Otherwise, if an element of\n@var{size} is larger than the corresponding dimension then @var{A} is\nresized and padded with zeros.\n@seealso{fftn, ifft, ifft2, fftw}\n@end deftypefn") 
}

static void
install_file_io_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/file-io.cc")
 XDEFUN_INTERNAL (fclose, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fclose (@var{fid})\n@deftypefnx {Built-in Function} {} fclose (\"all\")\n@deftypefnx {Built-in Function} {@var{status} =} fclose (\"all\")\nClose the file specified by the file descriptor @var{fid}.\n\nIf successful, @code{fclose} returns 0, otherwise, it returns -1.  The\nsecond form of the @code{fclose} call closes all open files except\n@code{stdout}, @code{stderr}, and @code{stdin}.\n\nProgramming Note: When using @qcode{\"all\"} the file descriptors associated\nwith gnuplot will also be closed.  This will prevent further plotting with\ngnuplot until Octave is closed and restarted.\n@seealso{fopen, fflush, freport}\n@end deftypefn") 
 XDEFUN_INTERNAL (fclear, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} fclear (@var{fid})\nClear the stream state for the file specified by the file descriptor\n@var{fid}.\n@seealso{ferror, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fflush, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} fflush (@var{fid})\nFlush output to file descriptor @var{fid}.\n\n@code{fflush} returns 0 on success and an OS dependent error value\n(@minus{}1 on Unix) on error.\n\nProgramming Note: Flushing is useful for ensuring that all pending output\nmakes it to the screen before some other event occurs.  For example, it is\nalways a good idea to flush the standard output stream before calling\n@code{input}.\n@seealso{fopen, fclose}\n@end deftypefn") 
 XDEFUN_INTERNAL (fgetl, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{str} =} fgetl (@var{fid})\n@deftypefnx {Built-in Function} {@var{str} =} fgetl (@var{fid}, @var{len})\nRead characters from a file, stopping after a newline, or EOF,\nor @var{len} characters have been read.\n\nThe characters read, excluding the possible trailing newline, are returned\nas a string.\n\nIf @var{len} is omitted, @code{fgetl} reads until the next newline character.\n\nIf there are no more characters to read, @code{fgetl} returns @minus{}1.\n\nTo read a line and return the terminating newline see @code{fgets}.\n@seealso{fgets, fscanf, fread, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fgets, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{str} =} fgets (@var{fid})\n@deftypefnx {Built-in Function} {@var{str} =} fgets (@var{fid}, @var{len})\nRead characters from a file, stopping after a newline, or EOF,\nor @var{len} characters have been read.\n\nThe characters read, including the possible trailing newline, are returned\nas a string.\n\nIf @var{len} is omitted, @code{fgets} reads until the next newline character.\n\nIf there are no more characters to read, @code{fgets} returns @minus{}1.\n\nTo read a line and discard the terminating newline see @code{fgetl}.\n@seealso{fputs, fgetl, fscanf, fread, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fskipl, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{nlines} =} fskipl (@var{fid})\n@deftypefnx {Built-in Function} {@var{nlines} =} fskipl (@var{fid}, @var{count})\n@deftypefnx {Built-in Function} {@var{nlines} =} fskipl (@var{fid}, Inf)\nRead and skip @var{count} lines from the file specified by the file\ndescriptor @var{fid}.\n\n@code{fskipl} discards characters until an end-of-line is encountered exactly\n@var{count}-times, or until the end-of-file marker is found.\n\nIf @var{count} is omitted, it defaults to 1.  @var{count} may also be\n@code{Inf}, in which case lines are skipped until the end of the file.\nThis form is suitable for counting the number of lines in a file.\n\nReturns the number of lines skipped (end-of-line sequences encountered).\n@seealso{fgetl, fgets, fscanf, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fopen, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{fid} =} fopen (@var{name})\n@deftypefnx {Built-in Function} {@var{fid} =} fopen (@var{name}, @var{mode})\n@deftypefnx {Built-in Function} {@var{fid} =} fopen (@var{name}, @var{mode}, @var{arch})\n@deftypefnx {Built-in Function} {[@var{fid}, @var{msg}] =} fopen (@dots{})\n@deftypefnx {Built-in Function} {@var{fid_list} =} fopen (\"all\")\n@deftypefnx {Built-in Function} {[@var{file}, @var{mode}, @var{arch}] =} fopen (@var{fid})\nOpen a file for low-level I/O or query open files and file descriptors.\n\nThe first form of the @code{fopen} function opens the named file with\nthe specified mode (read-write, read-only, etc.) and architecture\ninterpretation (IEEE big endian, IEEE little endian, etc.), and returns\nan integer value that may be used to refer to the file later.  If an\nerror occurs, @var{fid} is set to @minus{}1 and @var{msg} contains the\ncorresponding system error message.  The @var{mode} is a one or two\ncharacter string that specifies whether the file is to be opened for\nreading, writing, or both.\n\nThe second form of the @code{fopen} function returns a vector of file ids\ncorresponding to all the currently open files, excluding the\n@code{stdin}, @code{stdout}, and @code{stderr} streams.\n\nThe third form of the @code{fopen} function returns information about the\nopen file given its file id.\n\nFor example,\n\n@example\nmyfile = fopen (\"splat.dat\", \"r\", \"ieee-le\");\n@end example\n\n@noindent\nopens the file @file{splat.dat} for reading.  If necessary, binary\nnumeric values will be read assuming they are stored in IEEE format with\nthe least significant bit first, and then converted to the native\nrepresentation.\n\nOpening a file that is already open simply opens it again and returns a\nseparate file id.  It is not an error to open a file several times,\nthough writing to the same file through several different file ids may\nproduce unexpected results.\n\nThe possible values @samp{mode} may have are\n\n@table @asis\n@item @samp{r} (default)\nOpen a file for reading.\n\n@item @samp{w}\nOpen a file for writing.  The previous contents are discarded.\n\n@item @samp{a}\nOpen or create a file for writing at the end of the file.\n\n@item @samp{r+}\nOpen an existing file for reading and writing.\n\n@item @samp{w+}\nOpen a file for reading or writing.  The previous contents are\ndiscarded.\n\n@item @samp{a+}\nOpen or create a file for reading or writing at the end of the\nfile.\n@end table\n\nAppend a @qcode{\"t\"} to the mode string to open the file in text mode or a\n@qcode{\"b\"} to open in binary mode.  On Windows and Macintosh systems, text\nmode reading and writing automatically converts linefeeds to the\nappropriate line end character for the system (carriage-return linefeed\non Windows, carriage-return on Macintosh).  The default when no mode is\nspecified is binary mode.\n\nAdditionally, you may append a @qcode{\"z\"} to the mode string to open a\ngzipped file for reading or writing.  For this to be successful, you\nmust also open the file in binary mode.\n\nThe parameter @var{arch} is a string specifying the default data format\nfor the file.  Valid values for @var{arch} are:\n\n@table @samp\n@item native (default)\nThe format of the current machine.\n\n@item ieee-be\nIEEE big endian format.\n\n@item ieee-le\nIEEE little endian format.\n@end table\n\n@noindent\nhowever, conversions are currently only supported for @samp{native}\n@samp{ieee-be}, and @samp{ieee-le} formats.\n\nWhen opening a new file that does not yet exist, permissions will be set to\n@code{0666 - @var{umask}}.\n@seealso{fclose, fgets, fgetl, fscanf, fread, fputs, fdisp, fprintf, fwrite, fskipl, fseek, frewind, ftell, feof, ferror, fclear, fflush, freport, umask}\n@end deftypefn") 
 XDEFUN_INTERNAL (freport, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} freport ()\nPrint a list of which files have been opened, and whether they are open\nfor reading, writing, or both.\n\nFor example:\n\n@example\n@group\nfreport ()\n\n     @print{}  number  mode  arch       name\n     @print{}  ------  ----  ----       ----\n     @print{}     0     r    ieee-le    stdin\n     @print{}     1     w    ieee-le    stdout\n     @print{}     2     w    ieee-le    stderr\n     @print{}     3     r    ieee-le    myfile\n@end group\n@end example\n@seealso{fopen, fclose, is_valid_file_id}\n@end deftypefn") 
 XDEFUN_INTERNAL (frewind, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} frewind (@var{fid})\n@deftypefnx {Built-in Function} {@var{status} =} frewind (@var{fid})\nMove the file pointer to the beginning of the file specified by file\ndescriptor @var{fid}.\n\n@code{frewind} returns 0 for success, and -1 if an error is encountered.  It\nis equivalent to @code{fseek (@var{fid}, 0, SEEK_SET)}.\n@seealso{fseek, ftell, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fseek, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fseek (@var{fid}, @var{offset})\n@deftypefnx {Built-in Function} {} fseek (@var{fid}, @var{offset}, @var{origin})\n@deftypefnx {Built-in Function} {@var{status} =} fseek (@dots{})\nSet the file pointer to the location @var{offset} within the file @var{fid}.\n\nThe pointer is positioned @var{offset} characters from the @var{origin},\nwhich may be one of the predefined variables @w{@code{SEEK_CUR}} (current\nposition), @w{@code{SEEK_SET}} (beginning), or @w{@code{SEEK_END}} (end of\nfile) or strings @qcode{\"cof\"}, @qcode{\"bof\"} or @qcode{\"eof\"}.  If\n@var{origin} is omitted, @w{@code{SEEK_SET}} is assumed.  @var{offset} may\nbe positive, negative, or zero but not all combinations of @var{origin} and\n@var{offset} can be realized.\n\n@code{fseek} returns 0 on success and -1 on error.\n@seealso{fskipl, frewind, ftell, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (ftell, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{pos} =} ftell (@var{fid})\nReturn the position of the file pointer as the number of characters from the\nbeginning of the file specified by file descriptor @var{fid}.\n@seealso{fseek, frewind, feof, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fprintf, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fprintf (@var{fid}, @var{template}, @dots{})\n@deftypefnx {Built-in Function} {} fprintf (@var{template}, @dots{})\n@deftypefnx {Built-in Function} {@var{numbytes} =} fprintf (@dots{})\nThis function is equivalent to @code{printf}, except that the output is\nwritten to the file descriptor @var{fid} instead of @code{stdout}.\n\nIf @var{fid} is omitted, the output is written to @code{stdout} making the\nfunction exactly equivalent to @code{printf}.\n\nThe optional output returns the number of bytes written to the file.\n\nImplementation Note: For compatibility with @sc{matlab}, escape sequences in\nthe template string (e.g., @qcode{\"@xbackslashchar{}n\"} => newline) are\nexpanded even when the template string is defined with single quotes.\n@seealso{fputs, fdisp, fwrite, fscanf, printf, sprintf, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (printf, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} printf (@var{template}, @dots{})\nPrint optional arguments under the control of the template string\n@var{template} to the stream @code{stdout} and return the number of\ncharacters printed.\n@ifclear OCTAVE_MANUAL\n\nSee the Formatted Output section of the GNU Octave manual for a\ncomplete description of the syntax of the template string.\n@end ifclear\n\nImplementation Note: For compatibility with @sc{matlab}, escape sequences in\nthe template string (e.g., @qcode{\"@xbackslashchar{}n\"} => newline) are\nexpanded even when the template string is defined with single quotes.\n@seealso{fprintf, sprintf, scanf}\n@end deftypefn") 
 XDEFUN_INTERNAL (fputs, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fputs (@var{fid}, @var{string})\n@deftypefnx {Built-in Function} {@var{status} =} fputs (@var{fid}, @var{string})\nWrite the string @var{string} to the file with file descriptor @var{fid}.\n\nThe string is written to the file with no additional formatting.  Use\n@code{fdisp} instead to automatically append a newline character appropriate\nfor the local machine.\n\nReturn a non-negative number on success or EOF on error.\n@seealso{fdisp, fprintf, fwrite, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (puts, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} puts (@var{string})\n@deftypefnx {Built-in Function} {@var{status} =} puts (@var{string})\nWrite a string to the standard output with no formatting.\n\nThe string is written verbatim to the standard output.  Use @code{disp} to\nautomatically append a newline character appropriate for the local machine.\n\nReturn a non-negative number on success and EOF on error.\n@seealso{fputs, disp}\n@end deftypefn") 
 XDEFUN_INTERNAL (sprintf, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} sprintf (@var{template}, @dots{})\nThis is like @code{printf}, except that the output is returned as a\nstring.\n\nUnlike the C library function, which requires you to provide a suitably\nsized string as an argument, Octave's @code{sprintf} function returns the\nstring, automatically sized to hold all of the items converted.\n\nImplementation Note: For compatibility with @sc{matlab}, escape sequences in\nthe template string (e.g., @qcode{\"@xbackslashchar{}n\"} => newline) are\nexpanded even when the template string is defined with single quotes.\n@seealso{printf, fprintf, sscanf}\n@end deftypefn") 
 XDEFUN_INTERNAL (fscanf, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{val}, @var{count}, @var{errmsg}] =} fscanf (@var{fid}, @var{template}, @var{size})\n@deftypefnx {Built-in Function} {[@var{v1}, @var{v2}, @dots{}, @var{count}, @var{errmsg}] =} fscanf (@var{fid}, @var{template}, \"C\")\nIn the first form, read from @var{fid} according to @var{template},\nreturning the result in the matrix @var{val}.\n\nThe optional argument @var{size} specifies the amount of data to read\nand may be one of\n\n@table @code\n@item Inf\nRead as much as possible, returning a column vector.\n\n@item @var{nr}\nRead up to @var{nr} elements, returning a column vector.\n\n@item [@var{nr}, Inf]\nRead as much as possible, returning a matrix with @var{nr} rows.  If the\nnumber of elements read is not an exact multiple of @var{nr}, the last\ncolumn is padded with zeros.\n\n@item [@var{nr}, @var{nc}]\nRead up to @code{@var{nr} * @var{nc}} elements, returning a matrix with\n@var{nr} rows.  If the number of elements read is not an exact multiple\nof @var{nr}, the last column is padded with zeros.\n@end table\n\n@noindent\nIf @var{size} is omitted, a value of @code{Inf} is assumed.\n\nA string is returned if @var{template} specifies only character conversions.\n\nThe number of items successfully read is returned in @var{count}.\n\nIf an error occurs, @var{errmsg} contains a system-dependent error message.\n\nIn the second form, read from @var{fid} according to @var{template},\nwith each conversion specifier in @var{template} corresponding to a\nsingle scalar return value.  This form is more ``C-like'', and also\ncompatible with previous versions of Octave.  The number of successful\nconversions is returned in @var{count}\n@ifclear OCTAVE_MANUAL\n\nSee the Formatted Input section of the GNU Octave manual for a\ncomplete description of the syntax of the template string.\n@end ifclear\n@seealso{fgets, fgetl, fread, scanf, sscanf, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (sscanf, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{val}, @var{count}, @var{errmsg}, @var{pos}] =} sscanf (@var{string}, @var{template}, @var{size})\n@deftypefnx {Built-in Function} {[@var{v1}, @var{v2}, @dots{}, @var{count}, @var{errmsg}] =} sscanf (@var{string}, @var{template}, \"C\")\nThis is like @code{fscanf}, except that the characters are taken from the\nstring @var{string} instead of from a stream.\n\nReaching the end of the string is treated as an end-of-file condition.  In\naddition to the values returned by @code{fscanf}, the index of the next\ncharacter to be read is returned in @var{pos}.\n@seealso{fscanf, scanf, sprintf}\n@end deftypefn") 
 XDEFUN_INTERNAL (scanf, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{val}, @var{count}, @var{errmsg}] =} scanf (@var{template}, @var{size})\n@deftypefnx {Built-in Function} {[@var{v1}, @var{v2}, @dots{}, @var{count}, @var{errmsg}]] =} scanf (@var{template}, \"C\")\nThis is equivalent to calling @code{fscanf} with @var{fid} = @code{stdin}.\n\nIt is currently not useful to call @code{scanf} in interactive programs.\n@seealso{fscanf, sscanf, printf}\n@end deftypefn") 
 XDEFUN_INTERNAL (fread, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} fread (@var{fid})\n@deftypefnx {Built-in Function} {@var{val} =} fread (@var{fid}, @var{size})\n@deftypefnx {Built-in Function} {@var{val} =} fread (@var{fid}, @var{size}, @var{precision})\n@deftypefnx {Built-in Function} {@var{val} =} fread (@var{fid}, @var{size}, @var{precision}, @var{skip})\n@deftypefnx {Built-in Function} {@var{val} =} fread (@var{fid}, @var{size}, @var{precision}, @var{skip}, @var{arch})\n@deftypefnx {Built-in Function} {[@var{val}, @var{count}] =} fread (@dots{})\nRead binary data from the file specified by the file descriptor @var{fid}.\n\nThe optional argument @var{size} specifies the amount of data to read\nand may be one of\n\n@table @code\n@item Inf\nRead as much as possible, returning a column vector.\n\n@item @var{nr}\nRead up to @var{nr} elements, returning a column vector.\n\n@item [@var{nr}, Inf]\nRead as much as possible, returning a matrix with @var{nr} rows.  If the\nnumber of elements read is not an exact multiple of @var{nr}, the last\ncolumn is padded with zeros.\n\n@item [@var{nr}, @var{nc}]\nRead up to @code{@var{nr} * @var{nc}} elements, returning a matrix with\n@var{nr} rows.  If the number of elements read is not an exact multiple\nof @var{nr}, the last column is padded with zeros.\n@end table\n\n@noindent\nIf @var{size} is omitted, a value of @code{Inf} is assumed.\n\nThe optional argument @var{precision} is a string specifying the type of\ndata to read and may be one of\n\n@table @asis\n@item  @qcode{\"schar\"}\n@itemx @qcode{\"signed char\"}\nSigned character.\n\n@item  @qcode{\"uchar\"}\n@itemx @qcode{\"unsigned char\"}\nUnsigned character.\n\n@item  @qcode{\"int8\"}\n@itemx @qcode{\"integer*1\"}\n\n8-bit signed integer.\n\n@item  @qcode{\"int16\"}\n@itemx @qcode{\"integer*2\"}\n16-bit signed integer.\n\n@item  @qcode{\"int32\"}\n@itemx @qcode{\"integer*4\"}\n32-bit signed integer.\n\n@item  @qcode{\"int64\"}\n@itemx @qcode{\"integer*8\"}\n64-bit signed integer.\n\n@item @qcode{\"uint8\"}\n8-bit unsigned integer.\n\n@item @qcode{\"uint16\"}\n16-bit unsigned integer.\n\n@item @qcode{\"uint32\"}\n32-bit unsigned integer.\n\n@item @qcode{\"uint64\"}\n64-bit unsigned integer.\n\n@item  @qcode{\"single\"}\n@itemx @qcode{\"float32\"}\n@itemx @qcode{\"real*4\"}\n32-bit floating point number.\n\n@item  @qcode{\"double\"}\n@itemx @qcode{\"float64\"}\n@itemx @qcode{\"real*8\"}\n64-bit floating point number.\n\n@item  @qcode{\"char\"}\n@itemx @qcode{\"char*1\"}\nSingle character.\n\n@item @qcode{\"short\"}\nShort integer (size is platform dependent).\n\n@item @qcode{\"int\"}\nInteger (size is platform dependent).\n\n@item @qcode{\"long\"}\nLong integer (size is platform dependent).\n\n@item  @qcode{\"ushort\"}\n@itemx @qcode{\"unsigned short\"}\nUnsigned short integer (size is platform dependent).\n\n@item  @qcode{\"uint\"}\n@itemx @qcode{\"unsigned int\"}\nUnsigned integer (size is platform dependent).\n\n@item  @qcode{\"ulong\"}\n@itemx @qcode{\"unsigned long\"}\nUnsigned long integer (size is platform dependent).\n\n@item @qcode{\"float\"}\nSingle precision floating point number (size is platform dependent).\n@end table\n\n@noindent\nThe default precision is @qcode{\"uchar\"}.\n\nThe @var{precision} argument may also specify an optional repeat\ncount.  For example, @samp{32*single} causes @code{fread} to read\na block of 32 single precision floating point numbers.  Reading in\nblocks is useful in combination with the @var{skip} argument.\n\nThe @var{precision} argument may also specify a type conversion.\nFor example, @samp{int16=>int32} causes @code{fread} to read 16-bit\ninteger values and return an array of 32-bit integer values.  By\ndefault, @code{fread} returns a double precision array.  The special\nform @samp{*TYPE} is shorthand for @samp{TYPE=>TYPE}.\n\nThe conversion and repeat counts may be combined.  For example, the\nspecification @samp{32*single=>single} causes @code{fread} to read\nblocks of single precision floating point values and return an array\nof single precision values instead of the default array of double\nprecision values.\n\nThe optional argument @var{skip} specifies the number of bytes to skip\nafter each element (or block of elements) is read.  If it is not\nspecified, a value of 0 is assumed.  If the final block read is not\ncomplete, the final skip is omitted.  For example,\n\n@example\nfread (f, 10, \"3*single=>single\", 8)\n@end example\n\n@noindent\nwill omit the final 8-byte skip because the last read will not be\na complete block of 3 values.\n\nThe optional argument @var{arch} is a string specifying the data format\nfor the file.  Valid values are\n\n@table @asis\n@item @qcode{\"native\"}\nThe format of the current machine.\n\n@item @qcode{\"ieee-be\"}\nIEEE big endian.\n\n@item @qcode{\"ieee-le\"}\nIEEE little endian.\n@end table\n\nThe output argument @var{val} contains the data read from the file.\nThe optional return value @var{count} contains the number of elements read.\n@seealso{fwrite, fgets, fgetl, fscanf, fopen}\n@end deftypefn") 
 XDEFUN_INTERNAL (fwrite, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} fwrite (@var{fid}, @var{data})\n@deftypefnx {Built-in Function} {} fwrite (@var{fid}, @var{data}, @var{precision})\n@deftypefnx {Built-in Function} {} fwrite (@var{fid}, @var{data}, @var{precision}, @var{skip})\n@deftypefnx {Built-in Function} {} fwrite (@var{fid}, @var{data}, @var{precision}, @var{skip}, @var{arch})\n@deftypefnx {Built-in Function} {@var{count} =} fwrite (@dots{})\nWrite data in binary form to the file specified by the file descriptor\n@var{fid}, returning the number of values @var{count} successfully written\nto the file.\n\nThe argument @var{data} is a matrix of values that are to be written to\nthe file.  The values are extracted in column-major order.\n\nThe remaining arguments @var{precision}, @var{skip}, and @var{arch} are\noptional, and are interpreted as described for @code{fread}.\n\nThe behavior of @code{fwrite} is undefined if the values in @var{data}\nare too large to fit in the specified precision.\n@seealso{fread, fputs, fprintf, fopen}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("feof", Ffeof, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{status} =} feof (@var{fid})\nReturn 1 if an end-of-file condition has been encountered for the file\nspecified by file descriptor @var{fid} and 0 otherwise.\n\nNote that @code{feof} will only return 1 if the end of the file has already\nbeen encountered, not if the next read operation will result in an\nend-of-file condition.\n@seealso{fread, frewind, fseek, fclear, fopen}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("ferror", Fferror, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{msg} =} ferror (@var{fid})\n@deftypefnx {Built-in Function} {[@var{msg}, @var{err}] =} ferror (@var{fid})\n@deftypefnx {Built-in Function} {[@var{dots}] =} ferror (@var{fid}, \"clear\")\nQuery the error status of the stream specified by file descriptor @var{fid}\n\nIf an error condition exists then return a string @var{msg} describing the\nerror.  Otherwise, return an empty string @qcode{\"\"}.\n\nThe second input @qcode{\"clear\"} is optional.  If supplied, the error\nstate on the stream will be cleared.\n\nThe optional second output is a numeric indication of the error status.\n@var{err} is 1 if an error condition has been encountered and 0 otherwise.\n\nNote that @code{ferror} indicates if an error has already occurred, not\nwhether the next operation will result in an error condition.\n@seealso{fclear, fopen}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("popen", Fpopen, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{fid} =} popen (@var{command}, @var{mode})\nStart a process and create a pipe.\n\nThe name of the command to run is given by @var{command}.  The argument\n@var{mode} may be\n\n@table @code\n@item @qcode{\"r\"}\nThe pipe will be connected to the standard output of the process, and\nopen for reading.\n\n@item @qcode{\"w\"}\nThe pipe will be connected to the standard input of the process, and\nopen for writing.\n@end table\n\nThe file identifier corresponding to the input or output stream of the\nprocess is returned in @var{fid}.\n\nFor example:\n\n@example\n@group\nfid = popen (\"ls -ltr / | tail -3\", \"r\");\nwhile (ischar (s = fgets (fid)))\n  fputs (stdout, s);\nendwhile\n\n   @print{} drwxr-xr-x  33 root  root  3072 Feb 15 13:28 etc\n   @print{} drwxr-xr-x   3 root  root  1024 Feb 15 13:28 lib\n   @print{} drwxrwxrwt  15 root  root  2048 Feb 17 14:53 tmp\n@end group\n@end example\n@seealso{popen2}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("pclose", Fpclose, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} pclose (@var{fid})\nClose a file identifier that was opened by @code{popen}.\n\nThe function @code{fclose} may also be used for the same purpose.\n@seealso{fclose, popen}\n@end deftypefn") 
 XDEFUN_INTERNAL (tempname, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{fname} =} tempname ()\n@deftypefnx {Built-in Function} {@var{fname} =} tempname (@var{dir})\n@deftypefnx {Built-in Function} {@var{fname} =} tempname (@var{dir}, @var{prefix})\nReturn a unique temporary file name as a string.\n\nIf @var{prefix} is omitted, a value of @qcode{\"oct-\"} is used.\n\nIf @var{dir} is also omitted, the default directory for temporary files\n(@code{P_tmpdir}) is used.  If @var{dir} is provided, it must exist,\notherwise the default directory for temporary files is used.\n\nProgramming Note: Because the named file is not opened by @code{tempname},\nit is possible, though relatively unlikely, that it will not be available\nby the time your program attempts to open it.  If this is a concern,\nsee @code{tmpfile}.\n@seealso{mkstemp, tempdir, P_tmpdir, tmpfile}\n@end deftypefn") 
 XDEFUN_INTERNAL (tmpfile, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{fid}, @var{msg}] =} tmpfile ()\nReturn the file ID corresponding to a new temporary file with a unique\nname.\n\nThe file is opened in binary read/write (@qcode{\"w+b\"}) mode and will be\ndeleted automatically when it is closed or when Octave exits.\n\nIf successful, @var{fid} is a valid file ID and @var{msg} is an empty\nstring.  Otherwise, @var{fid} is -1 and @var{msg} contains a\nsystem-dependent error message.\n@seealso{tempname, mkstemp, tempdir, P_tmpdir}\n@end deftypefn") 
 XDEFUN_INTERNAL (mkstemp, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{fid}, @var{name}, @var{msg}] =} mkstemp (\"@var{template}\")\n@deftypefnx {Built-in Function} {[@var{fid}, @var{name}, @var{msg}] =} mkstemp (\"@var{template}\", @var{delete})\nReturn the file descriptor @var{fid} corresponding to a new temporary file\nwith a unique name created from @var{template}.\n\nThe last six characters of @var{template} must be @qcode{\"XXXXXX\"} and\nthese are replaced with a string that makes the filename unique.  The file\nis then created with mode read/write and permissions that are system\ndependent (on GNU/Linux systems, the permissions will be 0600 for versions of\nglibc 2.0.7 and later).  The file is opened in binary mode and with the\n@w{@code{O_EXCL}} flag.\n\nIf the optional argument @var{delete} is supplied and is true, the file will\nbe deleted automatically when Octave exits.\n\nIf successful, @var{fid} is a valid file ID, @var{name} is the name of the\nfile, and @var{msg} is an empty string.  Otherwise, @var{fid} is -1,\n@var{name} is empty, and @var{msg} contains a system-dependent error message.\n@seealso{tempname, tempdir, P_tmpdir, tmpfile, fopen}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("umask", Fumask, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} umask (@var{mask})\nSet the permission mask for file creation.\n\nThe parameter @var{mask} is an integer, interpreted as an octal number.\n\nIf successful, returns the previous value of the mask (as an integer to be\ninterpreted as an octal number); otherwise an error message is printed.\n\nThe permission mask is a UNIX concept used when creating new objects on a\nfile system such as files, directories, or named FIFOs.  The object to be\ncreated has base permissions in an octal number @var{mode} which are\nmodified according to the octal value of @var{mask}.  The final permissions\nfor the new object are @code{@var{mode} - @var{mask}}.\n@seealso{fopen, mkdir, mkfifo}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("P_tmpdir", FP_tmpdir, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} P_tmpdir ()\nReturn the name of the host system's @strong{default} directory for\ntemporary files.\n\nProgramming Note: The value returned by @code{P_tmpdir} is always the\ndefault location.  This value may not agree with that returned from\n@code{tempdir} if the user has overridden the default with the @env{TMPDIR}\nenvironment variable.\n@seealso{tempdir, tempname, mkstemp, tmpfile}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("SEEK_SET", FSEEK_SET, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} SEEK_SET ()\n@deftypefnx {Built-in Function} {} SEEK_CUR ()\n@deftypefnx {Built-in Function} {} SEEK_END ()\nReturn the numerical value to pass to @code{fseek} to perform one of the\nfollowing actions:\n\n@table @code\n@item SEEK_SET\nPosition file relative to the beginning.\n\n@item SEEK_CUR\nPosition file relative to the current position.\n\n@item SEEK_END\nPosition file relative to the end.\n@end table\n@seealso{fseek}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("SEEK_CUR", FSEEK_CUR, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} SEEK_CUR ()\nReturn the numerical value to pass to @code{fseek} to\nposition the file pointer relative to the current position.\n@seealso{SEEK_SET, SEEK_END}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("SEEK_END", FSEEK_END, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} SEEK_END ()\nReturn the numerical value to pass to @code{fseek} to\nposition the file pointer relative to the end of the file.\n@seealso{SEEK_SET, SEEK_CUR}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("stdin", Fstdin, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} stdin ()\nReturn the numeric value corresponding to the standard input stream.\n\nWhen Octave is used interactively, stdin is filtered through the command\nline editing functions.\n@seealso{stdout, stderr}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("stdout", Fstdout, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} stdout ()\nReturn the numeric value corresponding to the standard output stream.\n\nData written to the standard output is normally filtered through the pager.\n@seealso{stdin, stderr}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("stderr", Fstderr, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} stderr ()\nReturn the numeric value corresponding to the standard error stream.\n\nEven if paging is turned on, the standard error is not sent to the pager.\nIt is useful for error messages and prompts.\n@seealso{stdin, stdout}\n@end deftypefn") 
}

static void
install_filter_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/filter.cc")
 XDEFUN_INTERNAL (filter, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{y} =} filter (@var{b}, @var{a}, @var{x})\n@deftypefnx {Built-in Function} {[@var{y}, @var{sf}] =} filter (@var{b}, @var{a}, @var{x}, @var{si})\n@deftypefnx {Built-in Function} {[@var{y}, @var{sf}] =} filter (@var{b}, @var{a}, @var{x}, [], @var{dim})\n@deftypefnx {Built-in Function} {[@var{y}, @var{sf}] =} filter (@var{b}, @var{a}, @var{x}, @var{si}, @var{dim})\nApply a 1-D digital filter to the data @var{x}.\n\n@code{filter} returns the solution to the following linear, time-invariant\ndifference equation:\n@tex\n$$\n\\sum_{k=0}^N a_{k+1} y_{n-k} = \\sum_{k=0}^M b_{k+1} x_{n-k}, \\qquad\n 1 \\le n \\le P\n$$\n@end tex\n@ifnottex\n@c Set example in small font to prevent overfull line\n\n@smallexample\n@group\n N                   M\nSUM a(k+1) y(n-k) = SUM b(k+1) x(n-k)    for 1<=n<=length(x)\nk=0                 k=0\n@end group\n@end smallexample\n\n@end ifnottex\n\n@noindent\nwhere\n@ifnottex\nN=length(a)-1 and M=length(b)-1.\n@end ifnottex\n@tex\n$a \\in \\Re^{N-1}$, $b \\in \\Re^{M-1}$, and $x \\in \\Re^P$.\n@end tex\nThe result is calculated over the first non-singleton dimension of @var{x}\nor over @var{dim} if supplied.\n\nAn equivalent form of the equation is:\n@tex\n$$\ny_n = -\\sum_{k=1}^N c_{k+1} y_{n-k} + \\sum_{k=0}^M d_{k+1} x_{n-k}, \\qquad\n 1 \\le n \\le P\n$$\n@end tex\n@ifnottex\n@c Set example in small font to prevent overfull line\n\n@smallexample\n@group\n          N                   M\ny(n) = - SUM c(k+1) y(n-k) + SUM d(k+1) x(n-k)  for 1<=n<=length(x)\n         k=1                 k=0\n@end group\n@end smallexample\n\n@end ifnottex\n\n@noindent\nwhere\n@ifnottex\n c = a/a(1) and d = b/a(1).\n@end ifnottex\n@tex\n$c = a/a_1$ and $d = b/a_1$.\n@end tex\n\nIf the fourth argument @var{si} is provided, it is taken as the\ninitial state of the system and the final state is returned as\n@var{sf}.  The state vector is a column vector whose length is\nequal to the length of the longest coefficient vector minus one.\nIf @var{si} is not supplied, the initial state vector is set to all\nzeros.\n\nIn terms of the Z Transform, @var{y} is the result of passing the\ndiscrete-time signal @var{x} through a system characterized by the following\nrational system function:\n@tex\n$$\nH(z) = {\\displaystyle\\sum_{k=0}^M d_{k+1} z^{-k}\n        \\over 1 + \\displaystyle\\sum_{k+1}^N c_{k+1} z^{-k}}\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n          M\n         SUM d(k+1) z^(-k)\n         k=0\nH(z) = ---------------------\n            N\n       1 + SUM c(k+1) z^(-k)\n           k=1\n@end group\n@end example\n\n@end ifnottex\n@seealso{filter2, fftfilt, freqz}\n@end deftypefn") 
}

static void
install_find_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/find.cc")
 XDEFUN_INTERNAL (find, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{idx} =} find (@var{x})\n@deftypefnx {Built-in Function} {@var{idx} =} find (@var{x}, @var{n})\n@deftypefnx {Built-in Function} {@var{idx} =} find (@var{x}, @var{n}, @var{direction})\n@deftypefnx {Built-in Function} {[i, j] =} find (@dots{})\n@deftypefnx {Built-in Function} {[i, j, v] =} find (@dots{})\nReturn a vector of indices of nonzero elements of a matrix, as a row if\n@var{x} is a row vector or as a column otherwise.\n\nTo obtain a single index for each matrix element, Octave pretends that the\ncolumns of a matrix form one long vector (like Fortran arrays are stored).\nFor example:\n\n@example\n@group\nfind (eye (2))\n  @result{} [ 1; 4 ]\n@end group\n@end example\n\nIf two inputs are given, @var{n} indicates the maximum number of elements to\nfind from the beginning of the matrix or vector.\n\nIf three inputs are given, @var{direction} should be one of\n@qcode{\"first\"} or @qcode{\"last\"}, requesting only the first or last\n@var{n} indices, respectively.  However, the indices are always returned in\nascending order.\n\nIf two outputs are requested, @code{find} returns the row and column\nindices of nonzero elements of a matrix.  For example:\n\n@example\n@group\n[i, j] = find (2 * eye (2))\n    @result{} i = [ 1; 2 ]\n    @result{} j = [ 1; 2 ]\n@end group\n@end example\n\nIf three outputs are requested, @code{find} also returns a vector\ncontaining the nonzero values.  For example:\n\n@example\n@group\n[i, j, v] = find (3 * eye (2))\n       @result{} i = [ 1; 2 ]\n       @result{} j = [ 1; 2 ]\n       @result{} v = [ 3; 3 ]\n@end group\n@end example\n\nNote that this function is particularly useful for sparse matrices, as\nit extracts the nonzero elements as vectors, which can then be used to\ncreate the original matrix.  For example:\n\n@example\n@group\nsz = size (a);\n[i, j, v] = find (a);\nb = sparse (i, j, v, sz(1), sz(2));\n@end group\n@end example\n@seealso{nonzeros}\n@end deftypefn") 
}

static void
install_gammainc_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/gammainc.cc")
 XDEFUN_INTERNAL (gammainc, args, , "-*- texinfo -*-\n@deftypefn  {Mapping Function} {} gammainc (@var{x}, @var{a})\n@deftypefnx {Mapping Function} {} gammainc (@var{x}, @var{a}, \"lower\")\n@deftypefnx {Mapping Function} {} gammainc (@var{x}, @var{a}, \"upper\")\nCompute the normalized incomplete gamma function.\n\nThis is defined as\n@tex\n$$\n \\gamma (x, a) = {1 \\over {\\Gamma (a)}}\\displaystyle{\\int_0^x t^{a-1} e^{-t} dt}\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n                                x\n                       1       /\ngammainc (x, a) = ---------    | exp (-t) t^(a-1) dt\n                  gamma (a)    /\n                            t=0\n@end group\n@end example\n\n@end ifnottex\nwith the limiting value of 1 as @var{x} approaches infinity.\nThe standard notation is @math{P(a,x)}, e.g., @nospell{Abramowitz} and\n@nospell{Stegun} (6.5.1).\n\nIf @var{a} is scalar, then @code{gammainc (@var{x}, @var{a})} is returned\nfor each element of @var{x} and vice versa.\n\nIf neither @var{x} nor @var{a} is scalar, the sizes of @var{x} and\n@var{a} must agree, and @code{gammainc} is applied element-by-element.\n\nBy default the incomplete gamma function integrated from 0 to @var{x} is\ncomputed.  If @qcode{\"upper\"} is given then the complementary function\nintegrated from @var{x} to infinity is calculated.  It should be noted that\n\n@example\ngammainc (@var{x}, @var{a}) @equiv{} 1 - gammainc (@var{x}, @var{a}, \"upper\")\n@end example\n@seealso{gamma, gammaln}\n@end deftypefn") 
}

static void
install_gcd_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/gcd.cc")
 XDEFUN_INTERNAL (gcd, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{g} =} gcd (@var{a1}, @var{a2}, @dots{})\n@deftypefnx {Built-in Function} {[@var{g}, @var{v1}, @dots{}] =} gcd (@var{a1}, @var{a2}, @dots{})\nCompute the greatest common divisor of @var{a1}, @var{a2}, @dots{}.\n\nIf more than one argument is given then all arguments must be the same size\nor scalar.  In this case the greatest common divisor is calculated for each\nelement individually.  All elements must be ordinary or Gaussian (complex)\nintegers.  Note that for Gaussian integers, the gcd is only unique up to a\nphase factor (multiplication by 1, -1, i, or -i), so an arbitrary greatest\ncommon divisor among the four possible is returned.\n\nOptional return arguments @var{v1}, @dots{}, contain integer vectors such\nthat,\n\n@tex\n$g = v_1 a_1 + v_2 a_2 + \\cdots$\n@end tex\n@ifnottex\n\n@example\n@var{g} = @var{v1} .* @var{a1} + @var{v2} .* @var{a2} + @dots{}\n@end example\n\n@end ifnottex\n\nExample code:\n\n@example\n@group\ngcd ([15, 9], [20, 18])\n   @result{}  5  9\n@end group\n@end example\n\n@seealso{lcm, factor, isprime}\n@end deftypefn") 
}

static void
install_getgrent_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/getgrent.cc")
 XDEFUN_INTERNAL (getgrent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{grp_struct} =} getgrent ()\nReturn an entry from the group database, opening it if necessary.\n\nOnce the end of data has been reached, @code{getgrent} returns 0.\n@seealso{setgrent, endgrent}\n@end deftypefn") 
 XDEFUN_INTERNAL (getgrgid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{grp_struct} =} getgrgid (@var{gid}).\nReturn the first entry from the group database with the group ID\n@var{gid}.\n\nIf the group ID does not exist in the database, @code{getgrgid} returns 0.\n@seealso{getgrnam}\n@end deftypefn") 
 XDEFUN_INTERNAL (getgrnam, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{grp_struct} =} getgrnam (@var{name})\nReturn the first entry from the group database with the group name\n@var{name}.\n\nIf the group name does not exist in the database, @code{getgrnam} returns 0.\n@seealso{getgrgid}\n@end deftypefn") 
 XDEFUN_INTERNAL (setgrent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} setgrent ()\nReturn the internal pointer to the beginning of the group database.\n@seealso{getgrent, endgrent}\n@end deftypefn") 
 XDEFUN_INTERNAL (endgrent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} endgrent ()\nClose the group database.\n@seealso{getgrent, setgrent}\n@end deftypefn") 
}

static void
install_getpwent_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/getpwent.cc")
 XDEFUN_INTERNAL (getpwent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{pw_struct} =} getpwent ()\nReturn a structure containing an entry from the password database,\nopening it if necessary.\n\nOnce the end of the data has been reached, @code{getpwent} returns 0.\n@seealso{setpwent, endpwent}\n@end deftypefn") 
 XDEFUN_INTERNAL (getpwuid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{pw_struct} =} getpwuid (@var{uid}).\nReturn a structure containing the first entry from the password database\nwith the user ID @var{uid}.\n\nIf the user ID does not exist in the database, @code{getpwuid} returns 0.\n@seealso{getpwnam}\n@end deftypefn") 
 XDEFUN_INTERNAL (getpwnam, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{pw_struct} =} getpwnam (@var{name})\nReturn a structure containing the first entry from the password database\nwith the user name @var{name}.\n\nIf the user name does not exist in the database, @code{getpwname} returns 0.\n@seealso{getpwuid}\n@end deftypefn") 
 XDEFUN_INTERNAL (setpwent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} setpwent ()\nReturn the internal pointer to the beginning of the password database.\n@seealso{getpwent, endpwent}\n@end deftypefn") 
 XDEFUN_INTERNAL (endpwent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} endpwent ()\nClose the password database.\n@seealso{getpwent, setpwent}\n@end deftypefn") 
}

static void
install_getrusage_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/getrusage.cc")
 XDEFUN_INTERNAL (getrusage, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} getrusage ()\nReturn a structure containing a number of statistics about the current\nOctave process.\n\nNot all fields are available on all systems.  If it is not possible to get\nCPU time statistics, the CPU time slots are set to zero.  Other missing data\nare replaced by NaN@.  The list of possible fields is:\n\n@table @code\n@item idrss\nUnshared data size.\n\n@item inblock\nNumber of block input operations.\n\n@item isrss\nUnshared stack size.\n\n@item ixrss\nShared memory size.\n\n@item majflt\nNumber of major page faults.\n\n@item maxrss\nMaximum data size.\n\n@item minflt\nNumber of minor page faults.\n\n@item msgrcv\nNumber of messages received.\n\n@item msgsnd\nNumber of messages sent.\n\n@item nivcsw\nNumber of involuntary context switches.\n\n@item nsignals\nNumber of signals received.\n\n@item nswap\nNumber of swaps.\n\n@item nvcsw\nNumber of voluntary context switches.\n\n@item oublock\nNumber of block output operations.\n\n@item stime\nA structure containing the system CPU time used.  The structure has the\nelements @code{sec} (seconds) @code{usec} (microseconds).\n\n@item utime\nA structure containing the user CPU time used.  The structure has the\nelements @code{sec} (seconds) @code{usec} (microseconds).\n@end table\n@end deftypefn") 
}

static void
install_givens_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/givens.cc")
 XDEFUN_INTERNAL (givens, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{G} =} givens (@var{x}, @var{y})\n@deftypefnx {Built-in Function} {[@var{c}, @var{s}] =} givens (@var{x}, @var{y})\nCompute the Givens rotation matrix @var{G}.\n\n@tex\nThe Givens matrix is a $2\\times 2$ orthogonal matrix\n$$\n G = \\left[\\matrix{c & s\\cr -s'& c\\cr}\\right]\n$$\nsuch that\n$$\n G \\left[\\matrix{x\\cr y}\\right] = \\left[\\matrix{\\ast\\cr 0}\\right]\n$$\nwith $x$ and $y$ scalars.\n@end tex\n@ifnottex\nThe Givens matrix is a 2 by 2 orthogonal matrix\n\n@code{@var{g} = [@var{c} @var{s}; -@var{s}' @var{c}]}\n\nsuch that\n\n@code{@var{g} [@var{x}; @var{y}] = [*; 0]}\n\nwith @var{x} and @var{y} scalars.\n@end ifnottex\n\nIf two output arguments are requested, return the factors @var{c} and\n@var{s} rather than the Givens rotation matrix.\n\nFor example:\n\n@example\n@group\ngivens (1, 1)\n   @result{}   0.70711   0.70711\n       -0.70711   0.70711\n@end group\n@end example\n@seealso{planerot}\n@end deftypefn") 
}

static void
install_graphics_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/graphics.cc")
 XDEFUN_INTERNAL (ishandle, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ishandle (@var{h})\nReturn true if @var{h} is a graphics handle and false otherwise.\n\n@var{h} may also be a matrix of handles in which case a logical array is\nreturned that is true where the elements of @var{h} are graphics handles and\nfalse where they are not.\n@seealso{isaxes, isfigure}\n@end deftypefn") 
 XDEFUN_INTERNAL (__is_handle_visible__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __is_handle_visible__ (@var{h})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (reset, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} reset (@var{h})\nReset the properties of the graphic object @var{h} to their default values.\n\nFor figures, the properties @qcode{\"position\"}, @qcode{\"units\"},\n@qcode{\"windowstyle\"}, and @qcode{\"paperunits\"} are not affected.\nFor axes, the properties @qcode{\"position\"} and @qcode{\"units\"} are\nnot affected.\n\nThe input @var{h} may also be a vector of graphic handles in which case\neach individual object will be reset.\n@seealso{cla, clf, newplot}\n@end deftypefn") 
 XDEFUN_INTERNAL (set, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} set (@var{h}, @var{property}, @var{value}, @dots{})\n@deftypefnx {Built-in Function} {} set (@var{h}, @var{properties}, @var{values})\n@deftypefnx {Built-in Function} {} set (@var{h}, @var{pv})\n@deftypefnx {Built-in Function} {@var{value_list} =} set (@var{h}, @var{property})\n@deftypefnx {Built-in Function} {@var{all_value_list} =} set (@var{h})\nSet named property values for the graphics handle (or vector of graphics\nhandles) @var{h}.\n\nThere are three ways to give the property names and values:\n\n@itemize\n@item as a comma separated list of @var{property}, @var{value} pairs\n\nHere, each @var{property} is a string containing the property name, each\n@var{value} is a value of the appropriate type for the property.\n\n@item as a cell array of strings @var{properties} containing property names\nand a cell array @var{values} containing property values.\n\nIn this case, the number of columns of @var{values} must match the number of\nelements in @var{properties}.  The first column of @var{values} contains\nvalues for the first entry in @var{properties}, etc.  The number of rows of\n@var{values} must be 1 or match the number of elements of @var{h}.  In the\nfirst case, each handle in @var{h} will be assigned the same values.  In the\nlatter case, the first handle in @var{h} will be assigned the values from\nthe first row of @var{values} and so on.\n\n@item as a structure array @var{pv}\n\nHere, the field names of @var{pv} represent the property names, and the field\nvalues give the property values.  In contrast to the previous case, all\nelements of @var{pv} will be set in all handles in @var{h} independent of\nthe dimensions of @var{pv}.\n@end itemize\n\n@code{set} is also used to query the list of values a named property will\ntake.  @code{@var{clist} = set (@var{h}, \"property\")} will return the list\nof possible values for @qcode{\"property\"} in the cell list @var{clist}.\nIf no output variable is used then the list is formatted and printed to the\nscreen.\n\nIf no property is specified (@code{@var{slist} = set (@var{h})}) then a\nstructure @var{slist} is returned where the fieldnames are the properties of\nthe object @var{h} and the fields are the list of possible values for each\nproperty.  If no output variable is used then the list is formatted and\nprinted to the screen.\n\nFor example,\n\n@example\n@group\nhf = figure ();\nset (hf, \"paperorientation\")\n@result{}  paperorientation:  [ landscape | @{portrait@} | rotated ]\n@end group\n@end example\n\n@noindent\nshows the paperorientation property can take three values with the default\nbeing @qcode{\"portrait\"}.\n@seealso{get}\n@end deftypefn") 
 XDEFUN_INTERNAL (get, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} get (@var{h})\n@deftypefnx {Built-in Function} {@var{val} =} get (@var{h}, @var{p})\nReturn the value of the named property @var{p} from the graphics handle\n@var{h}.\n\nIf @var{p} is omitted, return the complete property list for @var{h}.\n\nIf @var{h} is a vector, return a cell array including the property values or\nlists respectively.\n@seealso{set}\n@end deftypefn") 
 XDEFUN_INTERNAL (__get__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __get__ (@var{h})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_figure__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_figure__ (@var{fignum})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__calc_dimensions__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __calc_dimensions__ (@var{axes})\nInternal function.\n\nDetermine the number of dimensions in a graphics object, either 2 or 3.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_axes__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_axes__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_line__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_line__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_text__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_text__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_image__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_image__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_surface__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_surface__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_patch__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_patch__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_hggroup__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_hggroup__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uimenu__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uimenu__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uicontrol__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uicontrol__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uipanel__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uipanel__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uicontextmenu__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uicontextmenu__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uitoolbar__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uitoolbar__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uipushtool__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uipushtool__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_uitoggletool__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_uitoggletool__ (@var{parent})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_delete__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_delete__ (@var{h})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_axes_init__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_axes_init__ (@var{h}, @var{mode})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_handles__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_handles__ (@var{show_hidden})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_figure_handles__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __go_figure_handles__ (@var{show_hidden})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__go_execute_callback__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __go_execute_callback__ (@var{h}, @var{name})\n@deftypefnx {Built-in Function} {} __go_execute_callback__ (@var{h}, @var{name}, @var{param})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__image_pixel_size__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{px}, @var{py}} __image_pixel_size__ (@var{h})\nInternal function: returns the pixel size of the image in normalized units.\n@end deftypefn") 
 XDEFUN_INTERNAL (available_graphics_toolkits, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} available_graphics_toolkits ()\nReturn a cell array of registered graphics toolkits.\n@seealso{graphics_toolkit, register_graphics_toolkit}\n@end deftypefn") 
 XDEFUN_INTERNAL (register_graphics_toolkit, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} register_graphics_toolkit (@var{toolkit})\nList @var{toolkit} as an available graphics toolkit.\n@seealso{available_graphics_toolkits}\n@end deftypefn") 
 XDEFUN_INTERNAL (loaded_graphics_toolkits, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} loaded_graphics_toolkits ()\nReturn a cell array of the currently loaded graphics toolkits.\n@seealso{available_graphics_toolkits}\n@end deftypefn") 
 XDEFUN_INTERNAL (drawnow, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} drawnow ()\n@deftypefnx {Built-in Function} {} drawnow (\"expose\")\n@deftypefnx {Built-in Function} {} drawnow (@var{term}, @var{file}, @var{mono}, @var{debug_file})\nUpdate figure windows and their children.\n\nThe event queue is flushed and any callbacks generated are executed.\n\nWith the optional argument @qcode{\"expose\"}, only graphic objects are\nupdated and no other events or callbacks are processed.\n\nThe third calling form of @code{drawnow} is for debugging and is\nundocumented.\n@seealso{refresh}\n@end deftypefn") 
 XDEFUN_INTERNAL (addlistener, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} addlistener (@var{h}, @var{prop}, @var{fcn})\nRegister @var{fcn} as listener for the property @var{prop} of the graphics\nobject @var{h}.\n\nProperty listeners are executed (in order of registration) when the property\nis set.  The new value is already available when the listeners are executed.\n\n@var{prop} must be a string naming a valid property in @var{h}.\n\n@var{fcn} can be a function handle, a string or a cell array whose first\nelement is a function handle.  If @var{fcn} is a function handle, the\ncorresponding function should accept at least 2 arguments, that will be\nset to the object handle and the empty matrix respectively.  If @var{fcn}\nis a string, it must be any valid octave expression.  If @var{fcn} is a cell\narray, the first element must be a function handle with the same signature\nas described above.  The next elements of the cell array are passed\nas additional arguments to the function.\n\nExample:\n\n@example\n@group\nfunction my_listener (h, dummy, p1)\n  fprintf (\"my_listener called with p1=%s\\n\", p1);\nendfunction\n\naddlistener (gcf, \"position\", @{@@my_listener, \"my string\"@})\n@end group\n@end example\n\n@seealso{addproperty, hggroup}\n@end deftypefn") 
 XDEFUN_INTERNAL (dellistener, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} dellistener (@var{h}, @var{prop}, @var{fcn})\nRemove the registration of @var{fcn} as a listener for the property\n@var{prop} of the graphics object @var{h}.\n\nThe function @var{fcn} must be the same variable (not just the same value),\nas was passed to the original call to @code{addlistener}.\n\nIf @var{fcn} is not defined then all listener functions of @var{prop}\nare removed.\n\nExample:\n\n@example\n@group\nfunction my_listener (h, dummy, p1)\n  fprintf (\"my_listener called with p1=%s\\n\", p1);\nendfunction\n\nc = @{@@my_listener, \"my string\"@};\naddlistener (gcf, \"position\", c);\ndellistener (gcf, \"position\", c);\n@end group\n@end example\n\n@end deftypefn") 
 XDEFUN_INTERNAL (addproperty, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} addproperty (@var{name}, @var{h}, @var{type})\n@deftypefnx {Built-in Function} {} addproperty (@var{name}, @var{h}, @var{type}, @var{arg}, @dots{})\nCreate a new property named @var{name} in graphics object @var{h}.\n\n@var{type} determines the type of the property to create.  @var{args}\nusually contains the default value of the property, but additional\narguments might be given, depending on the type of the property.\n\nThe supported property types are:\n\n@table @code\n@item string\nA string property.  @var{arg} contains the default string value.\n\n@item any\nAn @nospell{un-typed} property.  This kind of property can hold any octave\nvalue.  @var{args} contains the default value.\n\n@item radio\nA string property with a limited set of accepted values.  The first\nargument must be a string with all accepted values separated by\na vertical bar ('|').  The default value can be marked by enclosing\nit with a '@{' '@}' pair.  The default value may also be given as\nan optional second string argument.\n\n@item boolean\nA boolean property.  This property type is equivalent to a radio\nproperty with \"on|off\" as accepted values.  @var{arg} contains\nthe default property value.\n\n@item double\nA scalar double property.  @var{arg} contains the default value.\n\n@item handle\nA handle property.  This kind of property holds the handle of a\ngraphics object.  @var{arg} contains the default handle value.\nWhen no default value is given, the property is initialized to\nthe empty matrix.\n\n@item data\nA data (matrix) property.  @var{arg} contains the default data\nvalue.  When no default value is given, the data is initialized to\nthe empty matrix.\n\n@item color\nA color property.  @var{arg} contains the default color value.\nWhen no default color is given, the property is set to black.\nAn optional second string argument may be given to specify an\nadditional set of accepted string values (like a radio property).\n@end table\n\n@var{type} may also be the concatenation of a core object type and\na valid property name for that object type.  The property created\nthen has the same characteristics as the referenced property (type,\npossible values, hidden state@dots{}).  This allows one to clone an\nexisting property into the graphics object @var{h}.\n\nExamples:\n\n@example\n@group\naddproperty (\"my_property\", gcf, \"string\", \"a string value\");\naddproperty (\"my_radio\", gcf, \"radio\", \"val_1|val_2|@{val_3@}\");\naddproperty (\"my_style\", gcf, \"linelinestyle\", \"--\");\n@end group\n@end example\n\n@seealso{addlistener, hggroup}\n@end deftypefn") 
 XDEFUN_INTERNAL (waitfor, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} waitfor (@var{h})\n@deftypefnx {Built-in Function} {} waitfor (@var{h}, @var{prop})\n@deftypefnx {Built-in Function} {} waitfor (@var{h}, @var{prop}, @var{value})\n@deftypefnx {Built-in Function} {} waitfor (@dots{}, \"timeout\", @var{timeout})\nSuspend the execution of the current program until a condition is\nsatisfied on the graphics handle @var{h}.\n\nWhile the program is suspended graphics events are still processed normally,\nallowing callbacks to modify the state of graphics objects.  This function\nis reentrant and can be called from a callback, while another @code{waitfor}\ncall is pending at the top-level.\n\nIn the first form, program execution is suspended until the graphics object\n@var{h} is destroyed.  If the graphics handle is invalid, the function\nreturns immediately.\n\nIn the second form, execution is suspended until the graphics object is\ndestroyed or the property named @var{prop} is modified.  If the graphics\nhandle is invalid or the property does not exist, the function returns\nimmediately.\n\nIn the third form, execution is suspended until the graphics object is\ndestroyed or the property named @var{prop} is set to @var{value}.  The\nfunction @code{isequal} is used to compare property values.  If the graphics\nhandle is invalid, the property does not exist or the property is already\nset to @var{value}, the function returns immediately.\n\nAn optional timeout can be specified using the property @code{timeout}.\nThis timeout value is the number of seconds to wait for the condition to be\ntrue.  @var{timeout} must be at least 1. If a smaller value is specified, a\nwarning is issued and a value of 1 is used instead.  If the timeout value is\nnot an integer, it is truncated towards 0.\n\nTo define a condition on a property named @code{timeout}, use the string\n@code{\\timeout} instead.\n\nIn all cases, typing CTRL-C stops program execution immediately.\n@seealso{waitforbuttonpress, isequal}\n@end deftypefn") 
 XDEFUN_INTERNAL (__zoom__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __zoom__ (@var{axes}, @var{mode}, @var{factor})\n@deftypefnx {Built-in Function} {} __zoom__ (@var{axes}, \"out\")\n@deftypefnx {Built-in Function} {} __zoom__ (@var{axes}, \"reset\")\nUndocumented internal function.\n@end deftypefn") 
}

static void
install_help_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/help.cc")
 XDEFUN_INTERNAL (built_in_docstrings_file, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} built_in_docstrings_file ()\n@deftypefnx {Built-in Function} {@var{old_val} =} built_in_docstrings_file (@var{new_val})\n@deftypefnx {Built-in Function} {} built_in_docstrings_file (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the\nfile containing docstrings for built-in Octave functions.\n\nThe default value is\n@file{@var{octave-home}/share/octave/@var{version}/etc/built-in-docstrings},\nin which @var{octave-home} is the root directory of the Octave installation,\nand @var{version} is the Octave version number.  The default value may be\noverridden by the environment variable\n@w{@env{OCTAVE_BUILT_IN_DOCSTRINGS_FILE}}, or the command line argument\n@option{--built-in-docstrings-file FNAME}.\n\nNote: This variable is only used when Octave is initializing itself.\nModifying it during a running session of Octave will have no effect.\n@end deftypefn") 
 XDEFUN_INTERNAL (get_help_text, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{text}, @var{format}] =} get_help_text (@var{name})\nReturn the raw help text of function @var{name}.\n\nThe raw help text is returned in @var{text} and the format in @var{format}\nThe format is a string which is one of @qcode{\"texinfo\"},\n@qcode{\"html\"}, or @qcode{\"plain text\"}.\n@seealso{get_help_text_from_file}\n@end deftypefn") 
 XDEFUN_INTERNAL (get_help_text_from_file, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{text}, @var{format}] =} get_help_text_from_file (@var{fname})\nReturn the raw help text from the file @var{fname}.\n\nThe raw help text is returned in @var{text} and the format in @var{format}\nThe format is a string which is one of @qcode{\"texinfo\"},\n@qcode{\"html\"}, or @qcode{\"plain text\"}.\n@seealso{get_help_text}\n@end deftypefn") 
 XDEFUN_INTERNAL (__operators__, , , "-*- texinfo -*-\n@deftypefn {Function File} {} __operators__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__keywords__, , , "-*- texinfo -*-\n@deftypefn {Function File} {} __keywords__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__builtins__, , , "-*- texinfo -*-\n@deftypefn {Function File} {} __builtins__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__which__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __which__ (@var{name}, @dots{})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__list_functions__, args, , "-*- texinfo -*-\n@deftypefn  {Function File} {@var{retval} =} __list_functions__ ()\n@deftypefnx {Function File} {@var{retval} =} __list_functions__ (@var{directory})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (doc_cache_file, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} doc_cache_file ()\n@deftypefnx {Built-in Function} {@var{old_val} =} doc_cache_file (@var{new_val})\n@deftypefnx {Built-in Function} {} doc_cache_file (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the\nOctave documentation cache file.\n\nA cache file significantly improves the performance of the @code{lookfor}\ncommand.  The default value is\n@file{@var{octave-home}/share/octave/@var{version}/etc/doc-cache},\nin which @var{octave-home} is the root directory of the Octave installation,\nand @var{version} is the Octave version number.\nThe default value may be overridden by the environment variable\n@w{@env{OCTAVE_DOC_CACHE_FILE}}, or the command line argument\n@option{--doc-cache-file FNAME}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{doc_cache_create, lookfor, info_program, doc, help, makeinfo_program}\n@seealso{lookfor}\n@end deftypefn") 
 XDEFUN_INTERNAL (texi_macros_file, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} texi_macros_file ()\n@deftypefnx {Built-in Function} {@var{old_val} =} texi_macros_file (@var{new_val})\n@deftypefnx {Built-in Function} {} texi_macros_file (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the\nfile containing Texinfo macros that are prepended to documentation strings\nbefore they are passed to makeinfo.\n\nThe default value is\n@file{@var{octave-home}/share/octave/@var{version}/etc/macros.texi},\nin which @var{octave-home} is the root directory of the Octave installation,\nand @var{version} is the Octave version number.\nThe default value may be overridden by the environment variable\n@w{@env{OCTAVE_TEXI_MACROS_FILE}}, or the command line argument\n@option{--texi-macros-file FNAME}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{makeinfo_program}\n@end deftypefn") 
 XDEFUN_INTERNAL (info_file, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} info_file ()\n@deftypefnx {Built-in Function} {@var{old_val} =} info_file (@var{new_val})\n@deftypefnx {Built-in Function} {} info_file (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the\nOctave info file.\n\nThe default value is\n@file{@var{octave-home}/info/octave.info}, in\nwhich @var{octave-home} is the root directory of the Octave installation.\nThe default value may be overridden by the environment variable\n@w{@env{OCTAVE_INFO_FILE}}, or the command line argument\n@option{--info-file FNAME}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{info_program, doc, help, makeinfo_program}\n@end deftypefn") 
 XDEFUN_INTERNAL (info_program, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} info_program ()\n@deftypefnx {Built-in Function} {@var{old_val} =} info_program (@var{new_val})\n@deftypefnx {Built-in Function} {} info_program (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the\ninfo program to run.\n\nThe default value is\n@file{@var{octave-home}/libexec/octave/@var{version}/exec/@var{arch}/info}\nin which @var{octave-home} is the root directory of the Octave installation,\n@var{version} is the Octave version number, and @var{arch} is the system\ntype (for example, @code{i686-pc-linux-gnu}).  The default value may be\noverridden by the environment variable\n@w{@env{OCTAVE_INFO_PROGRAM}}, or the command line argument\n@option{--info-program NAME}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{info_file, doc, help, makeinfo_program}\n@end deftypefn") 
 XDEFUN_INTERNAL (makeinfo_program, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} makeinfo_program ()\n@deftypefnx {Built-in Function} {@var{old_val} =} makeinfo_program (@var{new_val})\n@deftypefnx {Built-in Function} {} makeinfo_program (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the\nprogram that Octave runs to format help text containing\nTexinfo markup commands.\n\nThe default value is @code{makeinfo}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{texi_macros_file, info_file, info_program, doc, help}\n@end deftypefn") 
 XDEFUN_INTERNAL (suppress_verbose_help_message, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} suppress_verbose_help_message ()\n@deftypefnx {Built-in Function} {@var{old_val} =} suppress_verbose_help_message (@var{new_val})\n@deftypefnx {Built-in Function} {} suppress_verbose_help_message (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave\nwill add additional help information to the end of the output from\nthe @code{help} command and usage messages for built-in commands.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_hess_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/hess.cc")
 XDEFUN_INTERNAL (hess, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{H} =} hess (@var{A})\n@deftypefnx {Built-in Function} {[@var{P}, @var{H}] =} hess (@var{A})\n@cindex Hessenberg decomposition\nCompute the Hessenberg decomposition of the matrix @var{A}.\n\nThe Hessenberg decomposition is\n@tex\n$$\nA = PHP^T\n$$\nwhere $P$ is a square unitary matrix ($P^TP = I$), and $H$\nis upper Hessenberg ($H_{i,j} = 0, \\forall i \\ge j+1$).\n@end tex\n@ifnottex\n@code{@var{P} * @var{H} * @var{P}' = @var{A}} where @var{P} is a square\nunitary matrix (@code{@var{P}' * @var{P} = I}, using complex-conjugate\ntransposition) and @var{H} is upper Hessenberg\n(@code{@var{H}(i, j) = 0 forall i >= j+1)}.\n@end ifnottex\n\nThe Hessenberg decomposition is usually used as the first step in an\neigenvalue computation, but has other applications as well\n(see @nospell{Golub, Nash, and Van Loan},\nIEEE Transactions on Automatic Control, 1979).\n@seealso{eig, chol, lu, qr, qz, schur, svd}\n@end deftypefn") 
}

static void
install_hex2num_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/hex2num.cc")
 XDEFUN_INTERNAL (hex2num, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{n} =} hex2num (@var{s})\n@deftypefnx {Built-in Function} {@var{n} =} hex2num (@var{s}, @var{class})\nTypecast the 16 character hexadecimal character string to an IEEE 754\ndouble precision number.\n\nIf fewer than 16 characters are given the strings are right padded with\n@qcode{'0'} characters.\n\nGiven a string matrix, @code{hex2num} treats each row as a separate number.\n\n@example\n@group\nhex2num ([\"4005bf0a8b145769\"; \"4024000000000000\"])\n   @result{} [2.7183; 10.000]\n@end group\n@end example\n\nThe optional argument @var{class} can be passed as the string\n@qcode{\"single\"} to specify that the given string should be interpreted as\na single precision number.  In this case, @var{s} should be an 8 character\nhexadecimal string.  For example:\n\n@example\n@group\nhex2num ([\"402df854\"; \"41200000\"], \"single\")\n   @result{} [2.7183; 10.000]\n@end group\n@end example\n@seealso{num2hex, hex2dec, dec2hex}\n@end deftypefn") 
 XDEFUN_INTERNAL (num2hex, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{s} =} num2hex (@var{n})\nTypecast a double or single precision number or vector to a 8 or 16\ncharacter hexadecimal string of the IEEE 754 representation of the number.\n\nFor example:\n\n@example\n@group\nnum2hex ([-1, 1, e, Inf])\n@result{} \"bff0000000000000\n    3ff0000000000000\n    4005bf0a8b145769\n    7ff0000000000000\"\n@end group\n@end example\n\nIf the argument @var{n} is a single precision number or vector, the returned\nstring has a length of 8.  For example:\n\n@example\n@group\nnum2hex (single ([-1, 1, e, Inf]))\n@result{} \"bf800000\n    3f800000\n    402df854\n    7f800000\"\n@end group\n@end example\n@seealso{hex2num, hex2dec, dec2hex}\n@end deftypefn") 
}

static void
install_input_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/input.cc")
 XDEFUN_INTERNAL (input, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{ans} =} input (@var{prompt})\n@deftypefnx {Built-in Function} {@var{ans} =} input (@var{prompt}, \"s\")\nPrint @var{prompt} and wait for user input.\n\nFor example,\n\n@example\ninput (\"Pick a number, any number! \")\n@end example\n\n@noindent\nprints the prompt\n\n@example\nPick a number, any number!\n@end example\n\n@noindent\nand waits for the user to enter a value.  The string entered by the user\nis evaluated as an expression, so it may be a literal constant, a variable\nname, or any other valid Octave code.\n\nThe number of return arguments, their size, and their class depend on the\nexpression entered.\n\nIf you are only interested in getting a literal string value, you can call\n@code{input} with the character string @qcode{\"s\"} as the second argument.\nThis tells Octave to return the string entered by the user directly, without\nevaluating it first.\n\nBecause there may be output waiting to be displayed by the pager, it is a\ngood idea to always call @code{fflush (stdout)} before calling @code{input}.\n This will ensure that all pending output is written to the screen before\nyour prompt.\n@seealso{yes_or_no, kbhit, pause, menu, listdlg}\n@end deftypefn") 
 XDEFUN_INTERNAL (yes_or_no, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{ans} =} yes_or_no (\"@var{prompt}\")\nAsk the user a yes-or-no question.\n\nReturn logical true if the answer is yes or false if the answer is no.\n\nTakes one argument, @var{prompt}, which is the string to display when asking\nthe question.  @var{prompt} should end in a space; @code{yes-or-no} adds the\nstring @samp{(yes or no) } to it.  The user must confirm the answer with\n@key{RET} and can edit it until it has been confirmed.\n@seealso{input}\n@end deftypefn") 
 XDEFUN_INTERNAL (keyboard, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} keyboard ()\n@deftypefnx {Built-in Function} {} keyboard (\"@var{prompt}\")\nStop m-file execution and enter debug mode.\n\nWhen the @code{keyboard} function is executed, Octave prints a prompt and\nwaits for user input.  The input strings are then evaluated and the results\nare printed.  This makes it possible to examine the values of variables\nwithin a function, and to assign new values if necessary.  To leave the\nprompt and return to normal execution type @samp{return} or @samp{dbcont}.\nThe @code{keyboard} function does not return an exit status.\n\nIf @code{keyboard} is invoked without arguments, a default prompt of\n@samp{debug> } is used.\n@seealso{dbstop, dbcont, dbquit}\n@end deftypefn") 
 XDEFUN_INTERNAL (echo, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} echo\n@deftypefnx {Command} {} echo on\n@deftypefnx {Command} {} echo off\n@deftypefnx {Command} {} echo on all\n@deftypefnx {Command} {} echo off all\nControl whether commands are displayed as they are executed.\n\nValid options are:\n\n@table @code\n@item on\nEnable echoing of commands as they are executed in script files.\n\n@item off\nDisable echoing of commands as they are executed in script files.\n\n@item on all\nEnable echoing of commands as they are executed in script files and\nfunctions.\n\n@item off all\nDisable echoing of commands as they are executed in script files and\nfunctions.\n@end table\n\n@noindent\nWith no arguments, @code{echo} toggles the current echo state.\n@end deftypefn") 
 XDEFUN_INTERNAL (__echostate__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{state} =} __echostate__ ()\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (completion_matches, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} completion_matches (@var{hint})\nGenerate possible completions given @var{hint}.\n\nThis function is provided for the benefit of programs like Emacs which\nmight be controlling Octave and handling user input.  The current\ncommand number is not incremented when this function is called.  This is\na feature, not a bug.\n@end deftypefn") 
 XDEFUN_INTERNAL (readline_read_init_file, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} readline_read_init_file (@var{file})\nRead the readline library initialization file @var{file}.\n\nIf @var{file} is omitted, read the default initialization file\n(normally @file{~/.inputrc}).\n\n@xref{Readline Init File, , , readline, GNU Readline Library},\nfor details.\n@seealso{readline_re_read_init_file}\n@end deftypefn") 
 XDEFUN_INTERNAL (readline_re_read_init_file, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} readline_re_read_init_file ()\nRe-read the last readline library initialization file that was read.\n\n@xref{Readline Init File, , , readline, GNU Readline Library},\nfor details.\n@seealso{readline_read_init_file}\n@end deftypefn") 
 XDEFUN_INTERNAL (add_input_event_hook, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{id} =} add_input_event_hook (@var{fcn})\n@deftypefnx {Built-in Function} {@var{id} =} add_input_event_hook (@var{fcn}, @var{data})\nAdd the named function or function handle @var{fcn} to the list of functions\nto call periodically when Octave is waiting for input.\n\nThe function should have the form\n\n@example\n@var{fcn} (@var{data})\n@end example\n\nIf @var{data} is omitted, Octave calls the function without any arguments.\n\nThe returned identifier may be used to remove the function handle from the\nlist of input hook functions.\n@seealso{remove_input_event_hook}\n@end deftypefn") 
 XDEFUN_INTERNAL (remove_input_event_hook, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} remove_input_event_hook (@var{name})\n@deftypefnx {Built-in Function} {} remove_input_event_hook (@var{fcn_id})\nRemove the named function or function handle with the given identifier\nfrom the list of functions to call periodically when Octave is waiting\nfor input.\n@seealso{add_input_event_hook}\n@end deftypefn") 
 XDEFUN_INTERNAL (PS1, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} PS1 ()\n@deftypefnx {Built-in Function} {@var{old_val} =} PS1 (@var{new_val})\n@deftypefnx {Built-in Function} {} PS1 (@var{new_val}, \"local\")\nQuery or set the primary prompt string.\n\nWhen executing interactively, Octave displays the primary prompt when it is\nready to read a command.\n\nThe default value of the primary prompt string is @qcode{\"octave:\\#> \"}.\nTo change it, use a command like\n\n@example\nPS1 (\"\\\\u@@\\\\H> \")\n@end example\n\n@noindent\nwhich will result in the prompt @samp{boris@@kremvax> } for the user\n@samp{boris} logged in on the host @samp{kremvax.kgb.su}.  Note that two\nbackslashes are required to enter a backslash into a double-quoted\ncharacter string.  @xref{Strings}.\n\nYou can also use ANSI escape sequences if your terminal supports them.\nThis can be useful for coloring the prompt.  For example,\n\n@example\nPS1 (\"\\\\[\\\\033[01;31m\\\\]\\\\s:\\\\#> \\\\[\\\\033[0m\\\\]\")\n@end example\n\n@noindent\nwill give the default Octave prompt a red coloring.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{PS2, PS4}\n@end deftypefn") 
 XDEFUN_INTERNAL (PS2, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} PS2 ()\n@deftypefnx {Built-in Function} {@var{old_val} =} PS2 (@var{new_val})\n@deftypefnx {Built-in Function} {} PS2 (@var{new_val}, \"local\")\nQuery or set the secondary prompt string.\n\nThe secondary prompt is printed when Octave is expecting additional input to\ncomplete a command.  For example, if you are typing a @code{for} loop that\nspans several lines, Octave will print the secondary prompt at the beginning\nof each line after the first.  The default value of the secondary prompt\nstring is @qcode{\"> \"}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{PS1, PS4}\n@end deftypefn") 
 XDEFUN_INTERNAL (PS4, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} PS4 ()\n@deftypefnx {Built-in Function} {@var{old_val} =} PS4 (@var{new_val})\n@deftypefnx {Built-in Function} {} PS4 (@var{new_val}, \"local\")\nQuery or set the character string used to prefix output produced\nwhen echoing commands is enabled.\n\nThe default value is @qcode{\"+ \"}.\n@xref{Diary and Echo Commands}, for a description of echoing commands.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{echo, echo_executing_commands, PS1, PS2}\n@end deftypefn") 
 XDEFUN_INTERNAL (completion_append_char, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} completion_append_char ()\n@deftypefnx {Built-in Function} {@var{old_val} =} completion_append_char (@var{new_val})\n@deftypefnx {Built-in Function} {} completion_append_char (@var{new_val}, \"local\")\nQuery or set the internal character variable that is appended to\nsuccessful command-line completion attempts.\n\nThe default value is @qcode{\" \"} (a single space).\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
 XDEFUN_INTERNAL (echo_executing_commands, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} echo_executing_commands ()\n@deftypefnx {Built-in Function} {@var{old_val} =} echo_executing_commands (@var{new_val})\n@deftypefnx {Built-in Function} {} echo_executing_commands (@var{new_val}, \"local\")\nQuery or set the internal variable that controls the echo state.\n\nIt may be the sum of the following values:\n\n@table @asis\n@item 1\nEcho commands read from script files.\n\n@item 2\nEcho commands from functions.\n\n@item 4\nEcho commands read from command line.\n@end table\n\nMore than one state can be active at once.  For example, a value of 3 is\nequivalent to the command @kbd{echo on all}.\n\nThe value of @code{echo_executing_commands} may be set by the @kbd{echo}\ncommand or the command line option @option{--echo-commands}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__request_drawnow__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __request_drawnow__ ()\n@deftypefnx {Built-in Function} {} __request_drawnow__ (@var{flag})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__gud_mode__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __gud_mode__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (filemarker, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} filemarker ()\n@deftypefnx {Built-in Function} {@var{old_val} =} filemarker (@var{new_val})\n@deftypefnx {Built-in Function} {} filemarker (@var{new_val}, \"local\")\nQuery or set the character used to separate the filename from the subfunction\nnames contained within the file.\n\nBy default this is the character @samp{>}.\nThis can be used in a generic manner to interact with subfunctions.\nFor example,\n\n@example\nhelp ([\"myfunc\", filemarker, \"mysubfunc\"])\n@end example\n\n@noindent\nreturns the help string associated with the subfunction @code{mysubfunc}\nlocated in the file @file{myfunc.m}.\n\n@code{filemarker} is also useful during debugging for placing breakpoints\nwithin subfunctions or nested functions.\nFor example,\n\n@example\ndbstop ([\"myfunc\", filemarker, \"mysubfunc\"])\n@end example\n\n@noindent\nwill set a breakpoint at the first line of the subfunction @code{mysubfunc}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_inv_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/inv.cc")
 XDEFUN_INTERNAL (inv, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{x} =} inv (@var{A})\n@deftypefnx {Built-in Function} {[@var{x}, @var{rcond}] =} inv (@var{A})\nCompute the inverse of the square matrix @var{A}.\n\nReturn an estimate of the reciprocal condition number if requested,\notherwise warn of an ill-conditioned matrix if the reciprocal condition\nnumber is small.\n\nIn general it is best to avoid calculating the inverse of a matrix directly.\nFor example, it is both faster and more accurate to solve systems of\nequations (@var{A}*@math{x} = @math{b}) with\n@code{@var{y} = @var{A} \\ @math{b}}, rather than\n@code{@var{y} = inv (@var{A}) * @math{b}}.\n\nIf called with a sparse matrix, then in general @var{x} will be a full\nmatrix requiring significantly more storage.  Avoid forming the inverse of a\nsparse matrix if possible.\n@seealso{ldivide, rdivide}\n@end deftypefn") 
 XDEFUN_INTERNAL (inverse, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{x} =} inverse (@var{A})\n@deftypefnx {Built-in Function} {[@var{x}, @var{rcond}] =} inverse (@var{A})\nCompute the inverse of the square matrix @var{A}.\n\nThis is an alias for @code{inv}.\n@seealso{inv}\n@end deftypefn") 
}

static void
install_kron_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/kron.cc")
 XDEFUN_INTERNAL (kron, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} kron (@var{A}, @var{B})\n@deftypefnx {Built-in Function} {} kron (@var{A1}, @var{A2}, @dots{})\nForm the Kronecker product of two or more matrices.\n\nThis is defined block by block as\n\n@example\nx = [ a(i,j)*b ]\n@end example\n\nFor example:\n\n@example\n@group\nkron (1:4, ones (3, 1))\n     @result{}  1  2  3  4\n         1  2  3  4\n         1  2  3  4\n@end group\n@end example\n\nIf there are more than two input arguments @var{A1}, @var{A2}, @dots{},\n@var{An} the Kronecker product is computed as\n\n@example\nkron (kron (@var{A1}, @var{A2}), @dots{}, @var{An})\n@end example\n\n@noindent\nSince the Kronecker product is associative, this is well-defined.\n@end deftypefn") 
}

static void
install_load_path_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/load-path.cc")
 XDEFUN_INTERNAL (genpath, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} genpath (@var{dir})\n@deftypefnx {Built-in Function} {} genpath (@var{dir}, @var{skip}, @dots{})\nReturn a path constructed from @var{dir} and all its subdirectories.\n\nIf additional string parameters are given, the resulting path will exclude\ndirectories with those names.\n@end deftypefn") 
 XDEFUN_INTERNAL (rehash, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} rehash ()\nReinitialize Octave's load path directory cache.\n@end deftypefn") 
 XDEFUN_INTERNAL (command_line_path, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} command_line_path (@dots{})\nReturn the command line path variable.\n\n@seealso{path, addpath, rmpath, genpath, pathdef, savepath, pathsep}\n@end deftypefn") 
 XDEFUN_INTERNAL (restoredefaultpath, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} restoredefaultpath (@dots{})\nRestore Octave's path to its initial state at startup.\n\n@seealso{path, addpath, rmpath, genpath, pathdef, savepath, pathsep}\n@end deftypefn") 
 XDEFUN_INTERNAL (__pathorig__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{val} =} __pathorig__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (path, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} path (@dots{})\nModify or display Octave's load path.\n\nIf @var{nargin} and @var{nargout} are zero, display the elements of\nOctave's load path in an easy to read format.\n\nIf @var{nargin} is zero and nargout is greater than zero, return the\ncurrent load path.\n\nIf @var{nargin} is greater than zero, concatenate the arguments,\nseparating them with @code{pathsep}.  Set the internal search path\nto the result and return it.\n\nNo checks are made for duplicate elements.\n@seealso{addpath, rmpath, genpath, pathdef, savepath, pathsep}\n@end deftypefn") 
 XDEFUN_INTERNAL (addpath, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} addpath (@var{dir1}, @dots{})\n@deftypefnx {Built-in Function} {} addpath (@var{dir1}, @dots{}, @var{option})\nAdd named directories to the function search path.\n\nIf @var{option} is @qcode{\"-begin\"} or 0 (the default), prepend the\ndirectory name to the current path.  If @var{option} is @qcode{\"-end\"}\nor 1, append the directory name to the current path.\nDirectories added to the path must exist.\n\nIn addition to accepting individual directory arguments, lists of\ndirectory names separated by @code{pathsep} are also accepted.  For example:\n\n@example\naddpath (\"dir1:/dir2:~/dir3\")\n@end example\n@seealso{path, rmpath, genpath, pathdef, savepath, pathsep}\n@end deftypefn") 
 XDEFUN_INTERNAL (rmpath, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} rmpath (@var{dir1}, @dots{})\nRemove @var{dir1}, @dots{} from the current function search path.\n\nIn addition to accepting individual directory arguments, lists of\ndirectory names separated by @code{pathsep} are also accepted.  For example:\n\n@example\nrmpath (\"dir1:/dir2:~/dir3\")\n@end example\n@seealso{path, addpath, genpath, pathdef, savepath, pathsep}\n@end deftypefn") 
 XDEFUN_INTERNAL (__dump_load_path__, , , "") 
}

static void
install_load_save_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/load-save.cc")
 XDEFUN_INTERNAL (load, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} load file\n@deftypefnx {Command} {} load options file\n@deftypefnx {Command} {} load options file v1 v2 @dots{}\n@deftypefnx {Command} {S =} load (\"options\", \"file\", \"v1\", \"v2\", @dots{})\n@deftypefnx {Command} {} load file options\n@deftypefnx {Command} {} load file options v1 v2 @dots{}\n@deftypefnx {Command} {S =} load (\"file\", \"options\", \"v1\", \"v2\", @dots{})\nLoad the named variables @var{v1}, @var{v2}, @dots{}, from the file\n@var{file}.\n\nIf no variables are specified then all variables found in the\nfile will be loaded.  As with @code{save}, the list of variables to extract\ncan be full names or use a pattern syntax.  The format of the file is\nautomatically detected but may be overridden by supplying the appropriate\noption.\n\nIf load is invoked using the functional form\n\n@example\nload (\"-option1\", @dots{}, \"file\", \"v1\", @dots{})\n@end example\n\n@noindent\nthen the @var{options}, @var{file}, and variable name arguments\n(@var{v1}, @dots{}) must be specified as character strings.\n\nIf a variable that is not marked as global is loaded from a file when a\nglobal symbol with the same name already exists, it is loaded in the\nglobal symbol table.  Also, if a variable is marked as global in a file\nand a local symbol exists, the local symbol is moved to the global\nsymbol table and given the value from the file.\n\nIf invoked with a single output argument, Octave returns data instead\nof inserting variables in the symbol table.  If the data file contains\nonly numbers (TAB- or space-delimited columns), a matrix of values is\nreturned.  Otherwise, @code{load} returns a structure with members\n corresponding to the names of the variables in the file.\n\nThe @code{load} command can read data stored in Octave's text and\nbinary formats, and @sc{matlab}'s binary format.  If compiled with zlib\nsupport, it can also load gzip-compressed files.  It will automatically\ndetect the type of file and do conversion from different floating point\nformats (currently only IEEE big and little endian, though other formats\nmay be added in the future).\n\nValid options for @code{load} are listed in the following table.\n\n@table @code\n@item -force\nThis option is accepted for backward compatibility but is ignored.\nOctave now overwrites variables currently in memory with\nthose of the same name found in the file.\n\n@item -ascii\nForce Octave to assume the file contains columns of numbers in text format\nwithout any header or other information.  Data in the file will be loaded\nas a single numeric matrix with the name of the variable derived from the\nname of the file.\n\n@item -binary\nForce Octave to assume the file is in Octave's binary format.\n\n@item -hdf5\nForce Octave to assume the file is in @sc{hdf5} format.\n(@sc{hdf5} is a free, portable binary format developed by the National\nCenter for Supercomputing Applications at the University of Illinois.)\nNote that Octave can read @sc{hdf5} files not created by itself, but may\nskip some datasets in formats that it cannot support.  This format is\nonly available if Octave was built with a link to the @sc{hdf5} libraries.\n\n@item -import\nThis option is accepted for backward compatibility but is ignored.\nOctave can now support multi-dimensional HDF data and automatically\nmodifies variable names if they are invalid Octave identifiers.\n\n@item  -mat\n@itemx -mat-binary\n@itemx -6\n@itemx -v6\n@itemx -7\n@itemx -v7\nForce Octave to assume the file is in @sc{matlab}'s version 6 or 7 binary\nformat.\n\n@item  -mat4-binary\n@itemx -4\n@itemx -v4\n@itemx -V4\nForce Octave to assume the file is in the binary format written by\n@sc{matlab} version 4.\n\n@item -text\nForce Octave to assume the file is in Octave's text format.\n@end table\n@seealso{save, dlmwrite, csvwrite, fwrite}\n@end deftypefn") 
 XDEFUN_INTERNAL (save, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} save file\n@deftypefnx {Command} {} save options file\n@deftypefnx {Command} {} save options file @var{v1} @var{v2} @dots{}\n@deftypefnx {Command} {} save options file -struct @var{STRUCT} @var{f1} @var{f2} @dots{}\n@deftypefnx {Command} {} save @code{\"-\"} @var{v1} @var{v2} @dots{}\n@deftypefnx {Built-in Function} {@var{s} =} save (@code{\"-\"} @var{v1} @var{v2} @dots{})\nSave the named variables @var{v1}, @var{v2}, @dots{}, in the file\n@var{file}.\n\nThe special filename @samp{-} may be used to return the\ncontent of the variables as a string.  If no variable names are listed,\nOctave saves all the variables in the current scope.  Otherwise, full\nvariable names or pattern syntax can be used to specify the variables to\nsave.  If the @option{-struct} modifier is used, fields @var{f1} @var{f2}\n@dots{} of the scalar structure @var{STRUCT} are saved as if they were\nvariables with corresponding names.  Valid options for the @code{save}\ncommand are listed in the following table.  Options that modify the output\nformat override the format specified by @code{save_default_options}.\n\nIf save is invoked using the functional form\n\n@example\nsave (\"-option1\", @dots{}, \"file\", \"v1\", @dots{})\n@end example\n\n@noindent\nthen the @var{options}, @var{file}, and variable name arguments\n(@var{v1}, @dots{}) must be specified as character strings.\n\nIf called with a filename of @qcode{\"-\"}, write the output to stdout\nif nargout is 0, otherwise return the output in a character string.\n\n@table @code\n@item -append\nAppend to the destination instead of overwriting.\n\n@item -ascii\nSave a single matrix in a text file without header or any other information.\n\n@item -binary\nSave the data in Octave's binary data format.\n\n@item -float-binary\nSave the data in Octave's binary data format but only using single\nprecision.  Only use this format if you know that all the\nvalues to be saved can be represented in single precision.\n\n@item -hdf5\nSave the data in @sc{hdf5} format.\n(HDF5 is a free, portable binary format developed by the National\nCenter for Supercomputing Applications at the University of Illinois.)\nThis format is only available if Octave was built with a link to the\n@sc{hdf5} libraries.\n\n@item -float-hdf5\nSave the data in @sc{hdf5} format but only using single precision.\nOnly use this format if you know that all the\nvalues to be saved can be represented in single precision.\n\n@item  -V7\n@itemx -v7\n@itemx -7\n@itemx -mat7-binary\nSave the data in @sc{matlab}'s v7 binary data format.\n\n@item  -V6\n@itemx -v6\n@itemx -6\n@itemx -mat\n@itemx -mat-binary\nSave the data in @sc{matlab}'s v6 binary data format.\n\n@item  -V4\n@itemx -v4\n@itemx -4\n@itemx -mat4-binary\nSave the data in the binary format written by @sc{matlab} version 4.\n\n@item -text\nSave the data in Octave's text data format.  (default).\n\n@item  -zip\n@itemx -z\nUse the gzip algorithm to compress the file.  This works equally on files\nthat are compressed with gzip outside of octave, and gzip can equally be\nused to convert the files for backward compatibility.\nThis option is only available if Octave was built with a link to the zlib\nlibraries.\n@end table\n\nThe list of variables to save may use wildcard patterns containing\nthe following special characters:\n\n@table @code\n@item ?\nMatch any single character.\n\n@item *\nMatch zero or more characters.\n\n@item [ @var{list} ]\nMatch the list of characters specified by @var{list}.  If the first\ncharacter is @code{!} or @code{^}, match all characters except those\nspecified by @var{list}.  For example, the pattern @code{[a-zA-Z]} will\nmatch all lower and uppercase alphabetic characters.\n\nWildcards may also be used in the field name specifications when using\nthe @option{-struct} modifier (but not in the struct name itself).\n\n@end table\n\nExcept when using the @sc{matlab} binary data file format or the\n@samp{-ascii} format, saving global\nvariables also saves the global status of the variable.  If the variable\nis restored at a later time using @samp{load}, it will be restored as a\nglobal variable.\n\nThe command\n\n@example\nsave -binary data a b*\n@end example\n\n@noindent\nsaves the variable @samp{a} and all variables beginning with @samp{b} to\nthe file @file{data} in Octave's binary format.\n@seealso{load, save_default_options, save_header_format_string, dlmread, csvread, fread}\n@end deftypefn") 
 XDEFUN_INTERNAL (crash_dumps_octave_core, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} crash_dumps_octave_core ()\n@deftypefnx {Built-in Function} {@var{old_val} =} crash_dumps_octave_core (@var{new_val})\n@deftypefnx {Built-in Function} {} crash_dumps_octave_core (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave tries\nto save all current variables to the file @file{octave-workspace} if it\ncrashes or receives a hangup, terminate or similar signal.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{octave_core_file_limit, octave_core_file_name, octave_core_file_options}\n@end deftypefn") 
 XDEFUN_INTERNAL (save_default_options, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} save_default_options ()\n@deftypefnx {Built-in Function} {@var{old_val} =} save_default_options (@var{new_val})\n@deftypefnx {Built-in Function} {} save_default_options (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the default options\nfor the @code{save} command, and defines the default format.\n\nTypical values include @qcode{\"-ascii\"}, @qcode{\"-text -zip\"}.\nThe default value is @option{-text}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{save}\n@end deftypefn") 
 XDEFUN_INTERNAL (octave_core_file_limit, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} octave_core_file_limit ()\n@deftypefnx {Built-in Function} {@var{old_val} =} octave_core_file_limit (@var{new_val})\n@deftypefnx {Built-in Function} {} octave_core_file_limit (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the maximum amount\nof memory (in kilobytes) of the top-level workspace that Octave will\nattempt to save when writing data to the crash dump file (the name of\nthe file is specified by @var{octave_core_file_name}).\n\nIf @var{octave_core_file_options} flags specify a binary format,\nthen @var{octave_core_file_limit} will be approximately the maximum\nsize of the file.  If a text file format is used, then the file could\nbe much larger than the limit.  The default value is -1 (unlimited)\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{crash_dumps_octave_core, octave_core_file_name, octave_core_file_options}\n@end deftypefn") 
 XDEFUN_INTERNAL (octave_core_file_name, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} octave_core_file_name ()\n@deftypefnx {Built-in Function} {@var{old_val} =} octave_core_file_name (@var{new_val})\n@deftypefnx {Built-in Function} {} octave_core_file_name (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the name of the file\nused for saving data from the top-level workspace if Octave aborts.\n\nThe default value is @qcode{\"octave-workspace\"}\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{crash_dumps_octave_core, octave_core_file_name, octave_core_file_options}\n@end deftypefn") 
 XDEFUN_INTERNAL (octave_core_file_options, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} octave_core_file_options ()\n@deftypefnx {Built-in Function} {@var{old_val} =} octave_core_file_options (@var{new_val})\n@deftypefnx {Built-in Function} {} octave_core_file_options (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the options used for\nsaving the workspace data if Octave aborts.\n\nThe value of @code{octave_core_file_options} should follow the same format\nas the options for the @code{save} function.  The default value is Octave's\nbinary format.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{crash_dumps_octave_core, octave_core_file_name, octave_core_file_limit}\n@end deftypefn") 
 XDEFUN_INTERNAL (save_header_format_string, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} save_header_format_string ()\n@deftypefnx {Built-in Function} {@var{old_val} =} save_header_format_string (@var{new_val})\n@deftypefnx {Built-in Function} {} save_header_format_string (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the format\nstring used for the comment line written at the beginning of\ntext-format data files saved by Octave.\n\nThe format string is passed to @code{strftime} and should begin with the\ncharacter @samp{#} and contain no newline characters.  If the value of\n@code{save_header_format_string} is the empty string, the header comment is\nomitted from text-format data files.  The default value is\n@c Set example in small font to prevent overfull line\n\n@smallexample\n\"# Created by Octave VERSION, %a %b %d %H:%M:%S %Y %Z <USER@@HOST>\"\n@end smallexample\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{strftime, save}\n@end deftypefn") 
}

static void
install_lookup_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/lookup.cc")
 XDEFUN_INTERNAL (lookup, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{idx} =} lookup (@var{table}, @var{y})\n@deftypefnx {Built-in Function} {@var{idx} =} lookup (@var{table}, @var{y}, @var{opt})\nLookup values in a sorted table.\n\nThis function is usually used as a prelude to interpolation.\n\nIf table is increasing and @code{idx = lookup (table, y)}, then\n@code{table(idx(i)) <= y(i) < table(idx(i+1))} for all @code{y(i)} within\nthe table.  If @code{y(i) < table(1)} then @code{idx(i)} is 0.  If\n@code{y(i) >= table(end)} or @code{isnan (y(i))} then @code{idx(i)} is\n@code{n}.\n\nIf the table is decreasing, then the tests are reversed.\nFor non-strictly monotonic tables, empty intervals are always skipped.\nThe result is undefined if @var{table} is not monotonic, or if\n@var{table} contains a NaN.\n\nThe complexity of the lookup is O(M*log(N)) where N is the size of\n@var{table} and M is the size of @var{y}.  In the special case when @var{y}\nis also sorted, the complexity is O(min(M*log(N),M+N)).\n\n@var{table} and @var{y} can also be cell arrays of strings\n(or @var{y} can be a single string).  In this case, string lookup\nis performed using lexicographical comparison.\n\nIf @var{opts} is specified, it must be a string with letters indicating\nadditional options.\n\n@table @code\n@item m\n@code{table(idx(i)) == val(i)} if @code{val(i)}\noccurs in table; otherwise, @code{idx(i)} is zero.\n\n@item b\n@code{idx(i)} is a logical 1 or 0, indicating whether\n@code{val(i)} is contained in table or not.\n\n@item l\nFor numeric lookups\nthe leftmost subinterval shall be extended to infinity (i.e., all indices\nat least 1)\n\n@item r\nFor numeric lookups\nthe rightmost subinterval shall be extended to infinity (i.e., all indices\nat most n-1).\n@end table\n@end deftypefn") 
}

static void
install_ls_oct_ascii_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/ls-oct-ascii.cc")
 XDEFUN_INTERNAL (save_precision, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} save_precision ()\n@deftypefnx {Built-in Function} {@var{old_val} =} save_precision (@var{new_val})\n@deftypefnx {Built-in Function} {} save_precision (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the number of digits to\nkeep when saving data in text format.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_lsode_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/lsode.cc")
 XDEFUN_INTERNAL (lsode_options, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} lsode_options ()\n@deftypefnx {Built-in Function} {val =} lsode_options (@var{opt})\n@deftypefnx {Built-in Function} {} lsode_options (@var{opt}, @var{val})\nQuery or set options for the function @code{lsode}.\n\nWhen called with no arguments, the names of all available options and\ntheir current values are displayed.\n\nGiven one argument, return the value of the option @var{opt}.\n\nWhen called with two arguments, @code{lsode_options} sets the option\n@var{opt} to value @var{val}.\n\nOptions include\n\n@table @code\n@item @qcode{\"absolute tolerance\"}\nAbsolute tolerance.  May be either vector or scalar.  If a vector, it\nmust match the dimension of the state vector.\n\n@item @qcode{\"relative tolerance\"}\nRelative tolerance parameter.  Unlike the absolute tolerance, this\nparameter may only be a scalar.\n\nThe local error test applied at each integration step is\n\n@example\n@group\n  abs (local error in x(i)) <= ...\n      rtol * abs (y(i)) + atol(i)\n@end group\n@end example\n\n@item @qcode{\"integration method\"}\nA string specifying the method of integration to use to solve the ODE\nsystem.  Valid values are\n\n@table @asis\n@item  @qcode{\"adams\"}\n@itemx @qcode{\"non-stiff\"}\nNo Jacobian used (even if it is available).\n\n@item  @qcode{\"bdf\"}\n@itemx @qcode{\"stiff\"}\nUse stiff backward differentiation formula (BDF) method.  If a\nfunction to compute the Jacobian is not supplied, @code{lsode} will\ncompute a finite difference approximation of the Jacobian matrix.\n@end table\n\n@item @qcode{\"initial step size\"}\nThe step size to be attempted on the first step (default is determined\nautomatically).\n\n@item @qcode{\"maximum order\"}\nRestrict the maximum order of the solution method.  If using the Adams\nmethod, this option must be between 1 and 12.  Otherwise, it must be\nbetween 1 and 5, inclusive.\n\n@item @qcode{\"maximum step size\"}\nSetting the maximum stepsize will avoid passing over very large\nregions  (default is not specified).\n\n@item @qcode{\"minimum step size\"}\nThe minimum absolute step size allowed (default is 0).\n\n@item @qcode{\"step limit\"}\nMaximum number of steps allowed (default is 100000).\n@end table\n@end deftypefn") 
 XDEFUN_INTERNAL (lsode, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{x}, @var{istate}, @var{msg}] =} lsode (@var{fcn}, @var{x_0}, @var{t})\n@deftypefnx {Built-in Function} {[@var{x}, @var{istate}, @var{msg}] =} lsode (@var{fcn}, @var{x_0}, @var{t}, @var{t_crit})\nOrdinary Differential Equation (ODE) solver.\n\nThe set of differential equations to solve is\n@tex\n$$ {dx \\over dt} = f (x, t) $$\nwith\n$$ x(t_0) = x_0 $$\n@end tex\n@ifnottex\n\n@example\n@group\ndx\n-- = f (x, t)\ndt\n@end group\n@end example\n\n@noindent\nwith\n\n@example\nx(t_0) = x_0\n@end example\n\n@end ifnottex\nThe solution is returned in the matrix @var{x}, with each row\ncorresponding to an element of the vector @var{t}.  The first element\nof @var{t} should be @math{t_0} and should correspond to the initial\nstate of the system @var{x_0}, so that the first row of the output\nis @var{x_0}.\n\nThe first argument, @var{fcn}, is a string, inline, or function handle\nthat names the function @math{f} to call to compute the vector of right\nhand sides for the set of equations.  The function must have the form\n\n@example\n@var{xdot} = f (@var{x}, @var{t})\n@end example\n\n@noindent\nin which @var{xdot} and @var{x} are vectors and @var{t} is a scalar.\n\nIf @var{fcn} is a two-element string array or a two-element cell array\nof strings, inline functions, or function handles, the first element names\nthe function @math{f} described above, and the second element names a\nfunction to compute the Jacobian of @math{f}.  The Jacobian function\nmust have the form\n\n@example\n@var{jac} = j (@var{x}, @var{t})\n@end example\n\n@noindent\nin which @var{jac} is the matrix of partial derivatives\n@tex\n$$ J = {\\partial f_i \\over \\partial x_j} = \\left[\\matrix{\n{\\partial f_1 \\over \\partial x_1}\n  & {\\partial f_1 \\over \\partial x_2}\n  & \\cdots\n  & {\\partial f_1 \\over \\partial x_N} \\cr\n{\\partial f_2 \\over \\partial x_1}\n  & {\\partial f_2 \\over \\partial x_2}\n  & \\cdots\n  & {\\partial f_2 \\over \\partial x_N} \\cr\n \\vdots & \\vdots & \\ddots & \\vdots \\cr\n{\\partial f_3 \\over \\partial x_1}\n  & {\\partial f_3 \\over \\partial x_2}\n  & \\cdots\n  & {\\partial f_3 \\over \\partial x_N} \\cr}\\right]$$\n@end tex\n@ifnottex\n\n@example\n@group\n             | df_1  df_1       df_1 |\n             | ----  ----  ...  ---- |\n             | dx_1  dx_2       dx_N |\n             |                       |\n             | df_2  df_2       df_2 |\n             | ----  ----  ...  ---- |\n      df_i   | dx_1  dx_2       dx_N |\njac = ---- = |                       |\n      dx_j   |  .    .     .    .    |\n             |  .    .      .   .    |\n             |  .    .       .  .    |\n             |                       |\n             | df_N  df_N       df_N |\n             | ----  ----  ...  ---- |\n             | dx_1  dx_2       dx_N |\n@end group\n@end example\n\n@end ifnottex\n\nThe second and third arguments specify the initial state of the system,\n@math{x_0}, and the initial value of the independent variable @math{t_0}.\n\nThe fourth argument is optional, and may be used to specify a set of\ntimes that the ODE solver should not integrate past.  It is useful for\navoiding difficulties with singularities and points where there is a\ndiscontinuity in the derivative.\n\nAfter a successful computation, the value of @var{istate} will be 2\n(consistent with the Fortran version of @sc{lsode}).\n\nIf the computation is not successful, @var{istate} will be something\nother than 2 and @var{msg} will contain additional information.\n\nYou can use the function @code{lsode_options} to set optional\nparameters for @code{lsode}.\n@seealso{daspk, dassl, dasrt}\n@end deftypefn") 
}

static void
install_lu_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/lu.cc")
 XDEFUN_INTERNAL (lu, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{L}, @var{U}] =} lu (@var{A})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}] =} lu (@var{A})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}, @var{Q}] =} lu (@var{S})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}, @var{Q}, @var{R}] =} lu (@var{S})\n@deftypefnx {Built-in Function} {[@dots{}] =} lu (@var{S}, @var{thres})\n@deftypefnx {Built-in Function} {@var{y} =} lu (@dots{})\n@deftypefnx {Built-in Function} {[@dots{}] =} lu (@dots{}, \"vector\")\n@cindex LU decomposition\nCompute the LU@tie{}decomposition of @var{A}.\n\nIf @var{A} is full subroutines from @sc{lapack} are used and if @var{A} is\nsparse then @sc{umfpack} is used.\n\nThe result is returned in a permuted form, according to the optional return\nvalue @var{P}.  For example, given the matrix @code{a = [1, 2; 3, 4]},\n\n@example\n[l, u, p] = lu (@var{a})\n@end example\n\n@noindent\nreturns\n\n@example\n@group\nl =\n\n  1.00000  0.00000\n  0.33333  1.00000\n\nu =\n\n  3.00000  4.00000\n  0.00000  0.66667\n\np =\n\n  0  1\n  1  0\n@end group\n@end example\n\nThe matrix is not required to be square.\n\nWhen called with two or three output arguments and a spare input matrix,\n@code{lu} does not attempt to perform sparsity preserving column\npermutations.  Called with a fourth output argument, the sparsity\npreserving column transformation @var{Q} is returned, such that\n@code{@var{P} * @var{A} * @var{Q} = @var{L} * @var{U}}.\n\nCalled with a fifth output argument and a sparse input matrix,\n@code{lu} attempts to use a scaling factor @var{R} on the input matrix\nsuch that\n@code{@var{P} * (@var{R} \\ @var{A}) * @var{Q} = @var{L} * @var{U}}.\nThis typically leads to a sparser and more stable factorization.\n\nAn additional input argument @var{thres}, that defines the pivoting\nthreshold can be given.  @var{thres} can be a scalar, in which case\nit defines the @sc{umfpack} pivoting tolerance for both symmetric and\nunsymmetric cases.  If @var{thres} is a 2-element vector, then the first\nelement defines the pivoting tolerance for the unsymmetric @sc{umfpack}\npivoting strategy and the second for the symmetric strategy.  By default,\nthe values defined by @code{spparms} are used ([0.1, 0.001]).\n\nGiven the string argument @qcode{\"vector\"}, @code{lu} returns the values\nof @var{P} and @var{Q} as vector values, such that for full matrix,\n@code{@var{A} (@var{P},:) = @var{L} * @var{U}}, and @code{@var{R}(@var{P},:)\n* @var{A} (:, @var{Q}) = @var{L} * @var{U}}.\n\nWith two output arguments, returns the permuted forms of the upper and\nlower triangular matrices, such that @code{@var{A} = @var{L} * @var{U}}.\nWith one output argument @var{y}, then the matrix returned by the @sc{lapack}\nroutines is returned.  If the input matrix is sparse then the matrix @var{L}\nis embedded into @var{U} to give a return value similar to the full case.\nFor both full and sparse matrices, @code{lu} loses the permutation\ninformation.\n@seealso{luupdate, ilu, chol, hess, qr, qz, schur, svd}\n@end deftypefn") 
 XDEFUN_INTERNAL (luupdate, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{L}, @var{U}] =} luupdate (@var{L}, @var{U}, @var{x}, @var{y})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}] =} luupdate (@var{L}, @var{U}, @var{P}, @var{x}, @var{y})\nGiven an LU@tie{}factorization of a real or complex matrix\n@w{@var{A} = @var{L}*@var{U}}, @var{L}@tie{}lower unit trapezoidal and\n@var{U}@tie{}upper trapezoidal, return the LU@tie{}factorization\nof @w{@var{A} + @var{x}*@var{y}.'}, where @var{x} and @var{y} are\ncolumn vectors (rank-1 update) or matrices with equal number of columns\n(rank-k update).\n\nOptionally, row-pivoted updating can be used by supplying a row permutation\n(pivoting) matrix @var{P}; in that case, an updated permutation matrix is\nreturned.  Note that if @var{L}, @var{U}, @var{P} is a pivoted\nLU@tie{}factorization as obtained by @code{lu}:\n\n@example\n[@var{L}, @var{U}, @var{P}] = lu (@var{A});\n@end example\n\n@noindent\nthen a factorization of @tcode{@var{A}+@var{x}*@var{y}.'} can be obtained\neither as\n\n@example\n[@var{L1}, @var{U1}] = lu (@var{L}, @var{U}, @var{P}*@var{x}, @var{y})\n@end example\n\n@noindent\nor\n\n@example\n[@var{L1}, @var{U1}, @var{P1}] = lu (@var{L}, @var{U}, @var{P}, @var{x}, @var{y})\n@end example\n\nThe first form uses the unpivoted algorithm, which is faster, but less\nstable.  The second form uses a slower pivoted algorithm, which is more\nstable.\n\nThe matrix case is done as a sequence of rank-1 updates; thus, for large\nenough k, it will be both faster and more accurate to recompute the\nfactorization from scratch.\n@seealso{lu, cholupdate, qrupdate}\n@end deftypefn") 
}

static void
install_luinc_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/luinc.cc")
 XDEFUN_INTERNAL (__luinc__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{L}, @var{U}, @var{P}, @var{Q}] =} luinc (@var{A}, '0')\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}, @var{Q}] =} luinc (@var{A}, @var{droptol})\n@deftypefnx {Built-in Function} {[@var{L}, @var{U}, @var{P}, @var{Q}] =} luinc (@var{A}, @var{opts})\n@cindex LU decomposition\nProduce the incomplete LU@tie{}factorization of the sparse matrix @var{A}.\n\nTwo types of incomplete factorization are possible, and the type\nis determined by the second argument to @code{luinc}.\n\nCalled with a second argument of @qcode{'0'}, the zero-level incomplete\nLU@tie{}factorization is produced.  This creates a factorization of @var{A}\nwhere the position of the nonzero arguments correspond to the same\npositions as in the matrix @var{A}.\n\nAlternatively, the fill-in of the incomplete LU@tie{}factorization can\nbe controlled through the variable @var{droptol} or the structure\n@var{opts}.  The @sc{umfpack} multifrontal factorization code by Tim A.\nDavis is used for the incomplete LU@tie{}factorization, (availability\n@url{http://www.cise.ufl.edu/research/sparse/umfpack/})\n\n@var{droptol} determines the values below which the values in the\nLU@tie{} factorization are dropped and replaced by zero.  It must be a\npositive scalar, and any values in the factorization whose absolute value\nare less than this value are dropped, expect if leaving them increase the\nsparsity of the matrix.  Setting @var{droptol} to zero results in a complete\nLU@tie{}factorization which is the default.\n\n@var{opts} is a structure containing one or more of the fields\n\n@table @code\n@item droptol\nThe drop tolerance as above.  If @var{opts} only contains @code{droptol}\nthen this is equivalent to using the variable @var{droptol}.\n\n@item milu\nA logical variable flagging whether to use the modified incomplete\nLU@tie{} factorization.  In the case that @code{milu} is true, the dropped\nvalues are subtracted from the diagonal of the matrix @var{U} of the\nfactorization.  The default is @code{false}.\n\n@item udiag\nA logical variable that flags whether zero elements on the diagonal of\n@var{U} should be replaced with @var{droptol} to attempt to avoid singular\nfactors.  The default is @code{false}.\n\n@item thresh\nDefines the pivot threshold in the interval [0,1].  Values outside that\nrange are ignored.\n@end table\n\nAll other fields in @var{opts} are ignored.  The outputs from @code{luinc}\nare the same as for @code{lu}.\n\nGiven the string argument @qcode{\"vector\"}, @code{luinc} returns the\nvalues of @var{p} @var{q} as vector values.\n@seealso{sparse, lu, ilu, ichol}\n@end deftypefn") 
}

static void
install_mappers_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/mappers.cc")
 XDEFUN_INTERNAL (abs, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} abs (@var{z})\nCompute the magnitude of @var{z}.\n\nThe magnitude is defined as\n@tex\n$|z| = \\sqrt{x^2 + y^2}$.\n@end tex\n@ifnottex\n|@var{z}| = @code{sqrt (x^2 + y^2)}.\n@end ifnottex\n\nFor example:\n\n@example\n@group\nabs (3 + 4i)\n     @result{} 5\n@end group\n@end example\n@seealso{arg}\n@end deftypefn") 
 XDEFUN_INTERNAL (acos, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} acos (@var{x})\nCompute the inverse cosine in radians for each element of @var{x}.\n@seealso{cos, acosd}\n@end deftypefn") 
 XDEFUN_INTERNAL (acosh, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} acosh (@var{x})\nCompute the inverse hyperbolic cosine for each element of @var{x}.\n@seealso{cosh}\n@end deftypefn") 
 XDEFUN_INTERNAL (angle, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} angle (@var{z})\nSee @code{arg}.\n@seealso{arg}\n@end deftypefn") 
 XDEFUN_INTERNAL (arg, args, , "-*- texinfo -*-\n@deftypefn  {Mapping Function} {} arg (@var{z})\n@deftypefnx {Mapping Function} {} angle (@var{z})\nCompute the argument, i.e., angle of @var{z}.\n\nThis is defined as,\n@tex\n$\\theta = atan2 (y, x),$\n@end tex\n@ifnottex\n@var{theta} = @code{atan2 (@var{y}, @var{x})},\n@end ifnottex\nin radians.\n\nFor example:\n\n@example\n@group\narg (3 + 4i)\n     @result{} 0.92730\n@end group\n@end example\n@seealso{abs}\n@end deftypefn") 
 XDEFUN_INTERNAL (asin, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} asin (@var{x})\nCompute the inverse sine in radians for each element of @var{x}.\n@seealso{sin, asind}\n@end deftypefn") 
 XDEFUN_INTERNAL (asinh, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} asinh (@var{x})\nCompute the inverse hyperbolic sine for each element of @var{x}.\n@seealso{sinh}\n@end deftypefn") 
 XDEFUN_INTERNAL (atan, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} atan (@var{x})\nCompute the inverse tangent in radians for each element of @var{x}.\n@seealso{tan, atand}\n@end deftypefn") 
 XDEFUN_INTERNAL (atanh, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} atanh (@var{x})\nCompute the inverse hyperbolic tangent for each element of @var{x}.\n@seealso{tanh}\n@end deftypefn") 
 XDEFUN_INTERNAL (cbrt, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} cbrt (@var{x})\nCompute the real cube root of each element of @var{x}.\n\nUnlike @code{@var{x}^(1/3)}, the result will be negative if @var{x} is\nnegative.\n@seealso{nthroot}\n@end deftypefn") 
 XDEFUN_INTERNAL (ceil, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} ceil (@var{x})\nReturn the smallest integer not less than @var{x}.\n\nThis is equivalent to rounding towards positive infinity.\n\nIf @var{x} is complex, return\n@code{ceil (real (@var{x})) + ceil (imag (@var{x})) * I}.\n\n@example\n@group\nceil ([-2.7, 2.7])\n    @result{} -2    3\n@end group\n@end example\n@seealso{floor, round, fix}\n@end deftypefn") 
 XDEFUN_INTERNAL (conj, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} conj (@var{z})\nReturn the complex conjugate of @var{z}.\n\nThe complex conjugate is defined as\n@tex\n$\\bar{z} = x - iy$.\n@end tex\n@ifnottex\n@code{conj (@var{z})} = @var{x} - @var{i}@var{y}.\n@end ifnottex\n@seealso{real, imag}\n@end deftypefn") 
 XDEFUN_INTERNAL (cos, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} cos (@var{x})\nCompute the cosine for each element of @var{x} in radians.\n@seealso{acos, cosd, cosh}\n@end deftypefn") 
 XDEFUN_INTERNAL (cosh, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} cosh (@var{x})\nCompute the hyperbolic cosine for each element of @var{x}.\n@seealso{acosh, sinh, tanh}\n@end deftypefn") 
 XDEFUN_INTERNAL (erf, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} erf (@var{z})\nCompute the error function.\n\nThe error function is defined as\n@tex\n$$\n {\\rm erf} (z) = {2 \\over \\sqrt{\\pi}}\\int_0^z e^{-t^2} dt\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n                        z\n              2        /\nerf (z) = --------- *  | e^(-t^2) dt\n          sqrt (pi)    /\n                    t=0\n@end group\n@end example\n\n@end ifnottex\n@seealso{erfc, erfcx, erfi, dawson, erfinv, erfcinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (erfinv, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} erfinv (@var{x})\nCompute the inverse error function.\n\nThe inverse error function is defined such that\n\n@example\nerf (@var{y}) == @var{x}\n@end example\n@seealso{erf, erfc, erfcx, erfi, dawson, erfcinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (erfcinv, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} erfcinv (@var{x})\nCompute the inverse complementary error function.\n\nThe inverse complementary error function is defined such that\n\n@example\nerfc (@var{y}) == @var{x}\n@end example\n@seealso{erfc, erf, erfcx, erfi, dawson, erfinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (erfc, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} erfc (@var{z})\nCompute the complementary error function.\n\nThe complementary error function is defined as\n@tex\n$1 - {\\rm erf} (z)$.\n@end tex\n@ifnottex\n@w{@code{1 - erf (@var{z})}}.\n@end ifnottex\n@seealso{erfcinv, erfcx, erfi, dawson, erf, erfinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (erfcx, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} erfcx (@var{z})\nCompute the scaled complementary error function.\n\nThe scaled complementary error function is defined as\n@tex\n$$\n e^{z^2} {\\rm erfc} (z) \\equiv e^{z^2} (1 - {\\rm erf} (z))\n$$\n@end tex\n@ifnottex\n\n@example\nexp (z^2) * erfc (z)\n@end example\n\n@end ifnottex\n@seealso{erfc, erf, erfi, dawson, erfinv, erfcinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (erfi, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} erfi (@var{z})\nCompute the imaginary error function.\n\nThe imaginary error function is defined as\n@tex\n$$\n -i {\\rm erf} (iz)\n$$\n@end tex\n@ifnottex\n\n@example\n-i * erf (i*z)\n@end example\n\n@end ifnottex\n@seealso{erfc, erf, erfcx, dawson, erfinv, erfcinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (dawson, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} dawson (@var{z})\nCompute the Dawson (scaled imaginary error) function.\n\nThe Dawson function is defined as\n@tex\n$$\n {\\sqrt{\\pi} \\over 2} e^{-z^2} {\\rm erfi} (z) \\equiv -i {\\sqrt{\\pi} \\over 2} e^{-z^2} {\\rm erf} (iz)\n$$\n@end tex\n@ifnottex\n\n@example\n(sqrt (pi) / 2) * exp (-z^2) * erfi (z)\n@end example\n\n@end ifnottex\n@seealso{erfc, erf, erfcx, erfi, erfinv, erfcinv}\n@end deftypefn") 
 XDEFUN_INTERNAL (exp, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} exp (@var{x})\nCompute\n@tex\n$e^{x}$\n@end tex\n@ifnottex\n@code{e^x}\n@end ifnottex\nfor each element of @var{x}.\n\nTo compute the matrix exponential, see @ref{Linear Algebra}.\n@seealso{log}\n@end deftypefn") 
 XDEFUN_INTERNAL (expm1, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} expm1 (@var{x})\nCompute\n@tex\n$ e^{x} - 1 $\n@end tex\n@ifnottex\n@code{exp (@var{x}) - 1}\n@end ifnottex\naccurately in the neighborhood of zero.\n@seealso{exp}\n@end deftypefn") 
 XDEFUN_INTERNAL (isfinite, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isfinite (@var{x})\nReturn a logical array which is true where the elements of @var{x} are\nfinite values and false where they are not.\n\nFor example:\n\n@example\n@group\nisfinite ([13, Inf, NA, NaN])\n     @result{} [ 1, 0, 0, 0 ]\n@end group\n@end example\n@seealso{isinf, isnan, isna}\n@end deftypefn") 
 XDEFUN_INTERNAL (fix, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} fix (@var{x})\nTruncate fractional portion of @var{x} and return the integer portion.\n\nThis is equivalent to rounding towards zero.  If @var{x} is complex, return\n@code{fix (real (@var{x})) + fix (imag (@var{x})) * I}.\n\n@example\n@group\nfix ([-2.7, 2.7])\n   @result{} -2    2\n@end group\n@end example\n@seealso{ceil, floor, round}\n@end deftypefn") 
 XDEFUN_INTERNAL (floor, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} floor (@var{x})\nReturn the largest integer not greater than @var{x}.\n\nThis is equivalent to rounding towards negative infinity.  If @var{x} is\ncomplex, return @code{floor (real (@var{x})) + floor (imag (@var{x})) * I}.\n\n@example\n@group\nfloor ([-2.7, 2.7])\n     @result{} -3    2\n@end group\n@end example\n@seealso{ceil, round, fix}\n@end deftypefn") 
 XDEFUN_INTERNAL (gamma, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} gamma (@var{z})\nCompute the Gamma function.\n\nThe Gamma function is defined as\n@tex\n$$\n \\Gamma (z) = \\int_0^\\infty t^{z-1} e^{-t} dt.\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n             infinity\n            /\ngamma (z) = | t^(z-1) exp (-t) dt.\n            /\n         t=0\n@end group\n@end example\n\n@end ifnottex\n\nProgramming Note: The gamma function can grow quite large even for small\ninput values.  In many cases it may be preferable to use the natural\nlogarithm of the gamma function (@code{gammaln}) in calculations to minimize\nloss of precision.  The final result is then\n@code{exp (@var{result_using_gammaln}).}\n@seealso{gammainc, gammaln, factorial}\n@end deftypefn") 
 XDEFUN_INTERNAL (imag, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} imag (@var{z})\nReturn the imaginary part of @var{z} as a real number.\n@seealso{real, conj}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isalnum", Fisalnum, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isalnum (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nletters or digits and false where they are not.\n\nThis is equivalent to (@code{isalpha (@var{s}) | isdigit (@var{s})}).\n@seealso{isalpha, isdigit, ispunct, isspace, iscntrl}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isalpha", Fisalpha, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isalpha (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nletters and false where they are not.\n\nThis is equivalent to (@code{islower (@var{s}) | isupper (@var{s})}).\n@seealso{isdigit, ispunct, isspace, iscntrl, isalnum, islower, isupper}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isascii", Fisascii, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isascii (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nASCII characters (in the range 0 to 127 decimal) and false where they are\nnot.\n@end deftypefn") 
 XDEFUNX_INTERNAL ("iscntrl", Fiscntrl, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} iscntrl (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\ncontrol characters and false where they are not.\n@seealso{ispunct, isspace, isalpha, isdigit}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isdigit", Fisdigit, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isdigit (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\ndecimal digits (0-9) and false where they are not.\n@seealso{isxdigit, isalpha, isletter, ispunct, isspace, iscntrl}\n@end deftypefn") 
 XDEFUN_INTERNAL (isinf, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isinf (@var{x})\nReturn a logical array which is true where the elements of @var{x} are\ninfinite and false where they are not.\n\nFor example:\n\n@example\n@group\nisinf ([13, Inf, NA, NaN])\n      @result{} [ 0, 1, 0, 0 ]\n@end group\n@end example\n@seealso{isfinite, isnan, isna}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isgraph", Fisgraph, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isgraph (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nprintable characters (but not the space character) and false where they are\nnot.\n@seealso{isprint}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("islower", Fislower, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} islower (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nlowercase letters and false where they are not.\n@seealso{isupper, isalpha, isletter, isalnum}\n@end deftypefn") 
 XDEFUN_INTERNAL (isna, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isna (@var{x})\nReturn a logical array which is true where the elements of @var{x} are\nNA (missing) values and false where they are not.\n\nFor example:\n\n@example\n@group\nisna ([13, Inf, NA, NaN])\n     @result{} [ 0, 0, 1, 0 ]\n@end group\n@end example\n@seealso{isnan, isinf, isfinite}\n@end deftypefn") 
 XDEFUN_INTERNAL (isnan, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isnan (@var{x})\nReturn a logical array which is true where the elements of @var{x} are\nNaN values and false where they are not.\n\nNA values are also considered NaN values.  For example:\n\n@example\n@group\nisnan ([13, Inf, NA, NaN])\n      @result{} [ 0, 0, 1, 1 ]\n@end group\n@end example\n@seealso{isna, isinf, isfinite}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isprint", Fisprint, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isprint (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nprintable characters (including the space character) and false where they\nare not.\n@seealso{isgraph}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("ispunct", Fispunct, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} ispunct (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\npunctuation characters and false where they are not.\n@seealso{isalpha, isdigit, isspace, iscntrl}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isspace", Fisspace, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isspace (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nwhitespace characters (space, formfeed, newline, carriage return, tab, and\nvertical tab) and false where they are not.\n@seealso{iscntrl, ispunct, isalpha, isdigit}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isupper", Fisupper, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isupper (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nuppercase letters and false where they are not.\n@seealso{islower, isalpha, isletter, isalnum}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("isxdigit", Fisxdigit, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} isxdigit (@var{s})\nReturn a logical array which is true where the elements of @var{s} are\nhexadecimal digits (0-9 and @nospell{a-fA-F}).\n@seealso{isdigit}\n@end deftypefn") 
 XDEFUN_INTERNAL (lgamma, args, , "-*- texinfo -*-\n@deftypefn  {Mapping Function} {} gammaln (@var{x})\n@deftypefnx {Mapping Function} {} lgamma (@var{x})\nReturn the natural logarithm of the gamma function of @var{x}.\n@seealso{gamma, gammainc}\n@end deftypefn") 
 XDEFUN_INTERNAL (log, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} log (@var{x})\nCompute the natural logarithm,\n@tex\n$\\ln{(x)},$\n@end tex\n@ifnottex\n@code{ln (@var{x})},\n@end ifnottex\nfor each element of @var{x}.\n\nTo compute the matrix logarithm, see @ref{Linear Algebra}.\n@seealso{exp, log1p, log2, log10, logspace}\n@end deftypefn") 
 XDEFUN_INTERNAL (log10, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} log10 (@var{x})\nCompute the base-10 logarithm of each element of @var{x}.\n@seealso{log, log2, logspace, exp}\n@end deftypefn") 
 XDEFUN_INTERNAL (log1p, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} log1p (@var{x})\nCompute\n@tex\n$\\ln{(1 + x)}$\n@end tex\n@ifnottex\n@code{log (1 + @var{x})}\n@end ifnottex\naccurately in the neighborhood of zero.\n@seealso{log, exp, expm1}\n@end deftypefn") 
 XDEFUN_INTERNAL (real, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} real (@var{z})\nReturn the real part of @var{z}.\n@seealso{imag, conj}\n@end deftypefn") 
 XDEFUN_INTERNAL (round, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} round (@var{x})\nReturn the integer nearest to @var{x}.\n\nIf @var{x} is complex, return\n@code{round (real (@var{x})) + round (imag (@var{x})) * I}.  If there\nare two nearest integers, return the one further away from zero.\n\n@example\n@group\nround ([-2.7, 2.7])\n     @result{} -3    3\n@end group\n@end example\n@seealso{ceil, floor, fix, roundb}\n@end deftypefn") 
 XDEFUN_INTERNAL (roundb, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} roundb (@var{x})\nReturn the integer nearest to @var{x}.  If there are two nearest\nintegers, return the even one (banker's rounding).\n\nIf @var{x} is complex,\nreturn @code{roundb (real (@var{x})) + roundb (imag (@var{x})) * I}.\n@seealso{round}\n@end deftypefn") 
 XDEFUN_INTERNAL (sign, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} sign (@var{x})\nCompute the @dfn{signum} function.\n\nThis is defined as\n@tex\n$$\n{\\rm sign} (@var{x}) = \\cases{1,&$x>0$;\\cr 0,&$x=0$;\\cr -1,&$x<0$.\\cr}\n$$\n@end tex\n@ifnottex\n\n@example\n@group\n           -1, x < 0;\nsign (x) =  0, x = 0;\n            1, x > 0.\n@end group\n@end example\n\n@end ifnottex\n\nFor complex arguments, @code{sign} returns @code{x ./ abs (@var{x})}.\n\nNote that @code{sign (-0.0)} is 0.  Although IEEE 754 floating point\nallows zero to be signed, 0.0 and -0.0 compare equal.  If you must test\nwhether zero is signed, use the @code{signbit} function.\n@seealso{signbit}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("signbit", Fsignbit, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} signbit (@var{x})\nReturn logical true if the value of @var{x} has its sign bit set and false\notherwise.\n\nThis behavior is consistent with the other logical functions.\nSee @ref{Logical Values}.  The behavior differs from the C language function\nwhich returns nonzero if the sign bit is set.\n\nThis is not the same as @code{x < 0.0}, because IEEE 754 floating point\nallows zero to be signed.  The comparison @code{-0.0 < 0.0} is false,\nbut @code{signbit (-0.0)} will return a nonzero value.\n@seealso{sign}\n@end deftypefn") 
 XDEFUN_INTERNAL (sin, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} sin (@var{x})\nCompute the sine for each element of @var{x} in radians.\n@seealso{asin, sind, sinh}\n@end deftypefn") 
 XDEFUN_INTERNAL (sinh, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} sinh (@var{x})\nCompute the hyperbolic sine for each element of @var{x}.\n@seealso{asinh, cosh, tanh}\n@end deftypefn") 
 XDEFUN_INTERNAL (sqrt, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} sqrt (@var{x})\nCompute the square root of each element of @var{x}.\n\nIf @var{x} is negative, a complex result is returned.\n\nTo compute the matrix square root, see @ref{Linear Algebra}.\n@seealso{realsqrt, nthroot}\n@end deftypefn") 
 XDEFUN_INTERNAL (tan, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} tan (@var{z})\nCompute the tangent for each element of @var{x} in radians.\n@seealso{atan, tand, tanh}\n@end deftypefn") 
 XDEFUN_INTERNAL (tanh, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} tanh (@var{x})\nCompute hyperbolic tangent for each element of @var{x}.\n@seealso{atanh, sinh, cosh}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("toascii", Ftoascii, args, , "-*- texinfo -*-\n@deftypefn {Mapping Function} {} toascii (@var{s})\nReturn ASCII representation of @var{s} in a matrix.\n\nFor example:\n\n@example\n@group\ntoascii (\"ASCII\")\n     @result{} [ 65, 83, 67, 73, 73 ]\n@end group\n\n@end example\n@seealso{char}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("tolower", Ftolower, args, , "-*- texinfo -*-\n@deftypefn  {Mapping Function} {} tolower (@var{s})\n@deftypefnx {Mapping Function} {} lower (@var{s})\nReturn a copy of the string or cell string @var{s}, with each uppercase\ncharacter replaced by the corresponding lowercase one; non-alphabetic\ncharacters are left unchanged.\n\nFor example:\n\n@example\n@group\ntolower (\"MiXeD cAsE 123\")\n      @result{} \"mixed case 123\"\n@end group\n@end example\n@seealso{toupper}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(lower, tolower) ;
 XDEFUNX_INTERNAL ("toupper", Ftoupper, args, , "-*- texinfo -*-\n@deftypefn  {Mapping Function} {} toupper (@var{s})\n@deftypefnx {Mapping Function} {} upper (@var{s})\nReturn a copy of the string or cell string @var{s}, with each lowercase\ncharacter replaced by the corresponding uppercase one; non-alphabetic\ncharacters are left unchanged.\n\nFor example:\n\n@example\n@group\ntoupper (\"MiXeD cAsE 123\")\n      @result{} \"MIXED CASE 123\"\n@end group\n@end example\n@seealso{tolower}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(upper, toupper) ;
 XDEFALIAS_INTERNAL(gammaln, lgamma) ;
}

static void
install_matrix_type_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/matrix_type.cc")
 XDEFUN_INTERNAL (matrix_type, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{type} =} matrix_type (@var{A})\n@deftypefnx {Built-in Function} {@var{type} =} matrix_type (@var{A}, \"nocompute\")\n@deftypefnx {Built-in Function} {@var{A} =} matrix_type (@var{A}, @var{type})\n@deftypefnx {Built-in Function} {@var{A} =} matrix_type (@var{A}, \"upper\", @var{perm})\n@deftypefnx {Built-in Function} {@var{A} =} matrix_type (@var{A}, \"lower\", @var{perm})\n@deftypefnx {Built-in Function} {@var{A} =} matrix_type (@var{A}, \"banded\", @var{nl}, @var{nu})\nIdentify the matrix type or mark a matrix as a particular type.\n\nThis allows more rapid solutions of linear equations involving @var{A} to be\nperformed.\n\nCalled with a single argument, @code{matrix_type} returns the type of the\nmatrix and caches it for future use.\n\nCalled with more than one argument, @code{matrix_type} allows the type of\nthe matrix to be defined.\n\nIf the option @qcode{\"nocompute\"} is given, the function will not attempt\nto guess the type if it is still unknown.  This is useful for debugging\npurposes.\n\nThe possible matrix types depend on whether the matrix is full or sparse, and\ncan be one of the following\n\n@table @asis\n@item @qcode{\"unknown\"}\nRemove any previously cached matrix type, and mark type as unknown.\n\n@item @qcode{\"full\"}\nMark the matrix as full.\n\n@item @qcode{\"positive definite\"}\nProbable full positive definite matrix.\n\n@item @qcode{\"diagonal\"}\nDiagonal matrix.  (Sparse matrices only)\n\n@item @qcode{\"permuted diagonal\"}\nPermuted Diagonal matrix.  The permutation does not need to be specifically\nindicated, as the structure of the matrix explicitly gives this.  (Sparse\nmatrices only)\n\n@item @qcode{\"upper\"}\nUpper triangular.  If the optional third argument @var{perm} is given, the\nmatrix is assumed to be a permuted upper triangular with the permutations\ndefined by the vector @var{perm}.\n\n@item @qcode{\"lower\"}\nLower triangular.  If the optional third argument @var{perm} is given, the\nmatrix is assumed to be a permuted lower triangular with the permutations\ndefined by the vector @var{perm}.\n\n@item  @qcode{\"banded\"}\n@itemx @qcode{\"banded positive definite\"}\nBanded matrix with the band size of @var{nl} below the diagonal and @var{nu}\nabove it.  If @var{nl} and @var{nu} are 1, then the matrix is tridiagonal and\ntreated with specialized code.  In addition the matrix can be marked as\nprobably a positive definite.  (Sparse matrices only)\n\n@item @qcode{\"singular\"}\nThe matrix is assumed to be singular and will be treated with a minimum norm\nsolution.\n\n@end table\n\nNote that the matrix type will be discovered automatically on the first\nattempt to solve a linear equation involving @var{A}.  Therefore\n@code{matrix_type} is only useful to give Octave hints of the matrix type.\nIncorrectly defining the matrix type will result in incorrect results from\nsolutions of linear equations; it is entirely @strong{the responsibility of\nthe user} to correctly identify the matrix type.\n\nAlso, the test for positive definiteness is a low-cost test for a Hermitian\nmatrix with a real positive diagonal.  This does not guarantee that the\nmatrix is positive definite, but only that it is a probable candidate.  When\nsuch a matrix is factorized, a Cholesky@tie{}factorization is first\nattempted, and if that fails the matrix is then treated with an\nLU@tie{}factorization.  Once the matrix has been factorized,\n@code{matrix_type} will return the correct classification of the matrix.\n@end deftypefn") 
}

static void
install_max_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/max.cc")
 XDEFUN_INTERNAL (min, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} min (@var{x})\n@deftypefnx {Built-in Function} {} min (@var{x}, [], @var{dim})\n@deftypefnx {Built-in Function} {[@var{w}, @var{iw}] =} min (@var{x})\n@deftypefnx {Built-in Function} {} min (@var{x}, @var{y})\nFind minimum values in the array @var{x}.\n\nFor a vector argument, return the minimum value.  For a matrix argument,\nreturn a row vector with the minimum value of each column.  For a\nmulti-dimensional array, @code{min} operates along the first non-singleton\ndimension.\n\nIf the optional third argument @var{dim} is present then operate along\nthis dimension.  In this case the second argument is ignored and should be\nset to the empty matrix.\n\nFor two matrices (or a matrix and a scalar), return the pairwise minimum.\n\nThus,\n\n@example\nmin (min (@var{x}))\n@end example\n\n@noindent\nreturns the smallest element of the 2-D matrix @var{x}, and\n\n@example\n@group\nmin (2:5, pi)\n    @result{}  2.0000  3.0000  3.1416  3.1416\n@end group\n@end example\n\n@noindent\ncompares each element of the range @code{2:5} with @code{pi}, and returns a\nrow vector of the minimum values.\n\nFor complex arguments, the magnitude of the elements are used for\ncomparison.  If the magnitudes are identical, then the results are ordered\nby phase angle in the range (-pi, pi].  Hence,\n\n@example\n@group\nmin ([-1 i 1 -i])\n    @result{} -i\n@end group\n@end example\n\n@noindent\nbecause all entries have magnitude 1, but -i has the smallest phase angle\nwith value -pi/2.\n\nIf called with one input and two output arguments, @code{min} also returns\nthe first index of the minimum value(s).  Thus,\n\n@example\n@group\n[x, ix] = min ([1, 3, 0, 2, 0])\n    @result{}  x = 0\n        ix = 3\n@end group\n@end example\n@seealso{max, cummin, cummax}\n@end deftypefn") 
 XDEFUN_INTERNAL (max, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} max (@var{x})\n@deftypefnx {Built-in Function} {} max (@var{x}, [], @var{dim})\n@deftypefnx {Built-in Function} {[@var{w}, @var{iw}] =} max (@var{x})\n@deftypefnx {Built-in Function} {} max (@var{x}, @var{y})\nFind maximum values in the array @var{x}.\n\nFor a vector argument, return the maximum value.  For a matrix argument,\nreturn a row vector with the maximum value of each column.  For a\nmulti-dimensional array, @code{max} operates along the first non-singleton\ndimension.\n\nIf the optional third argument @var{dim} is present then operate along\nthis dimension.  In this case the second argument is ignored and should be\nset to the empty matrix.\n\nFor two matrices (or a matrix and a scalar), return the pairwise maximum.\n\nThus,\n\n@example\nmax (max (@var{x}))\n@end example\n\n@noindent\nreturns the largest element of the 2-D matrix @var{x}, and\n\n@example\n@group\nmax (2:5, pi)\n    @result{}  3.1416  3.1416  4.0000  5.0000\n@end group\n@end example\n\n@noindent\ncompares each element of the range @code{2:5} with @code{pi}, and returns a\nrow vector of the maximum values.\n\nFor complex arguments, the magnitude of the elements are used for\ncomparison.  If the magnitudes are identical, then the results are ordered\nby phase angle in the range (-pi, pi].  Hence,\n\n@example\n@group\nmax ([-1 i 1 -i])\n    @result{} -1\n@end group\n@end example\n\n@noindent\nbecause all entries have magnitude 1, but -1 has the largest phase angle\nwith value pi.\n\nIf called with one input and two output arguments, @code{max} also returns\nthe first index of the maximum value(s).  Thus,\n\n@example\n@group\n[x, ix] = max ([1, 3, 5, 2, 5])\n    @result{}  x = 5\n        ix = 3\n@end group\n@end example\n@seealso{min, cummax, cummin}\n@end deftypefn") 
 XDEFUN_INTERNAL (cummin, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cummin (@var{x})\n@deftypefnx {Built-in Function} {} cummin (@var{x}, @var{dim})\n@deftypefnx {Built-in Function} {[@var{w}, @var{iw}] =} cummin (@var{x})\nReturn the cumulative minimum values along dimension @var{dim}.\n\nIf @var{dim} is unspecified it defaults to column-wise operation.  For\nexample:\n\n@example\n@group\ncummin ([5 4 6 2 3 1])\n   @result{}  5  4  4  2  2  1\n@end group\n@end example\n\nIf called with two output arguments the index of the minimum value is also\nreturned.\n\n@example\n@group\n[w, iw] = cummin ([5 4 6 2 3 1])\n@result{}\nw =  5  4  4  2  2  1\niw = 1  2  2  4  4  6\n@end group\n@end example\n\n@seealso{cummax, min, max}\n@end deftypefn") 
 XDEFUN_INTERNAL (cummax, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} cummax (@var{x})\n@deftypefnx {Built-in Function} {} cummax (@var{x}, @var{dim})\n@deftypefnx {Built-in Function} {[@var{w}, @var{iw}] =} cummax (@dots{})\nReturn the cumulative maximum values along dimension @var{dim}.\n\nIf @var{dim} is unspecified it defaults to column-wise operation.  For\nexample:\n\n@example\n@group\ncummax ([1 3 2 6 4 5])\n   @result{}  1  3  3  6  6  6\n@end group\n@end example\n\nIf called with two output arguments the index of the maximum value is also\nreturned.\n\n@example\n@group\n[w, iw] = cummax ([1 3 2 6 4 5])\n@result{}\nw =  1  3  3  6  6  6\niw = 1  2  2  4  4  4\n@end group\n@end example\n\n@seealso{cummin, max, min}\n@end deftypefn") 
}

static void
install_md5sum_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/md5sum.cc")
 XDEFUN_INTERNAL (md5sum, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} md5sum (@var{file})\n@deftypefnx {Built-in Function} {} md5sum (@var{str}, @var{opt})\nCalculate the MD5 sum of the file @var{file}.\n\nIf the second parameter @var{opt} exists and is true, then calculate the MD5\nsum of the string @var{str}.\n@end deftypefn") 
}

static void
install_mgorth_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/mgorth.cc")
 XDEFUN_INTERNAL (mgorth, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{y}, @var{h}] =} mgorth (@var{x}, @var{v})\nOrthogonalize a given column vector @var{x} with respect to a set of\northonormal vectors comprising the columns of @var{v} using the modified\nGram-Schmidt method.\n\nOn exit, @var{y} is a unit vector such that:\n\n@example\n@group\n  norm (@var{y}) = 1\n  @var{v}' * @var{y} = 0\n  @var{x} = [@var{v}, @var{y}]*@var{h}'\n@end group\n@end example\n\n@end deftypefn") 
}

static void
install_nproc_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/nproc.cc")
 XDEFUN_INTERNAL (nproc, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} nproc ()\n@deftypefnx {Built-in Function} {} nproc (@var{query})\nReturn the current number of available processors.\n\nIf called with the optional argument @var{query}, modify how processors\nare counted as follows:\n\n@table @code\n@item all\ntotal number of processors.\n\n@item current\nprocessors available to the current process.\n\n@item overridable\nsame as @code{current}, but overridable through the @w{@env{OMP_NUM_THREADS}}\nenvironment variable.\n@end table\n@end deftypefn") 
}

static void
install_oct_hist_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/oct-hist.cc")
 XDEFUN_INTERNAL (edit_history, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} edit_history\n@deftypefnx {Command} {} edit_history @var{cmd_number}\n@deftypefnx {Command} {} edit_history @var{first} @var{last}\nEdit the history list using the editor named by the variable @env{EDITOR}.\n\nThe commands to be edited are first copied to a temporary file.  When you\nexit the editor, Octave executes the commands that remain in the file.  It\nis often more convenient to use @code{edit_history} to define functions\nrather than attempting to enter them directly on the command line.\nThe block of commands is executed as soon as you exit the editor.\nTo avoid executing any commands, simply delete all the lines from the buffer\nbefore leaving the editor.\n\nWhen invoked with no arguments, edit the previously executed command;\nWith one argument, edit the specified command @var{cmd_number};\nWith two arguments, edit the list of commands between @var{first} and\n@var{last}.  Command number specifiers may also be negative where -1\nrefers to the most recently executed command.\nThe following are equivalent and edit the most recently executed command.\n\n@example\n@group\nedit_history\nedit_history -1\n@end group\n@end example\n\nWhen using ranges, specifying a larger number for the first command than the\nlast command reverses the list of commands before they are placed in the\nbuffer to be edited.\n@seealso{run_history, history}\n@end deftypefn") 
 XDEFUN_INTERNAL (history, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} history\n@deftypefnx {Command} {} history @var{opt1} @dots{}\n@deftypefnx {Built-in Function} {@var{h} =} history ()\n@deftypefnx {Built-in Function} {@var{h} =} history (@var{opt1}, @dots{})\nIf invoked with no arguments, @code{history} displays a list of commands\nthat you have executed.\n\nValid options are:\n\n@table @code\n@item   @var{n}\n@itemx -@var{n}\nDisplay only the most recent @var{n} lines of history.\n\n@item -c\nClear the history list.\n\n@item -q\nDon't number the displayed lines of history.  This is useful for cutting\nand pasting commands using the X Window System.\n\n@item -r @var{file}\nRead the file @var{file}, appending its contents to the current\nhistory list.  If the name is omitted, use the default history file\n(normally @file{~/.octave_hist}).\n\n@item -w @var{file}\nWrite the current history to the file @var{file}.  If the name is\nomitted, use the default history file (normally @file{~/.octave_hist}).\n@end table\n\nFor example, to display the five most recent commands that you have\ntyped without displaying line numbers, use the command\n@kbd{history -q 5}.\n\nIf invoked with a single output argument, the history will be saved to that\nargument as a cell string and will not be output to screen.\n@seealso{edit_history, run_history}\n@end deftypefn") 
 XDEFUN_INTERNAL (run_history, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} run_history\n@deftypefnx {Command} {} run_history @var{cmd_number}\n@deftypefnx {Command} {} run_history @var{first} @var{last}\nRun commands from the history list.\n\nWhen invoked with no arguments, run the previously executed command;\n\nWith one argument, run the specified command @var{cmd_number};\n\nWith two arguments, run the list of commands between @var{first} and\n@var{last}.  Command number specifiers may also be negative where -1\nrefers to the most recently executed command.  For example, the command\n\n@example\n@group\nrun_history\n     OR\nrun_history -1\n@end group\n@end example\n\n@noindent\nexecutes the most recent command again.\nThe command\n\n@example\nrun_history 13 169\n@end example\n\n@noindent\nexecutes commands 13 through 169.\n\nSpecifying a larger number for the first command than the last command\nreverses the list of commands before executing them.\nFor example:\n\n@example\n@group\ndisp (1)\ndisp (2)\nrun_history -1 -2\n@result{}\n 2\n 1\n@end group\n@end example\n\n@seealso{edit_history, history}\n@end deftypefn") 
 XDEFUN_INTERNAL (history_control, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} history_control ()\n@deftypefnx {Built-in Function} {@var{old_val} =} history_control (@var{new_val})\nQuery or set the internal variable that specifies how commands are saved\nto the history list.\n\nThe default value is an empty character string, but may be overridden by the\nenvironment variable @w{@env{OCTAVE_HISTCONTROL}}.\n\nThe value of @code{history_control} is a colon-separated list of values\ncontrolling how commands are saved on the history list.  If the list\nof values includes @code{ignorespace}, lines which begin with a space\ncharacter are not saved in the history list.  A value of @code{ignoredups}\ncauses lines matching the previous history entry to not be saved.\nA value of @code{ignoreboth} is shorthand for @code{ignorespace} and\n@code{ignoredups}.  A value of @code{erasedups} causes all previous lines\nmatching the current line to be removed from the history list before that\nline is saved.  Any value not in the above list is ignored.  If\n@code{history_control} is the empty string, all commands are saved on\nthe history list, subject to the value of @code{history_save}.\n@seealso{history_file, history_size, history_timestamp_format_string, history_save}\n@end deftypefn") 
 XDEFUN_INTERNAL (history_size, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} history_size ()\n@deftypefnx {Built-in Function} {@var{old_val} =} history_size (@var{new_val})\nQuery or set the internal variable that specifies how many entries\nto store in the history file.\n\nThe default value is @code{1000}, but may be overridden by the environment\nvariable @w{@env{OCTAVE_HISTSIZE}}.\n@seealso{history_file, history_timestamp_format_string, history_save}\n@end deftypefn") 
 XDEFUN_INTERNAL (history_file, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} history_file ()\n@deftypefnx {Built-in Function} {@var{old_val} =} history_file (@var{new_val})\nQuery or set the internal variable that specifies the name of the\nfile used to store command history.\n\nThe default value is @file{~/.octave_hist}, but may be overridden by the\nenvironment variable @w{@env{OCTAVE_HISTFILE}}.\n@seealso{history_size, history_save, history_timestamp_format_string}\n@end deftypefn") 
 XDEFUN_INTERNAL (history_timestamp_format_string, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} history_timestamp_format_string ()\n@deftypefnx {Built-in Function} {@var{old_val} =} history_timestamp_format_string (@var{new_val})\n@deftypefnx {Built-in Function} {} history_timestamp_format_string (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the format string\nfor the comment line that is written to the history file when Octave\nexits.\n\nThe format string is passed to @code{strftime}.  The default value is\n\n@example\n\"# Octave VERSION, %a %b %d %H:%M:%S %Y %Z <USER@@HOST>\"\n@end example\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{strftime, history_file, history_size, history_save}\n@end deftypefn") 
 XDEFUN_INTERNAL (history_save, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} history_save ()\n@deftypefnx {Built-in Function} {@var{old_val} =} history_save (@var{new_val})\n@deftypefnx {Built-in Function} {} history_save (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether commands entered\non the command line are saved in the history file.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{history_control, history_file, history_size, history_timestamp_format_string}\n@end deftypefn") 
}

static void
install_octave_link_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/octave-link.cc")
 XDEFUN_INTERNAL (__octave_link_enabled__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_enabled__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_edit_file__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_edit_file__ (@var{file})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_message_dialog__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_message_dialog__ (@var{dlg}, @var{msg}, @var{title})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_question_dialog__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_question_dialog__ (@var{msg}, @var{title}, @var{btn1}, @var{btn2}, @var{btn3}, @var{default})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_file_dialog__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_file_dialog__ (@var{filterlist}, @var{title}, @var{filename}, @var{size} @var{multiselect}, @var{pathname})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_list_dialog__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_list_dialog__ (@var{list}, @var{mode}, @var{size}, @var{intial}, @var{name}, @var{prompt}, @var{ok_string}, @var{cancel_string})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_input_dialog__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_input_dialog__ (@var{prompt}, @var{title}, @var{rowscols}, @var{defaults})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_show_preferences__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_show_preferences__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__octave_link_show_doc__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __octave_link_show_doc__ (@var{filename})\nUndocumented internal function.\n@end deftypefn") 
}

static void
install_ordschur_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/ordschur.cc")
 XDEFUN_INTERNAL (ordschur, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {[@var{UR}, @var{SR}] =} ordschur (@var{U}, @var{S}, @var{select})\nReorders the real Schur factorization (@var{U},@var{S}) obtained with the\n@code{schur} function, so that selected eigenvalues appear in the upper left\ndiagonal blocks of the quasi triangular Schur matrix.\n\nThe logical vector @var{select} specifies the selected eigenvalues as they\nappear along @var{S}'s diagonal.\n\nFor example, given the matrix @code{@var{A} = [1, 2; 3, 4]}, and its Schur\ndecomposition\n\n@example\n[@var{U}, @var{S}] = schur (@var{A})\n@end example\n\n@noindent\nwhich returns\n\n@example\n@group\n@var{U} =\n\n  -0.82456  -0.56577\n   0.56577  -0.82456\n\n@var{S} =\n\n  -0.37228  -1.00000\n   0.00000   5.37228\n\n@end group\n@end example\n\nIt is possible to reorder the decomposition so that the positive eigenvalue\nis in the upper left corner, by doing:\n\n@example\n[@var{U}, @var{S}] = ordschur (@var{U}, @var{S}, [0,1])\n@end example\n\n@seealso{schur}\n@end deftypefn") 
}

static void
install_pager_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/pager.cc")
 XDEFUN_INTERNAL (diary, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} diary\n@deftypefnx {Command} {} diary on\n@deftypefnx {Command} {} diary off\n@deftypefnx {Command} {} diary @var{filename}\nRecord a list of all commands @emph{and} the output they produce, mixed\ntogether just as they appear on the terminal.\n\nValid options are:\n\n@table @asis\n@item on\nStart recording a session in a file called @file{diary} in the\ncurrent working directory.\n\n@item off\nStop recording the session in the diary file.\n\n@item @var{filename}\nRecord the session in the file named @var{filename}.\n@end table\n\nWith no arguments, @code{diary} toggles the current diary state.\n@seealso{history}\n@end deftypefn") 
 XDEFUN_INTERNAL (__diaryfile__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{fname} =} __diaryfile__ ()\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__diarystate__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{state} =} __diarystate__ ()\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (more, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} more\n@deftypefnx {Command} {} more on\n@deftypefnx {Command} {} more off\nTurn output pagination on or off.\n\nWithout an argument, @code{more} toggles the current state.\n\nThe current state can be determined via @code{page_screen_output}.\n@seealso{page_screen_output, page_output_immediately, PAGER, PAGER_FLAGS}\n@end deftypefn") 
 XDEFUN_INTERNAL (terminal_size, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} terminal_size ()\nReturn a two-element row vector containing the current size of the terminal\nwindow in characters (rows and columns).\n@seealso{list_in_columns}\n@end deftypefn") 
 XDEFUN_INTERNAL (page_output_immediately, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} page_output_immediately ()\n@deftypefnx {Built-in Function} {@var{old_val} =} page_output_immediately (@var{new_val})\n@deftypefnx {Built-in Function} {} page_output_immediately (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave sends\noutput to the pager as soon as it is available.\n\nOtherwise, Octave buffers its output and waits until just before the prompt\nis printed to flush it to the pager.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{page_screen_output, more, PAGER, PAGER_FLAGS}\n@end deftypefn") 
 XDEFUN_INTERNAL (page_screen_output, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} page_screen_output ()\n@deftypefnx {Built-in Function} {@var{old_val} =} page_screen_output (@var{new_val})\n@deftypefnx {Built-in Function} {} page_screen_output (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether output intended\nfor the terminal window that is longer than one page is sent through a\npager.\n\nThis allows you to view one screenful at a time.  Some pagers\n(such as @code{less}---see @ref{Installation}) are also capable of moving\nbackward on the output.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{more, page_output_immediately, PAGER, PAGER_FLAGS}\n@end deftypefn") 
 XDEFUN_INTERNAL (PAGER, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} PAGER ()\n@deftypefnx {Built-in Function} {@var{old_val} =} PAGER (@var{new_val})\n@deftypefnx {Built-in Function} {} PAGER (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the program to use\nto display terminal output on your system.\n\nThe default value is normally @qcode{\"less\"}, @qcode{\"more\"}, or\n@qcode{\"pg\"}, depending on what programs are installed on your system.\n@xref{Installation}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{PAGER_FLAGS, page_output_immediately, more, page_screen_output}\n@end deftypefn") 
 XDEFUN_INTERNAL (PAGER_FLAGS, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} PAGER_FLAGS ()\n@deftypefnx {Built-in Function} {@var{old_val} =} PAGER_FLAGS (@var{new_val})\n@deftypefnx {Built-in Function} {} PAGER_FLAGS (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the options to pass\nto the pager.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{PAGER, more, page_screen_output, page_output_immediately}\n@end deftypefn") 
}

static void
install_pinv_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/pinv.cc")
 XDEFUN_INTERNAL (pinv, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} pinv (@var{x})\n@deftypefnx {Built-in Function} {} pinv (@var{x}, @var{tol})\nReturn the pseudoinverse of @var{x}.\n\nSingular values less than @var{tol} are ignored.\n\nIf the second argument is omitted, it is taken to be\n\n@example\ntol = max (size (@var{x})) * sigma_max (@var{x}) * eps,\n@end example\n\n@noindent\nwhere @code{sigma_max (@var{x})} is the maximal singular value of @var{x}.\n@end deftypefn") 
}

static void
install_pr_output_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/pr-output.cc")
 XDEFUN_INTERNAL (rats, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} rats (@var{x}, @var{len})\nConvert @var{x} into a rational approximation represented as a string.\n\nThe string can be converted back into a matrix as follows:\n\n@example\n@group\nr = rats (hilb (4));\nx = str2num (r)\n@end group\n@end example\n\nThe optional second argument defines the maximum length of the string\nrepresenting the elements of @var{x}.  By default @var{len} is 9.\n\nIf the length of the smallest possible rational approximation exceeds\n@var{len}, an asterisk (*) padded with spaces will be returned instead.\n@seealso{format, rat}\n@end deftypefn") 
 XDEFUN_INTERNAL (disp, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} disp (@var{x})\nDisplay the value of @var{x}.\n\nFor example:\n\n@example\n@group\ndisp (\"The value of pi is:\"), disp (pi)\n\n     @print{} the value of pi is:\n     @print{} 3.1416\n@end group\n@end example\n\n@noindent\nNote that the output from @code{disp} always ends with a newline.\n\nIf an output value is requested, @code{disp} prints nothing and returns the\nformatted output in a string.\n@seealso{fdisp}\n@end deftypefn") 
 XDEFUN_INTERNAL (fdisp, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} fdisp (@var{fid}, @var{x})\nDisplay the value of @var{x} on the stream @var{fid}.\n\nFor example:\n\n@example\n@group\nfdisp (stdout, \"The value of pi is:\"), fdisp (stdout, pi)\n\n     @print{} the value of pi is:\n     @print{} 3.1416\n@end group\n@end example\n\n@noindent\nNote that the output from @code{fdisp} always ends with a newline.\n@seealso{disp}\n@end deftypefn") 
 XDEFUN_INTERNAL (format, args, , "-*- texinfo -*-\n@deftypefn  {Command} {} format\n@deftypefnx {Command} {} format options\nReset or specify the format of the output produced by @code{disp} and\nOctave's normal echoing mechanism.\n\nThis command only affects the display of numbers but not how they are stored\nor computed.  To change the internal representation from the default double\nuse one of the conversion functions such as @code{single}, @code{uint8},\n@code{int64}, etc.\n\nBy default, Octave displays 5 significant digits in a human readable form\n(option @samp{short} paired with @samp{loose} format for matrices).\nIf @code{format} is invoked without any options, this default format\nis restored.\n\nValid formats for floating point numbers are listed in the following\ntable.\n\n@table @code\n@item short\nFixed point format with 5 significant figures in a field that is a maximum\nof 10 characters wide.  (default).\n\nIf Octave is unable to format a matrix so that columns line up on the\ndecimal point and all numbers fit within the maximum field width then\nit switches to an exponential @samp{e} format.\n\n@item long\nFixed point format with 15 significant figures in a field that is a maximum\nof 20 characters wide.\n\nAs with the @samp{short} format, Octave will switch to an exponential\n@samp{e} format if it is unable to format a matrix properly using the\ncurrent format.\n\n@item  short e\n@itemx long e\nExponential format.  The number to be represented is split between a mantissa\nand an exponent (power of 10).  The mantissa has 5 significant digits in the\nshort format and 15 digits in the long format.\nFor example, with the @samp{short e} format, @code{pi} is displayed as\n@code{3.1416e+00}.\n\n@item  short E\n@itemx long E\nIdentical to @samp{short e} or @samp{long e} but displays an uppercase\n@samp{E} to indicate the exponent.\nFor example, with the @samp{long E} format, @code{pi} is displayed as\n@code{3.14159265358979E+00}.\n\n@item  short g\n@itemx long g\nOptimally choose between fixed point and exponential format based on\nthe magnitude of the number.\nFor example, with the @samp{short g} format,\n@code{pi .^ [2; 4; 8; 16; 32]} is displayed as\n\n@example\n@group\nans =\n\n      9.8696\n      97.409\n      9488.5\n  9.0032e+07\n  8.1058e+15\n@end group\n@end example\n\n@item  short eng\n@itemx long eng\nIdentical to @samp{short e} or @samp{long e} but displays the value\nusing an engineering format, where the exponent is divisible by 3. For\nexample, with the @samp{short eng} format, @code{10 * pi} is displayed as\n@code{31.4159e+00}.\n\n@item  long G\n@itemx short G\nIdentical to @samp{short g} or @samp{long g} but displays an uppercase\n@samp{E} to indicate the exponent.\n\n@item  free\n@itemx none\nPrint output in free format, without trying to line up columns of\nmatrices on the decimal point.  This also causes complex numbers to be\nformatted as numeric pairs like this @samp{(0.60419, 0.60709)} instead\nof like this @samp{0.60419 + 0.60709i}.\n@end table\n\nThe following formats affect all numeric output (floating point and\ninteger types).\n\n@table @code\n@item  \"+\"\n@itemx \"+\" @var{chars}\n@itemx plus\n@itemx plus @var{chars}\nPrint a @samp{+} symbol for matrix elements greater than zero, a\n@samp{-} symbol for elements less than zero and a space for zero matrix\nelements.  This format can be very useful for examining the structure\nof a large sparse matrix.\n\nThe optional argument @var{chars} specifies a list of 3 characters to use\nfor printing values greater than zero, less than zero and equal to zero.\nFor example, with the @samp{\"+\" \"+-.\"} format,\n@code{[1, 0, -1; -1, 0, 1]} is displayed as\n\n@example\n@group\nans =\n\n+.-\n-.+\n@end group\n@end example\n\n@item bank\nPrint in a fixed format with two digits to the right of the decimal\npoint.\n\n@item native-hex\nPrint the hexadecimal representation of numbers as they are stored in\nmemory.  For example, on a workstation which stores 8 byte real values\nin IEEE format with the least significant byte first, the value of\n@code{pi} when printed in @code{native-hex} format is\n@code{400921fb54442d18}.\n\n@item hex\nThe same as @code{native-hex}, but always print the most significant\nbyte first.\n\n@item native-bit\nPrint the bit representation of numbers as stored in memory.\nFor example, the value of @code{pi} is\n\n@example\n@group\n01000000000010010010000111111011\n01010100010001000010110100011000\n@end group\n@end example\n\n(shown here in two 32 bit sections for typesetting purposes) when\nprinted in native-bit format on a workstation which stores 8 byte real values\nin IEEE format with the least significant byte first.\n\n@item bit\nThe same as @code{native-bit}, but always print the most significant\nbits first.\n\n@item rat\nPrint a rational approximation, i.e., values are approximated\nas the ratio of small integers.\nFor example, with the @samp{rat} format,\n@code{pi} is displayed as @code{355/113}.\n@end table\n\nThe following two options affect the display of all matrices.\n\n@table @code\n@item compact\nRemove blank lines around column number labels and between\nmatrices producing more compact output with more data per page.\n\n@item loose\nInsert blank lines above and below column number labels and between matrices\nto produce a more readable output with less data per page.  (default).\n@end table\n@seealso{fixed_point_format, output_max_field_width, output_precision, split_long_rows, print_empty_dimensions, rats}\n@end deftypefn") 
 XDEFUN_INTERNAL (__compactformat__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} __compactformat__ ()\n@deftypefnx {Built-in Function} {} __compactformat__ (@var{TRUE|FALSE})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__formatstring__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{val} =} __formatstring__ ()\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (fixed_point_format, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} fixed_point_format ()\n@deftypefnx {Built-in Function} {@var{old_val} =} fixed_point_format (@var{new_val})\n@deftypefnx {Built-in Function} {} fixed_point_format (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will\nuse a scaled format to print matrix values.\n\nThe scaled format prints a scaling factor on the first line of output chosen\nsuch that the largest matrix element can be written with a single leading\ndigit.  For example:\n\n@example\n@group\nlogspace (1, 7, 5)'\nans =\n\n  1.0e+07  *\n\n  0.00000\n  0.00003\n  0.00100\n  0.03162\n  1.00000\n@end group\n@end example\n\n@noindent\nNotice that the first value appears to be 0 when it is actually 1.  Because\nof the possibility for confusion you should be careful about enabling\n@code{fixed_point_format}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{format, output_max_field_width, output_precision}\n@end deftypefn") 
 XDEFUN_INTERNAL (print_empty_dimensions, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} print_empty_dimensions ()\n@deftypefnx {Built-in Function} {@var{old_val} =} print_empty_dimensions (@var{new_val})\n@deftypefnx {Built-in Function} {} print_empty_dimensions (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether the dimensions of\nempty matrices are printed along with the empty matrix symbol, @samp{[]}.\n\nFor example, the expression\n\n@example\nzeros (3, 0)\n@end example\n\n@noindent\nwill print\n\n@example\nans = [](3x0)\n@end example\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{format}\n@end deftypefn") 
 XDEFUN_INTERNAL (split_long_rows, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} split_long_rows ()\n@deftypefnx {Built-in Function} {@var{old_val} =} split_long_rows (@var{new_val})\n@deftypefnx {Built-in Function} {} split_long_rows (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether rows of a matrix\nmay be split when displayed to a terminal window.\n\nIf the rows are split, Octave will display the matrix in a series of smaller\npieces, each of which can fit within the limits of your terminal width and\neach set of rows is labeled so that you can easily see which columns are\ncurrently being displayed.  For example:\n\n@example\n@group\noctave:13> rand (2,10)\nans =\n\n Columns 1 through 6:\n\n  0.75883  0.93290  0.40064  0.43818  0.94958  0.16467\n  0.75697  0.51942  0.40031  0.61784  0.92309  0.40201\n\n Columns 7 through 10:\n\n  0.90174  0.11854  0.72313  0.73326\n  0.44672  0.94303  0.56564  0.82150\n@end group\n@end example\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{format}\n@end deftypefn") 
 XDEFUN_INTERNAL (output_max_field_width, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} output_max_field_width ()\n@deftypefnx {Built-in Function} {@var{old_val} =} output_max_field_width (@var{new_val})\n@deftypefnx {Built-in Function} {} output_max_field_width (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the maximum width\nof a numeric output field.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{format, fixed_point_format, output_precision}\n@end deftypefn") 
 XDEFUN_INTERNAL (output_precision, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} output_precision ()\n@deftypefnx {Built-in Function} {@var{old_val} =} output_precision (@var{new_val})\n@deftypefnx {Built-in Function} {} output_precision (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the minimum number of\nsignificant figures to display for numeric output.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{format, fixed_point_format, output_max_field_width}\n@end deftypefn") 
}

static void
install_profiler_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/profiler.cc")
 XDEFUN_INTERNAL (__profiler_enable__, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} __profiler_enable__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__profiler_reset__, args, , "-*- texinfo -*-\n@deftypefn {Function File} {} __profiler_reset__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__profiler_data__, args, nargout, "-*- texinfo -*-\n@deftypefn {Function File} {} __profiler_data__ ()\nUndocumented internal function.\n@end deftypefn") 
}

static void
install_quad_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/quad.cc")
 XDEFUN_INTERNAL (quad_options, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} quad_options ()\n@deftypefnx {Built-in Function} {val =} quad_options (@var{opt})\n@deftypefnx {Built-in Function} {} quad_options (@var{opt}, @var{val})\nQuery or set options for the function @code{quad}.\n\nWhen called with no arguments, the names of all available options and\ntheir current values are displayed.\n\nGiven one argument, return the value of the option @var{opt}.\n\nWhen called with two arguments, @code{quad_options} sets the option\n@var{opt} to value @var{val}.\n\nOptions include\n\n@table @code\n@item @qcode{\"absolute tolerance\"}\nAbsolute tolerance; may be zero for pure relative error test.\n\n@item @qcode{\"relative tolerance\"}\nNon-negative relative tolerance.  If the absolute tolerance is zero,\nthe relative tolerance must be greater than or equal to\n@w{@code{max (50*eps, 0.5e-28)}}.\n\n@item @qcode{\"single precision absolute tolerance\"}\nAbsolute tolerance for single precision; may be zero for pure relative\nerror test.\n\n@item @qcode{\"single precision relative tolerance\"}\nNon-negative relative tolerance for single precision.  If the absolute\ntolerance is zero, the relative tolerance must be greater than or equal to\n@w{@code{max (50*eps, 0.5e-28)}}.\n@end table\n@end deftypefn") 
 XDEFUN_INTERNAL (quad, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{q} =} quad (@var{f}, @var{a}, @var{b})\n@deftypefnx {Built-in Function} {@var{q} =} quad (@var{f}, @var{a}, @var{b}, @var{tol})\n@deftypefnx {Built-in Function} {@var{q} =} quad (@var{f}, @var{a}, @var{b}, @var{tol}, @var{sing})\n@deftypefnx {Built-in Function} {[@var{q}, @var{ier}, @var{nfun}, @var{err}] =} quad (@dots{})\nNumerically evaluate the integral of @var{f} from @var{a} to @var{b} using\nFortran routines from @w{@sc{quadpack}}.\n\n@var{f} is a function handle, inline function, or a string containing the\nname of the function to evaluate.  The function must have the form @code{y =\nf (x)} where @var{y} and @var{x} are scalars.\n\n@var{a} and @var{b} are the lower and upper limits of integration.  Either\nor both may be infinite.\n\nThe optional argument @var{tol} is a vector that specifies the desired\naccuracy of the result.  The first element of the vector is the desired\nabsolute tolerance, and the second element is the desired relative\ntolerance.  To choose a relative test only, set the absolute\ntolerance to zero.  To choose an absolute test only, set the relative\ntolerance to zero.  Both tolerances default to @code{sqrt (eps)} or\napproximately @math{1.5e^{-8}}.\n\nThe optional argument @var{sing} is a vector of values at which the\nintegrand is known to be singular.\n\nThe result of the integration is returned in @var{q}.\n\n@var{ier} contains an integer error code (0 indicates a successful\nintegration).\n\n@var{nfun} indicates the number of function evaluations that were\nmade.\n\n@var{err} contains an estimate of the error in the solution.\n\nThe function @code{quad_options} can set other optional parameters for\n@code{quad}.\n\nNote: because @code{quad} is written in Fortran it cannot be called\nrecursively.  This prevents its use in integrating over more than one\nvariable by routines @code{dblquad} and @code{triplequad}.\n@seealso{quad_options, quadv, quadl, quadgk, quadcc, trapz, dblquad, triplequad}\n@end deftypefn") 
}

static void
install_quadcc_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/quadcc.cc")
 XDEFUN_INTERNAL (quadcc, args, nargout, "-*- texinfo -*-\n@deftypefn  {Function File} {@var{q} =} quadcc (@var{f}, @var{a}, @var{b})\n@deftypefnx {Function File} {@var{q} =} quadcc (@var{f}, @var{a}, @var{b}, @var{tol})\n@deftypefnx {Function File} {@var{q} =} quadcc (@var{f}, @var{a}, @var{b}, @var{tol}, @var{sing})\n@deftypefnx {Function File} {[@var{q}, @var{err}, @var{nr_points}] =} quadcc (@dots{})\nNumerically evaluate the integral of @var{f} from @var{a} to @var{b}\nusing doubly-adaptive @nospell{Clenshaw-Curtis} quadrature.\n\n@var{f} is a function handle, inline function, or string containing the name\nof the function to evaluate.  The function @var{f} must be vectorized and\nmust return a vector of output values if given a vector of input values.\nFor example,\n\n@example\nf = @@(x) x .* sin (1./x) .* sqrt (abs (1 - x));\n@end example\n\n@noindent\nwhich uses the element-by-element ``dot'' form for all operators.\n\n@var{a} and @var{b} are the lower and upper limits of integration.  Either\nor both limits may be infinite.  @code{quadcc} handles an inifinite limit\nby substituting the variable of integration with @code{x = tan (pi/2*u)}.\n\nThe optional argument @var{tol} defines the relative tolerance used to stop\nthe integration procedure.  The default value is @math{1e^{-6}}.\n\nThe optional argument @var{sing} contains a list of points where the\nintegrand has known singularities, or discontinuities\nin any of its derivatives, inside the integration interval.\nFor the example above, which has a discontinuity at x=1, the call to\n@code{quadcc} would be as follows\n\n@example\nint = quadcc (f, a, b, 1.0e-6, [ 1 ]);\n@end example\n\nThe result of the integration is returned in @var{q}.\n\n@var{err} is an estimate of the absolute integration error.\n\n@var{nr_points} is the number of points at which the integrand was evaluated.\n\nIf the adaptive integration did not converge, the value of @var{err} will be\nlarger than the requested tolerance.  Therefore, it is recommended to verify\nthis value for difficult integrands.\n\n@code{quadcc} is capable of dealing with non-numeric values of the integrand\nsuch as @code{NaN} or @code{Inf}.  If the integral diverges, and\n@code{quadcc} detects this, then a warning is issued and @code{Inf} or\n@code{-Inf} is returned.\n\nNote: @code{quadcc} is a general purpose quadrature algorithm and, as such,\nmay be less efficient for a smooth or otherwise well-behaved integrand than\nother methods such as @code{quadgk}.\n\nThe algorithm uses @nospell{Clenshaw-Curtis} quadrature rules of increasing\ndegree in each interval and bisects the interval if either the function does\nnot appear to be smooth or a rule of maximum degree has been reached.  The\nerror estimate is computed from the L2-norm of the difference between two\nsuccessive interpolations of the integrand over the nodes of the respective\nquadrature rules.\n\nReference: @nospell{P. Gonnet}, @cite{Increasing the Reliability of Adaptive\nQuadrature Using Explicit Interpolants}, ACM Transactions on\nMathematical Software, Vol. 37, Issue 3, Article No. 3, 2010.\n@seealso{quad, quadv, quadl, quadgk, trapz, dblquad, triplequad}\n@end deftypefn") 
}

static void
install_qz_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/qz.cc")
 XDEFUN_INTERNAL (qz, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{lambda} =} qz (@var{A}, @var{B})\n@deftypefnx {Built-in Function} {@var{lambda} =} qz (@var{A}, @var{B}, @var{opt})\nQZ@tie{}decomposition of the generalized eigenvalue problem\n(@math{A x = s B x}).\n\nThere are three ways to call this function:\n@enumerate\n@item @code{@var{lambda} = qz (@var{A}, @var{B})}\n\nComputes the generalized eigenvalues\n@tex\n$\\lambda$\n@end tex\n@ifnottex\n@var{lambda}\n@end ifnottex\nof @math{(A - s B)}.\n\n@item @code{[AA, BB, Q, Z, V, W, @var{lambda}] = qz (@var{A}, @var{B})}\n\nComputes QZ@tie{}decomposition, generalized eigenvectors, and generalized\neigenvalues of @math{(A - s B)}\n@tex\n$$ AV = BV{ \\rm diag }(\\lambda) $$\n$$ W^T A = { \\rm diag }(\\lambda)W^T B $$\n$$ AA = Q^T AZ, BB = Q^T BZ $$\n@end tex\n@ifnottex\n\n@example\n@group\n\nA * V = B * V * diag (@var{lambda})\nW' * A = diag (@var{lambda}) * W' * B\nAA = Q * A * Z, BB = Q * B * Z\n\n@end group\n@end example\n\n@end ifnottex\nwith @var{Q} and @var{Z} orthogonal (unitary)= @var{I}\n\n@item @code{[AA,BB,Z@{, @var{lambda}@}] = qz (@var{A}, @var{B}, @var{opt})}\n\nAs in form [2], but allows ordering of generalized eigenpairs for, e.g.,\nsolution of discrete time algebraic Riccati equations.  Form 3 is not\navailable for complex matrices, and does not compute the generalized\neigenvectors @var{V}, @var{W}, nor the orthogonal matrix @var{Q}.\n\n@table @var\n@item opt\nfor ordering eigenvalues of the @nospell{GEP} pencil.  The leading block of\nthe revised pencil contains all eigenvalues that satisfy:\n\n@table @asis\n@item @qcode{\"N\"}\n= unordered (default)\n\n@item @qcode{\"S\"}\n= small: leading block has all |lambda| @leq{} 1\n\n@item @qcode{\"B\"}\n= big: leading block has all |lambda| @geq{} 1\n\n@item @qcode{\"-\"}\n= negative real part: leading block has all eigenvalues\nin the open left half-plane\n\n@item @qcode{\"+\"}\n= non-negative real part: leading block has all eigenvalues\nin the closed right half-plane\n@end table\n@end table\n@end enumerate\n\nNote: @code{qz} performs permutation balancing, but not scaling\n(@pxref{XREFbalance}).  The order of output arguments was selected for\ncompatibility with @sc{matlab}.\n@seealso{eig, balance, lu, chol, hess, qr, qzhess, schur, svd}\n@end deftypefn") 
}

static void
install_rand_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/rand.cc")
 XDEFUN_INTERNAL (rand, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} rand (@var{n})\n@deftypefnx {Built-in Function} {} rand (@var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} rand ([@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {@var{v} =} rand (\"state\")\n@deftypefnx {Built-in Function} {} rand (\"state\", @var{v})\n@deftypefnx {Built-in Function} {} rand (\"state\", \"reset\")\n@deftypefnx {Built-in Function} {@var{v} =} rand (\"seed\")\n@deftypefnx {Built-in Function} {} rand (\"seed\", @var{v})\n@deftypefnx {Built-in Function} {} rand (\"seed\", \"reset\")\n@deftypefnx {Built-in Function} {} rand (@dots{}, \"single\")\n@deftypefnx {Built-in Function} {} rand (@dots{}, \"double\")\nReturn a matrix with random elements uniformly distributed on the\ninterval (0, 1).\n\nThe arguments are handled the same as the arguments for @code{eye}.\n\nYou can query the state of the random number generator using the form\n\n@example\nv = rand (\"state\")\n@end example\n\nThis returns a column vector @var{v} of length 625.  Later, you can restore\nthe random number generator to the state @var{v} using the form\n\n@example\nrand (\"state\", v)\n@end example\n\n@noindent\nYou may also initialize the state vector from an arbitrary vector of length\n@leq{} 625 for @var{v}.  This new state will be a hash based on the value of\n@var{v}, not @var{v} itself.\n\nBy default, the generator is initialized from @code{/dev/urandom} if it is\navailable, otherwise from CPU time, wall clock time, and the current\nfraction of a second.  Note that this differs from @sc{matlab}, which\nalways initializes the state to the same state at startup.  To obtain\nbehavior comparable to @sc{matlab}, initialize with a deterministic state\nvector in Octave's startup files (@pxref{Startup Files}).\n\nTo compute the pseudo-random sequence, @code{rand} uses the Mersenne\nTwister with a period of @math{2^{19937}-1}\n(See @nospell{M. Matsumoto and T. Nishimura},\n@cite{Mersenne Twister: A 623-dimensionally equidistributed uniform\npseudorandom number generator},\nACM Trans. on Modeling and Computer Simulation Vol. 8, No. 1, pp. 3--30,\nJanuary 1998,\n@url{http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html}).\nDo @strong{not} use for cryptography without securely hashing several\nreturned values together, otherwise the generator state can be learned after\nreading 624 consecutive values.\n\nOlder versions of Octave used a different random number generator.\nThe new generator is used by default as it is significantly faster than the\nold generator, and produces random numbers with a significantly longer cycle\ntime.  However, in some circumstances it might be desirable to obtain the\nsame random sequences as produced by the old generators.  To do this the\nkeyword @qcode{\"seed\"} is used to specify that the old generators should\nbe used, as in\n\n@example\nrand (\"seed\", val)\n@end example\n\n@noindent\nwhich sets the seed of the generator to @var{val}.  The seed of the\ngenerator can be queried with\n\n@example\ns = rand (\"seed\")\n@end example\n\nHowever, it should be noted that querying the seed will not cause\n@code{rand} to use the old generators, only setting the seed will.  To cause\n@code{rand} to once again use the new generators, the keyword\n@qcode{\"state\"} should be used to reset the state of the @code{rand}.\n\nThe state or seed of the generator can be reset to a new random value using\nthe @qcode{\"reset\"} keyword.\n\nThe class of the value returned can be controlled by a trailing\n@qcode{\"double\"} or @qcode{\"single\"} argument.  These are the only valid\nclasses.\n@seealso{randn, rande, randg, randp}\n@end deftypefn") 
 XDEFUN_INTERNAL (randn, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} randn (@var{n})\n@deftypefnx {Built-in Function} {} randn (@var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} randn ([@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {@var{v} =} randn (\"state\")\n@deftypefnx {Built-in Function} {} randn (\"state\", @var{v})\n@deftypefnx {Built-in Function} {} randn (\"state\", \"reset\")\n@deftypefnx {Built-in Function} {@var{v} =} randn (\"seed\")\n@deftypefnx {Built-in Function} {} randn (\"seed\", @var{v})\n@deftypefnx {Built-in Function} {} randn (\"seed\", \"reset\")\n@deftypefnx {Built-in Function} {} randn (@dots{}, \"single\")\n@deftypefnx {Built-in Function} {} randn (@dots{}, \"double\")\nReturn a matrix with normally distributed random elements having zero mean\nand variance one.\n\nThe arguments are handled the same as the arguments for @code{rand}.\n\nBy default, @code{randn} uses the @nospell{Marsaglia and Tsang}\n``Ziggurat technique'' to transform from a uniform to a normal distribution.\n\nThe class of the value returned can be controlled by a trailing\n@qcode{\"double\"} or @qcode{\"single\"} argument.  These are the only valid\nclasses.\n\nReference: @nospell{G. Marsaglia and W.W. Tsang},\n@cite{Ziggurat Method for Generating Random Variables},\nJ. Statistical Software, vol 5, 2000,\n@url{http://www.jstatsoft.org/v05/i08/}\n\n@seealso{rand, rande, randg, randp}\n@end deftypefn") 
 XDEFUN_INTERNAL (rande, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} rande (@var{n})\n@deftypefnx {Built-in Function} {} rande (@var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} rande ([@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {@var{v} =} rande (\"state\")\n@deftypefnx {Built-in Function} {} rande (\"state\", @var{v})\n@deftypefnx {Built-in Function} {} rande (\"state\", \"reset\")\n@deftypefnx {Built-in Function} {@var{v} =} rande (\"seed\")\n@deftypefnx {Built-in Function} {} rande (\"seed\", @var{v})\n@deftypefnx {Built-in Function} {} rande (\"seed\", \"reset\")\n@deftypefnx {Built-in Function} {} rande (@dots{}, \"single\")\n@deftypefnx {Built-in Function} {} rande (@dots{}, \"double\")\nReturn a matrix with exponentially distributed random elements.\n\nThe arguments are handled the same as the arguments for @code{rand}.\n\nBy default, @code{randn} uses the @nospell{Marsaglia and Tsang}\n``Ziggurat technique'' to transform from a uniform to a normal distribution.\n\nThe class of the value returned can be controlled by a trailing\n@qcode{\"double\"} or @qcode{\"single\"} argument.  These are the only valid\nclasses.\n\nReference: @nospell{G. Marsaglia and W.W. Tsang},\n@cite{Ziggurat Method for Generating Random Variables},\nJ. Statistical Software, vol 5, 2000,\n@url{http://www.jstatsoft.org/v05/i08/}\n\n@seealso{rand, randn, randg, randp}\n@end deftypefn") 
 XDEFUN_INTERNAL (randg, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} randg (@var{n})\n@deftypefnx {Built-in Function} {} randg (@var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} randg ([@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {@var{v} =} randg (\"state\")\n@deftypefnx {Built-in Function} {} randg (\"state\", @var{v})\n@deftypefnx {Built-in Function} {} randg (\"state\", \"reset\")\n@deftypefnx {Built-in Function} {@var{v} =} randg (\"seed\")\n@deftypefnx {Built-in Function} {} randg (\"seed\", @var{v})\n@deftypefnx {Built-in Function} {} randg (\"seed\", \"reset\")\n@deftypefnx {Built-in Function} {} randg (@dots{}, \"single\")\n@deftypefnx {Built-in Function} {} randg (@dots{}, \"double\")\nReturn a matrix with @code{gamma (@var{a},1)} distributed random elements.\n\nThe arguments are handled the same as the arguments for @code{rand}, except\nfor the argument @var{a}.\n\nThis can be used to generate many distributions:\n\n@table @asis\n@item @code{gamma (a, b)} for @code{a > -1}, @code{b > 0}\n\n@example\nr = b * randg (a)\n@end example\n\n@item @code{beta (a, b)} for @code{a > -1}, @code{b > -1}\n\n@example\n@group\nr1 = randg (a, 1)\nr = r1 / (r1 + randg (b, 1))\n@end group\n@end example\n\n@item @code{Erlang (a, n)}\n\n@example\nr = a * randg (n)\n@end example\n\n@item @code{chisq (df)} for @code{df > 0}\n\n@example\nr = 2 * randg (df / 2)\n@end example\n\n@item @code{t (df)} for @code{0 < df < inf} (use randn if df is infinite)\n\n@example\nr = randn () / sqrt (2 * randg (df / 2) / df)\n@end example\n\n@item @code{F (n1, n2)} for @code{0 < n1}, @code{0 < n2}\n\n@example\n@group\n## r1 equals 1 if n1 is infinite\nr1 = 2 * randg (n1 / 2) / n1\n## r2 equals 1 if n2 is infinite\nr2 = 2 * randg (n2 / 2) / n2\nr = r1 / r2\n\n@end group\n@end example\n\n@item negative @code{binomial (n, p)} for @code{n > 0}, @code{0 < p <= 1}\n\n@example\nr = randp ((1 - p) / p * randg (n))\n@end example\n\n@item non-central @code{chisq (df, L)}, for @code{df >= 0} and @code{L > 0}\n(use chisq if @code{L = 0})\n\n@example\n@group\nr = randp (L / 2)\nr(r > 0) = 2 * randg (r(r > 0))\nr(df > 0) += 2 * randg (df(df > 0)/2)\n@end group\n@end example\n\n@item @code{Dirichlet (a1, @dots{} ak)}\n\n@example\n@group\nr = (randg (a1), @dots{}, randg (ak))\nr = r / sum (r)\n@end group\n@end example\n\n@end table\n\nThe class of the value returned can be controlled by a trailing\n@qcode{\"double\"} or @qcode{\"single\"} argument.  These are the only valid\nclasses.\n@seealso{rand, randn, rande, randp}\n@end deftypefn") 
 XDEFUN_INTERNAL (randp, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} randp (@var{l}, @var{n})\n@deftypefnx {Built-in Function} {} randp (@var{l}, @var{m}, @var{n}, @dots{})\n@deftypefnx {Built-in Function} {} randp (@var{l}, [@var{m} @var{n} @dots{}])\n@deftypefnx {Built-in Function} {@var{v} =} randp (\"state\")\n@deftypefnx {Built-in Function} {} randp (\"state\", @var{v})\n@deftypefnx {Built-in Function} {} randp (\"state\", \"reset\")\n@deftypefnx {Built-in Function} {@var{v} =} randp (\"seed\")\n@deftypefnx {Built-in Function} {} randp (\"seed\", @var{v})\n@deftypefnx {Built-in Function} {} randp (\"seed\", \"reset\")\n@deftypefnx {Built-in Function} {} randp (@dots{}, \"single\")\n@deftypefnx {Built-in Function} {} randp (@dots{}, \"double\")\nReturn a matrix with Poisson distributed random elements with mean value\nparameter given by the first argument, @var{l}.\n\nThe arguments are handled the same as the arguments for @code{rand}, except\nfor the argument @var{l}.\n\nFive different algorithms are used depending on the range of @var{l} and\nwhether or not @var{l} is a scalar or a matrix.\n\n@table @asis\n@item For scalar @var{l} @leq{} 12, use direct method.\nW.H. Press, et al., @cite{Numerical Recipes in C},\nCambridge University Press, 1992.\n\n@item For scalar @var{l} > 12, use rejection method.[1]\nW.H. Press, et al., @cite{Numerical Recipes in C},\nCambridge University Press, 1992.\n\n@item For matrix @var{l} @leq{} 10, use inversion method.[2]\n@nospell{E. Stadlober, et al., WinRand source code}, available via FTP.\n\n@item For matrix @var{l} > 10, use patchwork rejection method.\n@nospell{E. Stadlober, et al., WinRand source code}, available via FTP, or\n@nospell{H. Zechner}, @cite{Efficient sampling from continuous and discrete\nunimodal distributions}, Doctoral Dissertation, 156pp., Technical\nUniversity @nospell{Graz}, Austria, 1994.\n\n@item For @var{l} > 1e8, use normal approximation.\n@nospell{L. Montanet}, et al., @cite{Review of Particle Properties},\nPhysical Review D 50 p1284, 1994.\n@end table\n\nThe class of the value returned can be controlled by a trailing\n@qcode{\"double\"} or @qcode{\"single\"} argument.  These are the only valid\nclasses.\n@seealso{rand, randn, rande, randg}\n@end deftypefn") 
 XDEFUN_INTERNAL (randperm, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} randperm (@var{n})\n@deftypefnx {Built-in Function} {} randperm (@var{n}, @var{m})\nReturn a row vector containing a random permutation of @code{1:@var{n}}.\n\nIf @var{m} is supplied, return @var{m} unique entries, sampled without\nreplacement from @code{1:@var{n}}.\n\nThe complexity is O(@var{n}) in memory and O(@var{m}) in time, unless\n@var{m} < @var{n}/5, in which case O(@var{m}) memory is used as well.  The\nrandomization is performed using rand().  All permutations are equally\nlikely.\n@seealso{perms}\n@end deftypefn") 
}

static void
install_rcond_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/rcond.cc")
 XDEFUN_INTERNAL (rcond, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{c} =} rcond (@var{A})\nCompute the 1-norm estimate of the reciprocal condition number as returned\nby @sc{lapack}.\n\nIf the matrix is well-conditioned then @var{c} will be near 1 and if the\nmatrix is poorly conditioned it will be close to 0.\n\nThe matrix @var{A} must not be sparse.  If the matrix is sparse then\n@code{condest (@var{A})} or @code{rcond (full (@var{A}))} should be used\ninstead.\n@seealso{cond, condest}\n@end deftypefn") 
}

static void
install_regexp_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/regexp.cc")
 XDEFUN_INTERNAL (regexp, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{s}, @var{e}, @var{te}, @var{m}, @var{t}, @var{nm}, @var{sp}] =} regexp (@var{str}, @var{pat})\n@deftypefnx {Built-in Function} {[@dots{}] =} regexp (@var{str}, @var{pat}, \"@var{opt1}\", @dots{})\nRegular expression string matching.\n\nSearch for @var{pat} in @var{str} and return the positions and substrings of\nany matches, or empty values if there are none.\n\nThe matched pattern @var{pat} can include any of the standard regex\noperators, including:\n\n@table @code\n@item .\nMatch any character\n\n@item * + ? @{@}\nRepetition operators, representing\n\n@table @code\n@item *\nMatch zero or more times\n\n@item +\nMatch one or more times\n\n@item ?\nMatch zero or one times\n\n@item @{@var{n}@}\nMatch exactly @var{n} times\n\n@item @{@var{n},@}\nMatch @var{n} or more times\n\n@item @{@var{m},@var{n}@}\nMatch between @var{m} and @var{n} times\n@end table\n\n@item [@dots{}] [^@dots{}]\n\nList operators.  The pattern will match any character listed between \"[\"\nand \"]\".  If the first character is \"^\" then the pattern is inverted and\nany character except those listed between brackets will match.\n\nEscape sequences defined below can also be used inside list operators.  For\nexample, a template for a floating point number might be @code{[-+.\\d]+}.\n\n@item () (?:)\nGrouping operator.  The first form, parentheses only, also creates a token.\n\n@item |\nAlternation operator.  Match one of a choice of regular expressions.  The\nalternatives must be delimited by the grouping operator @code{()} above.\n\n@item ^ $\nAnchoring operators.  Requires pattern to occur at the start (@code{^}) or\nend (@code{$}) of the string.\n@end table\n\nIn addition, the following escaped characters have special meaning.\n\n@table @code\n\n@item \\d\nMatch any digit\n\n@item \\D\nMatch any non-digit\n\n@item \\s\nMatch any whitespace character\n\n@item \\S\nMatch any non-whitespace character\n\n@item \\w\nMatch any word character\n\n@item \\W\nMatch any non-word character\n\n@item \\<\nMatch the beginning of a word\n\n@item \\>\nMatch the end of a word\n\n@item \\B\nMatch within a word\n@end table\n\nImplementation Note: For compatibility with @sc{matlab}, escape sequences\nin @var{pat} (e.g., @qcode{\"@xbackslashchar{}n\"} => newline) are expanded\neven when @var{pat} has been defined with single quotes.  To disable\nexpansion use a second backslash before the escape sequence (e.g.,\n\"@xbackslashchar{}@xbackslashchar{}n\") or use the @code{regexptranslate}\nfunction.\n\nThe outputs of @code{regexp} default to the order given below\n\n@table @var\n@item s\nThe start indices of each matching substring\n\n@item e\nThe end indices of each matching substring\n\n@item te\nThe extents of each matched token surrounded by @code{(@dots{})} in\n@var{pat}\n\n@item m\nA cell array of the text of each match\n\n@item t\nA cell array of the text of each token matched\n\n@item nm\nA structure containing the text of each matched named token, with the name\nbeing used as the fieldname.  A named token is denoted by\n@code{(?<name>@dots{})}.\n\n@item sp\nA cell array of the text not returned by match, i.e., what remains if you\nsplit the string based on @var{pat}.\n@end table\n\nParticular output arguments, or the order of the output arguments, can be\nselected by additional @var{opt} arguments.  These are strings and the\ncorrespondence between the output arguments and the optional argument\nare\n\n@multitable @columnfractions 0.2 0.3 0.3 0.2\n@item @tab @qcode{'start'}        @tab @var{s}  @tab\n@item @tab @qcode{'end'}          @tab @var{e}  @tab\n@item @tab @qcode{'tokenExtents'} @tab @var{te} @tab\n@item @tab @qcode{'match'}        @tab @var{m}  @tab\n@item @tab @qcode{'tokens'}       @tab @var{t}  @tab\n@item @tab @qcode{'names'}        @tab @var{nm} @tab\n@item @tab @qcode{'split'}        @tab @var{sp} @tab\n@end multitable\n\nAdditional arguments are summarized below.\n\n@table @samp\n@item once\nReturn only the first occurrence of the pattern.\n\n@item matchcase\nMake the matching case sensitive.  (default)\n\nAlternatively, use (?-i) in the pattern.\n\n@item ignorecase\nIgnore case when matching the pattern to the string.\n\nAlternatively, use (?i) in the pattern.\n\n@item stringanchors\nMatch the anchor characters at the beginning and end of the string.\n(default)\n\nAlternatively, use (?-m) in the pattern.\n\n@item lineanchors\nMatch the anchor characters at the beginning and end of the line.\n\nAlternatively, use (?m) in the pattern.\n\n@item dotall\nThe pattern @code{.} matches all characters including the newline character.\n (default)\n\nAlternatively, use (?s) in the pattern.\n\n@item dotexceptnewline\nThe pattern @code{.} matches all characters except the newline character.\n\nAlternatively, use (?-s) in the pattern.\n\n@item literalspacing\nAll characters in the pattern, including whitespace, are significant and are\nused in pattern matching.  (default)\n\nAlternatively, use (?-x) in the pattern.\n\n@item freespacing\nThe pattern may include arbitrary whitespace and also comments beginning with\nthe character @samp{#}.\n\nAlternatively, use (?x) in the pattern.\n\n@item noemptymatch\nZero-length matches are not returned.  (default)\n\n@item emptymatch\nReturn zero-length matches.\n\n@code{regexp ('a', 'b*', 'emptymatch')} returns @code{[1 2]} because there\nare zero or more @qcode{'b'} characters at positions 1 and end-of-string.\n\n@end table\n@seealso{regexpi, strfind, regexprep}\n@end deftypefn") 
 XDEFUN_INTERNAL (regexpi, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{s}, @var{e}, @var{te}, @var{m}, @var{t}, @var{nm}, @var{sp}] =} regexpi (@var{str}, @var{pat})\n@deftypefnx {Built-in Function} {[@dots{}] =} regexpi (@var{str}, @var{pat}, \"@var{opt1}\", @dots{})\n\nCase insensitive regular expression string matching.\n\nSearch for @var{pat} in @var{str} and return the positions and substrings of\nany matches, or empty values if there are none.  @xref{XREFregexp,,regexp},\nfor details on the syntax of the search pattern.\n@seealso{regexp}\n@end deftypefn") 
 XDEFUN_INTERNAL (regexprep, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{outstr} =} regexprep (@var{string}, @var{pat}, @var{repstr})\n@deftypefnx {Built-in Function} {@var{outstr} =} regexprep (@var{string}, @var{pat}, @var{repstr}, \"@var{opt1}\", @dots{})\nReplace occurrences of pattern @var{pat} in @var{string} with @var{repstr}.\n\nThe pattern is a regular expression as documented for @code{regexp}.\n@xref{XREFregexp,,regexp}.\n\nThe replacement string may contain @code{$i}, which substitutes for the ith\nset of parentheses in the match string.  For example,\n\n@example\nregexprep (\"Bill Dunn\", '(\\w+) (\\w+)', '$2, $1')\n@end example\n\n@noindent\nreturns \"Dunn, Bill\"\n\nOptions in addition to those of @code{regexp} are\n\n@table @samp\n\n@item once\nReplace only the first occurrence of @var{pat} in the result.\n\n@item warnings\nThis option is present for compatibility but is ignored.\n\n@end table\n\nImplementation Note: For compatibility with @sc{matlab}, escape sequences\nin @var{pat} (e.g., @qcode{\"@xbackslashchar{}n\"} => newline) are expanded\neven when @var{pat} has been defined with single quotes.  To disable\nexpansion use a second backslash before the escape sequence (e.g.,\n\"@xbackslashchar{}@xbackslashchar{}n\") or use the @code{regexptranslate}\nfunction.\n@seealso{regexp, regexpi, strrep}\n@end deftypefn") 
}

static void
install_schur_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/schur.cc")
 XDEFUN_INTERNAL (schur, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{S} =} schur (@var{A})\n@deftypefnx {Built-in Function} {@var{S} =} schur (@var{A}, \"real\")\n@deftypefnx {Built-in Function} {@var{S} =} schur (@var{A}, \"complex\")\n@deftypefnx {Built-in Function} {@var{S} =} schur (@var{A}, @var{opt})\n@deftypefnx {Built-in Function} {[@var{U}, @var{S}] =} schur (@dots{})\n@cindex Schur decomposition\nCompute the Schur@tie{}decomposition of @var{A}.\n\nThe Schur@tie{}decomposition is defined as\n@tex\n$$\n S = U^T A U\n$$\n@end tex\n@ifnottex\n\n@example\n@code{@var{S} = @var{U}' * @var{A} * @var{U}}\n@end example\n\n@end ifnottex\nwhere @var{U} is a unitary matrix\n@tex\n($U^T U$ is identity)\n@end tex\n@ifnottex\n(@code{@var{U}'* @var{U}} is identity)\n@end ifnottex\nand @var{S} is upper triangular.  The eigenvalues of @var{A} (and @var{S})\nare the diagonal elements of @var{S}.  If the matrix @var{A} is real, then\nthe real Schur@tie{}decomposition is computed, in which the matrix @var{U}\nis orthogonal and @var{S} is block upper triangular with blocks of size at\nmost\n@tex\n$2 \\times 2$\n@end tex\n@ifnottex\n@code{2 x 2}\n@end ifnottex\nalong the diagonal.  The diagonal elements of @var{S}\n(or the eigenvalues of the\n@tex\n$2 \\times 2$\n@end tex\n@ifnottex\n@code{2 x 2}\n@end ifnottex\nblocks, when appropriate) are the eigenvalues of @var{A} and @var{S}.\n\nThe default for real matrices is a real Schur@tie{}decomposition.\nA complex decomposition may be forced by passing the flag\n@qcode{\"complex\"}.\n\nThe eigenvalues are optionally ordered along the diagonal according to the\nvalue of @var{opt}.  @code{@var{opt} = \"a\"} indicates that all eigenvalues\nwith negative real parts should be moved to the leading block of @var{S}\n(used in @code{are}), @code{@var{opt} = \"d\"} indicates that all\neigenvalues with magnitude less than one should be moved to the leading\nblock of @var{S} (used in @code{dare}), and @code{@var{opt} = \"u\"}, the\ndefault, indicates that no ordering of eigenvalues should occur.  The\nleading @var{k} columns of @var{U} always span the @var{A}-invariant\nsubspace corresponding to the @var{k} leading eigenvalues of @var{S}.\n\nThe Schur@tie{}decomposition is used to compute eigenvalues of a square\nmatrix, and has applications in the solution of algebraic Riccati equations\nin control (see @code{are} and @code{dare}).\n@seealso{rsf2csf, ordschur, lu, chol, hess, qr, qz, svd}\n@end deftypefn") 
 XDEFUN_INTERNAL (rsf2csf, args, nargout, "-*- texinfo -*-\n@deftypefn {Function File} {[@var{U}, @var{T}] =} rsf2csf (@var{UR}, @var{TR})\nConvert a real, upper quasi-triangular Schur@tie{}form @var{TR} to a complex,\nupper triangular Schur@tie{}form @var{T}.\n\nNote that the following relations hold:\n\n@tex\n$UR \\cdot TR \\cdot {UR}^T = U T U^{\\dagger}$ and\n$U^{\\dagger} U$ is the identity matrix I.\n@end tex\n@ifnottex\n@tcode{@var{UR} * @var{TR} * @var{UR}' = @var{U} * @var{T} * @var{U}'} and\n@code{@var{U}' * @var{U}} is the identity matrix I.\n@end ifnottex\n\nNote also that @var{U} and @var{T} are not unique.\n@seealso{schur}\n@end deftypefn") 
}

static void
install_sighandlers_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/sighandlers.cc")
 XDEFUN_INTERNAL (SIG, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} SIG ()\nReturn a structure containing Unix signal names and their defined values.\n@end deftypefn") 
 XDEFUN_INTERNAL (debug_on_interrupt, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} debug_on_interrupt ()\n@deftypefnx {Built-in Function} {@var{old_val} =} debug_on_interrupt (@var{new_val})\n@deftypefnx {Built-in Function} {} debug_on_interrupt (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave will try\nto enter debugging mode when it receives an interrupt signal (typically\ngenerated with @kbd{C-c}).\n\nIf a second interrupt signal is received before reaching the debugging mode,\na normal interrupt will occur.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{debug_on_error, debug_on_warning}\n@end deftypefn") 
 XDEFUN_INTERNAL (sighup_dumps_octave_core, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} sighup_dumps_octave_core ()\n@deftypefnx {Built-in Function} {@var{old_val} =} sighup_dumps_octave_core (@var{new_val})\n@deftypefnx {Built-in Function} {} sighup_dumps_octave_core (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave tries\nto save all current variables to the file @file{octave-workspace} if it\nreceives a hangup signal.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
 XDEFUN_INTERNAL (sigterm_dumps_octave_core, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} sigterm_dumps_octave_core ()\n@deftypefnx {Built-in Function} {@var{old_val} =} sigterm_dumps_octave_core (@var{new_val})\n@deftypefnx {Built-in Function} {} sigterm_dumps_octave_core (@var{new_val}, \"local\")\nQuery or set the internal variable that controls whether Octave tries\nto save all current variables to the file @file{octave-workspace} if it\nreceives a terminate signal.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@end deftypefn") 
}

static void
install_sparse_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/sparse.cc")
 XDEFUN_INTERNAL (issparse, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} issparse (@var{x})\nReturn true if @var{x} is a sparse matrix.\n@seealso{ismatrix}\n@end deftypefn") 
 XDEFUN_INTERNAL (sparse, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{s} =} sparse (@var{a})\n@deftypefnx {Built-in Function} {@var{s} =} sparse (@var{i}, @var{j}, @var{sv}, @var{m}, @var{n})\n@deftypefnx {Built-in Function} {@var{s} =} sparse (@var{i}, @var{j}, @var{sv})\n@deftypefnx {Built-in Function} {@var{s} =} sparse (@var{m}, @var{n})\n@deftypefnx {Built-in Function} {@var{s} =} sparse (@var{i}, @var{j}, @var{s}, @var{m}, @var{n}, \"unique\")\n@deftypefnx {Built-in Function} {@var{s} =} sparse (@var{i}, @var{j}, @var{sv}, @var{m}, @var{n}, @var{nzmax})\nCreate a sparse matrix from a full matrix, or row, column, value triplets.\n\nIf @var{a} is a full matrix, convert it to a sparse matrix representation,\nremoving all zero values in the process.\n\nGiven the integer index vectors @var{i} and @var{j}, and a 1-by-@code{nnz}\nvector of real or complex values @var{sv}, construct the sparse matrix\n@code{S(@var{i}(@var{k}),@var{j}(@var{k})) = @var{sv}(@var{k})} with overall\ndimensions @var{m} and @var{n}.  If any of @var{sv}, @var{i} or @var{j} are\nscalars, they are expanded to have a common size.\n\nIf @var{m} or @var{n} are not specified their values are derived from the\nmaximum index in the vectors @var{i} and @var{j} as given by\n@code{@var{m} = max (@var{i})}, @code{@var{n} = max (@var{j})}.\n\n@strong{Note}: if multiple values are specified with the same @var{i},\n@var{j} indices, the corresponding value in @var{s} will be the sum of the\nvalues at the repeated location.  See @code{accumarray} for an example of how\nto produce different behavior, such as taking the minimum instead.\n\nIf the option @qcode{\"unique\"} is given, and more than one value is\nspecified at the same @var{i}, @var{j} indices, then the last specified\nvalue will be used.\n\n@code{sparse (@var{m}, @var{n})} will create an empty @var{m}x@var{n} sparse\nmatrix and is equivalent to @code{sparse ([], [], [], @var{m}, @var{n})}\n\nThe argument @code{nzmax} is ignored but accepted for compatibility with\n@sc{matlab}.\n\nExample 1 (sum at repeated indices):\n\n@example\n@group\n@var{i} = [1 1 2]; @var{j} = [1 1 2]; @var{sv} = [3 4 5];\nsparse (@var{i}, @var{j}, @var{sv}, 3, 4)\n@result{}\nCompressed Column Sparse (rows = 3, cols = 4, nnz = 2 [17%])\n\n  (1, 1) ->  7\n  (2, 2) ->  5\n@end group\n@end example\n\nExample 2 (\"unique\" option):\n\n@example\n@group\n@var{i} = [1 1 2]; @var{j} = [1 1 2]; @var{sv} = [3 4 5];\nsparse (@var{i}, @var{j}, @var{sv}, 3, 4, \"unique\")\n@result{}\nCompressed Column Sparse (rows = 3, cols = 4, nnz = 2 [17%])\n\n  (1, 1) ->  4\n  (2, 2) ->  5\n@end group\n@end example\n@seealso{full, accumarray, spalloc, spdiags, speye, spones, sprand, sprandn, sprandsym, spconvert, spfun}\n@end deftypefn") 
 XDEFUN_INTERNAL (spalloc, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{s} =} spalloc (@var{m}, @var{n}, @var{nz})\nCreate an @var{m}-by-@var{n} sparse matrix with pre-allocated space for at\nmost @var{nz} nonzero elements.\n\nThis is useful for building a matrix incrementally by a sequence of indexed\nassignments.  Subsequent indexed assignments after @code{spalloc} will reuse\nthe pre-allocated memory, provided they are of one of the simple forms\n\n@itemize\n@item @code{@var{s}(I:J) = @var{x}}\n\n@item @code{@var{s}(:,I:J) = @var{x}}\n\n@item @code{@var{s}(K:L,I:J) = @var{x}}\n@end itemize\n\n@b{and} that the following conditions are met:\n\n@itemize\n@item the assignment does not decrease nnz (@var{S}).\n\n@item after the assignment, nnz (@var{S}) does not exceed @var{nz}.\n\n@item no index is out of bounds.\n@end itemize\n\nPartial movement of data may still occur, but in general the assignment will\nbe more memory and time efficient under these circumstances.  In particular,\nit is possible to efficiently build a pre-allocated sparse matrix from a\ncontiguous block of columns.\n\nThe amount of pre-allocated memory for a given matrix may be queried using\nthe function @code{nzmax}.\n@seealso{nzmax, sparse}\n@end deftypefn") 
}

static void
install_spparms_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/spparms.cc")
 XDEFUN_INTERNAL (spparms, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} { } spparms ()\n@deftypefnx {Built-in Function} {@var{vals} =} spparms ()\n@deftypefnx {Built-in Function} {[@var{keys}, @var{vals}] =} spparms ()\n@deftypefnx {Built-in Function} {@var{val} =} spparms (@var{key})\n@deftypefnx {Built-in Function} { } spparms (@var{vals})\n@deftypefnx {Built-in Function} { } spparms (\"default\")\n@deftypefnx {Built-in Function} { } spparms (\"tight\")\n@deftypefnx {Built-in Function} { } spparms (@var{key}, @var{val})\nQuery or set the parameters used by the sparse solvers and factorization\nfunctions.\n\nThe first four calls above get information about the current settings, while\nthe others change the current settings.  The parameters are stored as pairs\nof keys and values, where the values are all floats and the keys are one of\nthe following strings:\n\n@table @samp\n@item spumoni\nPrinting level of debugging information of the solvers (default 0)\n\n@item ths_rel\nIncluded for compatibility.  Not used.  (default 1)\n\n@item ths_abs\nIncluded for compatibility.  Not used.  (default 1)\n\n@item exact_d\nIncluded for compatibility.  Not used.  (default 0)\n\n@item supernd\nIncluded for compatibility.  Not used.  (default 3)\n\n@item rreduce\nIncluded for compatibility.  Not used.  (default 3)\n\n@item wh_frac\nIncluded for compatibility.  Not used.  (default 0.5)\n\n@item autommd\nFlag whether the LU/QR and the '\\' and '/' operators will automatically\nuse the sparsity preserving mmd functions (default 1)\n\n@item autoamd\nFlag whether the LU and the '\\' and '/' operators will automatically\nuse the sparsity preserving amd functions (default 1)\n\n@item piv_tol\nThe pivot tolerance of the @sc{umfpack} solvers (default 0.1)\n\n@item sym_tol\nThe pivot tolerance of the @sc{umfpack} symmetric solvers (default 0.001)\n\n@item bandden\nThe density of nonzero elements in a banded matrix before it is treated\nby the @sc{lapack} banded solvers (default 0.5)\n\n@item umfpack\nFlag whether the @sc{umfpack} or mmd solvers are used for the LU, '\\' and\n'/' operations (default 1)\n@end table\n\nThe value of individual keys can be set with\n@code{spparms (@var{key}, @var{val})}.\nThe default values can be restored with the special keyword\n@qcode{\"default\"}.  The special keyword @qcode{\"tight\"} can be used to\nset the mmd solvers to attempt a sparser solution at the potential cost of\nlonger running time.\n@seealso{chol, colamd, lu, qr, symamd}\n@end deftypefn") 
}

static void
install_sqrtm_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/sqrtm.cc")
 XDEFUN_INTERNAL (sqrtm, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{s} =} sqrtm (@var{A})\n@deftypefnx {Built-in Function} {[@var{s}, @var{error_estimate}] =} sqrtm (@var{A})\nCompute the matrix square root of the square matrix @var{A}.\n\nRef: @nospell{N.J. Higham}.  @cite{A New sqrtm for @sc{matlab}}.  Numerical\nAnalysis Report No. 336, Manchester @nospell{Centre} for Computational\nMathematics, Manchester, England, January 1999.\n@seealso{expm, logm}\n@end deftypefn") 
}

static void
install_str2double_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/str2double.cc")
 XDEFUN_INTERNAL (str2double, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} str2double (@var{s})\nConvert a string to a real or complex number.\n\nThe string must be in one of the following formats where a and b are real\nnumbers and the complex unit is @qcode{'i'} or @qcode{'j'}:\n\n@itemize\n@item a + bi\n\n@item a + b*i\n\n@item a + i*b\n\n@item bi + a\n\n@item b*i + a\n\n@item i*b + a\n@end itemize\n\nIf present, a and/or b are of the form @nospell{[+-]d[,.]d[[eE][+-]d]} where\nthe brackets indicate optional arguments and @qcode{'d'} indicates zero or\nmore digits.  The special input values @code{Inf}, @code{NaN}, and @code{NA}\nare also accepted.\n\n@var{s} may be a character string, character matrix, or cell array.  For\ncharacter arrays the conversion is repeated for every row, and a double or\ncomplex array is returned.  Empty rows in @var{s} are deleted and not\nreturned in the numeric array.  For cell arrays each character string\nelement is processed and a double or complex array of the same dimensions as\n@var{s} is returned.\n\nFor unconvertible scalar or character string input @code{str2double} returns\na NaN@.  Similarly, for character array input @code{str2double} returns a\nNaN for any row of @var{s} that could not be converted.  For a cell array,\n@code{str2double} returns a NaN for any element of @var{s} for which\nconversion fails.  Note that numeric elements in a mixed string/numeric\ncell array are not strings and the conversion will fail for these elements\nand return NaN.\n\n@code{str2double} can replace @code{str2num}, and it avoids the security\nrisk of using @code{eval} on unknown data.\n@seealso{str2num}\n@end deftypefn") 
}

static void
install_strfind_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/strfind.cc")
 XDEFUN_INTERNAL (strfind, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{idx} =} strfind (@var{str}, @var{pattern})\n@deftypefnx {Built-in Function} {@var{idx} =} strfind (@var{cellstr}, @var{pattern})\n@deftypefnx {Built-in Function} {@var{idx} =} strfind (@dots{}, \"overlaps\", @var{val})\nSearch for @var{pattern} in the string @var{str} and return the starting\nindex of every such occurrence in the vector @var{idx}.\n\nIf there is no such occurrence, or if @var{pattern} is longer than\n@var{str}, or if @var{pattern} itself is empty, then @var{idx} is the empty\narray @code{[]}.\n\nThe optional argument @qcode{\"overlaps\"} determines whether the pattern\ncan match at every position in @var{str} (true), or only for unique\noccurrences of the complete pattern (false).  The default is true.\n\nIf a cell array of strings @var{cellstr} is specified then @var{idx} is a\ncell array of vectors, as specified above.\n\nExamples:\n\n@example\n@group\nstrfind (\"abababa\", \"aba\")\n     @result{} [1, 3, 5]\n\nstrfind (\"abababa\", \"aba\", \"overlaps\", false)\n     @result{} [1, 5]\n\nstrfind (@{\"abababa\", \"bebebe\", \"ab\"@}, \"aba\")\n     @result{}\n        @{\n          [1,1] =\n\n             1   3   5\n\n          [1,2] = [](1x0)\n          [1,3] = [](1x0)\n        @}\n@end group\n@end example\n@seealso{findstr, strmatch, regexp, regexpi, find}\n@end deftypefn") 
 XDEFUN_INTERNAL (strrep, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{newstr} =} strrep (@var{str}, @var{ptn}, @var{rep})\n@deftypefnx {Built-in Function} {@var{newstr} =} strrep (@var{cellstr}, @var{ptn}, @var{rep})\n@deftypefnx {Built-in Function} {@var{newstr} =} strrep (@dots{}, \"overlaps\", @var{val})\nReplace all occurrences of the pattern @var{ptn} in the string @var{str}\nwith the string @var{rep} and return the result.\n\nThe optional argument @qcode{\"overlaps\"} determines whether the pattern\ncan match at every position in @var{str} (true), or only for unique\noccurrences of the complete pattern (false).  The default is true.\n\n@var{s} may also be a cell array of strings, in which case the replacement is\ndone for each element and a cell array is returned.\n\nExample:\n\n@example\n@group\nstrrep (\"This is a test string\", \"is\", \"&%$\")\n    @result{}  \"Th&%$ &%$ a test string\"\n@end group\n@end example\n\n@seealso{regexprep, strfind, findstr}\n@end deftypefn") 
}

static void
install_strfns_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/strfns.cc")
 XDEFUN_INTERNAL (char, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} char (@var{x})\n@deftypefnx {Built-in Function} {} char (@var{x}, @dots{})\n@deftypefnx {Built-in Function} {} char (@var{s1}, @var{s2}, @dots{})\n@deftypefnx {Built-in Function} {} char (@var{cell_array})\nCreate a string array from one or more numeric matrices, character\nmatrices, or cell arrays.\n\nArguments are concatenated vertically.  The returned values are padded with\nblanks as needed to make each row of the string array have the same length.\nEmpty input strings are significant and will concatenated in the output.\n\nFor numerical input, each element is converted to the corresponding ASCII\ncharacter.  A range error results if an input is outside the ASCII range\n(0-255).\n\nFor cell arrays, each element is concatenated separately.  Cell arrays\nconverted through @code{char} can mostly be converted back with\n@code{cellstr}.  For example:\n\n@example\n@group\nchar ([97, 98, 99], \"\", @{\"98\", \"99\", 100@}, \"str1\", [\"ha\", \"lf\"])\n   @result{} [\"abc    \"\n       \"       \"\n       \"98     \"\n       \"99     \"\n       \"d      \"\n       \"str1   \"\n       \"half   \"]\n@end group\n@end example\n@seealso{strvcat, cellstr}\n@end deftypefn") 
 XDEFUN_INTERNAL (strvcat, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} strvcat (@var{x})\n@deftypefnx {Built-in Function} {} strvcat (@var{x}, @dots{})\n@deftypefnx {Built-in Function} {} strvcat (@var{s1}, @var{s2}, @dots{})\n@deftypefnx {Built-in Function} {} strvcat (@var{cell_array})\nCreate a character array from one or more numeric matrices, character\nmatrices, or cell arrays.\n\nArguments are concatenated vertically.  The returned values are padded with\nblanks as needed to make each row of the string array have the same length.\nUnlike @code{char}, empty strings are removed and will not appear in the\noutput.\n\nFor numerical input, each element is converted to the corresponding ASCII\ncharacter.  A range error results if an input is outside the ASCII range\n(0-255).\n\nFor cell arrays, each element is concatenated separately.  Cell arrays\nconverted through @code{strvcat} can mostly be converted back with\n@code{cellstr}.  For example:\n\n@example\n@group\nstrvcat ([97, 98, 99], \"\", @{\"98\", \"99\", 100@}, \"str1\", [\"ha\", \"lf\"])\n      @result{} [\"abc    \"\n          \"98     \"\n          \"99     \"\n          \"d      \"\n          \"str1   \"\n          \"half   \"]\n@end group\n@end example\n@seealso{char, strcat, cstrcat}\n@end deftypefn") 
 XDEFUN_INTERNAL (ischar, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} ischar (@var{x})\nReturn true if @var{x} is a character array.\n@seealso{isfloat, isinteger, islogical, isnumeric, iscellstr, isa}\n@end deftypefn") 
 XDEFUN_INTERNAL (strcmp, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} strcmp (@var{s1}, @var{s2})\nReturn 1 if the character strings @var{s1} and @var{s2} are the same,\nand 0 otherwise.\n\nIf either @var{s1} or @var{s2} is a cell array of strings, then an array\nof the same size is returned, containing the values described above for\nevery member of the cell array.  The other argument may also be a cell\narray of strings (of the same size or with only one element), char matrix\nor character string.\n\n@strong{Caution:} For compatibility with @sc{matlab}, Octave's strcmp\nfunction returns 1 if the character strings are equal, and 0 otherwise.\nThis is just the opposite of the corresponding C library function.\n@seealso{strcmpi, strncmp, strncmpi}\n@end deftypefn") 
 XDEFUN_INTERNAL (strncmp, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} strncmp (@var{s1}, @var{s2}, @var{n})\nReturn 1 if the first @var{n} characters of strings @var{s1} and @var{s2} are\nthe same, and 0 otherwise.\n\n@example\n@group\nstrncmp (\"abce\", \"abcd\", 3)\n      @result{} 1\n@end group\n@end example\n\nIf either @var{s1} or @var{s2} is a cell array of strings, then an array\nof the same size is returned, containing the values described above for\nevery member of the cell array.  The other argument may also be a cell\narray of strings (of the same size or with only one element), char matrix\nor character string.\n\n@example\n@group\nstrncmp (\"abce\", @{\"abcd\", \"bca\", \"abc\"@}, 3)\n     @result{} [1, 0, 1]\n@end group\n@end example\n\n@strong{Caution:} For compatibility with @sc{matlab}, Octave's strncmp\nfunction returns 1 if the character strings are equal, and 0 otherwise.\nThis is just the opposite of the corresponding C library function.\n@seealso{strncmpi, strcmp, strcmpi}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("strcmpi", Fstrcmpi, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} strcmpi (@var{s1}, @var{s2})\nReturn 1 if the character strings @var{s1} and @var{s2} are the same,\ndisregarding case of alphabetic characters, and 0 otherwise.\n\nIf either @var{s1} or @var{s2} is a cell array of strings, then an array\nof the same size is returned, containing the values described above for\nevery member of the cell array.  The other argument may also be a cell\narray of strings (of the same size or with only one element), char matrix\nor character string.\n\n@strong{Caution:} For compatibility with @sc{matlab}, Octave's strcmp\nfunction returns 1 if the character strings are equal, and 0 otherwise.\nThis is just the opposite of the corresponding C library function.\n\n@strong{Caution:} National alphabets are not supported.\n@seealso{strcmp, strncmp, strncmpi}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("strncmpi", Fstrncmpi, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} strncmpi (@var{s1}, @var{s2}, @var{n})\nReturn 1 if the first @var{n} character of @var{s1} and @var{s2} are the\nsame, disregarding case of alphabetic characters, and 0 otherwise.\n\nIf either @var{s1} or @var{s2} is a cell array of strings, then an array\nof the same size is returned, containing the values described above for\nevery member of the cell array.  The other argument may also be a cell\narray of strings (of the same size or with only one element), char matrix\nor character string.\n\n@strong{Caution:} For compatibility with @sc{matlab}, Octave's strncmpi\nfunction returns 1 if the character strings are equal, and 0 otherwise.\nThis is just the opposite of the corresponding C library function.\n\n@strong{Caution:} National alphabets are not supported.\n@seealso{strncmp, strcmp, strcmpi}\n@end deftypefn") 
 XDEFUN_INTERNAL (list_in_columns, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} list_in_columns (@var{arg}, @var{width}, @var{prefix})\nReturn a string containing the elements of @var{arg} listed in columns with\nan overall maximum width of @var{width} and optional prefix @var{prefix}.\n\nThe argument @var{arg} must be a cell array of character strings or a\ncharacter array.\n\nIf @var{width} is not specified or is an empty matrix, or less than or equal\nto zero, the width of the terminal screen is used.  Newline characters are\nused to break the lines in the output string.  For example:\n@c Set example in small font to prevent overfull line\n\n@smallexample\n@group\nlist_in_columns (@{\"abc\", \"def\", \"ghijkl\", \"mnop\", \"qrs\", \"tuv\"@}, 20)\n     @result{} abc     mnop\n        def     qrs\n        ghijkl  tuv\n\nwhos ans\n     @result{}\n     Variables in the current scope:\n\n       Attr Name        Size                     Bytes  Class\n       ==== ====        ====                     =====  =====\n            ans         1x37                        37  char\n\n     Total is 37 elements using 37 bytes\n@end group\n@end smallexample\n\n@seealso{terminal_size}\n@end deftypefn") 
}

static void
install_sub2ind_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/sub2ind.cc")
 XDEFUN_INTERNAL (sub2ind, args, , "-*- texinfo -*-\n@deftypefn  {Function File} {@var{ind} =} sub2ind (@var{dims}, @var{i}, @var{j})\n@deftypefnx {Function File} {@var{ind} =} sub2ind (@var{dims}, @var{s1}, @var{s2}, @dots{}, @var{sN})\nConvert subscripts to a linear index.\n\nThe following example shows how to convert the two-dimensional index\n@code{(2,3)} of a 3-by-3 matrix to a linear index.  The matrix is linearly\nindexed moving from one column to next, filling up all rows in each column.\n\n@example\n@group\nlinear_index = sub2ind ([3, 3], 2, 3)\n@result{} 8\n@end group\n@end example\n@seealso{ind2sub}\n@end deftypefn") 
 XDEFUN_INTERNAL (ind2sub, args, nargout, "-*- texinfo -*-\n@deftypefn {Function File} {[@var{s1}, @var{s2}, @dots{}, @var{sN}] =} ind2sub (@var{dims}, @var{ind})\nConvert a linear index to subscripts.\n\nThe following example shows how to convert the linear index @code{8}\nin a 3-by-3 matrix into a subscript.  The matrix is linearly indexed\nmoving from one column to next, filling up all rows in each column.\n\n@example\n@group\n[r, c] = ind2sub ([3, 3], 8)\n    @result{} r =  2\n    @result{} c =  3\n@end group\n@end example\n@seealso{sub2ind}\n@end deftypefn") 
}

static void
install_svd_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/svd.cc")
 XDEFUN_INTERNAL (svd, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{s} =} svd (@var{A})\n@deftypefnx {Built-in Function} {[@var{U}, @var{S}, @var{V}] =} svd (@var{A})\n@deftypefnx {Built-in Function} {[@var{U}, @var{S}, @var{V}] =} svd (@var{A}, @var{econ})\n@cindex singular value decomposition\nCompute the singular value decomposition of @var{A}\n@tex\n$$\n A = U S V^{\\dagger}\n$$\n@end tex\n@ifnottex\n\n@example\nA = U*S*V'\n@end example\n\n@end ifnottex\n\nThe function @code{svd} normally returns only the vector of singular values.\nWhen called with three return values, it computes\n@tex\n$U$, $S$, and $V$.\n@end tex\n@ifnottex\n@var{U}, @var{S}, and @var{V}.\n@end ifnottex\nFor example,\n\n@example\nsvd (hilb (3))\n@end example\n\n@noindent\nreturns\n\n@example\n@group\nans =\n\n  1.4083189\n  0.1223271\n  0.0026873\n@end group\n@end example\n\n@noindent\nand\n\n@example\n[u, s, v] = svd (hilb (3))\n@end example\n\n@noindent\nreturns\n\n@example\n@group\nu =\n\n  -0.82704   0.54745   0.12766\n  -0.45986  -0.52829  -0.71375\n  -0.32330  -0.64901   0.68867\n\ns =\n\n  1.40832  0.00000  0.00000\n  0.00000  0.12233  0.00000\n  0.00000  0.00000  0.00269\n\nv =\n\n  -0.82704   0.54745   0.12766\n  -0.45986  -0.52829  -0.71375\n  -0.32330  -0.64901   0.68867\n@end group\n@end example\n\nIf given a second argument, @code{svd} returns an economy-sized\ndecomposition, eliminating the unnecessary rows or columns of @var{U} or\n@var{V}.\n@seealso{svd_driver, svds, eig, lu, chol, hess, qr, qz}\n@end deftypefn") 
 XDEFUN_INTERNAL (svd_driver, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} svd_driver ()\n@deftypefnx {Built-in Function} {@var{old_val} =} svd_driver (@var{new_val})\n@deftypefnx {Built-in Function} {} svd_driver (@var{new_val}, \"local\")\nQuery or set the underlying @sc{lapack} driver used by @code{svd}.\n\nCurrently recognized values are @qcode{\"gesvd\"} and @qcode{\"gesdd\"}.\nThe default is @qcode{\"gesvd\"}.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{svd}\n@end deftypefn") 
}

static void
install_sylvester_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/sylvester.cc")
 XDEFUN_INTERNAL (sylvester, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{X} =} syl (@var{A}, @var{B}, @var{C})\nSolve the Sylvester equation\n@tex\n$$\n A X + X B = C\n$$\n@end tex\n@ifnottex\n\n@example\nA X + X B = C\n@end example\n\n@end ifnottex\nusing standard @sc{lapack} subroutines.\n\nFor example:\n\n@example\n@group\nsylvester ([1, 2; 3, 4], [5, 6; 7, 8], [9, 10; 11, 12])\n   @result{} [ 0.50000, 0.66667; 0.66667, 0.50000 ]\n@end group\n@end example\n@end deftypefn") 
}

static void
install_symtab_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/symtab.cc")
 XDEFUN_INTERNAL (ignore_function_time_stamp, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} ignore_function_time_stamp ()\n@deftypefnx {Built-in Function} {@var{old_val} =} ignore_function_time_stamp (@var{new_val})\nQuery or set the internal variable that controls whether Octave checks\nthe time stamp on files each time it looks up functions defined in\nfunction files.\n\nIf the internal variable is set to @qcode{\"system\"}, Octave will not\nautomatically recompile function files in subdirectories of\n@file{@var{octave-home}/lib/@var{version}} if they have changed since they were last compiled, but will recompile other function files in the search path if they change.\n\nIf set to @qcode{\"all\"}, Octave will not recompile any function files\nunless their definitions are removed with @code{clear}.\n\nIf set to @qcode{\"none\"}, Octave will always check time stamps on files to\ndetermine whether functions defined in function files need to recompiled.\n@end deftypefn") 
 XDEFUN_INTERNAL (__current_scope__, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{scope}, @var{context}]} __dump_symtab_info__ ()\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (__dump_symtab_info__, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} __dump_symtab_info__ ()\n@deftypefnx {Built-in Function} {} __dump_symtab_info__ (@var{scope})\n@deftypefnx {Built-in Function} {} __dump_symtab_info__ (\"scopes\")\n@deftypefnx {Built-in Function} {} __dump_symtab_info__ (\"functions\")\nUndocumented internal function.\n@end deftypefn") 
}

static void
install_syscalls_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/syscalls.cc")
 XDEFUNX_INTERNAL ("dup2", Fdup2, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{fid}, @var{msg}] =} dup2 (@var{old}, @var{new})\nDuplicate a file descriptor.\n\nIf successful, @var{fid} is greater than zero and contains the new file ID@.\nOtherwise, @var{fid} is negative and @var{msg} contains a system-dependent\nerror message.\n@seealso{fopen, fclose, fcntl}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("exec", Fexec, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{err}, @var{msg}] =} exec (@var{file}, @var{args})\nReplace current process with a new process.\n\nCalling @code{exec} without first calling @code{fork} will terminate your\ncurrent Octave process and replace it with the program named by @var{file}.\nFor example,\n\n@example\nexec (\"ls\" \"-l\")\n@end example\n\n@noindent\nwill run @code{ls} and return you to your shell prompt.\n\nIf successful, @code{exec} does not return.  If @code{exec} does return,\n@var{err} will be nonzero, and @var{msg} will contain a system-dependent\nerror message.\n@end deftypefn") 
 XDEFUNX_INTERNAL ("popen2", Fpopen2, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{in}, @var{out}, @var{pid}] =} popen2 (@var{command}, @var{args})\nStart a subprocess with two-way communication.\n\nThe name of the process is given by @var{command}, and @var{args} is an\narray of strings containing options for the command.\n\nThe file identifiers for the input and output streams of the subprocess are\nreturned in @var{in} and @var{out}.  If execution of the command is\nsuccessful, @var{pid} contains the process ID of the subprocess.  Otherwise,\n@var{pid} is @minus{}1.\n\nFor example:\n\n@example\n[in, out, pid] = popen2 (\"sort\", \"-r\");\nfputs (in, \"these\\nare\\nsome\\nstrings\\n\");\nfclose (in);\nEAGAIN = errno (\"EAGAIN\");\ndone = false;\ndo\n  s = fgets (out);\n  if (ischar (s))\n    fputs (stdout, s);\n  elseif (errno () == EAGAIN)\n    sleep (0.1);\n    fclear (out);\n  else\n    done = true;\n  endif\nuntil (done)\nfclose (out);\nwaitpid (pid);\n\n   @print{} these\n   @print{} strings\n   @print{} some\n   @print{} are\n@end example\n\nNote that @code{popen2}, unlike @code{popen}, will not @nospell{\"reap\"} the\nchild process.  If you don't use @code{waitpid} to check the child's\nexit status, it will linger until Octave exits.\n@seealso{popen, waitpid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("fcntl", Ffcntl, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{err}, @var{msg}] =} fcntl (@var{fid}, @var{request}, @var{arg})\nChange the properties of the open file @var{fid}.\n\nThe following values may be passed as @var{request}:\n\n@vtable @code\n@item F_DUPFD\nReturn a duplicate file descriptor.\n\n@item F_GETFD\nReturn the file descriptor flags for @var{fid}.\n\n@item F_SETFD\nSet the file descriptor flags for @var{fid}.\n\n@item F_GETFL\nReturn the file status flags for @var{fid}.  The following codes may be\nreturned (some of the flags may be undefined on some systems).\n\n@vtable @code\n@item O_RDONLY\nOpen for reading only.\n\n@item O_WRONLY\nOpen for writing only.\n\n@item O_RDWR\nOpen for reading and writing.\n\n@item O_APPEND\nAppend on each write.\n\n@item O_CREAT\nCreate the file if it does not exist.\n\n@item O_NONBLOCK\nNon-blocking mode.\n\n@item O_SYNC\nWait for writes to complete.\n\n@item O_ASYNC\nAsynchronous I/O.\n@end vtable\n\n@item F_SETFL\nSet the file status flags for @var{fid} to the value specified by @var{arg}.\n The only flags that can be changed are @w{@code{O_APPEND}} and\n@w{@code{O_NONBLOCK}}.\n@end vtable\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.  Otherwise,\n@var{err} is nonzero and @var{msg} contains a system-dependent error\nmessage.\n@seealso{fopen, dup2}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("fork", Ffork, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{pid}, @var{msg}] =} fork ()\nCreate a copy of the current process.\n\nFork can return one of the following values:\n\n@table @asis\n@item > 0\nYou are in the parent process.  The value returned from @code{fork} is the\nprocess id of the child process.  You should probably arrange to wait for\nany child processes to exit.\n\n@item 0\nYou are in the child process.  You can call @code{exec} to start another\nprocess.  If that fails, you should probably call @code{exit}.\n\n@item < 0\nThe call to @code{fork} failed for some reason.  You must take evasive\naction.  A system dependent error message will be waiting in @var{msg}.\n@end table\n@end deftypefn") 
 XDEFUNX_INTERNAL ("getpgrp", Fgetpgrp, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {pgid =} getpgrp ()\nReturn the process group id of the current process.\n@end deftypefn") 
 XDEFUNX_INTERNAL ("getpid", Fgetpid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {pid =} getpid ()\nReturn the process id of the current process.\n@seealso{getppid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("getppid", Fgetppid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {pid =} getppid ()\nReturn the process id of the parent process.\n@seealso{getpid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("getegid", Fgetegid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {egid =} getegid ()\nReturn the effective group id of the current process.\n@seealso{getgid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("getgid", Fgetgid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {gid =} getgid ()\nReturn the real group id of the current process.\n@seealso{getegid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("geteuid", Fgeteuid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {euid =} geteuid ()\nReturn the effective user id of the current process.\n@seealso{getuid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("getuid", Fgetuid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {uid =} getuid ()\nReturn the real user id of the current process.\n@seealso{geteuid}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("kill", Fkill, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{err}, @var{msg}] =} kill (@var{pid}, @var{sig})\nSend signal @var{sig} to process @var{pid}.\n\nIf @var{pid} is positive, then signal @var{sig} is sent to @var{pid}.\n\nIf @var{pid} is 0, then signal @var{sig} is sent to every process\nin the process group of the current process.\n\nIf @var{pid} is -1, then signal @var{sig} is sent to every process\nexcept process 1.\n\nIf @var{pid} is less than -1, then signal @var{sig} is sent to every\nprocess in the process group @var{-pid}.\n\nIf @var{sig} is 0, then no signal is sent, but error checking is still\nperformed.\n\nReturn 0 if successful, otherwise return -1.\n@end deftypefn") 
 XDEFUNX_INTERNAL ("lstat", Flstat, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{info} =} lstat (@var{symlink})\n@deftypefnx {Built-in Function} {[@var{info}, @var{err}, @var{msg}] =} lstat (@var{symlink})\nReturn a structure @var{info} containing information about the symbolic link\n@var{symlink}.\n\nThe function outputs are described in the documentation for @code{stat}.\n@seealso{stat, symlink}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("mkfifo", Fmkfifo, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{err} =} mkfifo (@var{name}, @var{mode})\n@deftypefnx {Built-in Function} {[@var{err}, @var{msg}] =} mkfifo (@var{name}, @var{mode})\nCreate a FIFO special file named @var{name} with file mode @var{mode}.\n\n@var{mode} is interpreted as a decimal number (@emph{not} octal) and is\nsubject to umask processing.  The final calculated mode is\n@code{@var{mode} - @var{umask}}.\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{pipe, umask}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("pipe", Fpipe, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{read_fd}, @var{write_fd}, @var{err}, @var{msg}] =} pipe ()\nCreate a pipe and return the reading and writing ends of the pipe into\n@var{read_fd} and @var{write_fd} respectively.\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{mkfifo}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("stat", Fstat, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {[@var{info}, @var{err}, @var{msg}] =} stat (@var{file})\n@deftypefnx {Built-in Function} {[@var{info}, @var{err}, @var{msg}] =} stat (@var{fid})\n@deftypefnx {Built-in Function} {[@var{info}, @var{err}, @var{msg}] =} lstat (@var{file})\n@deftypefnx {Built-in Function} {[@var{info}, @var{err}, @var{msg}] =} lstat (@var{fid})\nReturn a structure @var{info} containing the following information about\n@var{file} or file identifier @var{fid}.\n\n@table @code\n@item dev\nID of device containing a directory entry for this file.\n\n@item ino\nFile number of the file.\n\n@item mode\nFile mode, as an integer.  Use the functions @w{@code{S_ISREG}},\n@w{@code{S_ISDIR}}, @w{@code{S_ISCHR}}, @w{@code{S_ISBLK}},\n@w{@code{S_ISFIFO}}, @w{@code{S_ISLNK}}, or @w{@code{S_ISSOCK}} to extract\ninformation from this value.\n\n@item modestr\nFile mode, as a string of ten letters or dashes as would be returned by\n@kbd{ls -l}.\n\n@item nlink\nNumber of links.\n\n@item uid\nUser ID of file's owner.\n\n@item gid\nGroup ID of file's group.\n\n@item rdev\nID of device for block or character special files.\n\n@item size\nSize in bytes.\n\n@item atime\nTime of last access in the same form as time values returned from\n@code{time}.  @xref{Timing Utilities}.\n\n@item mtime\nTime of last modification in the same form as time values returned from\n@code{time}.  @xref{Timing Utilities}.\n\n@item ctime\nTime of last file status change in the same form as time values\nreturned from @code{time}.  @xref{Timing Utilities}.\n\n@item blksize\nSize of blocks in the file.\n\n@item blocks\nNumber of blocks allocated for file.\n@end table\n\nIf the call is successful @var{err} is 0 and @var{msg} is an empty string.\nIf the file does not exist, or some other error occurs, @var{info} is an\nempty matrix, @var{err} is @minus{}1, and @var{msg} contains the\ncorresponding system error message.\n\nIf @var{file} is a symbolic link, @code{stat} will return information about\nthe actual file that is referenced by the link.  Use @code{lstat} if you\nwant information about the symbolic link itself.\n\nFor example:\n\n@example\n[info, err, msg] = stat (\"/vmlinuz\")\n  @result{} info =\n     @{\n       atime = 855399756\n       rdev = 0\n       ctime = 847219094\n       uid = 0\n       size = 389218\n       blksize = 4096\n       mtime = 847219094\n       gid = 6\n       nlink = 1\n       blocks = 768\n       mode = -rw-r--r--\n       modestr = -rw-r--r--\n       ino = 9316\n       dev = 2049\n     @}\n  @result{} err = 0\n  @result{} msg =\n@end example\n@seealso{lstat, ls, dir}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISREG", FS_ISREG, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISREG (@var{mode})\nReturn true if @var{mode} corresponds to a regular file.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISDIR", FS_ISDIR, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISDIR (@var{mode})\nReturn true if @var{mode} corresponds to a directory.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISCHR", FS_ISCHR, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISCHR (@var{mode})\nReturn true if @var{mode} corresponds to a character device.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISBLK", FS_ISBLK, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISBLK (@var{mode})\nReturn true if @var{mode} corresponds to a block device.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISFIFO", FS_ISFIFO, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISFIFO (@var{mode})\nReturn true if @var{mode} corresponds to a fifo.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISLNK", FS_ISLNK, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISLNK (@var{mode})\nReturn true if @var{mode} corresponds to a symbolic link.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("S_ISSOCK", FS_ISSOCK, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} S_ISSOCK (@var{mode})\nReturn true if @var{mode} corresponds to a socket.\n\nThe value of @var{mode} is assumed to be returned from a call to @code{stat}.\n@seealso{stat, lstat}\n@end deftypefn") 
 XDEFUN_INTERNAL (gethostname, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} gethostname ()\nReturn the hostname of the system where Octave is running.\n@end deftypefn") 
 XDEFUN_INTERNAL (uname, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{uts}, @var{err}, @var{msg}] =} uname ()\nReturn system information in the structure.\n\nFor example:\n\n@example\n@group\nuname ()\n   @result{} @{\n         sysname = x86_64\n         nodename = segfault\n         release = 2.6.15-1-amd64-k8-smp\n         version = Linux\n         machine = #2 SMP Thu Feb 23 04:57:49 UTC 2006\n      @}\n@end group\n@end example\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a\nsystem-dependent error message.\n@end deftypefn") 
 XDEFUNX_INTERNAL ("unlink", Funlink, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{err}, @var{msg}] =} unlink (@var{file})\nDelete the file named @var{file}.\n\nIf successful, @var{err} is 0 and @var{msg} is an empty string.\nOtherwise, @var{err} is nonzero and @var{msg} contains a system-dependent\nerror message.\n@seealso{delete, rmdir}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("waitpid", Fwaitpid, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{pid}, @var{status}, @var{msg}] =} waitpid (@var{pid}, @var{options})\nWait for process @var{pid} to terminate.\n\nThe @var{pid} argument can be:\n\n@table @asis\n@item @minus{}1\nWait for any child process.\n\n@item 0\nWait for any child process whose process group ID is equal to that of the\nOctave interpreter process.\n\n@item > 0\nWait for termination of the child process with ID @var{pid}.\n@end table\n\nThe @var{options} argument can be a bitwise OR of zero or more of the\nfollowing constants:\n\n@table @code\n@item 0\nWait until signal is received or a child process exits (this is the default\nif the @var{options} argument is missing).\n\n@item WNOHANG\nDo not hang if status is not immediately available.\n\n@item WUNTRACED\nReport the status of any child processes that are stopped, and whose status\nhas not yet been reported since they stopped.\n\n@item WCONTINUE\nReturn if a stopped child has been resumed by delivery of @code{SIGCONT}.\nThis value may not be meaningful on all systems.\n@end table\n\nIf the returned value of @var{pid} is greater than 0, it is the process ID\nof the child process that exited.  If an error occurs, @var{pid} will be\nless than zero and @var{msg} will contain a system-dependent error message.\nThe value of @var{status} contains additional system-dependent information\nabout the subprocess that exited.\n@seealso{WCONTINUE, WCOREDUMP, WEXITSTATUS, WIFCONTINUED, WIFSIGNALED, WIFSTOPPED, WNOHANG, WSTOPSIG, WTERMSIG, WUNTRACED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WIFEXITED", FWIFEXITED, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WIFEXITED (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\ntrue if the child terminated normally.\n@seealso{waitpid, WEXITSTATUS, WIFSIGNALED, WTERMSIG, WCOREDUMP, WIFSTOPPED, WSTOPSIG, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WEXITSTATUS", FWEXITSTATUS, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WEXITSTATUS (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\nthe exit status of the child.\n\nThis function should only be employed if @code{WIFEXITED} returned true.\n@seealso{waitpid, WIFEXITED, WIFSIGNALED, WTERMSIG, WCOREDUMP, WIFSTOPPED, WSTOPSIG, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WIFSIGNALED", FWIFSIGNALED, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WIFSIGNALED (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\ntrue if the child process was terminated by a signal.\n@seealso{waitpid, WIFEXITED, WEXITSTATUS, WTERMSIG, WCOREDUMP, WIFSTOPPED, WSTOPSIG, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WTERMSIG", FWTERMSIG, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WTERMSIG (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\nthe number of the signal that caused the child process to terminate.\n\nThis function should only be employed if @code{WIFSIGNALED} returned true.\n@seealso{waitpid, WIFEXITED, WEXITSTATUS, WIFSIGNALED, WCOREDUMP, WIFSTOPPED, WSTOPSIG, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WCOREDUMP", FWCOREDUMP, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WCOREDUMP (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\ntrue if the child produced a core dump.\n\nThis function should only be employed if @code{WIFSIGNALED} returned true.\nThe macro used to implement this function is not specified in POSIX.1-2001\nand is not available on some Unix implementations (e.g., AIX, SunOS).\n@seealso{waitpid, WIFEXITED, WEXITSTATUS, WIFSIGNALED, WTERMSIG, WIFSTOPPED, WSTOPSIG, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WIFSTOPPED", FWIFSTOPPED, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WIFSTOPPED (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\ntrue if the child process was stopped by delivery of a signal.\n\nThis is only possible if the call was done using @code{WUNTRACED} or when\nthe child is being traced (see ptrace(2)).\n@seealso{waitpid, WIFEXITED, WEXITSTATUS, WIFSIGNALED, WTERMSIG, WCOREDUMP, WSTOPSIG, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WSTOPSIG", FWSTOPSIG, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WSTOPSIG (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\nthe number of the signal which caused the child to stop.\n\nThis function should only be employed if @code{WIFSTOPPED} returned true.\n@seealso{waitpid, WIFEXITED, WEXITSTATUS, WIFSIGNALED, WTERMSIG, WCOREDUMP, WIFSTOPPED, WIFCONTINUED}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WIFCONTINUED", FWIFCONTINUED, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WIFCONTINUED (@var{status})\nGiven @var{status} from a call to @code{waitpid}, return\ntrue if the child process was resumed by delivery of @code{SIGCONT}.\n@seealso{waitpid, WIFEXITED, WEXITSTATUS, WIFSIGNALED, WTERMSIG, WCOREDUMP, WIFSTOPPED, WSTOPSIG}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("canonicalize_file_name", Fcanonicalize_file_name, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{cname}, @var{status}, @var{msg}] =} canonicalize_file_name (@var{fname})\nReturn the canonical name of file @var{fname}.\n\nIf the file does not exist the empty string (\"\") is returned.\n@seealso{make_absolute_filename, is_absolute_filename, is_rooted_relative_filename}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("F_DUPFD", FF_DUPFD, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} F_DUPFD ()\nReturn the numerical value to pass to @code{fcntl} to return\na duplicate file descriptor.\n@seealso{fcntl, F_GETFD, F_GETFL, F_SETFD, F_SETFL}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("F_GETFD", FF_GETFD, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} F_GETFD ()\nReturn the numerical value to pass to @code{fcntl} to return\nthe file descriptor flags.\n@seealso{fcntl, F_DUPFD, F_GETFL, F_SETFD, F_SETFL}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("F_GETFL", FF_GETFL, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} F_GETFL ()\nReturn the numerical value to pass to @code{fcntl} to return\nthe file status flags.\n@seealso{fcntl, F_DUPFD, F_GETFD, F_SETFD, F_SETFL}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("F_SETFD", FF_SETFD, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} F_SETFD ()\nReturn the numerical value to pass to @code{fcntl} to set the file\ndescriptor flags.\n@seealso{fcntl, F_DUPFD, F_GETFD, F_GETFL, F_SETFL}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("F_SETFL", FF_SETFL, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} F_SETFL ()\nReturn the numerical value to pass to @code{fcntl} to set the file\nstatus flags.\n@seealso{fcntl, F_DUPFD, F_GETFD, F_GETFL, F_SETFD}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_APPEND", FO_APPEND, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_APPEND ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate each write operation appends,\nor that may be passed to @code{fcntl} to set the write mode to append.\n@seealso{fcntl, O_ASYNC, O_CREAT, O_EXCL, O_NONBLOCK, O_RDONLY, O_RDWR, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_ASYNC", FO_ASYNC, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_ASYNC ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate asynchronous I/O.\n@seealso{fcntl, O_APPEND, O_CREAT, O_EXCL, O_NONBLOCK, O_RDONLY, O_RDWR, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_CREAT", FO_CREAT, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_CREAT ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that a file should be created if it\ndoes not exist.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_EXCL, O_NONBLOCK, O_RDONLY, O_RDWR, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_EXCL", FO_EXCL, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_EXCL ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that file locking is used.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_NONBLOCK, O_RDONLY, O_RDWR, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_NONBLOCK", FO_NONBLOCK, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_NONBLOCK ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that non-blocking I/O is in use,\nor that may be passsed to @code{fcntl} to set non-blocking I/O.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_EXCL, O_RDONLY, O_RDWR, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_RDONLY", FO_RDONLY, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_RDONLY ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that a file is open for reading only.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_EXCL, O_NONBLOCK, O_RDWR, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_RDWR", FO_RDWR, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_RDWR ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that a file is open for both reading\nand writing.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_EXCL, O_NONBLOCK, O_RDONLY, O_SYNC, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_SYNC", FO_SYNC, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_SYNC ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that a file is open for synchronous I/O.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_EXCL, O_NONBLOCK, O_RDONLY, O_RDWR, O_TRUNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_TRUNC", FO_TRUNC, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_TRUNC ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that if file exists, it should be\ntruncated when writing.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_EXCL, O_NONBLOCK, O_RDONLY, O_RDWR, O_SYNC, O_WRONLY}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("O_WRONLY", FO_WRONLY, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} O_WRONLY ()\nReturn the numerical value of the file status flag that may be\nreturned by @code{fcntl} to indicate that a file is open for writing only.\n@seealso{fcntl, O_APPEND, O_ASYNC, O_CREAT, O_EXCL, O_NONBLOCK, O_RDONLY, O_RDWR, O_SYNC, O_TRUNC}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WNOHANG", FWNOHANG, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WNOHANG ()\nReturn the numerical value of the option argument that may be\npassed to @code{waitpid} to indicate that it should return its status\nimmediately instead of waiting for a process to exit.\n@seealso{waitpid, WUNTRACED, WCONTINUE}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WUNTRACED", FWUNTRACED, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WUNTRACED ()\nReturn the numerical value of the option argument that may be\npassed to @code{waitpid} to indicate that it should also return if the child\nprocess has stopped but is not traced via the @code{ptrace} system call\n@seealso{waitpid, WNOHANG, WCONTINUE}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("WCONTINUE", FWCONTINUE, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} WCONTINUE ()\nReturn the numerical value of the option argument that may be\npassed to @code{waitpid} to indicate that it should also return if a stopped\nchild has been resumed by delivery of a @code{SIGCONT} signal.\n@seealso{waitpid, WNOHANG, WUNTRACED}\n@end deftypefn") 
}

static void
install_sysdep_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/sysdep.cc")
 XDEFUN_INTERNAL (__open_with_system_app__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __open_with_system_app__ (@var{file})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (clc, , , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} clc ()\n@deftypefnx {Built-in Function} {} home ()\nClear the terminal screen and move the cursor to the upper left corner.\n@end deftypefn") 
 XDEFALIAS_INTERNAL(home, clc) ;
 XDEFUN_INTERNAL (getenv, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} getenv (@var{var})\nReturn the value of the environment variable @var{var}.\n\nFor example,\n\n@example\ngetenv (\"PATH\")\n@end example\n\n@noindent\nreturns a string containing the value of your path.\n@seealso{setenv, unsetenv}\n@end deftypefn") 
 XDEFUN_INTERNAL (setenv, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} setenv (@var{var}, @var{value})\n@deftypefnx {Built-in Function} {} setenv (@var{var})\n@deftypefnx {Built-in Function} {} putenv (@dots{})\nSet the value of the environment variable @var{var} to @var{value}.\n\nIf no @var{value} is specified then the variable will be assigned the null\nstring.\n@seealso{unsetenv, getenv}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(putenv, setenv) ;
 XDEFUN_INTERNAL (unsetenv, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{status} =} unsetenv (@var{var})\nDelete the environment variable @var{var}.\n\nReturn 0 if the variable was deleted, or did not exist, and -1 if an error\noccurred.\n@seealso{setenv, getenv}\n@end deftypefn") 
 XDEFUN_INTERNAL (kbhit, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} kbhit ()\n@deftypefnx {Built-in Function} {} kbhit (1)\nRead a single keystroke from the keyboard.\n\nIf called with an argument, don't wait for a keypress.\n\nFor example,\n\n@example\nx = kbhit ();\n@end example\n\n@noindent\nwill set @var{x} to the next character typed at the keyboard as soon as\nit is typed.\n\n@example\nx = kbhit (1);\n@end example\n\n@noindent\nis identical to the above example, but doesn't wait for a keypress,\nreturning the empty string if no key is available.\n@seealso{input, pause}\n@end deftypefn") 
 XDEFUN_INTERNAL (pause, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} pause ()\n@deftypefnx {Built-in Function} {} pause (@var{n})\nSuspend the execution of the program for @var{n} seconds.\n\n@var{n} is a positive real value and may be a fraction of a second.\n\nIf invoked without an input arguments then the program is suspended until a\ncharacter is typed.\n\nThe following example prints a message and then waits 5 seconds before\nclearing the screen.\n\n@example\n@group\nfprintf (stderr, \"wait please...\\n\");\npause (5);\nclc;\n@end group\n@end example\n@seealso{kbhit, sleep}\n@end deftypefn") 
 XDEFUN_INTERNAL (sleep, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} sleep (@var{seconds})\nSuspend the execution of the program for the given number of seconds.\n@seealso{usleep, pause}\n@end deftypefn") 
 XDEFUN_INTERNAL (usleep, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} usleep (@var{microseconds})\nSuspend the execution of the program for the given number of\nmicroseconds.\n\nOn systems where it is not possible to sleep for periods of time less than\none second, @code{usleep} will pause the execution for @code{round\n(@var{microseconds} / 1e6)} seconds.\n@seealso{sleep, pause}\n@end deftypefn") 
 XDEFUN_INTERNAL (isieee, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isieee ()\nReturn true if your computer @emph{claims} to conform to the IEEE standard\nfor floating point calculations.\n\nNo actual tests are performed.\n@end deftypefn") 
 XDEFUN_INTERNAL (native_float_format, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} native_float_format ()\nReturn the native floating point format as a string.\n@end deftypefn") 
 XDEFUN_INTERNAL (tilde_expand, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} tilde_expand (@var{string})\nPerform tilde expansion on @var{string}.\n\nIf @var{string} begins with a tilde character, (@samp{~}), all of the\ncharacters preceding the first slash (or all characters, if there is no\nslash) are treated as a possible user name, and the tilde and the following\ncharacters up to the slash are replaced by the home directory of the named\nuser.  If the tilde is followed immediately by a slash, the tilde is\nreplaced by the home directory of the user running Octave.\n\nFor example:\n\n@example\n@group\ntilde_expand (\"~joeuser/bin\")\n     @result{} \"/home/joeuser/bin\"\ntilde_expand (\"~/bin\")\n     @result{} \"/home/jwe/bin\"\n@end group\n@end example\n@end deftypefn") 
 XDEFUN_INTERNAL (get_home_directory, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{homedir} =} get_home_directory ()\nReturn the current home directory.\n\nOn most systems, this is equivalent to @code{getenv (\"HOME\")}.  On Windows\nsystems, if the environment variable @env{HOME} is not set then it is\nequivalent to\n@code{fullfile (getenv (\"HOMEDRIVE\"), getenv (\"HOMEPATH\"))}\n@seealso{getenv}\n@end deftypefn") 
 XDEFUN_INTERNAL (have_window_system, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} have_window_system ()\nReturn true if a window system is available (X11, Windows, or Apple OS X)\nand false otherwise.\n@seealso{isguirunning}\n@end deftypefn") 
}

static void
install_time_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/time.cc")
 XDEFUN_INTERNAL (time, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{seconds} =} time ()\nReturn the current time as the number of seconds since the epoch.\n\nThe epoch is referenced to 00:00:00 CUT (Coordinated Universal Time) 1 Jan\n1970.  For example, on Monday February 17, 1997 at 07:15:06 CUT, the value\nreturned by @code{time} was 856163706.\n@seealso{strftime, strptime, localtime, gmtime, mktime, now, date, clock, datenum, datestr, datevec, calendar, weekday}\n@end deftypefn") 
 XDEFUN_INTERNAL (gmtime, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{tm_struct} =} gmtime (@var{t})\nGiven a value returned from @code{time}, or any non-negative integer,\nreturn a time structure corresponding to CUT (Coordinated Universal Time).\n\nFor example:\n\n@example\n@group\ngmtime (time ())\n     @result{} @{\n           usec = 0\n           sec = 6\n           min = 15\n           hour = 7\n           mday = 17\n           mon = 1\n           year = 97\n           wday = 1\n           yday = 47\n           isdst = 0\n           zone = CST\n        @}\n@end group\n@end example\n@seealso{strftime, strptime, localtime, mktime, time, now, date, clock, datenum, datestr, datevec, calendar, weekday}\n@end deftypefn") 
 XDEFUN_INTERNAL (localtime, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{tm_struct} =} localtime (@var{t})\nGiven a value returned from @code{time}, or any non-negative integer,\nreturn a time structure corresponding to the local time zone.\n\n@example\n@group\nlocaltime (time ())\n     @result{} @{\n           usec = 0\n           sec = 6\n           min = 15\n           hour = 1\n           mday = 17\n           mon = 1\n           year = 97\n           wday = 1\n           yday = 47\n           isdst = 0\n           zone = CST\n        @}\n@end group\n@end example\n@seealso{strftime, strptime, gmtime, mktime, time, now, date, clock, datenum, datestr, datevec, calendar, weekday}\n@end deftypefn") 
 XDEFUN_INTERNAL (mktime, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{seconds} =} mktime (@var{tm_struct})\nConvert a time structure corresponding to the local time to the number of\nseconds since the epoch.\n\nFor example:\n\n@example\n@group\nmktime (localtime (time ()))\n     @result{} 856163706\n@end group\n@end example\n@seealso{strftime, strptime, localtime, gmtime, time, now, date, clock, datenum, datestr, datevec, calendar, weekday}\n@end deftypefn") 
 XDEFUN_INTERNAL (strftime, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} strftime (@var{fmt}, @var{tm_struct})\nFormat the time structure @var{tm_struct} in a flexible way using the format\nstring @var{fmt} that contains @samp{%} substitutions similar to those in\n@code{printf}.\n\nExcept where noted, substituted fields have a fixed size; numeric fields are\npadded if necessary.  Padding is with zeros by default; for fields that\ndisplay a single number, padding can be changed or inhibited by following\nthe @samp{%} with one of the modifiers described below.  Unknown field\nspecifiers are copied as normal characters.  All other characters are copied\nto the output without change.  For example:\n\n@example\n@group\nstrftime (\"%r (%Z) %A %e %B %Y\", localtime (time ()))\n      @result{} \"01:15:06 AM (CST) Monday 17 February 1997\"\n@end group\n@end example\n\nOctave's @code{strftime} function supports a superset of the ANSI C field\nspecifiers.\n\n@noindent\nLiteral character fields:\n\n@table @code\n@item %%\n% character.\n\n@item %n\nNewline character.\n\n@item %t\nTab character.\n@end table\n\n@noindent\nNumeric modifiers (a nonstandard extension):\n\n@table @code\n@item - (dash)\nDo not pad the field.\n\n@item _ (underscore)\nPad the field with spaces.\n@end table\n\n@noindent\nTime fields:\n\n@table @code\n@item %H\nHour (00-23).\n\n@item %I\nHour (01-12).\n\n@item %k\nHour (0-23).\n\n@item %l\nHour (1-12).\n\n@item %M\nMinute (00-59).\n\n@item %p\nLocale's AM or PM.\n\n@item %r\nTime, 12-hour (hh:mm:ss [AP]M).\n\n@item %R\nTime, 24-hour (hh:mm).\n\n@item %s\nTime in seconds since 00:00:00, Jan 1, 1970 (a nonstandard extension).\n\n@item %S\nSecond (00-61).\n\n@item %T\nTime, 24-hour (hh:mm:ss).\n\n@item %X\nLocale's time representation (%H:%M:%S).\n\n@item %Z\nTime zone (EDT), or nothing if no time zone is determinable.\n@end table\n\n@noindent\nDate fields:\n\n@table @code\n@item %a\nLocale's abbreviated weekday name (Sun-Sat).\n\n@item %A\nLocale's full weekday name, variable length (Sunday-Saturday).\n\n@item %b\nLocale's abbreviated month name (Jan-Dec).\n\n@item %B\nLocale's full month name, variable length (January-December).\n\n@item %c\nLocale's date and time (Sat Nov 04 12:02:33 EST 1989).\n\n@item %C\nCentury (00-99).\n\n@item %d\nDay of month (01-31).\n\n@item %e\nDay of month ( 1-31).\n\n@item %D\nDate (mm/dd/yy).\n\n@item %h\nSame as %b.\n\n@item %j\nDay of year (001-366).\n\n@item %m\nMonth (01-12).\n\n@item %U\nWeek number of year with Sunday as first day of week (00-53).\n\n@item %w\nDay of week (0-6).\n\n@item %W\nWeek number of year with Monday as first day of week (00-53).\n\n@item %x\nLocale's date representation (mm/dd/yy).\n\n@item %y\nLast two digits of year (00-99).\n\n@item %Y\nYear (1970-).\n@end table\n@seealso{strptime, localtime, gmtime, mktime, time, now, date, clock, datenum, datestr, datevec, calendar, weekday}\n@end deftypefn") 
 XDEFUN_INTERNAL (strptime, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@var{tm_struct}, @var{nchars}] =} strptime (@var{str}, @var{fmt})\nConvert the string @var{str} to the time structure @var{tm_struct} under\nthe control of the format string @var{fmt}.\n\nIf @var{fmt} fails to match, @var{nchars} is 0; otherwise, it is set to the\nposition of last matched character plus 1. Always check for this unless\nyou're absolutely sure the date string will be parsed correctly.\n@seealso{strftime, localtime, gmtime, mktime, time, now, date, clock, datenum, datestr, datevec, calendar, weekday}\n@end deftypefn") 
}

static void
install_toplev_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/toplev.cc")
 XDEFUN_INTERNAL (quit, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} exit\n@deftypefnx {Built-in Function} {} exit (@var{status})\n@deftypefnx {Built-in Function} {} quit\n@deftypefnx {Built-in Function} {} quit (@var{status})\nExit the current Octave session.\n\nIf the optional integer value @var{status} is supplied, pass that value to\nthe operating system as Octave's exit status.  The default value is zero.\n\nWhen exiting, Octave will attempt to run the m-file @file{finish.m} if it\nexists.  User commands to save the workspace or clean up temporary files\nmay be placed in that file.  Alternatively, another m-file may be scheduled\nto run using @code{atexit}.\n@seealso{atexit}\n@end deftypefn") 
 XDEFALIAS_INTERNAL(exit, quit) ;
 XDEFUN_INTERNAL (warranty, , , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} warranty ()\nDescribe the conditions for copying and distributing Octave.\n@end deftypefn") 
 XDEFUN_INTERNAL (system, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} system (\"@var{string}\")\n@deftypefnx {Built-in Function} {} system (\"@var{string}\", @var{return_output})\n@deftypefnx {Built-in Function} {} system (\"@var{string}\", @var{return_output}, @var{type})\n@deftypefnx {Built-in Function} {[@var{status}, @var{output}] =} system (@dots{})\nExecute a shell command specified by @var{string}.\n\nIf the optional argument @var{type} is @qcode{\"async\"}, the process is\nstarted in the background and the process ID of the child process is\nreturned immediately.  Otherwise, the child process is started and Octave\nwaits until it exits.  If the @var{type} argument is omitted, it defaults to\nthe value @qcode{\"sync\"}.\n\nIf @var{system} is called with one or more output arguments, or if the\noptional argument @var{return_output} is true and the subprocess is started\nsynchronously, then the output from the command is returned as a variable.\nOtherwise, if the subprocess is executed synchronously, its output is sent\nto the standard output.  To send the output of a command executed with\n@code{system} through the pager, use a command like\n\n@example\n@group\n[output, text] = system (\"cmd\");\ndisp (text);\n@end group\n@end example\n\n@noindent\nor\n\n@example\nprintf (\"%s\\n\", nthargout (2, \"system\", \"cmd\"));\n@end example\n\nThe @code{system} function can return two values.  The first is the\nexit status of the command and the second is any output from the\ncommand that was written to the standard output stream.  For example,\n\n@example\n[status, output] = system (\"echo foo; exit 2\");\n@end example\n\n@noindent\nwill set the variable @code{output} to the string @samp{foo}, and the\nvariable @code{status} to the integer @samp{2}.\n\nFor commands run asynchronously, @var{status} is the process id of the\ncommand shell that is started to run the command.\n@seealso{unix, dos}\n@end deftypefn") 
 XDEFUN_INTERNAL (atexit, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} atexit (@var{fcn})\n@deftypefnx {Built-in Function} {} atexit (@var{fcn}, @var{flag})\nRegister a function to be called when Octave exits.\n\nFor example,\n\n@example\n@group\nfunction last_words ()\n  disp (\"Bye bye\");\nendfunction\natexit (\"last_words\");\n@end group\n@end example\n\n@noindent\nwill print the message @qcode{\"Bye bye\"} when Octave exits.\n\nThe additional argument @var{flag} will register or unregister @var{fcn}\nfrom the list of functions to be called when Octave exits.  If @var{flag} is\ntrue, the function is registered, and if @var{flag} is false, it is\nunregistered.  For example, after registering the function @code{last_words}\nabove,\n\n@example\natexit (\"last_words\", false);\n@end example\n\n@noindent\nwill remove the function from the list and Octave will not call\n@code{last_words} when it exits.\n\nNote that @code{atexit} only removes the first occurrence of a function\nfrom the list, so if a function was placed in the list multiple times with\n@code{atexit}, it must also be removed from the list multiple times.\n@seealso{quit}\n@end deftypefn") 
 XDEFUN_INTERNAL (octave_config_info, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} octave_config_info ()\n@deftypefnx {Built-in Function} {} octave_config_info (@var{option})\nReturn a structure containing configuration and installation information for\nOctave.\n\nIf @var{option} is a string, return the configuration information for the\nspecified option.\n\n@seealso{computer}\n@end deftypefn") 
}

static void
install_tril_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/tril.cc")
 XDEFUN_INTERNAL (tril, args, , "-*- texinfo -*-\n@deftypefn  {Function File} {} tril (@var{A})\n@deftypefnx {Function File} {} tril (@var{A}, @var{k})\n@deftypefnx {Function File} {} tril (@var{A}, @var{k}, @var{pack})\n@deftypefnx {Function File} {} triu (@var{A})\n@deftypefnx {Function File} {} triu (@var{A}, @var{k})\n@deftypefnx {Function File} {} triu (@var{A}, @var{k}, @var{pack})\nReturn a new matrix formed by extracting the lower (@code{tril})\nor upper (@code{triu}) triangular part of the matrix @var{A}, and\nsetting all other elements to zero.\n\nThe second argument is optional, and specifies how many diagonals above or\nbelow the main diagonal should also be set to zero.\n\nThe default value of @var{k} is zero, so that @code{triu} and @code{tril}\nnormally include the main diagonal as part of the result.\n\nIf the value of @var{k} is nonzero integer, the selection of elements starts\nat an offset of @var{k} diagonals above or below the main diagonal; above\nfor positive @var{k} and below for negative @var{k}.\n\nThe absolute value of @var{k} must not be greater than the number of\nsubdiagonals or superdiagonals.\n\nFor example:\n\n@example\n@group\ntril (ones (3), -1)\n     @result{}  0  0  0\n         1  0  0\n         1  1  0\n@end group\n@end example\n\n@noindent\nand\n\n@example\n@group\ntril (ones (3), 1)\n     @result{}  1  1  0\n         1  1  1\n         1  1  1\n@end group\n@end example\n\nIf the option @qcode{\"pack\"} is given as third argument, the extracted\nelements are not inserted into a matrix, but rather stacked column-wise one\nabove other.\n@seealso{diag}\n@end deftypefn") 
 XDEFUN_INTERNAL (triu, args, , "-*- texinfo -*-\n@deftypefn  {Function File} {} triu (@var{A})\n@deftypefnx {Function File} {} triu (@var{A}, @var{k})\n@deftypefnx {Function File} {} triu (@var{A}, @var{k}, @var{pack})\nSee the documentation for the @code{tril} function (@pxref{tril}).\n@seealso{tril}\n@end deftypefn") 
}

static void
install_tsearch_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/tsearch.cc")
 XDEFUN_INTERNAL (tsearch, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{idx} =} tsearch (@var{x}, @var{y}, @var{t}, @var{xi}, @var{yi})\nSearch for the enclosing Delaunay convex hull.\n\nFor @code{@var{t} = delaunay (@var{x}, @var{y})}, finds the index in @var{t}\ncontaining the points @code{(@var{xi}, @var{yi})}.  For points outside the\nconvex hull, @var{idx} is NaN.\n@seealso{delaunay, delaunayn}\n@end deftypefn") 
}

static void
install_typecast_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/typecast.cc")
 XDEFUN_INTERNAL (typecast, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{y} =} typecast (@var{x}, \"@var{class}\")\nReturn a new array @var{y} resulting from interpreting the data of @var{x}\nin memory as data of the numeric class @var{class}.\n\nBoth the class of @var{x} and @var{class} must be one of the built-in\nnumeric classes:\n\n@example\n@group\n\"logical\"\n\"char\"\n\"int8\"\n\"int16\"\n\"int32\"\n\"int64\"\n\"uint8\"\n\"uint16\"\n\"uint32\"\n\"uint64\"\n\"double\"\n\"single\"\n\"double complex\"\n\"single complex\"\n@end group\n@end example\n\n@noindent\nthe last two are only used with @var{class}; they indicate that a\ncomplex-valued result is requested.  Complex arrays are stored in memory as\nconsecutive pairs of real numbers.  The sizes of integer types are given by\ntheir bit counts.  Both logical and char are typically one byte wide;\nhowever, this is not guaranteed by C++.  If your system is IEEE conformant,\nsingle and double will be 4 bytes and 8 bytes wide, respectively.\n@qcode{\"logical\"} is not allowed for @var{class}.\n\nIf the input is a row vector, the return value is a row vector, otherwise it\nis a column vector.\n\nIf the bit length of @var{x} is not divisible by that of @var{class}, an\nerror occurs.\n\nAn example of the use of typecast on a little-endian machine is\n\n@example\n@group\n@var{x} = uint16 ([1, 65535]);\ntypecast (@var{x}, \"uint8\")\n@result{} [   1,   0, 255, 255]\n@end group\n@end example\n@seealso{cast, bitpack, bitunpack, swapbytes}\n@end deftypefn") 
 XDEFUN_INTERNAL (bitpack, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{y} =} bitpack (@var{x}, @var{class})\nReturn a new array @var{y} resulting from interpreting the logical array\n@var{x} as raw bit patterns for data of the numeric class @var{class}.\n\n@var{class} must be one of the built-in numeric classes:\n\n@example\n@group\n\"double\"\n\"single\"\n\"double complex\"\n\"single complex\"\n\"char\"\n\"int8\"\n\"int16\"\n\"int32\"\n\"int64\"\n\"uint8\"\n\"uint16\"\n\"uint32\"\n\"uint64\"\n@end group\n@end example\n\nThe number of elements of @var{x} should be divisible by the bit length of\n@var{class}.  If it is not, excess bits are discarded.  Bits come in\nincreasing order of significance, i.e., @code{x(1)} is bit 0, @code{x(2)} is\nbit 1, etc.\n\nThe result is a row vector if @var{x} is a row vector, otherwise it is a\ncolumn vector.\n@seealso{bitunpack, typecast}\n@end deftypefn") 
 XDEFUN_INTERNAL (bitunpack, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {@var{y} =} bitunpack (@var{x})\nReturn a logical array @var{y} corresponding to the raw bit patterns of\n@var{x}.\n\n@var{x} must belong to one of the built-in numeric classes:\n\n@example\n@group\n\"double\"\n\"single\"\n\"char\"\n\"int8\"\n\"int16\"\n\"int32\"\n\"int64\"\n\"uint8\"\n\"uint16\"\n\"uint32\"\n\"uint64\"\n@end group\n@end example\n\nThe result is a row vector if @var{x} is a row vector; otherwise, it is a\ncolumn vector.\n@seealso{bitpack, typecast}\n@end deftypefn") 
}

static void
install_urlwrite_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/urlwrite.cc")
 XDEFUN_INTERNAL (urlwrite, args, nargout, "-*- texinfo -*-\n@deftypefn  {Loadable Function} {} urlwrite (@var{url}, @var{localfile})\n@deftypefnx {Loadable Function} {@var{f} =} urlwrite (@var{url}, @var{localfile})\n@deftypefnx {Loadable Function} {[@var{f}, @var{success}] =} urlwrite (@var{url}, @var{localfile})\n@deftypefnx {Loadable Function} {[@var{f}, @var{success}, @var{message}] =} urlwrite (@var{url}, @var{localfile})\nDownload a remote file specified by its @var{url} and save it as\n@var{localfile}.\n\nFor example:\n\n@example\n@group\nurlwrite (\"ftp://ftp.octave.org/pub/README\",\n          \"README.txt\");\n@end group\n@end example\n\nThe full path of the downloaded file is returned in @var{f}.\n\nThe variable @var{success} is 1 if the download was successful,\notherwise it is 0 in which case @var{message} contains an error message.\n\nIf no output argument is specified and an error occurs, then the error is\nsignaled through Octave's error handling mechanism.\n\nThis function uses libcurl.  Curl supports, among others, the HTTP, FTP and\nFILE protocols.  Username and password may be specified in the URL, for\nexample:\n\n@example\n@group\nurlwrite (\"http://username:password@@example.com/file.txt\",\n          \"file.txt\");\n@end group\n@end example\n\nGET and POST requests can be specified by @var{method} and @var{param}.\nThe parameter @var{method} is either @samp{get} or @samp{post} and\n@var{param} is a cell array of parameter and value pairs.\nFor example:\n\n@example\n@group\nurlwrite (\"http://www.google.com/search\", \"search.html\",\n          \"get\", @{\"query\", \"octave\"@});\n@end group\n@end example\n@seealso{urlread}\n@end deftypefn") 
 XDEFUN_INTERNAL (urlread, args, nargout, "-*- texinfo -*-\n@deftypefn  {Loadable Function} {@var{s} =} urlread (@var{url})\n@deftypefnx {Loadable Function} {[@var{s}, @var{success}] =} urlread (@var{url})\n@deftypefnx {Loadable Function} {[@var{s}, @var{success}, @var{message}] =} urlread (@var{url})\n@deftypefnx {Loadable Function} {[@dots{}] =} urlread (@var{url}, @var{method}, @var{param})\nDownload a remote file specified by its @var{url} and return its content\nin string @var{s}.\n\nFor example:\n\n@example\ns = urlread (\"ftp://ftp.octave.org/pub/README\");\n@end example\n\nThe variable @var{success} is 1 if the download was successful,\notherwise it is 0 in which case @var{message} contains an error\nmessage.\n\nIf no output argument is specified and an error occurs, then the error is\nsignaled through Octave's error handling mechanism.\n\nThis function uses libcurl.  Curl supports, among others, the HTTP, FTP and\nFILE protocols.  Username and password may be specified in the URL@.  For\nexample:\n\n@example\ns = urlread (\"http://user:password@@example.com/file.txt\");\n@end example\n\nGET and POST requests can be specified by @var{method} and @var{param}.\nThe parameter @var{method} is either @samp{get} or @samp{post} and\n@var{param} is a cell array of parameter and value pairs.\nFor example:\n\n@example\n@group\ns = urlread (\"http://www.google.com/search\", \"get\",\n            @{\"query\", \"octave\"@});\n@end group\n@end example\n@seealso{urlwrite}\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp__, args, , "-*- texinfo -*-\n@deftypefn  {Loadable Function} {@var{handle} =} __ftp__ (@var{host})\n@deftypefnx {Loadable Function} {@var{handle} =} __ftp__ (@var{host}, @var{username}, @var{password})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_pwd__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_pwd__ (@var{handle})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_cwd__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_cwd__ (@var{handle}, @var{path})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_dir__, args, nargout, "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_dir__ (@var{handle})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_ascii__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_ascii__ (@var{handle})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_binary__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_binary__ (@var{handle})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_close__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_close__ (@var{handle})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_mode__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_mode__ (@var{handle})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_delete__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_delete__ (@var{handle}, @var{path})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_rmdir__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_rmdir__ (@var{handle}, @var{path})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_mkdir__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_mkdir__ (@var{handle}, @var{path})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_rename__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_rename__ (@var{handle}, @var{path})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_mput__, args, nargout, "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_mput__ (@var{handle}, @var{files})\nUndocumented internal function\n@end deftypefn") 
 XDEFUN_INTERNAL (__ftp_mget__, args, , "-*- texinfo -*-\n@deftypefn {Loadable Function} {} __ftp_mget__ (@var{handle}, @var{files})\nUndocumented internal function\n@end deftypefn") 
}

static void
install_utils_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/utils.cc")
 XDEFUN_INTERNAL (isvarname, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isvarname (@var{name})\nReturn true if @var{name} is a valid variable name.\n@seealso{iskeyword, exist, who}\n@end deftypefn") 
 XDEFUN_INTERNAL (file_in_loadpath, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} file_in_loadpath (@var{file})\n@deftypefnx {Built-in Function} {} file_in_loadpath (@var{file}, \"all\")\n\nReturn the absolute name of @var{file} if it can be found in\nthe list of directories specified by @code{path}.\n\nIf no file is found, return an empty character string.\n\nIf the first argument is a cell array of strings, search each directory of\nthe loadpath for element of the cell array and return the first that\nmatches.\n\nIf the second optional argument @qcode{\"all\"} is supplied, return a cell\narray containing the list of all files that have the same name in the path.\nIf no files are found, return an empty cell array.\n@seealso{file_in_path, dir_in_loadpath, path}\n@end deftypefn") 
 XDEFUN_INTERNAL (file_in_path, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} file_in_path (@var{path}, @var{file})\n@deftypefnx {Built-in Function} {} file_in_path (@var{path}, @var{file}, \"all\")\nReturn the absolute name of @var{file} if it can be found in @var{path}.\n\nThe value of @var{path} should be a colon-separated list of directories in\nthe format described for @code{path}.  If no file is found, return an empty\ncharacter string.  For example:\n\n@example\n@group\nfile_in_path (EXEC_PATH, \"sh\")\n     @result{} \"/bin/sh\"\n@end group\n@end example\n\nIf the second argument is a cell array of strings, search each directory of\nthe path for element of the cell array and return the first that matches.\n\nIf the third optional argument @qcode{\"all\"} is supplied, return a cell\narray containing the list of all files that have the same name in the path.\nIf no files are found, return an empty cell array.\n@seealso{file_in_loadpath, dir_in_loadpath, path}\n@end deftypefn") 
 XDEFUN_INTERNAL (do_string_escapes, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} do_string_escapes (@var{string})\nConvert escape sequences in @var{string} to the characters they represent.\n\nEscape sequences begin with a leading backslash\n(@qcode{'@xbackslashchar{}'}) followed by 1--3 characters\n(.e.g., @qcode{\"@xbackslashchar{}n\"} => newline).\n@seealso{undo_string_escapes}\n@end deftypefn") 
 XDEFUN_INTERNAL (undo_string_escapes, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} undo_string_escapes (@var{s})\nConvert special characters in strings back to their escaped forms.\n\nFor example, the expression\n\n@example\nbell = \"\\a\";\n@end example\n\n@noindent\nassigns the value of the alert character (control-g, ASCII code 7) to the\nstring variable @code{bell}.  If this string is printed, the system will\nring the terminal bell (if it is possible).  This is normally the desired\noutcome.  However, sometimes it is useful to be able to print the original\nrepresentation of the string, with the special characters replaced by their\nescape sequences.  For example,\n\n@example\n@group\noctave:13> undo_string_escapes (bell)\nans = \\a\n@end group\n@end example\n\n@noindent\nreplaces the unprintable alert character with its printable representation.\n@seealso{do_string_escapes}\n@end deftypefn") 
 XDEFUN_INTERNAL (is_absolute_filename, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} is_absolute_filename (@var{file})\nReturn true if @var{file} is an absolute filename.\n@seealso{is_rooted_relative_filename, make_absolute_filename, isdir}\n@end deftypefn") 
 XDEFUN_INTERNAL (is_rooted_relative_filename, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} is_rooted_relative_filename (@var{file})\nReturn true if @var{file} is a rooted-relative filename.\n@seealso{is_absolute_filename, make_absolute_filename, isdir}\n@end deftypefn") 
 XDEFUN_INTERNAL (make_absolute_filename, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} make_absolute_filename (@var{file})\nReturn the full name of @var{file} beginning from the root of the file\nsystem.\n\nNo check is done for the existence of @var{file}.\n@seealso{canonicalize_file_name, is_absolute_filename, is_rooted_relative_filename, isdir}\n@end deftypefn") 
 XDEFUN_INTERNAL (dir_in_loadpath, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} dir_in_loadpath (@var{dir})\n@deftypefnx {Built-in Function} {} dir_in_loadpath (@var{dir}, \"all\")\nReturn the full name of the path element matching @var{dir}.\n\nThe match is performed at the end of each path element.  For example, if\n@var{dir} is @qcode{\"foo/bar\"}, it matches the path element\n@nospell{@qcode{\"/some/dir/foo/bar\"}}, but not\n@nospell{@qcode{\"/some/dir/foo/bar/baz\"}}\n@nospell{@qcode{\"/some/dir/allfoo/bar\"}}.\n\nIf the optional second argument is supplied, return a cell array containing\nall name matches rather than just the first.\n@seealso{file_in_path, file_in_loadpath, path}\n@end deftypefn") 
 XDEFUNX_INTERNAL ("errno", Ferrno, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{err} =} errno ()\n@deftypefnx {Built-in Function} {@var{err} =} errno (@var{val})\n@deftypefnx {Built-in Function} {@var{err} =} errno (@var{name})\nReturn the current value of the system-dependent variable errno,\nset its value to @var{val} and return the previous value, or return\nthe named error code given @var{name} as a character string, or -1\nif @var{name} is not found.\n@seealso{errno_list}\n@end deftypefn") 
 XDEFUN_INTERNAL (errno_list, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} errno_list ()\nReturn a structure containing the system-dependent errno values.\n@seealso{errno}\n@end deftypefn") 
 XDEFUN_INTERNAL (isindex, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} isindex (@var{ind})\n@deftypefnx {Built-in Function} {} isindex (@var{ind}, @var{n})\nReturn true if @var{ind} is a valid index.\n\nValid indices are either positive integers (although possibly of real data\ntype), or logical arrays.\n\nIf present, @var{n} specifies the maximum extent of the dimension to be\nindexed.  When possible the internal result is cached so that subsequent\nindexing using @var{ind} will not perform the check again.\n\nImplementation Note: Strings are first converted to double values before the\nchecks for valid indices are made.  Unless a string contains the NULL\ncharacter @nospell{\"@xbackslashchar{}0\"}, it will always be a valid index.\n@end deftypefn") 
 XDEFUN_INTERNAL (isstudent, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isstudent ()\nReturn true if running in the student edition of @sc{matlab}.\n\n@code{isstudent} always returns false in Octave.\n@seealso{false}\n@end deftypefn") 
}

static void
install_variables_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/variables.cc")
 XDEFUN_INTERNAL (isglobal, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} isglobal (@var{name})\nReturn true if @var{name} is a globally visible variable.\n\nFor example:\n\n@example\n@group\nglobal x\nisglobal (\"x\")\n   @result{} 1\n@end group\n@end example\n@seealso{isvarname, exist}\n@end deftypefn") 
 XDEFUN_INTERNAL (exist, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{c} =} exist (@var{name})\n@deftypefnx {Built-in Function} {@var{c} =} exist (@var{name}, @var{type})\nCheck for the existence of @var{name} as a variable, function, file,\ndirectory, or class.\n\nThe return code @var{c} is one of\n\n@table @asis\n@item 1\n@var{name} is a variable.\n\n@item 2\n@var{name} is an absolute file name, an ordinary file in Octave's\n@code{path}, or (after appending @samp{.m}) a function file in Octave's\n@code{path}.\n\n@item 3\n@var{name} is a @samp{.oct} or @samp{.mex} file in Octave's @code{path}.\n\n@item 5\n@var{name} is a built-in function.\n\n@item 7\n@var{name} is a directory.\n\n@item 103\n@var{name} is a function not associated with a file (entered on the command\nline).\n\n@item 0\n@var{name} does not exist.\n@end table\n\nIf the optional argument @var{type} is supplied, check only for symbols of\nthe specified type.  Valid types are\n\n@table @asis\n@item @qcode{\"var\"}\nCheck only for variables.\n\n@item @qcode{\"builtin\"}\nCheck only for built-in functions.\n\n@item @qcode{\"dir\"}\nCheck only for directories.\n\n@item @qcode{\"file\"}\nCheck only for files and directories.\n\n@item @qcode{\"class\"}\nCheck only for classes.  (Note: This option is accepted, but not currently\nimplemented)\n@end table\n\nIf no type is given, and there are multiple possible matches for name,\n@code{exist} will return a code according to the following priority list:\nvariable, built-in function, oct-file, directory, file, class.\n\n@code{exist} returns 2 if a regular file called @var{name} is present in\nOctave's search path.  If you want information about other types of files\nnot on the search path you should use some combination of the functions\n@code{file_in_path} and @code{stat} instead.\n\n@seealso{file_in_loadpath, file_in_path, dir_in_loadpath, stat}\n@end deftypefn") 
 XDEFUN_INTERNAL (who, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} who\n@deftypefnx {Command} {} who pattern @dots{}\n@deftypefnx {Command} {} who option pattern @dots{}\n@deftypefnx {Command} {C =} who (\"pattern\", @dots{})\nList currently defined variables matching the given patterns.\n\nValid pattern syntax is the same as described for the @code{clear} command.\nIf no patterns are supplied, all variables are listed.\n\nBy default, only variables visible in the local scope are displayed.\n\nThe following are valid options, but may not be combined.\n\n@table @code\n@item global\nList variables in the global scope rather than the current scope.\n\n@item -regexp\nThe patterns are considered to be regular expressions when matching the\nvariables to display.  The same pattern syntax accepted by the @code{regexp}\nfunction is used.\n\n@item -file\nThe next argument is treated as a filename.  All variables found within the\nspecified file are listed.  No patterns are accepted when reading variables\nfrom a file.\n@end table\n\nIf called as a function, return a cell array of defined variable names\nmatching the given patterns.\n@seealso{whos, isglobal, isvarname, exist, regexp}\n@end deftypefn") 
 XDEFUN_INTERNAL (whos, args, nargout, "-*- texinfo -*-\n@deftypefn  {Command} {} whos\n@deftypefnx {Command} {} whos pattern @dots{}\n@deftypefnx {Command} {} whos option pattern @dots{}\n@deftypefnx {Built-in Function} {S =} whos (\"pattern\", @dots{})\nProvide detailed information on currently defined variables matching the\ngiven patterns.\n\nOptions and pattern syntax are the same as for the @code{who} command.\n\nExtended information about each variable is summarized in a table with the\nfollowing default entries.\n\n@table @asis\n@item Attr\nAttributes of the listed variable.  Possible attributes are:\n\n@table @asis\n@item blank\nVariable in local scope\n\n@item @code{a}\nAutomatic variable.  An automatic variable is one created by the\ninterpreter, for example @code{argn}.\n\n@item @code{c}\nVariable of complex type.\n\n@item @code{f}\nFormal parameter (function argument).\n\n@item @code{g}\nVariable with global scope.\n\n@item @code{p}\nPersistent variable.\n@end table\n\n@item Name\nThe name of the variable.\n\n@item Size\nThe logical size of the variable.  A scalar is 1x1, a vector is\n@nospell{1xN} or @nospell{Nx1}, a 2-D matrix is @nospell{MxN}.\n\n@item Bytes\nThe amount of memory currently used to store the variable.\n\n@item Class\nThe class of the variable.  Examples include double, single, char, uint16,\ncell, and struct.\n@end table\n\nThe table can be customized to display more or less information through\nthe function @code{whos_line_format}.\n\nIf @code{whos} is called as a function, return a struct array of defined\nvariable names matching the given patterns.  Fields in the structure\ndescribing each variable are: name, size, bytes, class, global, sparse,\ncomplex, nesting, persistent.\n@seealso{who, whos_line_format}\n@end deftypefn") 
 XDEFUN_INTERNAL (mlock, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} mlock ()\nLock the current function into memory so that it can't be cleared.\n@seealso{munlock, mislocked, persistent}\n@end deftypefn") 
 XDEFUN_INTERNAL (munlock, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} munlock ()\n@deftypefnx {Built-in Function} {} munlock (@var{fcn})\nUnlock the named function @var{fcn}.\n\nIf no function is named then unlock the current function.\n@seealso{mlock, mislocked, persistent}\n@end deftypefn") 
 XDEFUN_INTERNAL (mislocked, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} mislocked ()\n@deftypefnx {Built-in Function} {} mislocked (@var{fcn})\nReturn true if the named function @var{fcn} is locked.\n\nIf no function is named then return true if the current function is locked.\n@seealso{mlock, munlock, persistent}\n@end deftypefn") 
 XDEFUN_INTERNAL (clear, args, , "-*- texinfo -*-\n@deftypefn {Command} {} clear [options] pattern @dots{}\nDelete the names matching the given patterns from the symbol table.\n\nThe pattern may contain the following special characters:\n\n@table @code\n@item ?\nMatch any single character.\n\n@item *\nMatch zero or more characters.\n\n@item [ @var{list} ]\nMatch the list of characters specified by @var{list}.  If the first\ncharacter is @code{!} or @code{^}, match all characters except those\nspecified by @var{list}.  For example, the pattern @samp{[a-zA-Z]} will\nmatch all lowercase and uppercase alphabetic characters.\n@end table\n\nFor example, the command\n\n@example\nclear foo b*r\n@end example\n\n@noindent\nclears the name @code{foo} and all names that begin with the letter\n@code{b} and end with the letter @code{r}.\n\nIf @code{clear} is called without any arguments, all user-defined\nvariables (local and global) are cleared from the symbol table.\n\nIf @code{clear} is called with at least one argument, only the visible\nnames matching the arguments are cleared.  For example, suppose you have\ndefined a function @code{foo}, and then hidden it by performing the\nassignment @code{foo = 2}.  Executing the command @kbd{clear foo} once\nwill clear the variable definition and restore the definition of\n@code{foo} as a function.  Executing @kbd{clear foo} a second time will\nclear the function definition.\n\nThe following options are available in both long and short form\n\n@table @code\n@item -all, -a\nClear all local and global user-defined variables and all functions from the\nsymbol table.\n\n@item -exclusive, -x\nClear the variables that don't match the following pattern.\n\n@item -functions, -f\nClear the function names and the built-in symbols names.\n\n@item -global, -g\nClear global symbol names.\n\n@item -variables, -v\nClear local variable names.\n\n@item -classes, -c\nClears the class structure table and clears all objects.\n\n@item -regexp, -r\nThe arguments are treated as regular expressions as any variables that\nmatch will be cleared.\n@end table\n\nWith the exception of @code{exclusive}, all long options can be used\nwithout the dash as well.\n@seealso{who, whos, exist}\n@end deftypefn") 
 XDEFUN_INTERNAL (whos_line_format, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} whos_line_format ()\n@deftypefnx {Built-in Function} {@var{old_val} =} whos_line_format (@var{new_val})\n@deftypefnx {Built-in Function} {} whos_line_format (@var{new_val}, \"local\")\nQuery or set the format string used by the command @code{whos}.\n\nA full format string is:\n@c Set example in small font to prevent overfull line\n\n@smallexample\n%[modifier]<command>[:width[:left-min[:balance]]];\n@end smallexample\n\nThe following command sequences are available:\n\n@table @code\n@item %a\nPrints attributes of variables (g=global, p=persistent, f=formal parameter,\na=automatic variable).\n\n@item %b\nPrints number of bytes occupied by variables.\n\n@item %c\nPrints class names of variables.\n\n@item %e\nPrints elements held by variables.\n\n@item %n\nPrints variable names.\n\n@item %s\nPrints dimensions of variables.\n\n@item %t\nPrints type names of variables.\n@end table\n\nEvery command may also have an alignment modifier:\n\n@table @code\n@item l\nLeft alignment.\n\n@item r\nRight alignment (default).\n\n@item c\nColumn-aligned (only applicable to command %s).\n@end table\n\nThe @code{width} parameter is a positive integer specifying the minimum\nnumber of columns used for printing.  No maximum is needed as the field will\nauto-expand as required.\n\nThe parameters @code{left-min} and @code{balance} are only available when the\ncolumn-aligned modifier is used with the command @samp{%s}.\n@code{balance} specifies the column number within the field width which will\nbe aligned between entries.  Numbering starts from 0 which indicates the\nleftmost column.  @code{left-min} specifies the minimum field width to the\nleft of the specified balance column.\n\nThe default format is:\n\n@qcode{\"  %a:4; %ln:6; %cs:16:6:1;  %rb:12;  %lc:-1;@xbackslashchar{}n\"}\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{whos}\n@end deftypefn") 
 XDEFUN_INTERNAL (missing_function_hook, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} missing_function_hook ()\n@deftypefnx {Built-in Function} {@var{old_val} =} missing_function_hook (@var{new_val})\n@deftypefnx {Built-in Function} {} missing_function_hook (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the function to call when\nan unknown identifier is requested.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{missing_component_hook}\n@end deftypefn") 
 XDEFUN_INTERNAL (__varval__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __varval__ (@var{name})\nUndocumented internal function.\n@end deftypefn") 
 XDEFUN_INTERNAL (missing_component_hook, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} missing_component_hook ()\n@deftypefnx {Built-in Function} {@var{old_val} =} missing_component_hook (@var{new_val})\n@deftypefnx {Built-in Function} {} missing_component_hook (@var{new_val}, \"local\")\nQuery or set the internal variable that specifies the function to call when\na component of Octave is missing.\n\nThis can be useful for packagers that may split the Octave installation into\nmultiple sub-packages, for example, to provide a hint to users for how to\ninstall the missing components.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n\nThe hook function is expected to be of the form\n\n@example\n@var{fcn} (@var{component})\n@end example\n\nOctave will call @var{fcn} with the name of the function that requires the\ncomponent and a string describing the missing component.  The hook function\nshould return an error message to be displayed.\n@seealso{missing_function_hook}\n@end deftypefn") 
}

static void
install_pt_jit_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/corefcn/pt-jit.cc")
 XDEFUN_INTERNAL (jit_failcnt, args __attribute__ ((__unused__)), nargout __attribute__ ((__unused__)), "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} jit_failcnt ()\n@deftypefnx {Built-in Function} {@var{old_val} =} jit_failcnt (@var{new_val})\n@deftypefnx {Built-in Function} {} jit_failcnt (@var{new_val}, \"local\")\nQuery or set the internal variable that counts the number of JIT fail\nexceptions for Octave's JIT compiler.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{jit_enable, jit_startcnt, debug_jit}\n@end deftypefn") 
 XDEFUN_INTERNAL (debug_jit, args __attribute__ ((__unused__)), nargout __attribute__ ((__unused__)), "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} debug_jit ()\n@deftypefnx {Built-in Function} {@var{old_val} =} debug_jit (@var{new_val})\n@deftypefnx {Built-in Function} {} debug_jit (@var{new_val}, \"local\")\nQuery or set the internal variable that determines whether\ndebugging/tracing is enabled for Octave's JIT compiler.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{jit_enable, jit_startcnt}\n@end deftypefn") 
 XDEFUN_INTERNAL (jit_enable, args __attribute__ ((__unused__)), nargout __attribute__ ((__unused__)), "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} jit_enable ()\n@deftypefnx {Built-in Function} {@var{old_val} =} jit_enable (@var{new_val})\n@deftypefnx {Built-in Function} {} jit_enable (@var{new_val}, \"local\")\nQuery or set the internal variable that enables Octave's JIT compiler.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{jit_startcnt, debug_jit}\n@end deftypefn") 
 XDEFUN_INTERNAL (jit_startcnt, args __attribute__ ((__unused__)), nargout __attribute__ ((__unused__)), "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} jit_startcnt ()\n@deftypefnx {Built-in Function} {@var{old_val} =} jit_startcnt (@var{new_val})\n@deftypefnx {Built-in Function} {} jit_startcnt (@var{new_val}, \"local\")\nQuery or set the internal variable that determines whether JIT compilation\nwill take place for a specific loop.\n\nBecause compilation is a costly operation it does not make sense to employ\nJIT when the loop count is low.  By default only loops with greater than\n1000 iterations will be accelerated.\n\nWhen called from inside a function with the @qcode{\"local\"} option, the\nvariable is changed locally for the function and any subroutines it calls.\nThe original variable value is restored when exiting the function.\n@seealso{jit_enable, jit_failcnt, debug_jit}\n@end deftypefn") 
}

static void
install_oct_parse_fcns (void)
{
// DO NOT EDIT!  Generated automatically by mkdefs.
 XDEFUN_FILE_NAME ("libinterp/parse-tree/oct-parse.cc")
 XDEFUN_INTERNAL (autoload, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{autoload_map} =} autoload ()\n@deftypefnx {Built-in Function} {} autoload (@var{function}, @var{file})\n@deftypefnx {Built-in Function} {} autoload (@dots{}, \"remove\")\nDefine @var{function} to autoload from @var{file}.\n\nThe second argument, @var{file}, should be an absolute file name or a file\nname in the same directory as the function or script from which the autoload\ncommand was run.  @var{file} @emph{should not} depend on the Octave load\npath.\n\nNormally, calls to @code{autoload} appear in PKG_ADD script files that are\nevaluated when a directory is added to Octave's load path.  To avoid having\nto hardcode directory names in @var{file}, if @var{file} is in the same\ndirectory as the PKG_ADD script then\n\n@example\nautoload (\"foo\", \"bar.oct\");\n@end example\n\n@noindent\nwill load the function @code{foo} from the file @code{bar.oct}.  The above\nusage when @code{bar.oct} is not in the same directory, or usages such as\n\n@example\nautoload (\"foo\", file_in_loadpath (\"bar.oct\"))\n@end example\n\n@noindent\nare strongly discouraged, as their behavior may be unpredictable.\n\nWith no arguments, return a structure containing the current autoload map.\n\nIf a third argument @qcode{\"remove\"} is given, the function is cleared and\nnot loaded anymore during the current Octave session.\n\n@seealso{PKG_ADD}\n@end deftypefn") 
 XDEFUN_INTERNAL (mfilename, args, , "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} mfilename ()\n@deftypefnx {Built-in Function} {} mfilename (\"fullpath\")\n@deftypefnx {Built-in Function} {} mfilename (\"fullpathext\")\nReturn the name of the currently executing file.\n\nWhen called from outside an m-file return the empty string.\n\nGiven the argument @qcode{\"fullpath\"}, include the directory part of the\nfile name, but not the extension.\n\nGiven the argument @qcode{\"fullpathext\"}, include the directory part of\nthe file name and the extension.\n@end deftypefn") 
 XDEFUN_INTERNAL (source, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} source (@var{file})\nParse and execute the contents of @var{file}.\n\nThis is equivalent to executing commands from a script file, but without\nrequiring the file to be named @file{@var{file}.m}.\n@seealso{run}\n@end deftypefn") 
 XDEFUN_INTERNAL (feval, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {} feval (@var{name}, @dots{})\nEvaluate the function named @var{name}.\n\nAny arguments after the first are passed as inputs to the named function.\nFor example,\n\n@example\n@group\nfeval (\"acos\", -1)\n     @result{} 3.1416\n@end group\n@end example\n\n@noindent\ncalls the function @code{acos} with the argument @samp{-1}.\n\nThe function @code{feval} can also be used with function handles of any sort\n(@pxref{Function Handles}).  Historically, @code{feval} was the only way to\ncall user-supplied functions in strings, but function handles are now\npreferred due to the cleaner syntax they offer.  For example,\n\n@example\n@group\n@var{f} = @@exp;\nfeval (@var{f}, 1)\n    @result{} 2.7183\n@var{f} (1)\n    @result{} 2.7183\n@end group\n@end example\n\n@noindent\nare equivalent ways to call the function referred to by @var{f}.  If it\ncannot be predicted beforehand whether @var{f} is a function handle,\nfunction name in a string, or inline function then @code{feval} can be used\ninstead.\n@end deftypefn") 
 XDEFUN_INTERNAL (builtin, args, nargout, "-*- texinfo -*-\n@deftypefn {Built-in Function} {[@dots{}] =} builtin (@var{f}, @dots{})\nCall the base function @var{f} even if @var{f} is overloaded to another\nfunction for the given type signature.\n\nThis is normally useful when doing object-oriented programming and there is\na requirement to call one of Octave's base functions rather than the\noverloaded one of a new class.\n\nA trivial example which redefines the @code{sin} function to be the\n@code{cos} function shows how @code{builtin} works.\n\n@example\n@group\nsin (0)\n  @result{} 0\nfunction y = sin (x), y = cos (x); endfunction\nsin (0)\n  @result{} 1\nbuiltin (\"sin\", 0)\n  @result{} 0\n@end group\n@end example\n@end deftypefn") 
 XDEFUN_INTERNAL (eval, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} eval (@var{try})\n@deftypefnx {Built-in Function} {} eval (@var{try}, @var{catch})\nParse the string @var{try} and evaluate it as if it were an Octave\nprogram.\n\nIf execution fails, evaluate the optional string @var{catch}.\n\nThe string @var{try} is evaluated in the current context, so any results\nremain available after @code{eval} returns.\n\nThe following example creates the variable @var{A} with the approximate\nvalue of 3.1416 in the current workspace.\n\n@example\neval (\"A = acos(-1);\");\n@end example\n\nIf an error occurs during the evaluation of @var{try} then the @var{catch}\nstring is evaluated, as the following example shows:\n\n@example\n@group\neval ('error (\"This is a bad example\");',\n      'printf (\"This error occurred:\\n%s\\n\", lasterr ());');\n     @print{} This error occurred:\n        This is a bad example\n@end group\n@end example\n\nProgramming Note: if you are only using @code{eval} as an error-capturing\nmechanism, rather than for the execution of arbitrary code strings,\nConsider using try/catch blocks or unwind_protect/unwind_protect_cleanup\nblocks instead.  These techniques have higher performance and don't introduce\nthe security considerations that the evaluation of arbitrary code does.\n@seealso{evalin}\n@end deftypefn") 
 XDEFUN_INTERNAL (assignin, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} assignin (@var{context}, @var{varname}, @var{value})\nAssign @var{value} to @var{varname} in context @var{context}, which\nmay be either @qcode{\"base\"} or @qcode{\"caller\"}.\n@seealso{evalin}\n@end deftypefn") 
 XDEFUN_INTERNAL (evalin, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {} evalin (@var{context}, @var{try})\n@deftypefnx {Built-in Function} {} evalin (@var{context}, @var{try}, @var{catch})\nLike @code{eval}, except that the expressions are evaluated in the context\n@var{context}, which may be either @qcode{\"caller\"} or @qcode{\"base\"}.\n@seealso{eval, assignin}\n@end deftypefn") 
 XDEFUN_INTERNAL (__parser_debug_flag__, args, nargout, "-*- texinfo -*-\n@deftypefn  {Built-in Function} {@var{val} =} __parser_debug_flag__ ()\n@deftypefnx {Built-in Function} {@var{old_val} =} __parser_debug_flag__ (@var{new_val})\nQuery or set the internal flag that determines whether Octave's parser prints\ndebug information as it processes an expression.\n@seealso{__lexer_debug_flag__}\n@end deftypefn") 
 XDEFUN_INTERNAL (__parse_file__, args, , "-*- texinfo -*-\n@deftypefn {Built-in Function} {} __parse_file__ (@var{file}, @var{verbose})\nUndocumented internal function.\n@end deftypefn") 
}


void
install_builtins (void)
{
  install_octave_fcns ();
  install_ov_base_fcns ();
  install_ov_bool_mat_fcns ();
  install_ov_cell_fcns ();
  install_ov_class_fcns ();
  install_ov_classdef_fcns ();
  install_ov_fcn_handle_fcns ();
  install_ov_fcn_inline_fcns ();
  install_ov_flt_re_mat_fcns ();
  install_ov_java_fcns ();
  install_ov_null_mat_fcns ();
  install_ov_oncleanup_fcns ();
  install_ov_range_fcns ();
  install_ov_re_mat_fcns ();
  install_ov_struct_fcns ();
  install_ov_typeinfo_fcns ();
  install_ov_usr_fcn_fcns ();
  install_ov_fcns ();
  install_ov_int16_fcns ();
  install_ov_int32_fcns ();
  install_ov_int64_fcns ();
  install_ov_int8_fcns ();
  install_ov_uint16_fcns ();
  install_ov_uint32_fcns ();
  install_ov_uint64_fcns ();
  install_ov_uint8_fcns ();
  install_pt_arg_list_fcns ();
  install_pt_binop_fcns ();
  install_pt_eval_fcns ();
  install_pt_mat_fcns ();
  install_lex_fcns ();
  install___contourc___fcns ();
  install___dispatch___fcns ();
  install___dsearchn___fcns ();
  install___ichol___fcns ();
  install___ilu___fcns ();
  install___lin_interpn___fcns ();
  install___pchip_deriv___fcns ();
  install___qp___fcns ();
  install_balance_fcns ();
  install_besselj_fcns ();
  install_betainc_fcns ();
  install_bitfcns_fcns ();
  install_bsxfun_fcns ();
  install_cellfun_fcns ();
  install_colloc_fcns ();
  install_conv2_fcns ();
  install_daspk_fcns ();
  install_dasrt_fcns ();
  install_dassl_fcns ();
  install_data_fcns ();
  install_debug_fcns ();
  install_defaults_fcns ();
  install_det_fcns ();
  install_dirfns_fcns ();
  install_dlmread_fcns ();
  install_dot_fcns ();
  install_eig_fcns ();
  install_ellipj_fcns ();
  install_error_fcns ();
  install_fft_fcns ();
  install_fft2_fcns ();
  install_fftn_fcns ();
  install_file_io_fcns ();
  install_filter_fcns ();
  install_find_fcns ();
  install_gammainc_fcns ();
  install_gcd_fcns ();
  install_getgrent_fcns ();
  install_getpwent_fcns ();
  install_getrusage_fcns ();
  install_givens_fcns ();
  install_graphics_fcns ();
  install_help_fcns ();
  install_hess_fcns ();
  install_hex2num_fcns ();
  install_input_fcns ();
  install_inv_fcns ();
  install_kron_fcns ();
  install_load_path_fcns ();
  install_load_save_fcns ();
  install_lookup_fcns ();
  install_ls_oct_ascii_fcns ();
  install_lsode_fcns ();
  install_lu_fcns ();
  install_luinc_fcns ();
  install_mappers_fcns ();
  install_matrix_type_fcns ();
  install_max_fcns ();
  install_md5sum_fcns ();
  install_mgorth_fcns ();
  install_nproc_fcns ();
  install_oct_hist_fcns ();
  install_octave_link_fcns ();
  install_ordschur_fcns ();
  install_pager_fcns ();
  install_pinv_fcns ();
  install_pr_output_fcns ();
  install_profiler_fcns ();
  install_quad_fcns ();
  install_quadcc_fcns ();
  install_qz_fcns ();
  install_rand_fcns ();
  install_rcond_fcns ();
  install_regexp_fcns ();
  install_schur_fcns ();
  install_sighandlers_fcns ();
  install_sparse_fcns ();
  install_spparms_fcns ();
  install_sqrtm_fcns ();
  install_str2double_fcns ();
  install_strfind_fcns ();
  install_strfns_fcns ();
  install_sub2ind_fcns ();
  install_svd_fcns ();
  install_sylvester_fcns ();
  install_symtab_fcns ();
  install_syscalls_fcns ();
  install_sysdep_fcns ();
  install_time_fcns ();
  install_toplev_fcns ();
  install_tril_fcns ();
  install_tsearch_fcns ();
  install_typecast_fcns ();
  install_urlwrite_fcns ();
  install_utils_fcns ();
  install_variables_fcns ();
  install_pt_jit_fcns ();
  install_oct_parse_fcns ();

  install_built_in_docstrings ();
}

